/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs,
							  int location, core_yyscan_t yyscanner);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);



/* Line 268 of yacc.c  */
#line 248 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     ARRAY = 285,
     AS = 286,
     ASC = 287,
     ASSERTION = 288,
     ASSIGNMENT = 289,
     ASYMMETRIC = 290,
     AT = 291,
     ATTRIBUTE = 292,
     AUTHORIZATION = 293,
     BACKWARD = 294,
     BEFORE = 295,
     BEGIN_P = 296,
     BETWEEN = 297,
     BIGINT = 298,
     BINARY = 299,
     BIT = 300,
     BOOLEAN_P = 301,
     BOTH = 302,
     BY = 303,
     CACHE = 304,
     CALLED = 305,
     CASCADE = 306,
     CASCADED = 307,
     CASE = 308,
     CAST = 309,
     CATALOG_P = 310,
     CHAIN = 311,
     CHAR_P = 312,
     CHARACTER = 313,
     CHARACTERISTICS = 314,
     CHECK = 315,
     CHECKPOINT = 316,
     CLASS = 317,
     CLOSE = 318,
     CLUSTER = 319,
     COALESCE = 320,
     COLLATE = 321,
     COLLATION = 322,
     COLUMN = 323,
     COMMENT = 324,
     COMMENTS = 325,
     COMMIT = 326,
     COMMITTED = 327,
     CONCURRENTLY = 328,
     CONFIGURATION = 329,
     CONNECTION = 330,
     CONSTRAINT = 331,
     CONSTRAINTS = 332,
     CONTENT_P = 333,
     CONTINUE_P = 334,
     CONVERSION_P = 335,
     COPY = 336,
     COST = 337,
     CREATE = 338,
     CROSS = 339,
     CSV = 340,
     CURRENT_P = 341,
     CURRENT_CATALOG = 342,
     CURRENT_DATE = 343,
     CURRENT_ROLE = 344,
     CURRENT_SCHEMA = 345,
     CURRENT_TIME = 346,
     CURRENT_TIMESTAMP = 347,
     CURRENT_USER = 348,
     CURSOR = 349,
     CYCLE = 350,
     DATA_P = 351,
     DATABASE = 352,
     DAY_P = 353,
     DEALLOCATE = 354,
     DEC = 355,
     DECIMAL_P = 356,
     DECLARE = 357,
     DEFAULT = 358,
     DEFAULTS = 359,
     DEFERRABLE = 360,
     DEFERRED = 361,
     DEFINER = 362,
     DELETE_P = 363,
     DELIMITER = 364,
     DELIMITERS = 365,
     DESC = 366,
     DICTIONARY = 367,
     DISABLE_P = 368,
     DISCARD = 369,
     DISTINCT = 370,
     DO = 371,
     DOCUMENT_P = 372,
     DOMAIN_P = 373,
     DOUBLE_P = 374,
     DROP = 375,
     EACH = 376,
     ELSE = 377,
     ENABLE_P = 378,
     ENCODING = 379,
     ENCRYPTED = 380,
     END_P = 381,
     ENUM_P = 382,
     ESCAPE = 383,
     EVENT = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTENSION = 392,
     EXTERNAL = 393,
     EXTRACT = 394,
     FALSE_P = 395,
     FAMILY = 396,
     FETCH = 397,
     FIRST_P = 398,
     FLOAT_P = 399,
     FOLLOWING = 400,
     FOR = 401,
     FORCE = 402,
     FOREIGN = 403,
     FORWARD = 404,
     FREEZE = 405,
     FROM = 406,
     FULL = 407,
     FUNCTION = 408,
     FUNCTIONS = 409,
     GLOBAL = 410,
     GRANT = 411,
     GRANTED = 412,
     GREATEST = 413,
     GROUP_P = 414,
     HANDLER = 415,
     HAVING = 416,
     HEADER_P = 417,
     HOLD = 418,
     HOUR_P = 419,
     IDENTITY_P = 420,
     IF_P = 421,
     ILIKE = 422,
     IMMEDIATE = 423,
     IMMUTABLE = 424,
     IMPLICIT_P = 425,
     IN_P = 426,
     INCLUDING = 427,
     INCREMENT = 428,
     INDEX = 429,
     INDEXES = 430,
     INHERIT = 431,
     INHERITS = 432,
     INITIALLY = 433,
     INLINE_P = 434,
     INNER_P = 435,
     INOUT = 436,
     INPUT_P = 437,
     INSENSITIVE = 438,
     INSERT = 439,
     INSTEAD = 440,
     INT_P = 441,
     INTEGER = 442,
     INTERSECT = 443,
     INTERVAL = 444,
     INTO = 445,
     INVOKER = 446,
     IS = 447,
     ISNULL = 448,
     ISOLATION = 449,
     JOIN = 450,
     KEY = 451,
     LABEL = 452,
     LANGUAGE = 453,
     LARGE_P = 454,
     LAST_P = 455,
     LATERAL_P = 456,
     LC_COLLATE_P = 457,
     LC_CTYPE_P = 458,
     LEADING = 459,
     LEAKPROOF = 460,
     LEAST = 461,
     LEFT = 462,
     LEVEL = 463,
     LIKE = 464,
     LIMIT = 465,
     LISTEN = 466,
     LOAD = 467,
     LOCAL = 468,
     LOCALTIME = 469,
     LOCALTIMESTAMP = 470,
     LOCATION = 471,
     LOCK_P = 472,
     MAPPING = 473,
     MATCH = 474,
     MATERIALIZED = 475,
     MAXVALUE = 476,
     MINUTE_P = 477,
     MINVALUE = 478,
     MODE = 479,
     MONTH_P = 480,
     MOVE = 481,
     NAME_P = 482,
     NAMES = 483,
     NATIONAL = 484,
     NATURAL = 485,
     NCHAR = 486,
     NEXT = 487,
     NO = 488,
     NONE = 489,
     NOT = 490,
     NOTHING = 491,
     NOTIFY = 492,
     NOTNULL = 493,
     NOWAIT = 494,
     NULL_P = 495,
     NULLIF = 496,
     NULLS_P = 497,
     NUMERIC = 498,
     OBJECT_P = 499,
     OF = 500,
     OFF = 501,
     OFFSET = 502,
     OIDS = 503,
     ON = 504,
     ONLY = 505,
     OPERATOR = 506,
     OPTION = 507,
     OPTIONS = 508,
     OR = 509,
     ORDER = 510,
     OUT_P = 511,
     OUTER_P = 512,
     OVER = 513,
     OVERLAPS = 514,
     OVERLAY = 515,
     OWNED = 516,
     OWNER = 517,
     PARSER = 518,
     PARTIAL = 519,
     PARTITION = 520,
     PASSING = 521,
     PASSWORD = 522,
     PLACING = 523,
     PLANS = 524,
     POSITION = 525,
     PRECEDING = 526,
     PRECISION = 527,
     PRESERVE = 528,
     PREPARE = 529,
     PREPARED = 530,
     PRIMARY = 531,
     PRIOR = 532,
     PRIVILEGES = 533,
     PROCEDURAL = 534,
     PROCEDURE = 535,
     PROGRAM = 536,
     QUOTE = 537,
     RANGE = 538,
     READ = 539,
     REAL = 540,
     REASSIGN = 541,
     RECHECK = 542,
     RECURSIVE = 543,
     REF = 544,
     REFERENCES = 545,
     REFRESH = 546,
     REINDEX = 547,
     RELATIVE_P = 548,
     RELEASE = 549,
     RENAME = 550,
     REPEATABLE = 551,
     REPLACE = 552,
     REPLICA = 553,
     RESET = 554,
     RESTART = 555,
     RESTRICT = 556,
     RETURNING = 557,
     RETURNS = 558,
     REVOKE = 559,
     RIGHT = 560,
     ROLE = 561,
     ROLLBACK = 562,
     ROW = 563,
     ROWS = 564,
     RULE = 565,
     SAVEPOINT = 566,
     SCHEMA = 567,
     SCROLL = 568,
     SEARCH = 569,
     SECOND_P = 570,
     SECURITY = 571,
     SELECT = 572,
     SEQUENCE = 573,
     SEQUENCES = 574,
     SERIALIZABLE = 575,
     SERVER = 576,
     SESSION = 577,
     SESSION_USER = 578,
     SET = 579,
     SETOF = 580,
     SHARE = 581,
     SHOW = 582,
     SIMILAR = 583,
     SIMPLE = 584,
     SMALLINT = 585,
     SNAPSHOT = 586,
     SOME = 587,
     STABLE = 588,
     STANDALONE_P = 589,
     START = 590,
     STATEMENT = 591,
     STATISTICS = 592,
     STDIN = 593,
     STDOUT = 594,
     STORAGE = 595,
     STRICT_P = 596,
     STRIP_P = 597,
     SUBSTRING = 598,
     SYMMETRIC = 599,
     SYSID = 600,
     SYSTEM_P = 601,
     TABLE = 602,
     TABLES = 603,
     TABLESPACE = 604,
     TEMP = 605,
     TEMPLATE = 606,
     TEMPORARY = 607,
     TEXT_P = 608,
     THEN = 609,
     TIME = 610,
     TIMESTAMP = 611,
     TO = 612,
     TRAILING = 613,
     TRANSACTION = 614,
     TREAT = 615,
     TRIGGER = 616,
     TRIM = 617,
     TRUE_P = 618,
     TRUNCATE = 619,
     TRUSTED = 620,
     TYPE_P = 621,
     TYPES_P = 622,
     UNBOUNDED = 623,
     UNCOMMITTED = 624,
     UNENCRYPTED = 625,
     UNION = 626,
     UNIQUE = 627,
     UNKNOWN = 628,
     UNLISTEN = 629,
     UNLOGGED = 630,
     UNTIL = 631,
     UPDATE = 632,
     USER = 633,
     USING = 634,
     VACUUM = 635,
     VALID = 636,
     VALIDATE = 637,
     VALIDATOR = 638,
     VALUE_P = 639,
     VALUES = 640,
     VARCHAR = 641,
     VARIADIC = 642,
     VARYING = 643,
     VERBOSE = 644,
     VERSION_P = 645,
     VIEW = 646,
     VOLATILE = 647,
     WHEN = 648,
     WHERE = 649,
     WHITESPACE_P = 650,
     WINDOW = 651,
     WITH = 652,
     WITHOUT = 653,
     WORK = 654,
     WRAPPER = 655,
     WRITE = 656,
     XML_P = 657,
     XMLATTRIBUTES = 658,
     XMLCONCAT = 659,
     XMLELEMENT = 660,
     XMLEXISTS = 661,
     XMLFOREST = 662,
     XMLPARSE = 663,
     XMLPI = 664,
     XMLROOT = 665,
     XMLSERIALIZE = 666,
     YEAR_P = 667,
     YES_P = 668,
     ZONE = 669,
     NULLS_FIRST = 670,
     NULLS_LAST = 671,
     WITH_TIME = 672,
     POSTFIXOP = 673,
     UMINUS = 674
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 178 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 293 of yacc.c  */
#line 742 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 767 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  715
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   76224

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  437
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  558
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2318
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4454

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   674

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   426,     2,     2,
     431,   432,   424,   422,   435,   423,   433,   425,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   436,   434,
     419,   418,   420,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   429,     2,   430,   427,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   421,   428
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     240,   246,   248,   249,   252,   253,   256,   257,   260,   263,
     267,   271,   273,   277,   281,   284,   286,   288,   291,   294,
     297,   301,   305,   311,   317,   318,   322,   328,   334,   340,
     345,   349,   355,   359,   365,   371,   378,   380,   382,   386,
     392,   399,   404,   414,   422,   424,   425,   428,   429,   431,
     433,   435,   437,   439,   441,   444,   448,   452,   455,   461,
     463,   467,   471,   475,   479,   483,   487,   490,   493,   496,
     499,   503,   507,   511,   515,   517,   521,   523,   527,   529,
     531,   534,   537,   540,   542,   544,   546,   548,   550,   552,
     554,   558,   565,   567,   569,   571,   573,   575,   576,   578,
     580,   583,   587,   592,   596,   599,   602,   604,   607,   609,
     612,   616,   621,   625,   628,   633,   635,   637,   639,   641,
     643,   646,   649,   652,   655,   660,   667,   672,   679,   684,
     691,   696,   703,   709,   717,   719,   723,   726,   730,   735,
     742,   749,   756,   762,   768,   775,   782,   787,   796,   801,
     804,   808,   815,   820,   824,   828,   832,   836,   840,   845,
     850,   854,   858,   862,   866,   870,   874,   879,   884,   888,
     891,   895,   898,   901,   905,   909,   912,   915,   917,   921,
     924,   926,   928,   929,   932,   933,   936,   937,   941,   944,
     945,   947,   951,   955,   957,   963,   967,   972,   974,   978,
     983,   990,   995,  1004,  1007,  1010,  1022,  1030,  1032,  1034,
    1036,  1037,  1039,  1041,  1043,  1045,  1049,  1052,  1053,  1055,
    1057,  1059,  1063,  1067,  1069,  1071,  1075,  1079,  1083,  1087,
    1092,  1095,  1097,  1098,  1101,  1102,  1106,  1107,  1109,  1110,
    1112,  1116,  1119,  1121,  1123,  1125,  1129,  1130,  1132,  1136,
    1138,  1150,  1165,  1176,  1190,  1192,  1194,  1197,  1200,  1203,
    1206,  1208,  1209,  1211,  1212,  1216,  1217,  1219,  1223,  1225,
    1229,  1231,  1233,  1235,  1237,  1239,  1244,  1249,  1252,  1253,
    1257,  1259,  1261,  1264,  1267,  1269,  1273,  1278,  1284,  1287,
    1293,  1295,  1298,  1301,  1304,  1308,  1312,  1316,  1317,  1319,
    1321,  1323,  1325,  1327,  1329,  1333,  1335,  1341,  1349,  1353,
    1362,  1367,  1377,  1389,  1392,  1393,  1397,  1398,  1400,  1404,
    1406,  1409,  1412,  1415,  1416,  1418,  1422,  1426,  1433,  1438,
    1439,  1441,  1443,  1446,  1449,  1450,  1454,  1458,  1461,  1463,
    1465,  1468,  1471,  1476,  1477,  1480,  1483,  1486,  1487,  1491,
    1496,  1501,  1502,  1505,  1506,  1511,  1512,  1516,  1524,  1530,
    1533,  1537,  1538,  1547,  1552,  1554,  1555,  1561,  1567,  1572,
    1579,  1581,  1582,  1584,  1587,  1590,  1592,  1595,  1599,  1602,
    1605,  1608,  1611,  1615,  1619,  1621,  1625,  1627,  1628,  1630,
    1633,  1635,  1637,  1641,  1648,  1659,  1661,  1662,  1664,  1667,
    1670,  1671,  1674,  1677,  1679,  1680,  1686,  1694,  1696,  1697,
    1704,  1707,  1708,  1712,  1718,  1724,  1733,  1736,  1737,  1740,
    1743,  1746,  1752,  1755,  1756,  1759,  1767,  1778,  1785,  1792,
    1799,  1806,  1814,  1822,  1832,  1842,  1849,  1857,  1864,  1873,
    1882,  1891,  1900,  1907,  1914,  1922,  1930,  1939,  1946,  1953,
    1961,  1964,  1967,  1970,  1973,  1975,  1978,  1980,  1981,  1988,
    1997,  2005,  2012,  2017,  2018,  2020,  2024,  2029,  2031,  2035,
    2037,  2040,  2043,  2046,  2049,  2051,  2053,  2064,  2067,  2068,
    2071,  2074,  2076,  2077,  2082,  2089,  2095,  2100,  2105,  2116,
    2130,  2136,  2144,  2153,  2155,  2157,  2159,  2167,  2177,  2186,
    2202,  2223,  2225,  2227,  2230,  2232,  2236,  2238,  2240,  2242,
    2246,  2248,  2252,  2253,  2255,  2256,  2258,  2260,  2265,  2266,
    2268,  2272,  2273,  2275,  2277,  2279,  2281,  2284,  2285,  2286,
    2289,  2292,  2294,  2297,  2300,  2303,  2306,  2313,  2322,  2334,
    2348,  2350,  2354,  2360,  2362,  2366,  2372,  2374,  2377,  2380,
    2382,  2391,  2396,  2402,  2407,  2412,  2417,  2421,  2429,  2438,
    2445,  2452,  2459,  2466,  2473,  2478,  2484,  2488,  2490,  2494,
    2498,  2500,  2502,  2504,  2506,  2508,  2510,  2514,  2518,  2522,
    2524,  2528,  2532,  2534,  2535,  2537,  2541,  2549,  2559,  2569,
    2573,  2574,  2588,  2590,  2594,  2600,  2607,  2612,  2620,  2623,
    2625,  2626,  2629,  2630,  2633,  2638,  2639,  2641,  2642,  2649,
    2658,  2667,  2669,  2673,  2679,  2685,  2693,  2703,  2711,  2721,
    2727,  2734,  2741,  2746,  2752,  2760,  2762,  2764,  2766,  2769,
    2771,  2774,  2777,  2779,  2781,  2783,  2785,  2787,  2789,  2793,
    2797,  2801,  2805,  2807,  2811,  2813,  2816,  2819,  2823,  2829,
    2832,  2835,  2836,  2843,  2851,  2859,  2867,  2876,  2885,  2892,
    2901,  2911,  2921,  2929,  2940,  2948,  2950,  2952,  2954,  2956,
    2958,  2960,  2962,  2964,  2966,  2969,  2971,  2973,  2975,  2977,
    2979,  2982,  2984,  2988,  2991,  2995,  2999,  3003,  3007,  3009,
    3011,  3020,  3030,  3040,  3050,  3060,  3063,  3064,  3066,  3068,
    3071,  3074,  3076,  3078,  3080,  3082,  3084,  3086,  3088,  3090,
    3093,  3095,  3097,  3100,  3103,  3105,  3108,  3112,  3116,  3120,
    3124,  3129,  3134,  3138,  3142,  3146,  3151,  3156,  3160,  3165,
    3170,  3172,  3174,  3176,  3177,  3185,  3193,  3204,  3206,  3208,
    3211,  3216,  3222,  3224,  3228,  3231,  3234,  3237,  3240,  3242,
    3245,  3248,  3253,  3257,  3260,  3263,  3266,  3269,  3273,  3276,
    3279,  3282,  3288,  3294,  3300,  3302,  3306,  3308,  3311,  3315,
    3316,  3318,  3322,  3325,  3332,  3339,  3349,  3353,  3354,  3358,
    3359,  3365,  3368,  3369,  3373,  3377,  3381,  3389,  3397,  3408,
    3410,  3412,  3414,  3416,  3431,  3433,  3434,  3436,  3437,  3439,
    3440,  3443,  3444,  3446,  3450,  3456,  3462,  3470,  3473,  3474,
    3476,  3479,  3480,  3482,  3484,  3485,  3487,  3489,  3490,  3500,
    3513,  3521,  3524,  3525,  3529,  3532,  3534,  3538,  3542,  3545,
    3547,  3551,  3555,  3559,  3562,  3565,  3567,  3569,  3571,  3573,
    3576,  3578,  3580,  3582,  3584,  3589,  3595,  3597,  3601,  3605,
    3607,  3610,  3615,  3621,  3623,  3625,  3627,  3629,  3633,  3637,
    3640,  3643,  3645,  3648,  3651,  3654,  3656,  3659,  3662,  3664,
    3666,  3668,  3672,  3675,  3676,  3679,  3681,  3685,  3691,  3693,
    3696,  3698,  3699,  3705,  3713,  3719,  3727,  3733,  3741,  3745,
    3751,  3757,  3763,  3765,  3769,  3772,  3774,  3777,  3779,  3782,
    3794,  3805,  3816,  3819,  3822,  3823,  3833,  3836,  3837,  3842,
    3847,  3852,  3854,  3856,  3858,  3859,  3867,  3874,  3881,  3888,
    3895,  3904,  3913,  3920,  3927,  3935,  3945,  3955,  3962,  3969,
    3976,  3985,  3992,  4001,  4008,  4017,  4025,  4035,  4042,  4051,
    4059,  4069,  4078,  4089,  4099,  4111,  4120,  4130,  4142,  4151,
    4160,  4168,  4175,  4182,  4189,  4195,  4201,  4210,  4219,  4228,
    4237,  4244,  4254,  4256,  4257,  4260,  4261,  4269,  4276,  4283,
    4290,  4297,  4304,  4312,  4322,  4332,  4339,  4348,  4357,  4366,
    4375,  4384,  4391,  4400,  4407,  4416,  4424,  4434,  4442,  4452,
    4459,  4467,  4474,  4481,  4488,  4495,  4502,  4510,  4518,  4526,
    4536,  4546,  4553,  4560,  4567,  4576,  4585,  4594,  4601,  4609,
    4623,  4625,  4627,  4631,  4635,  4637,  4639,  4641,  4643,  4645,
    4647,  4649,  4650,  4652,  4654,  4656,  4658,  4660,  4662,  4663,
    4670,  4679,  4683,  4686,  4687,  4690,  4693,  4696,  4699,  4703,
    4707,  4710,  4713,  4716,  4719,  4723,  4726,  4732,  4737,  4741,
    4745,  4749,  4751,  4753,  4754,  4758,  4761,  4764,  4766,  4769,
    4771,  4775,  4778,  4780,  4781,  4791,  4803,  4815,  4829,  4833,
    4838,  4843,  4844,  4847,  4853,  4856,  4857,  4861,  4865,  4869,
    4873,  4877,  4881,  4885,  4889,  4893,  4897,  4901,  4905,  4909,
    4914,  4918,  4922,  4924,  4925,  4931,  4938,  4943,  4946,  4947,
    4952,  4956,  4962,  4969,  4974,  4981,  4988,  4994,  5002,  5012,
    5019,  5021,  5022,  5029,  5041,  5053,  5065,  5079,  5089,  5101,
    5112,  5117,  5120,  5126,  5129,  5130,  5135,  5141,  5147,  5152,
    5159,  5161,  5165,  5167,  5169,  5171,  5173,  5176,  5181,  5183,
    5185,  5187,  5188,  5190,  5191,  5193,  5194,  5198,  5199,  5202,
    5207,  5211,  5217,  5219,  5221,  5223,  5225,  5227,  5229,  5231,
    5233,  5235,  5237,  5241,  5244,  5246,  5248,  5250,  5252,  5253,
    5259,  5263,  5264,  5266,  5268,  5270,  5272,  5276,  5286,  5290,
    5291,  5294,  5298,  5301,  5305,  5312,  5314,  5319,  5322,  5324,
    5328,  5331,  5334,  5335,  5343,  5346,  5347,  5353,  5357,  5358,
    5361,  5364,  5367,  5371,  5373,  5377,  5379,  5382,  5384,  5385,
    5394,  5396,  5400,  5402,  5404,  5408,  5414,  5417,  5419,  5423,
    5431,  5433,  5434,  5438,  5441,  5444,  5447,  5448,  5451,  5454,
    5456,  5458,  5462,  5466,  5468,  5471,  5476,  5481,  5484,  5488,
    5494,  5500,  5502,  5504,  5514,  5516,  5519,  5524,  5529,  5534,
    5537,  5541,  5543,  5547,  5554,  5556,  5557,  5560,  5561,  5565,
    5569,  5574,  5579,  5584,  5589,  5593,  5596,  5598,  5600,  5601,
    5603,  5605,  5606,  5608,  5614,  5616,  5617,  5619,  5620,  5624,
    5626,  5630,  5635,  5639,  5642,  5645,  5647,  5649,  5651,  5652,
    5655,  5660,  5666,  5669,  5673,  5675,  5677,  5679,  5681,  5685,
    5686,  5688,  5690,  5692,  5694,  5696,  5700,  5701,  5704,  5705,
    5707,  5711,  5713,  5714,  5716,  5719,  5723,  5726,  5731,  5734,
    5738,  5741,  5742,  5745,  5749,  5752,  5753,  5755,  5759,  5762,
    5765,  5769,  5772,  5776,  5778,  5783,  5787,  5792,  5798,  5803,
    5809,  5814,  5820,  5823,  5828,  5830,  5832,  5833,  5835,  5840,
    5846,  5851,  5852,  5855,  5858,  5861,  5863,  5865,  5866,  5871,
    5874,  5876,  5879,  5882,  5887,  5889,  5893,  5895,  5898,  5902,
    5904,  5907,  5908,  5911,  5916,  5917,  5919,  5920,  5922,  5926,
    5930,  5933,  5937,  5943,  5950,  5953,  5957,  5961,  5966,  5967,
    5969,  5971,  5973,  5975,  5977,  5980,  5986,  5988,  5990,  5992,
    5994,  5997,  6001,  6005,  6006,  6008,  6010,  6012,  6014,  6016,
    6019,  6022,  6025,  6028,  6031,  6033,  6037,  6038,  6040,  6042,
    6044,  6046,  6052,  6055,  6057,  6059,  6061,  6063,  6069,  6072,
    6075,  6078,  6080,  6084,  6088,  6091,  6093,  6094,  6098,  6099,
    6105,  6108,  6114,  6117,  6119,  6122,  6126,  6127,  6129,  6131,
    6133,  6135,  6137,  6139,  6143,  6147,  6151,  6155,  6159,  6163,
    6167,  6168,  6170,  6175,  6177,  6181,  6185,  6191,  6194,  6197,
    6201,  6205,  6209,  6213,  6217,  6221,  6225,  6229,  6233,  6237,
    6240,  6243,  6247,  6251,  6254,  6258,  6264,  6269,  6276,  6280,
    6286,  6291,  6298,  6303,  6310,  6316,  6324,  6328,  6331,  6336,
    6339,  6343,  6347,  6352,  6356,  6361,  6365,  6370,  6376,  6383,
    6390,  6398,  6405,  6413,  6420,  6428,  6432,  6437,  6442,  6449,
    6452,  6456,  6461,  6463,  6467,  6470,  6473,  6477,  6481,  6485,
    6489,  6493,  6497,  6501,  6505,  6509,  6513,  6516,  6519,  6525,
    6532,  6539,  6547,  6551,  6556,  6558,  6560,  6563,  6568,  6570,
    6572,  6574,  6577,  6580,  6583,  6586,  6588,  6593,  6599,  6606,
    6615,  6622,  6630,  6638,  6644,  6650,  6652,  6654,  6659,  6661,
    6666,  6668,  6673,  6675,  6680,  6682,  6684,  6686,  6688,  6690,
    6692,  6699,  6704,  6709,  6714,  6719,  6726,  6732,  6738,  6744,
    6749,  6756,  6761,  6766,  6771,  6776,  6782,  6790,  6798,  6808,
    6814,  6819,  6826,  6832,  6840,  6848,  6856,  6859,  6863,  6867,
    6871,  6876,  6877,  6882,  6884,  6888,  6892,  6894,  6896,  6898,
    6901,  6904,  6905,  6908,  6913,  6918,  6925,  6928,  6929,  6931,
    6935,  6939,  6942,  6945,  6946,  6953,  6955,  6956,  6960,  6961,
    6964,  6967,  6968,  6970,  6975,  6978,  6981,  6984,  6987,  6990,
    6995,  6999,  7005,  7007,  7009,  7011,  7013,  7015,  7017,  7019,
    7021,  7023,  7025,  7027,  7029,  7031,  7033,  7035,  7040,  7042,
    7047,  7049,  7054,  7056,  7059,  7061,  7064,  7066,  7070,  7072,
    7076,  7078,  7082,  7084,  7088,  7092,  7096,  7099,  7101,  7105,
    7109,  7110,  7112,  7114,  7116,  7118,  7120,  7122,  7124,  7126,
    7131,  7135,  7138,  7142,  7143,  7147,  7151,  7154,  7157,  7159,
    7160,  7163,  7166,  7170,  7173,  7175,  7177,  7181,  7187,  7189,
    7192,  7197,  7200,  7201,  7203,  7204,  7206,  7209,  7212,  7215,
    7219,  7225,  7227,  7230,  7231,  7234,  7236,  7237,  7239,  7241,
    7243,  7247,  7251,  7253,  7257,  7261,  7264,  7266,  7268,  7270,
    7274,  7276,  7279,  7281,  7285,  7287,  7289,  7291,  7293,  7295,
    7297,  7299,  7302,  7304,  7306,  7308,  7310,  7312,  7315,  7321,
    7324,  7328,  7335,  7337,  7339,  7341,  7343,  7345,  7347,  7349,
    7353,  7355,  7358,  7361,  7363,  7365,  7367,  7369,  7371,  7373,
    7375,  7377,  7379,  7381,  7383,  7385,  7387,  7389,  7391,  7393,
    7395,  7397,  7399,  7401,  7403,  7405,  7407,  7409,  7411,  7413,
    7415,  7417,  7419,  7421,  7423,  7425,  7427,  7429,  7431,  7433,
    7435,  7437,  7439,  7441,  7443,  7445,  7447,  7449,  7451,  7453,
    7455,  7457,  7459,  7461,  7463,  7465,  7467,  7469,  7471,  7473,
    7475,  7477,  7479,  7481,  7483,  7485,  7487,  7489,  7491,  7493,
    7495,  7497,  7499,  7501,  7503,  7505,  7507,  7509,  7511,  7513,
    7515,  7517,  7519,  7521,  7523,  7525,  7527,  7529,  7531,  7533,
    7535,  7537,  7539,  7541,  7543,  7545,  7547,  7549,  7551,  7553,
    7555,  7557,  7559,  7561,  7563,  7565,  7567,  7569,  7571,  7573,
    7575,  7577,  7579,  7581,  7583,  7585,  7587,  7589,  7591,  7593,
    7595,  7597,  7599,  7601,  7603,  7605,  7607,  7609,  7611,  7613,
    7615,  7617,  7619,  7621,  7623,  7625,  7627,  7629,  7631,  7633,
    7635,  7637,  7639,  7641,  7643,  7645,  7647,  7649,  7651,  7653,
    7655,  7657,  7659,  7661,  7663,  7665,  7667,  7669,  7671,  7673,
    7675,  7677,  7679,  7681,  7683,  7685,  7687,  7689,  7691,  7693,
    7695,  7697,  7699,  7701,  7703,  7705,  7707,  7709,  7711,  7713,
    7715,  7717,  7719,  7721,  7723,  7725,  7727,  7729,  7731,  7733,
    7735,  7737,  7739,  7741,  7743,  7745,  7747,  7749,  7751,  7753,
    7755,  7757,  7759,  7761,  7763,  7765,  7767,  7769,  7771,  7773,
    7775,  7777,  7779,  7781,  7783,  7785,  7787,  7789,  7791,  7793,
    7795,  7797,  7799,  7801,  7803,  7805,  7807,  7809,  7811,  7813,
    7815,  7817,  7819,  7821,  7823,  7825,  7827,  7829,  7831,  7833,
    7835,  7837,  7839,  7841,  7843,  7845,  7847,  7849,  7851,  7853,
    7855,  7857,  7859,  7861,  7863,  7865,  7867,  7869,  7871,  7873,
    7875,  7877,  7879,  7881,  7883,  7885,  7887,  7889,  7891,  7893,
    7895,  7897,  7899,  7901,  7903,  7905,  7907,  7909,  7911,  7913,
    7915,  7917,  7919,  7921,  7923,  7925,  7927,  7929,  7931,  7933,
    7935,  7937,  7939,  7941,  7943,  7945,  7947,  7949,  7951,  7953,
    7955,  7957,  7959,  7961,  7963,  7965,  7967,  7969,  7971,  7973,
    7975,  7977,  7979,  7981,  7983,  7985,  7987,  7989,  7991,  7993,
    7995,  7997,  7999,  8001,  8003,  8005,  8007,  8009,  8011,  8013,
    8015,  8017,  8019,  8021,  8023,  8025,  8027,  8029,  8031,  8033,
    8035,  8037,  8039,  8041,  8043,  8045,  8047,  8049,  8051,  8053,
    8055,  8057,  8059,  8061,  8063,  8065,  8067,  8069,  8071,  8073,
    8075,  8077,  8079,  8081,  8083,  8085,  8087,  8089,  8091,  8093,
    8095,  8097,  8099,  8101,  8103,  8105,  8107,  8109,  8111,  8113,
    8115,  8117,  8119,  8121,  8123,  8125,  8127,  8129,  8131,  8133,
    8135,  8137,  8139,  8141,  8143,  8145,  8147,  8149,  8151,  8153,
    8155,  8157,  8159,  8161,  8163,  8165,  8167,  8169,  8171,  8173,
    8175,  8177,  8179,  8181,  8183,  8185,  8187,  8189,  8191
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     438,     0,    -1,   439,    -1,   439,   434,   440,    -1,   440,
      -1,   628,    -1,   775,    -1,   776,    -1,   693,    -1,   781,
      -1,   643,    -1,   580,    -1,   583,    -1,   589,    -1,   603,
      -1,   605,    -1,   728,    -1,   456,    -1,   749,    -1,   750,
      -1,   559,    -1,   483,    -1,   494,    -1,   450,    -1,   448,
      -1,   784,    -1,   783,    -1,   609,    -1,   452,    -1,   451,
      -1,   791,    -1,   481,    -1,   497,    -1,   786,    -1,   667,
      -1,   478,    -1,   498,    -1,   551,    -1,   630,    -1,   739,
      -1,   785,    -1,   780,    -1,   577,    -1,   584,    -1,   598,
      -1,   604,    -1,   709,    -1,   455,    -1,   554,    -1,   645,
      -1,   652,    -1,   653,    -1,   566,    -1,   459,    -1,   558,
      -1,   514,    -1,   574,    -1,   610,    -1,   624,    -1,   441,
      -1,   447,    -1,   606,    -1,   771,    -1,   808,    -1,   827,
      -1,   632,    -1,   814,    -1,   482,    -1,   736,    -1,   631,
      -1,   741,    -1,   588,    -1,   602,    -1,   458,    -1,   656,
      -1,   657,    -1,   658,    -1,   572,    -1,   758,    -1,   660,
      -1,   576,    -1,   623,    -1,   453,    -1,   454,    -1,   608,
      -1,   779,    -1,   806,    -1,   797,    -1,   674,    -1,   678,
      -1,   689,    -1,   698,    -1,   809,    -1,   761,    -1,   557,
      -1,   770,    -1,   816,    -1,   759,    -1,   803,    -1,   659,
      -1,   743,    -1,   732,    -1,   731,    -1,   733,    -1,   746,
      -1,   679,    -1,   690,    -1,   751,    -1,   670,    -1,   831,
      -1,   763,    -1,   665,    -1,   762,    -1,   820,    -1,   788,
      -1,   474,    -1,   463,    -1,   477,    -1,   768,    -1,    -1,
      83,   306,   984,   442,   443,    -1,   397,    -1,    -1,   443,
     446,    -1,    -1,   444,   445,    -1,    -1,   267,   983,    -1,
     267,   240,    -1,   125,   267,   983,    -1,   370,   267,   983,
      -1,   176,    -1,    75,   210,   986,    -1,   381,   376,   983,
      -1,   378,   985,    -1,     3,    -1,   445,    -1,   345,   982,
      -1,    19,   985,    -1,   306,   985,    -1,   171,   306,   985,
      -1,   171,   159,   985,    -1,    83,   378,   984,   442,   443,
      -1,    24,   306,   984,   442,   444,    -1,    -1,   171,    97,
     975,    -1,    24,   306,   984,   449,   475,    -1,    24,   306,
      22,   449,   475,    -1,    24,   378,   984,   442,   444,    -1,
      24,   378,   984,   475,    -1,   120,   306,   985,    -1,   120,
     306,   166,   135,   985,    -1,   120,   378,   985,    -1,   120,
     378,   166,   135,   985,    -1,    83,   159,   984,   442,   443,
      -1,    24,   159,   984,   457,   378,   985,    -1,    18,    -1,
     120,    -1,   120,   159,   985,    -1,   120,   159,   166,   135,
     985,    -1,    83,   312,   460,    38,   984,   461,    -1,    83,
     312,   987,   461,    -1,    83,   312,   166,   235,   135,   460,
      38,   984,   461,    -1,    83,   312,   166,   235,   135,   987,
     461,    -1,   987,    -1,    -1,   461,   462,    -1,    -1,   514,
      -1,   698,    -1,   558,    -1,   610,    -1,   678,    -1,   768,
      -1,   324,   464,    -1,   324,   213,   464,    -1,   324,   322,
     464,    -1,   359,   766,    -1,   322,    59,    31,   359,   766,
      -1,   465,    -1,   466,   357,   467,    -1,   466,   418,   467,
      -1,   466,   357,   103,    -1,   466,   418,   103,    -1,   466,
     151,    86,    -1,   355,   414,   471,    -1,    55,   983,    -1,
     312,   983,    -1,   228,   472,    -1,   306,   473,    -1,   322,
      38,   473,    -1,   322,    38,   103,    -1,   402,   252,   920,
      -1,   359,   331,   983,    -1,   987,    -1,   466,   433,   987,
      -1,   468,    -1,   467,   435,   468,    -1,   470,    -1,   564,
      -1,   284,   369,    -1,   284,    72,    -1,   296,   284,    -1,
     320,    -1,   363,    -1,   140,    -1,   249,    -1,   473,    -1,
     983,    -1,     3,    -1,   907,   983,   909,    -1,   907,   431,
     982,   432,   983,   909,    -1,   564,    -1,   103,    -1,   213,
      -1,   983,    -1,   103,    -1,    -1,   989,    -1,   983,    -1,
     299,   466,    -1,   299,   355,   414,    -1,   299,   359,   194,
     208,    -1,   299,   322,    38,    -1,   299,    22,    -1,   324,
     464,    -1,   474,    -1,   324,   465,    -1,   474,    -1,   327,
     466,    -1,   327,   355,   414,    -1,   327,   359,   194,   208,
      -1,   327,   322,    38,    -1,   327,    22,    -1,   324,    77,
     479,   480,    -1,    22,    -1,   971,    -1,   106,    -1,   168,
      -1,    61,    -1,   114,    22,    -1,   114,   350,    -1,   114,
     352,    -1,   114,   269,    -1,    24,   347,   878,   484,    -1,
      24,   347,   166,   135,   878,   484,    -1,    24,   174,   972,
     484,    -1,    24,   174,   166,   135,   972,   484,    -1,    24,
     318,   972,   484,    -1,    24,   318,   166,   135,   972,   484,
      -1,    24,   391,   972,   484,    -1,    24,   391,   166,   135,
     972,   484,    -1,    24,   220,   391,   972,   484,    -1,    24,
     220,   391,   166,   135,   972,   484,    -1,   485,    -1,   484,
     435,   485,    -1,    18,   522,    -1,    18,    68,   522,    -1,
      24,   747,   987,   486,    -1,    24,   747,   987,   120,   235,
     240,    -1,    24,   747,   987,   324,   235,   240,    -1,    24,
     747,   987,   324,   337,   986,    -1,    24,   747,   987,   324,
     490,    -1,    24,   747,   987,   299,   490,    -1,    24,   747,
     987,   324,   340,   987,    -1,   120,   747,   166,   135,   987,
     487,    -1,   120,   747,   987,   487,    -1,    24,   747,   987,
     748,   366,   887,   488,   489,    -1,    24,   747,   987,   592,
      -1,    18,   531,    -1,   382,    76,   974,    -1,   120,    76,
     166,   135,   974,   487,    -1,   120,    76,   974,   487,    -1,
     324,   397,   248,    -1,   324,   398,   248,    -1,    64,   249,
     974,    -1,   324,   398,    64,    -1,   123,   361,   974,    -1,
     123,    25,   361,   974,    -1,   123,   298,   361,   974,    -1,
     123,   361,    22,    -1,   123,   361,   378,    -1,   113,   361,
     974,    -1,   113,   361,    22,    -1,   113,   361,   378,    -1,
     123,   310,   974,    -1,   123,    25,   310,   974,    -1,   123,
     298,   310,   974,    -1,   113,   310,   974,    -1,   176,   972,
      -1,   233,   176,   972,    -1,   245,   663,    -1,   235,   245,
      -1,   262,   357,   984,    -1,   324,   349,   974,    -1,   324,
     490,    -1,   299,   490,    -1,   592,    -1,   324,   103,   911,
      -1,   120,   103,    -1,    51,    -1,   301,    -1,    -1,    66,
     663,    -1,    -1,   379,   911,    -1,    -1,   431,   492,   432,
      -1,   397,   490,    -1,    -1,   493,    -1,   492,   435,   493,
      -1,   990,   418,   636,    -1,   990,    -1,   990,   433,   990,
     418,   636,    -1,   990,   433,   990,    -1,    24,   366,   663,
     495,    -1,   496,    -1,   495,   435,   496,    -1,    18,    37,
     886,   487,    -1,   120,    37,   166,   135,   987,   487,    -1,
     120,    37,   987,   487,    -1,    24,    37,   987,   748,   366,
     887,   488,   487,    -1,    63,   828,    -1,    63,    22,    -1,
      81,   505,   972,   534,   506,   499,   500,   501,   507,   442,
     502,    -1,    81,   832,   357,   500,   501,   442,   502,    -1,
     151,    -1,   357,    -1,   281,    -1,    -1,   983,    -1,   338,
      -1,   339,    -1,   503,    -1,   431,   509,   432,    -1,   503,
     504,    -1,    -1,    44,    -1,   248,    -1,   150,    -1,   109,
     782,   983,    -1,   240,   782,   983,    -1,    85,    -1,   162,
      -1,   282,   782,   983,    -1,   128,   782,   983,    -1,   147,
     282,   535,    -1,   147,   282,   424,    -1,   147,   235,   240,
     535,    -1,   124,   983,    -1,    44,    -1,    -1,   397,   248,
      -1,    -1,   508,   110,   983,    -1,    -1,   379,    -1,    -1,
     510,    -1,   509,   435,   510,    -1,   990,   511,    -1,   470,
      -1,   564,    -1,   424,    -1,   431,   512,   432,    -1,    -1,
     513,    -1,   512,   435,   513,    -1,   470,    -1,    83,   515,
     347,   972,   431,   516,   432,   545,   546,   547,   548,    -1,
      83,   515,   347,   166,   235,   135,   972,   431,   516,   432,
     545,   546,   547,   548,    -1,    83,   515,   347,   972,   245,
     663,   517,   546,   547,   548,    -1,    83,   515,   347,   166,
     235,   135,   972,   245,   663,   517,   546,   547,   548,    -1,
     352,    -1,   350,    -1,   213,   352,    -1,   213,   350,    -1,
     155,   352,    -1,   155,   350,    -1,   375,    -1,    -1,   518,
      -1,    -1,   431,   519,   432,    -1,    -1,   520,    -1,   518,
     435,   520,    -1,   521,    -1,   519,   435,   521,    -1,   522,
      -1,   528,    -1,   531,    -1,   523,    -1,   531,    -1,   987,
     887,   590,   524,    -1,   987,   397,   253,   524,    -1,   524,
     525,    -1,    -1,    76,   974,   526,    -1,   526,    -1,   527,
      -1,    66,   663,    -1,   235,   240,    -1,   240,    -1,   372,
     725,   549,    -1,   276,   196,   725,   549,    -1,    60,   431,
     911,   432,   533,    -1,   103,   912,    -1,   290,   972,   534,
     537,   541,    -1,   105,    -1,   235,   105,    -1,   178,   106,
      -1,   178,   168,    -1,   209,   972,   529,    -1,   529,   172,
     530,    -1,   529,   132,   530,    -1,    -1,   104,    -1,    77,
      -1,   175,    -1,   340,    -1,    70,    -1,    22,    -1,    76,
     974,   532,    -1,   532,    -1,    60,   431,   911,   432,   621,
      -1,   372,   431,   535,   432,   725,   549,   621,    -1,   372,
     550,   621,    -1,   276,   196,   431,   535,   432,   725,   549,
     621,    -1,   276,   196,   550,   621,    -1,   131,   702,   431,
     538,   432,   725,   549,   540,   621,    -1,   148,   196,   431,
     535,   432,   290,   972,   534,   537,   541,   621,    -1,   233,
     176,    -1,    -1,   431,   535,   432,    -1,    -1,   536,    -1,
     535,   435,   536,    -1,   987,    -1,   219,   152,    -1,   219,
     264,    -1,   219,   329,    -1,    -1,   539,    -1,   538,   435,
     539,    -1,   704,   397,   735,    -1,   704,   397,   251,   431,
     735,   432,    -1,   394,   431,   911,   432,    -1,    -1,   542,
      -1,   543,    -1,   542,   543,    -1,   543,   542,    -1,    -1,
     249,   377,   544,    -1,   249,   108,   544,    -1,   233,    17,
      -1,   301,    -1,    51,    -1,   324,   240,    -1,   324,   103,
      -1,   177,   431,   971,   432,    -1,    -1,   397,   490,    -1,
     397,   248,    -1,   398,   248,    -1,    -1,   249,    71,   120,
      -1,   249,    71,   108,   309,    -1,   249,    71,   273,   309,
      -1,    -1,   349,   974,    -1,    -1,   379,   174,   349,   974,
      -1,    -1,   379,   174,   978,    -1,    83,   515,   347,   552,
      31,   831,   553,    -1,   972,   534,   546,   547,   548,    -1,
     397,    96,    -1,   397,   233,    96,    -1,    -1,    83,   556,
     220,   391,   555,    31,   831,   553,    -1,   972,   534,   491,
     548,    -1,   375,    -1,    -1,   291,   220,   391,   972,   553,
      -1,    83,   515,   318,   972,   560,    -1,    24,   318,   972,
     561,    -1,    24,   318,   166,   135,   972,   561,    -1,   561,
      -1,    -1,   562,    -1,   561,   562,    -1,    49,   564,    -1,
      95,    -1,   233,    95,    -1,   173,   563,   564,    -1,   221,
     564,    -1,   223,   564,    -1,   233,   221,    -1,   233,   223,
      -1,   261,    48,   663,    -1,   335,   442,   564,    -1,   300,
      -1,   300,   442,   564,    -1,    48,    -1,    -1,     4,    -1,
     423,     4,    -1,   986,    -1,   564,    -1,   565,   435,   564,
      -1,    83,   710,   567,   573,   198,   473,    -1,    83,   710,
     567,   573,   198,   473,   160,   568,   569,   571,    -1,   365,
      -1,    -1,   974,    -1,   974,   664,    -1,   179,   568,    -1,
      -1,   383,   568,    -1,   233,   383,    -1,   570,    -1,    -1,
     120,   573,   198,   473,   487,    -1,   120,   573,   198,   166,
     135,   473,   487,    -1,   279,    -1,    -1,    83,   349,   974,
     575,   216,   983,    -1,   262,   974,    -1,    -1,   120,   349,
     974,    -1,   120,   349,   166,   135,   974,    -1,    83,   137,
     974,   442,   578,    -1,    83,   137,   166,   235,   135,   974,
     442,   578,    -1,   578,   579,    -1,    -1,   312,   974,    -1,
     390,   473,    -1,   151,   473,    -1,    24,   137,   974,   377,
     581,    -1,   581,   582,    -1,    -1,   357,   473,    -1,    24,
     137,   974,   457,    21,   980,   637,    -1,    24,   137,   974,
     457,    54,   431,   887,    31,   887,   432,    -1,    24,   137,
     974,   457,    67,   663,    -1,    24,   137,   974,   457,    80,
     663,    -1,    24,   137,   974,   457,   118,   663,    -1,    24,
     137,   974,   457,   153,   688,    -1,    24,   137,   974,   457,
     573,   198,   974,    -1,    24,   137,   974,   457,   251,   735,
     734,    -1,    24,   137,   974,   457,   251,    62,   663,   379,
     976,    -1,    24,   137,   974,   457,   251,   141,   663,   379,
     976,    -1,    24,   137,   974,   457,   312,   974,    -1,    24,
     137,   974,   457,   129,   361,   974,    -1,    24,   137,   974,
     457,   347,   663,    -1,    24,   137,   974,   457,   353,   314,
     263,   663,    -1,    24,   137,   974,   457,   353,   314,   112,
     663,    -1,    24,   137,   974,   457,   353,   314,   351,   663,
      -1,    24,   137,   974,   457,   353,   314,    74,   663,    -1,
      24,   137,   974,   457,   318,   663,    -1,    24,   137,   974,
     457,   391,   663,    -1,    24,   137,   974,   457,   220,   391,
     663,    -1,    24,   137,   974,   457,   148,   347,   663,    -1,
      24,   137,   974,   457,   148,    96,   400,   974,    -1,    24,
     137,   974,   457,   321,   974,    -1,    24,   137,   974,   457,
     366,   663,    -1,    83,   148,    96,   400,   974,   587,   590,
      -1,   160,   568,    -1,   233,   160,    -1,   383,   568,    -1,
     233,   383,    -1,   585,    -1,   586,   585,    -1,   586,    -1,
      -1,   120,   148,    96,   400,   974,   487,    -1,   120,   148,
      96,   400,   166,   135,   974,   487,    -1,    24,   148,    96,
     400,   974,   587,   592,    -1,    24,   148,    96,   400,   974,
     586,    -1,   253,   431,   591,   432,    -1,    -1,   595,    -1,
     591,   435,   595,    -1,   253,   431,   593,   432,    -1,   594,
      -1,   593,   435,   594,    -1,   595,    -1,   324,   595,    -1,
      18,   595,    -1,   120,   596,    -1,   596,   597,    -1,   990,
      -1,   983,    -1,    83,   321,   974,   599,   601,   148,    96,
     400,   974,   590,    -1,   366,   983,    -1,    -1,   390,   983,
      -1,   390,   240,    -1,   600,    -1,    -1,   120,   321,   974,
     487,    -1,   120,   321,   166,   135,   974,   487,    -1,    24,
     321,   974,   600,   592,    -1,    24,   321,   974,   600,    -1,
      24,   321,   974,   592,    -1,    83,   148,   347,   972,   431,
     516,   432,   321,   974,   590,    -1,    83,   148,   347,   166,
     235,   135,   972,   431,   516,   432,   321,   974,   590,    -1,
      24,   148,   347,   878,   484,    -1,    24,   148,   347,   166,
     135,   878,   484,    -1,    83,   378,   218,   146,   607,   321,
     974,   590,    -1,    93,    -1,   378,    -1,   984,    -1,   120,
     378,   218,   146,   607,   321,   974,    -1,   120,   378,   218,
     166,   135,   146,   607,   321,   974,    -1,    24,   378,   218,
     146,   607,   321,   974,   592,    -1,    83,   361,   974,   611,
     612,   249,   972,   614,   617,   134,   280,   980,   431,   618,
     432,    -1,    83,    76,   361,   974,    20,   612,   249,   972,
     620,   621,   146,   121,   308,   617,   134,   280,   980,   431,
     618,   432,    -1,    40,    -1,    20,    -1,   185,   245,    -1,
     613,    -1,   612,   254,   613,    -1,   184,    -1,   108,    -1,
     377,    -1,   377,   245,   535,    -1,   364,    -1,   146,   615,
     616,    -1,    -1,   121,    -1,    -1,   308,    -1,   336,    -1,
     393,   431,   911,   432,    -1,    -1,   619,    -1,   618,   435,
     619,    -1,    -1,   982,    -1,     4,    -1,   983,    -1,   990,
      -1,   151,   972,    -1,    -1,    -1,   621,   622,    -1,   235,
     105,    -1,   105,    -1,   178,   168,    -1,   178,   106,    -1,
     235,   381,    -1,   233,   176,    -1,   120,   361,   974,   249,
     663,   487,    -1,   120,   361,   166,   135,   974,   249,   663,
     487,    -1,    83,   129,   361,   974,   249,   990,   134,   280,
     980,   431,   432,    -1,    83,   129,   361,   974,   249,   990,
     393,   625,   134,   280,   980,   431,   432,    -1,   626,    -1,
     625,    28,   626,    -1,   987,   171,   431,   627,   432,    -1,
       5,    -1,   627,   435,     5,    -1,    24,   129,   361,   974,
     629,    -1,   123,    -1,   123,   298,    -1,   123,    25,    -1,
     113,    -1,    83,    33,   974,    60,   431,   911,   432,   621,
      -1,   120,    33,   974,   487,    -1,    83,    21,   980,   637,
     633,    -1,    83,    21,   980,   638,    -1,    83,   251,   735,
     633,    -1,    83,   366,   663,   633,    -1,    83,   366,   663,
      -1,    83,   366,   663,    31,   431,   884,   432,    -1,    83,
     366,   663,    31,   127,   431,   641,   432,    -1,    83,   366,
     663,    31,   283,   633,    -1,    83,   353,   314,   263,   663,
     633,    -1,    83,   353,   314,   112,   663,   633,    -1,    83,
     353,   314,   351,   663,   633,    -1,    83,   353,   314,    74,
     663,   633,    -1,    83,    67,   663,   633,    -1,    83,    67,
     663,   151,   663,    -1,   431,   634,   432,    -1,   635,    -1,
     634,   435,   635,    -1,   990,   418,   636,    -1,   990,    -1,
     719,    -1,   994,    -1,   938,    -1,   564,    -1,   983,    -1,
     431,   943,   432,    -1,   431,   424,   432,    -1,   431,   639,
     432,    -1,   640,    -1,   639,   435,   640,    -1,     3,   418,
     636,    -1,   642,    -1,    -1,   983,    -1,   642,   435,   983,
      -1,    24,   366,   663,    18,   384,   644,   983,    -1,    24,
     366,   663,    18,   384,   644,   983,    40,   983,    -1,    24,
     366,   663,    18,   384,   644,   983,    20,   983,    -1,   166,
     235,   135,    -1,    -1,    83,   251,    62,   663,   648,   146,
     366,   887,   379,   976,   649,    31,   646,    -1,   647,    -1,
     646,   435,   647,    -1,   251,   982,   735,   650,   651,    -1,
     251,   982,   735,   734,   650,   651,    -1,   153,   982,   980,
     711,    -1,   153,   982,   431,   943,   432,   980,   711,    -1,
     340,   887,    -1,   103,    -1,    -1,   141,   663,    -1,    -1,
     146,   314,    -1,   146,   255,    48,   663,    -1,    -1,   287,
      -1,    -1,    83,   251,   141,   663,   379,   976,    -1,    24,
     251,   141,   663,   379,   976,    18,   646,    -1,    24,   251,
     141,   663,   379,   976,   120,   654,    -1,   655,    -1,   654,
     435,   655,    -1,   251,   982,   431,   943,   432,    -1,   153,
     982,   431,   943,   432,    -1,   120,   251,    62,   663,   379,
     976,   487,    -1,   120,   251,    62,   166,   135,   663,   379,
     976,   487,    -1,   120,   251,   141,   663,   379,   976,   487,
      -1,   120,   251,   141,   166,   135,   663,   379,   976,   487,
      -1,   120,   261,    48,   985,   487,    -1,   286,   261,    48,
     985,   357,   974,    -1,   120,   661,   166,   135,   662,   487,
      -1,   120,   661,   662,   487,    -1,   120,   174,    73,   662,
     487,    -1,   120,   174,    73,   166,   135,   662,   487,    -1,
     347,    -1,   318,    -1,   391,    -1,   220,   391,    -1,   174,
      -1,   148,   347,    -1,   129,   361,    -1,   366,    -1,   118,
      -1,    67,    -1,    80,    -1,   312,    -1,   137,    -1,   353,
     314,   263,    -1,   353,   314,   112,    -1,   353,   314,   351,
      -1,   353,   314,    74,    -1,   663,    -1,   662,   435,   663,
      -1,   987,    -1,   987,   664,    -1,   433,   977,    -1,   664,
     433,   977,    -1,   364,   842,   879,   666,   487,    -1,    79,
     165,    -1,   300,   165,    -1,    -1,    69,   249,   668,   663,
     192,   669,    -1,    69,   249,    21,   980,   637,   192,   669,
      -1,    69,   249,   153,   980,   711,   192,   669,    -1,    69,
     249,   251,   735,   734,   192,   669,    -1,    69,   249,    76,
     974,   249,   663,   192,   669,    -1,    69,   249,   310,   974,
     249,   663,   192,   669,    -1,    69,   249,   310,   974,   192,
     669,    -1,    69,   249,   361,   974,   249,   663,   192,   669,
      -1,    69,   249,   251,    62,   663,   379,   976,   192,   669,
      -1,    69,   249,   251,   141,   663,   379,   976,   192,   669,
      -1,    69,   249,   199,   244,   564,   192,   669,    -1,    69,
     249,    54,   431,   887,    31,   887,   432,   192,   669,    -1,
      69,   249,   573,   198,   663,   192,   669,    -1,    68,    -1,
      97,    -1,   312,    -1,   174,    -1,   318,    -1,   347,    -1,
     118,    -1,   366,    -1,   391,    -1,   220,   391,    -1,    67,
      -1,    80,    -1,   349,    -1,   137,    -1,   306,    -1,   148,
     347,    -1,   321,    -1,   148,    96,   400,    -1,   129,   361,
      -1,   353,   314,    74,    -1,   353,   314,   112,    -1,   353,
     314,   263,    -1,   353,   314,   351,    -1,   983,    -1,   240,
      -1,   316,   197,   671,   249,   672,   663,   192,   673,    -1,
     316,   197,   671,   249,    21,   980,   637,   192,   673,    -1,
     316,   197,   671,   249,   153,   980,   711,   192,   673,    -1,
     316,   197,   671,   249,   199,   244,   564,   192,   673,    -1,
     316,   197,   671,   249,   573,   198,   663,   192,   673,    -1,
     146,   473,    -1,    -1,    68,    -1,    97,    -1,   129,   361,
      -1,   148,   347,    -1,   312,    -1,   318,    -1,   347,    -1,
     118,    -1,   306,    -1,   349,    -1,   366,    -1,   391,    -1,
     220,   391,    -1,   983,    -1,   240,    -1,   142,   675,    -1,
     226,   675,    -1,   828,    -1,   676,   828,    -1,   232,   677,
     828,    -1,   277,   677,   828,    -1,   143,   677,   828,    -1,
     200,   677,   828,    -1,    15,   986,   677,   828,    -1,   293,
     986,   677,   828,    -1,   986,   677,   828,    -1,    22,   677,
     828,    -1,   149,   677,   828,    -1,   149,   986,   677,   828,
      -1,   149,    22,   677,   828,    -1,    39,   677,   828,    -1,
      39,   986,   677,   828,    -1,    39,    22,   677,   828,    -1,
     151,    -1,   171,    -1,   676,    -1,    -1,   156,   680,   249,
     683,   357,   684,   686,    -1,   304,   680,   249,   683,   151,
     684,   487,    -1,   304,   156,   252,   146,   680,   249,   683,
     151,   684,   487,    -1,   681,    -1,    22,    -1,    22,   278,
      -1,    22,   431,   535,   432,    -1,    22,   278,   431,   535,
     432,    -1,   682,    -1,   681,   435,   682,    -1,   317,   534,
      -1,   290,   534,    -1,    83,   534,    -1,   987,   534,    -1,
     971,    -1,   347,   971,    -1,   318,   971,    -1,   148,    96,
     400,   973,    -1,   148,   321,   973,    -1,   153,   687,    -1,
      97,   973,    -1,   118,   662,    -1,   198,   973,    -1,   199,
     244,   565,    -1,   312,   973,    -1,   349,   973,    -1,   366,
     662,    -1,    22,   348,   171,   312,   973,    -1,    22,   319,
     171,   312,   973,    -1,    22,   154,   171,   312,   973,    -1,
     685,    -1,   684,   435,   685,    -1,   984,    -1,   159,   984,
      -1,   397,   156,   252,    -1,    -1,   688,    -1,   687,   435,
     688,    -1,   980,   711,    -1,   156,   681,   357,   985,   691,
     692,    -1,   304,   681,   151,   985,   692,   487,    -1,   304,
      19,   252,   146,   681,   151,   985,   692,   487,    -1,   397,
      19,   252,    -1,    -1,   157,    48,   984,    -1,    -1,    24,
     103,   278,   694,   696,    -1,   694,   695,    -1,    -1,   171,
     312,   973,    -1,   146,   306,   985,    -1,   146,   378,   985,
      -1,   156,   680,   249,   697,   357,   684,   686,    -1,   304,
     680,   249,   697,   151,   684,   487,    -1,   304,   156,   252,
     146,   680,   249,   697,   151,   684,   487,    -1,   348,    -1,
     154,    -1,   319,    -1,   367,    -1,    83,   699,   174,   700,
     701,   249,   972,   702,   431,   703,   432,   491,   548,   882,
      -1,   372,    -1,    -1,    73,    -1,    -1,   978,    -1,    -1,
     379,   976,    -1,    -1,   704,    -1,   703,   435,   704,    -1,
     987,   705,   706,   707,   708,    -1,   914,   705,   706,   707,
     708,    -1,   431,   911,   432,   705,   706,   707,   708,    -1,
      66,   663,    -1,    -1,   663,    -1,   379,   663,    -1,    -1,
      32,    -1,   111,    -1,    -1,   415,    -1,   416,    -1,    -1,
      83,   710,   153,   980,   713,   303,   718,   721,   725,    -1,
      83,   710,   153,   980,   713,   303,   347,   431,   727,   432,
     721,   725,    -1,    83,   710,   153,   980,   713,   721,   725,
      -1,   254,   297,    -1,    -1,   431,   712,   432,    -1,   431,
     432,    -1,   715,    -1,   712,   435,   715,    -1,   431,   714,
     432,    -1,   431,   432,    -1,   720,    -1,   714,   435,   720,
      -1,   716,   717,   719,    -1,   717,   716,   719,    -1,   717,
     719,    -1,   716,   719,    -1,   719,    -1,   171,    -1,   256,
      -1,   181,    -1,   171,   256,    -1,   387,    -1,   988,    -1,
     719,    -1,   887,    -1,   988,   664,   426,   366,    -1,   325,
     988,   664,   426,   366,    -1,   715,    -1,   715,   103,   911,
      -1,   715,   418,   911,    -1,   723,    -1,   721,   723,    -1,
      50,   249,   240,   182,    -1,   303,   240,   249,   240,   182,
      -1,   341,    -1,   169,    -1,   333,    -1,   392,    -1,   138,
     316,   107,    -1,   138,   316,   191,    -1,   316,   107,    -1,
     316,   191,    -1,   205,    -1,   235,   205,    -1,    82,   564,
      -1,   309,   564,    -1,   476,    -1,    31,   724,    -1,   198,
     473,    -1,   396,    -1,   722,    -1,   983,    -1,   983,   435,
     983,    -1,   397,   633,    -1,    -1,   717,   719,    -1,   726,
      -1,   727,   435,   726,    -1,    24,   153,   688,   729,   730,
      -1,   722,    -1,   729,   722,    -1,   301,    -1,    -1,   120,
     153,   980,   711,   487,    -1,   120,   153,   166,   135,   980,
     711,   487,    -1,   120,    21,   980,   637,   487,    -1,   120,
      21,   166,   135,   980,   637,   487,    -1,   120,   251,   735,
     734,   487,    -1,   120,   251,   166,   135,   735,   734,   487,
      -1,   431,   887,   432,    -1,   431,   887,   435,   887,   432,
      -1,   431,   234,   435,   887,   432,    -1,   431,   887,   435,
     234,   432,    -1,   935,    -1,   987,   433,   735,    -1,   116,
     737,    -1,   738,    -1,   737,   738,    -1,   983,    -1,   198,
     473,    -1,    83,    54,   431,   887,    31,   887,   432,   397,
     153,   688,   740,    -1,    83,    54,   431,   887,    31,   887,
     432,   398,   153,   740,    -1,    83,    54,   431,   887,    31,
     887,   432,   397,   181,   740,    -1,    31,   170,    -1,    31,
      34,    -1,    -1,   120,    54,   742,   431,   887,    31,   887,
     432,   487,    -1,   166,   135,    -1,    -1,   292,   744,   972,
     745,    -1,   292,   346,   974,   745,    -1,   292,    97,   974,
     745,    -1,   174,    -1,   347,    -1,   147,    -1,    -1,    24,
      21,   980,   637,   295,   357,   974,    -1,    24,    67,   663,
     295,   357,   974,    -1,    24,    80,   663,   295,   357,   974,
      -1,    24,    97,   975,   295,   357,   975,    -1,    24,   118,
     663,   295,   357,   974,    -1,    24,   118,   663,   295,    76,
     974,   357,   974,    -1,    24,   148,    96,   400,   974,   295,
     357,   974,    -1,    24,   153,   688,   295,   357,   974,    -1,
      24,   159,   984,   295,   357,   984,    -1,    24,   573,   198,
     974,   295,   357,   974,    -1,    24,   251,    62,   663,   379,
     976,   295,   357,   974,    -1,    24,   251,   141,   663,   379,
     976,   295,   357,   974,    -1,    24,   312,   974,   295,   357,
     974,    -1,    24,   321,   974,   295,   357,   974,    -1,    24,
     347,   878,   295,   357,   974,    -1,    24,   347,   166,   135,
     878,   295,   357,   974,    -1,    24,   318,   972,   295,   357,
     974,    -1,    24,   318,   166,   135,   972,   295,   357,   974,
      -1,    24,   391,   972,   295,   357,   974,    -1,    24,   391,
     166,   135,   972,   295,   357,   974,    -1,    24,   220,   391,
     972,   295,   357,   974,    -1,    24,   220,   391,   166,   135,
     972,   295,   357,   974,    -1,    24,   174,   972,   295,   357,
     974,    -1,    24,   174,   166,   135,   972,   295,   357,   974,
      -1,    24,   148,   347,   878,   295,   357,   974,    -1,    24,
     148,   347,   166,   135,   878,   295,   357,   974,    -1,    24,
     347,   878,   295,   747,   974,   357,   974,    -1,    24,   347,
     166,   135,   878,   295,   747,   974,   357,   974,    -1,    24,
     220,   391,   972,   295,   747,   974,   357,   974,    -1,    24,
     220,   391,   166,   135,   972,   295,   747,   974,   357,   974,
      -1,    24,   347,   878,   295,    76,   974,   357,   974,    -1,
      24,   148,   347,   878,   295,   747,   974,   357,   974,    -1,
      24,   148,   347,   166,   135,   878,   295,   747,   974,   357,
     974,    -1,    24,   310,   974,   249,   972,   295,   357,   974,
      -1,    24,   361,   974,   249,   972,   295,   357,   974,    -1,
      24,   129,   361,   974,   295,   357,   974,    -1,    24,   306,
     984,   295,   357,   984,    -1,    24,   378,   984,   295,   357,
     984,    -1,    24,   349,   974,   295,   357,   974,    -1,    24,
     349,   974,   324,   490,    -1,    24,   349,   974,   299,   490,
      -1,    24,   353,   314,   263,   663,   295,   357,   974,    -1,
      24,   353,   314,   112,   663,   295,   357,   974,    -1,    24,
     353,   314,   351,   663,   295,   357,   974,    -1,    24,   353,
     314,    74,   663,   295,   357,   974,    -1,    24,   366,   663,
     295,   357,   974,    -1,    24,   366,   663,   295,    37,   974,
     357,   974,   487,    -1,    68,    -1,    -1,   324,    96,    -1,
      -1,    24,    21,   980,   637,   324,   312,   974,    -1,    24,
      67,   663,   324,   312,   974,    -1,    24,    80,   663,   324,
     312,   974,    -1,    24,   118,   663,   324,   312,   974,    -1,
      24,   137,   663,   324,   312,   974,    -1,    24,   153,   688,
     324,   312,   974,    -1,    24,   251,   735,   734,   324,   312,
     974,    -1,    24,   251,    62,   663,   379,   976,   324,   312,
     974,    -1,    24,   251,   141,   663,   379,   976,   324,   312,
     974,    -1,    24,   347,   878,   324,   312,   974,    -1,    24,
     347,   166,   135,   878,   324,   312,   974,    -1,    24,   353,
     314,   263,   663,   324,   312,   974,    -1,    24,   353,   314,
     112,   663,   324,   312,   974,    -1,    24,   353,   314,   351,
     663,   324,   312,   974,    -1,    24,   353,   314,    74,   663,
     324,   312,   974,    -1,    24,   318,   972,   324,   312,   974,
      -1,    24,   318,   166,   135,   972,   324,   312,   974,    -1,
      24,   391,   972,   324,   312,   974,    -1,    24,   391,   166,
     135,   972,   324,   312,   974,    -1,    24,   220,   391,   972,
     324,   312,   974,    -1,    24,   220,   391,   166,   135,   972,
     324,   312,   974,    -1,    24,   148,   347,   878,   324,   312,
     974,    -1,    24,   148,   347,   166,   135,   878,   324,   312,
     974,    -1,    24,   366,   663,   324,   312,   974,    -1,    24,
      21,   980,   637,   262,   357,   984,    -1,    24,    67,   663,
     262,   357,   984,    -1,    24,    80,   663,   262,   357,   984,
      -1,    24,    97,   975,   262,   357,   984,    -1,    24,   118,
     663,   262,   357,   984,    -1,    24,   153,   688,   262,   357,
     984,    -1,    24,   573,   198,   974,   262,   357,   984,    -1,
      24,   199,   244,   564,   262,   357,   984,    -1,    24,   251,
     735,   734,   262,   357,   984,    -1,    24,   251,    62,   663,
     379,   976,   262,   357,   984,    -1,    24,   251,   141,   663,
     379,   976,   262,   357,   984,    -1,    24,   312,   974,   262,
     357,   984,    -1,    24,   366,   663,   262,   357,   984,    -1,
      24,   349,   974,   262,   357,   984,    -1,    24,   353,   314,
     112,   663,   262,   357,   984,    -1,    24,   353,   314,    74,
     663,   262,   357,   984,    -1,    24,   148,    96,   400,   974,
     262,   357,   984,    -1,    24,   321,   974,   262,   357,   984,
      -1,    24,   129,   361,   974,   262,   357,   984,    -1,    83,
     710,   310,   974,    31,   249,   756,   357,   972,   882,   116,
     757,   752,    -1,   236,    -1,   754,    -1,   431,   753,   432,
      -1,   753,   434,   755,    -1,   755,    -1,   831,    -1,   809,
      -1,   820,    -1,   814,    -1,   759,    -1,   754,    -1,    -1,
     317,    -1,   377,    -1,   108,    -1,   184,    -1,   185,    -1,
      23,    -1,    -1,   120,   310,   974,   249,   663,   487,    -1,
     120,   310,   166,   135,   974,   249,   663,   487,    -1,   237,
     987,   760,    -1,   435,   983,    -1,    -1,   211,   987,    -1,
     374,   987,    -1,   374,   424,    -1,    14,   764,    -1,    41,
     764,   767,    -1,   335,   359,   767,    -1,    71,   764,    -1,
     126,   764,    -1,   307,   764,    -1,   311,   987,    -1,   294,
     311,   987,    -1,   294,   987,    -1,   307,   764,   357,   311,
     987,    -1,   307,   764,   357,   987,    -1,   274,   359,   983,
      -1,    71,   275,   983,    -1,   307,   275,   983,    -1,   399,
      -1,   359,    -1,    -1,   194,   208,   469,    -1,   284,   250,
      -1,   284,   401,    -1,   105,    -1,   235,   105,    -1,   765,
      -1,   766,   435,   765,    -1,   766,   765,    -1,   766,    -1,
      -1,    83,   515,   391,   972,   534,   491,    31,   831,   769,
      -1,    83,   254,   297,   515,   391,   972,   534,   491,    31,
     831,   769,    -1,    83,   515,   288,   391,   972,   431,   535,
     432,   491,    31,   831,    -1,    83,   254,   297,   515,   288,
     391,   972,   431,   535,   432,   491,    31,   831,    -1,   397,
      60,   252,    -1,   397,    52,    60,   252,    -1,   397,   213,
      60,   252,    -1,    -1,   212,   979,    -1,    83,    97,   975,
     442,   772,    -1,   772,   773,    -1,    -1,   349,   774,   974,
      -1,   349,   774,   103,    -1,   216,   774,   983,    -1,   216,
     774,   103,    -1,   351,   774,   974,    -1,   351,   774,   103,
      -1,   124,   774,   983,    -1,   124,   774,   982,    -1,   124,
     774,   103,    -1,   202,   774,   983,    -1,   202,   774,   103,
      -1,   203,   774,   983,    -1,   203,   774,   103,    -1,    75,
     210,   774,   986,    -1,   262,   774,   974,    -1,   262,   774,
     103,    -1,   418,    -1,    -1,    24,    97,   975,   442,   777,
      -1,    24,    97,   975,   324,   349,   974,    -1,    24,    97,
     975,   475,    -1,   777,   778,    -1,    -1,    75,   210,   774,
     986,    -1,   120,    97,   975,    -1,   120,    97,   166,   135,
     975,    -1,    83,   118,   663,   782,   887,   524,    -1,    24,
     118,   663,   486,    -1,    24,   118,   663,   120,   235,   240,
      -1,    24,   118,   663,   324,   235,   240,    -1,    24,   118,
     663,    18,   531,    -1,    24,   118,   663,   120,    76,   974,
     487,    -1,    24,   118,   663,   120,    76,   166,   135,   974,
     487,    -1,    24,   118,   663,   382,    76,   974,    -1,    31,
      -1,    -1,    24,   353,   314,   112,   663,   633,    -1,    24,
     353,   314,    74,   663,    18,   218,   146,   973,   397,   662,
      -1,    24,   353,   314,    74,   663,    24,   218,   146,   973,
     397,   662,    -1,    24,   353,   314,    74,   663,    24,   218,
     297,   663,   397,   663,    -1,    24,   353,   314,    74,   663,
      24,   218,   146,   973,   297,   663,   397,   663,    -1,    24,
     353,   314,    74,   663,   120,   218,   146,   973,    -1,    24,
     353,   314,    74,   663,   120,   218,   166,   135,   146,   973,
      -1,    83,   648,    80,   663,   146,   983,   357,   983,   151,
     663,    -1,    64,   793,   972,   787,    -1,    64,   793,    -1,
      64,   793,   978,   249,   972,    -1,   379,   978,    -1,    -1,
     380,   794,   795,   793,    -1,   380,   794,   795,   793,   972,
      -1,   380,   794,   795,   793,   791,    -1,   380,   431,   789,
     432,    -1,   380,   431,   789,   432,   972,   796,    -1,   790,
      -1,   789,   435,   790,    -1,   792,    -1,   389,    -1,   150,
      -1,   152,    -1,   792,   793,    -1,   792,   793,   972,   796,
      -1,    27,    -1,    26,    -1,   389,    -1,    -1,   152,    -1,
      -1,   150,    -1,    -1,   431,   973,   432,    -1,    -1,   136,
     798,    -1,   136,   792,   793,   798,    -1,   136,   389,   798,
      -1,   136,   431,   799,   432,   798,    -1,   831,    -1,   809,
      -1,   820,    -1,   814,    -1,   827,    -1,   551,    -1,   554,
      -1,   557,    -1,   806,    -1,   800,    -1,   799,   435,   800,
      -1,   801,   802,    -1,   989,    -1,   792,    -1,   470,    -1,
     564,    -1,    -1,   274,   974,   804,    31,   805,    -1,   431,
     943,   432,    -1,    -1,   831,    -1,   809,    -1,   820,    -1,
     814,    -1,   134,   974,   807,    -1,    83,   515,   347,   552,
      31,   134,   974,   807,   553,    -1,   431,   940,   432,    -1,
      -1,    99,   974,    -1,    99,   274,   974,    -1,    99,    22,
      -1,    99,   274,    22,    -1,   839,   184,   190,   972,   810,
     813,    -1,   831,    -1,   431,   811,   432,   831,    -1,   103,
     385,    -1,   812,    -1,   811,   435,   812,    -1,   987,   964,
      -1,   302,   969,    -1,    -1,   839,   108,   151,   880,   815,
     883,   813,    -1,   379,   869,    -1,    -1,   217,   842,   879,
     817,   819,    -1,   171,   818,   224,    -1,    -1,    16,   326,
      -1,   308,   326,    -1,   308,   133,    -1,   326,   377,   133,
      -1,   326,    -1,   326,   308,   133,    -1,   133,    -1,    16,
     133,    -1,   239,    -1,    -1,   839,   377,   880,   324,   821,
     868,   883,   813,    -1,   822,    -1,   821,   435,   822,    -1,
     823,    -1,   824,    -1,   825,   418,   966,    -1,   431,   826,
     432,   418,   968,    -1,   987,   964,    -1,   825,    -1,   826,
     435,   825,    -1,   102,   828,   829,    94,   830,   146,   831,
      -1,   974,    -1,    -1,   829,   233,   313,    -1,   829,   313,
      -1,   829,    44,    -1,   829,   183,    -1,    -1,   397,   163,
      -1,   398,   163,    -1,   833,    -1,   832,    -1,   431,   833,
     432,    -1,   431,   832,   432,    -1,   835,    -1,   834,   846,
      -1,   834,   845,   861,   850,    -1,   834,   845,   849,   862,
      -1,   836,   834,    -1,   836,   834,   846,    -1,   836,   834,
     845,   861,   850,    -1,   836,   834,   845,   849,   862,    -1,
     835,    -1,   832,    -1,   317,   844,   969,   840,   868,   882,
     859,   860,   923,    -1,   867,    -1,   347,   878,    -1,   834,
     371,   843,   834,    -1,   834,   188,   843,   834,    -1,   834,
     130,   843,   834,    -1,   397,   837,    -1,   397,   288,   837,
      -1,   838,    -1,   837,   435,   838,    -1,   974,   796,    31,
     431,   805,   432,    -1,   836,    -1,    -1,   190,   841,    -1,
      -1,   352,   842,   972,    -1,   350,   842,   972,    -1,   213,
     352,   842,   972,    -1,   213,   350,   842,   972,    -1,   155,
     352,   842,   972,    -1,   155,   350,   842,   972,    -1,   375,
     842,   972,    -1,   347,   972,    -1,   972,    -1,   347,    -1,
      -1,    22,    -1,   115,    -1,    -1,   115,    -1,   115,   249,
     431,   940,   432,    -1,    22,    -1,    -1,   846,    -1,    -1,
     255,    48,   847,    -1,   848,    -1,   847,   435,   848,    -1,
     911,   379,   938,   708,    -1,   911,   707,   708,    -1,   851,
     852,    -1,   852,   851,    -1,   851,    -1,   852,    -1,   849,
      -1,    -1,   210,   853,    -1,   210,   853,   435,   854,    -1,
     142,   858,   855,   857,   250,    -1,   247,   854,    -1,   247,
     856,   857,    -1,   911,    -1,    22,    -1,   911,    -1,   986,
      -1,   431,   911,   432,    -1,    -1,   913,    -1,   308,    -1,
     309,    -1,   143,    -1,   232,    -1,   159,    48,   940,    -1,
      -1,   161,   911,    -1,    -1,   863,    -1,   146,   284,   250,
      -1,   861,    -1,    -1,   864,    -1,   863,   864,    -1,   865,
     866,   819,    -1,   146,   377,    -1,   146,   233,   196,   377,
      -1,   146,   326,    -1,   146,   196,   326,    -1,   245,   971,
      -1,    -1,   385,   968,    -1,   867,   435,   968,    -1,   151,
     869,    -1,    -1,   870,    -1,   869,   435,   870,    -1,   878,
     873,    -1,   881,   874,    -1,   201,   881,   874,    -1,   832,
     873,    -1,   201,   832,   873,    -1,   871,    -1,   431,   871,
     432,   872,    -1,   431,   871,   432,    -1,   870,    84,   195,
     870,    -1,   870,   875,   195,   870,   877,    -1,   870,   195,
     870,   877,    -1,   870,   230,   875,   195,   870,    -1,   870,
     230,   195,   870,    -1,    31,   987,   431,   973,   432,    -1,
      31,   987,    -1,   987,   431,   973,   432,    -1,   987,    -1,
     872,    -1,    -1,   872,    -1,    31,   431,   885,   432,    -1,
      31,   987,   431,   885,   432,    -1,   987,   431,   885,   432,
      -1,    -1,   152,   876,    -1,   207,   876,    -1,   305,   876,
      -1,   180,    -1,   257,    -1,    -1,   379,   431,   973,   432,
      -1,   249,   911,    -1,   972,    -1,   972,   424,    -1,   250,
     972,    -1,   250,   431,   972,   432,    -1,   878,    -1,   879,
     435,   878,    -1,   878,    -1,   878,   987,    -1,   878,    31,
     987,    -1,   914,    -1,   394,   911,    -1,    -1,   394,   911,
      -1,   394,    86,   245,   828,    -1,    -1,   885,    -1,    -1,
     886,    -1,   885,   435,   886,    -1,   987,   887,   488,    -1,
     889,   888,    -1,   325,   889,   888,    -1,   889,    30,   429,
     982,   430,    -1,   325,   889,    30,   429,   982,   430,    -1,
     889,    30,    -1,   325,   889,    30,    -1,   888,   429,   430,
      -1,   888,   429,   982,   430,    -1,    -1,   891,    -1,   893,
      -1,   895,    -1,   899,    -1,   906,    -1,   907,   909,    -1,
     907,   431,   982,   432,   909,    -1,   893,    -1,   896,    -1,
     900,    -1,   906,    -1,   988,   892,    -1,   988,   664,   892,
      -1,   431,   940,   432,    -1,    -1,   186,    -1,   187,    -1,
     330,    -1,    43,    -1,   285,    -1,   144,   894,    -1,   119,
     272,    -1,   101,   892,    -1,   100,   892,    -1,   243,   892,
      -1,    46,    -1,   431,   982,   432,    -1,    -1,   897,    -1,
     898,    -1,   897,    -1,   898,    -1,    45,   904,   431,   940,
     432,    -1,    45,   904,    -1,   901,    -1,   902,    -1,   901,
      -1,   902,    -1,   903,   431,   982,   432,   905,    -1,   903,
     905,    -1,    58,   904,    -1,    57,   904,    -1,   386,    -1,
     229,    58,   904,    -1,   229,    57,   904,    -1,   231,   904,
      -1,   388,    -1,    -1,    58,   324,   987,    -1,    -1,   356,
     431,   982,   432,   908,    -1,   356,   908,    -1,   355,   431,
     982,   432,   908,    -1,   355,   908,    -1,   189,    -1,   417,
     414,    -1,   398,   355,   414,    -1,    -1,   412,    -1,   225,
      -1,    98,    -1,   164,    -1,   222,    -1,   910,    -1,   412,
     357,   225,    -1,    98,   357,   164,    -1,    98,   357,   222,
      -1,    98,   357,   910,    -1,   164,   357,   222,    -1,   164,
     357,   910,    -1,   222,   357,   910,    -1,    -1,   315,    -1,
     315,   431,   982,   432,    -1,   913,    -1,   911,    11,   887,
      -1,   911,    66,   663,    -1,   911,    36,   355,   414,   911,
      -1,   422,   911,    -1,   423,   911,    -1,   911,   422,   911,
      -1,   911,   423,   911,    -1,   911,   424,   911,    -1,   911,
     425,   911,    -1,   911,   426,   911,    -1,   911,   427,   911,
      -1,   911,   419,   911,    -1,   911,   420,   911,    -1,   911,
     418,   911,    -1,   911,   937,   911,    -1,   937,   911,    -1,
     911,   937,    -1,   911,    28,   911,    -1,   911,   254,   911,
      -1,   235,   911,    -1,   911,   209,   911,    -1,   911,   209,
     911,   128,   911,    -1,   911,   235,   209,   911,    -1,   911,
     235,   209,   911,   128,   911,    -1,   911,   167,   911,    -1,
     911,   167,   911,   128,   911,    -1,   911,   235,   167,   911,
      -1,   911,   235,   167,   911,   128,   911,    -1,   911,   328,
     357,   911,    -1,   911,   328,   357,   911,   128,   911,    -1,
     911,   235,   328,   357,   911,    -1,   911,   235,   328,   357,
     911,   128,   911,    -1,   911,   192,   240,    -1,   911,   193,
      -1,   911,   192,   235,   240,    -1,   911,   238,    -1,   933,
     259,   933,    -1,   911,   192,   363,    -1,   911,   192,   235,
     363,    -1,   911,   192,   140,    -1,   911,   192,   235,   140,
      -1,   911,   192,   373,    -1,   911,   192,   235,   373,    -1,
     911,   192,   115,   151,   911,    -1,   911,   192,   235,   115,
     151,   911,    -1,   911,   192,   245,   431,   943,   432,    -1,
     911,   192,   235,   245,   431,   943,   432,    -1,   911,    42,
     965,   912,    28,   912,    -1,   911,   235,    42,   965,   912,
      28,   912,    -1,   911,    42,   344,   912,    28,   912,    -1,
     911,   235,    42,   344,   912,    28,   912,    -1,   911,   171,
     955,    -1,   911,   235,   171,   955,    -1,   911,   939,   934,
     832,    -1,   911,   939,   934,   431,   911,   432,    -1,   372,
     832,    -1,   911,   192,   117,    -1,   911,   192,   235,   117,
      -1,   913,    -1,   912,    11,   887,    -1,   422,   912,    -1,
     423,   912,    -1,   912,   422,   912,    -1,   912,   423,   912,
      -1,   912,   424,   912,    -1,   912,   425,   912,    -1,   912,
     426,   912,    -1,   912,   427,   912,    -1,   912,   419,   912,
      -1,   912,   420,   912,    -1,   912,   418,   912,    -1,   912,
     937,   912,    -1,   937,   912,    -1,   912,   937,    -1,   912,
     192,   115,   151,   912,    -1,   912,   192,   235,   115,   151,
     912,    -1,   912,   192,   245,   431,   943,   432,    -1,   912,
     192,   235,   245,   431,   943,   432,    -1,   912,   192,   117,
      -1,   912,   192,   235,   117,    -1,   961,    -1,   981,    -1,
      10,   964,    -1,   431,   911,   432,   964,    -1,   956,    -1,
     914,    -1,   832,    -1,   832,   963,    -1,   135,   832,    -1,
      30,   832,    -1,    30,   944,    -1,   933,    -1,   980,   431,
     432,   926,    -1,   980,   431,   941,   432,   926,    -1,   980,
     431,   387,   942,   432,   926,    -1,   980,   431,   941,   435,
     387,   942,   432,   926,    -1,   980,   431,   941,   846,   432,
     926,    -1,   980,   431,    22,   941,   845,   432,   926,    -1,
     980,   431,   115,   941,   845,   432,   926,    -1,   980,   431,
     424,   432,   926,    -1,    67,   146,   431,   911,   432,    -1,
      88,    -1,    91,    -1,    91,   431,   982,   432,    -1,    92,
      -1,    92,   431,   982,   432,    -1,   214,    -1,   214,   431,
     982,   432,    -1,   215,    -1,   215,   431,   982,   432,    -1,
      89,    -1,    93,    -1,   323,    -1,   378,    -1,    87,    -1,
      90,    -1,    54,   431,   911,    31,   887,   432,    -1,   139,
     431,   946,   432,    -1,   260,   431,   948,   432,    -1,   270,
     431,   950,   432,    -1,   343,   431,   951,   432,    -1,   360,
     431,   911,    31,   887,   432,    -1,   362,   431,    47,   954,
     432,    -1,   362,   431,   204,   954,   432,    -1,   362,   431,
     358,   954,   432,    -1,   362,   431,   954,   432,    -1,   241,
     431,   911,   435,   911,   432,    -1,    65,   431,   940,   432,
      -1,   158,   431,   940,   432,    -1,   206,   431,   940,   432,
      -1,   404,   431,   940,   432,    -1,   405,   431,   227,   990,
     432,    -1,   405,   431,   227,   990,   435,   917,   432,    -1,
     405,   431,   227,   990,   435,   940,   432,    -1,   405,   431,
     227,   990,   435,   917,   435,   940,   432,    -1,   406,   431,
     913,   922,   432,    -1,   407,   431,   918,   432,    -1,   408,
     431,   920,   911,   921,   432,    -1,   409,   431,   227,   990,
     432,    -1,   409,   431,   227,   990,   435,   911,   432,    -1,
     410,   431,   911,   435,   915,   916,   432,    -1,   411,   431,
     920,   911,    31,   889,   432,    -1,   390,   911,    -1,   390,
     233,   384,    -1,   435,   334,   413,    -1,   435,   334,   233,
      -1,   435,   334,   233,   384,    -1,    -1,   403,   431,   918,
     432,    -1,   919,    -1,   918,   435,   919,    -1,   911,    31,
     990,    -1,   911,    -1,   117,    -1,    78,    -1,   273,   395,
      -1,   342,   395,    -1,    -1,   266,   913,    -1,   266,   913,
      48,   289,    -1,   266,    48,   289,   913,    -1,   266,    48,
     289,   913,    48,   289,    -1,   396,   924,    -1,    -1,   925,
      -1,   924,   435,   925,    -1,   987,    31,   927,    -1,   258,
     927,    -1,   258,   987,    -1,    -1,   431,   928,   929,   845,
     930,   432,    -1,   987,    -1,    -1,   265,    48,   940,    -1,
      -1,   283,   931,    -1,   309,   931,    -1,    -1,   932,    -1,
      42,   932,    28,   932,    -1,   368,   271,    -1,   368,   145,
      -1,    86,   308,    -1,   911,   271,    -1,   911,   145,    -1,
     308,   431,   940,   432,    -1,   308,   431,   432,    -1,   431,
     940,   435,   911,   432,    -1,    29,    -1,   332,    -1,    22,
      -1,     8,    -1,   936,    -1,   422,    -1,   423,    -1,   424,
      -1,   425,    -1,   426,    -1,   427,    -1,   419,    -1,   420,
      -1,   418,    -1,     8,    -1,   251,   431,   735,   432,    -1,
     935,    -1,   251,   431,   735,   432,    -1,   935,    -1,   251,
     431,   735,   432,    -1,   209,    -1,   235,   209,    -1,   167,
      -1,   235,   167,    -1,   911,    -1,   940,   435,   911,    -1,
     942,    -1,   941,   435,   942,    -1,   911,    -1,   717,    13,
     911,    -1,   887,    -1,   943,   435,   887,    -1,   429,   940,
     430,    -1,   429,   945,   430,    -1,   429,   430,    -1,   944,
      -1,   945,   435,   944,    -1,   947,   151,   911,    -1,    -1,
       3,    -1,   412,    -1,   225,    -1,    98,    -1,   164,    -1,
     222,    -1,   315,    -1,   983,    -1,   911,   949,   952,   953,
      -1,   911,   949,   952,    -1,   268,   911,    -1,   912,   171,
     912,    -1,    -1,   911,   952,   953,    -1,   911,   953,   952,
      -1,   911,   952,    -1,   911,   953,    -1,   940,    -1,    -1,
     151,   911,    -1,   146,   911,    -1,   911,   151,   940,    -1,
     151,   940,    -1,   940,    -1,   832,    -1,   431,   940,   432,
      -1,    53,   960,   957,   959,   126,    -1,   958,    -1,   957,
     958,    -1,   393,   911,   354,   911,    -1,   122,   911,    -1,
      -1,   911,    -1,    -1,   987,    -1,   987,   963,    -1,   433,
     977,    -1,   433,   424,    -1,   429,   911,   430,    -1,   429,
     911,   436,   911,   430,    -1,   962,    -1,   963,   962,    -1,
      -1,   964,   962,    -1,    35,    -1,    -1,   911,    -1,   103,
      -1,   966,    -1,   967,   435,   966,    -1,   431,   967,   432,
      -1,   970,    -1,   969,   435,   970,    -1,   911,    31,   990,
      -1,   911,     3,    -1,   911,    -1,   424,    -1,   972,    -1,
     971,   435,   972,    -1,   987,    -1,   987,   963,    -1,   974,
      -1,   973,   435,   974,    -1,   987,    -1,   987,    -1,   987,
      -1,   990,    -1,   987,    -1,   983,    -1,   988,    -1,   987,
     963,    -1,   982,    -1,     4,    -1,   983,    -1,     6,    -1,
       7,    -1,   980,   983,    -1,   980,   431,   941,   432,   983,
      -1,   890,   983,    -1,   907,   983,   909,    -1,   907,   431,
     982,   432,   983,   909,    -1,   363,    -1,   140,    -1,   240,
      -1,     9,    -1,     5,    -1,   989,    -1,   984,    -1,   985,
     435,   984,    -1,   982,    -1,   422,   982,    -1,   423,   982,
      -1,     3,    -1,   991,    -1,   992,    -1,     3,    -1,   991,
      -1,   993,    -1,     3,    -1,   991,    -1,   992,    -1,   993,
      -1,     3,    -1,   991,    -1,   992,    -1,   993,    -1,   994,
      -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    23,    -1,    24,
      -1,    25,    -1,    33,    -1,    34,    -1,    36,    -1,    37,
      -1,    39,    -1,    40,    -1,    41,    -1,    48,    -1,    49,
      -1,    50,    -1,    51,    -1,    52,    -1,    55,    -1,    56,
      -1,    59,    -1,    61,    -1,    62,    -1,    63,    -1,    64,
      -1,    69,    -1,    70,    -1,    71,    -1,    72,    -1,    74,
      -1,    75,    -1,    77,    -1,    78,    -1,    79,    -1,    80,
      -1,    81,    -1,    82,    -1,    85,    -1,    86,    -1,    94,
      -1,    95,    -1,    96,    -1,    97,    -1,    98,    -1,    99,
      -1,   102,    -1,   104,    -1,   106,    -1,   107,    -1,   108,
      -1,   109,    -1,   110,    -1,   112,    -1,   113,    -1,   114,
      -1,   117,    -1,   118,    -1,   119,    -1,   120,    -1,   121,
      -1,   123,    -1,   124,    -1,   125,    -1,   127,    -1,   128,
      -1,   129,    -1,   131,    -1,   132,    -1,   133,    -1,   134,
      -1,   136,    -1,   137,    -1,   138,    -1,   141,    -1,   143,
      -1,   145,    -1,   147,    -1,   149,    -1,   153,    -1,   154,
      -1,   155,    -1,   157,    -1,   160,    -1,   162,    -1,   163,
      -1,   164,    -1,   165,    -1,   166,    -1,   168,    -1,   169,
      -1,   170,    -1,   172,    -1,   173,    -1,   174,    -1,   175,
      -1,   176,    -1,   177,    -1,   179,    -1,   182,    -1,   183,
      -1,   184,    -1,   185,    -1,   191,    -1,   194,    -1,   196,
      -1,   197,    -1,   198,    -1,   199,    -1,   200,    -1,   202,
      -1,   203,    -1,   205,    -1,   208,    -1,   211,    -1,   212,
      -1,   213,    -1,   216,    -1,   217,    -1,   218,    -1,   219,
      -1,   220,    -1,   221,    -1,   222,    -1,   223,    -1,   224,
      -1,   225,    -1,   226,    -1,   227,    -1,   228,    -1,   232,
      -1,   233,    -1,   236,    -1,   237,    -1,   239,    -1,   242,
      -1,   244,    -1,   245,    -1,   246,    -1,   248,    -1,   251,
      -1,   252,    -1,   253,    -1,   261,    -1,   262,    -1,   263,
      -1,   264,    -1,   265,    -1,   266,    -1,   267,    -1,   269,
      -1,   271,    -1,   274,    -1,   275,    -1,   273,    -1,   277,
      -1,   278,    -1,   279,    -1,   280,    -1,   281,    -1,   282,
      -1,   283,    -1,   284,    -1,   286,    -1,   287,    -1,   288,
      -1,   289,    -1,   291,    -1,   292,    -1,   293,    -1,   294,
      -1,   295,    -1,   296,    -1,   297,    -1,   298,    -1,   299,
      -1,   300,    -1,   301,    -1,   303,    -1,   304,    -1,   306,
      -1,   307,    -1,   309,    -1,   310,    -1,   311,    -1,   312,
      -1,   313,    -1,   314,    -1,   315,    -1,   316,    -1,   318,
      -1,   319,    -1,   320,    -1,   321,    -1,   322,    -1,   324,
      -1,   326,    -1,   327,    -1,   329,    -1,   331,    -1,   333,
      -1,   334,    -1,   335,    -1,   336,    -1,   337,    -1,   338,
      -1,   339,    -1,   340,    -1,   341,    -1,   342,    -1,   345,
      -1,   346,    -1,   348,    -1,   349,    -1,   350,    -1,   351,
      -1,   352,    -1,   353,    -1,   359,    -1,   361,    -1,   364,
      -1,   365,    -1,   366,    -1,   367,    -1,   368,    -1,   369,
      -1,   370,    -1,   373,    -1,   374,    -1,   375,    -1,   376,
      -1,   377,    -1,   380,    -1,   381,    -1,   382,    -1,   383,
      -1,   384,    -1,   388,    -1,   390,    -1,   391,    -1,   392,
      -1,   395,    -1,   398,    -1,   399,    -1,   400,    -1,   401,
      -1,   402,    -1,   412,    -1,   413,    -1,   414,    -1,    42,
      -1,    43,    -1,    45,    -1,    46,    -1,    57,    -1,    58,
      -1,    65,    -1,   100,    -1,   101,    -1,   135,    -1,   139,
      -1,   144,    -1,   158,    -1,   181,    -1,   186,    -1,   187,
      -1,   189,    -1,   206,    -1,   229,    -1,   231,    -1,   234,
      -1,   241,    -1,   243,    -1,   256,    -1,   260,    -1,   270,
      -1,   272,    -1,   285,    -1,   308,    -1,   325,    -1,   330,
      -1,   343,    -1,   355,    -1,   356,    -1,   360,    -1,   362,
      -1,   385,    -1,   386,    -1,   403,    -1,   404,    -1,   405,
      -1,   406,    -1,   407,    -1,   408,    -1,   409,    -1,   410,
      -1,   411,    -1,    38,    -1,    44,    -1,    67,    -1,    73,
      -1,    84,    -1,    90,    -1,   150,    -1,   152,    -1,   167,
      -1,   180,    -1,   192,    -1,   193,    -1,   195,    -1,   207,
      -1,   209,    -1,   230,    -1,   238,    -1,   257,    -1,   258,
      -1,   259,    -1,   305,    -1,   328,    -1,   389,    -1,    22,
      -1,    26,    -1,    27,    -1,    28,    -1,    29,    -1,    30,
      -1,    31,    -1,    32,    -1,    35,    -1,    47,    -1,    53,
      -1,    54,    -1,    60,    -1,    66,    -1,    68,    -1,    76,
      -1,    83,    -1,    87,    -1,    88,    -1,    89,    -1,    91,
      -1,    92,    -1,    93,    -1,   103,    -1,   105,    -1,   111,
      -1,   115,    -1,   116,    -1,   122,    -1,   126,    -1,   130,
      -1,   140,    -1,   142,    -1,   146,    -1,   148,    -1,   151,
      -1,   156,    -1,   159,    -1,   161,    -1,   171,    -1,   178,
      -1,   188,    -1,   190,    -1,   201,    -1,   204,    -1,   210,
      -1,   214,    -1,   215,    -1,   235,    -1,   240,    -1,   247,
      -1,   249,    -1,   250,    -1,   254,    -1,   255,    -1,   268,
      -1,   276,    -1,   290,    -1,   302,    -1,   317,    -1,   323,
      -1,   332,    -1,   344,    -1,   347,    -1,   354,    -1,   357,
      -1,   358,    -1,   363,    -1,   371,    -1,   372,    -1,   378,
      -1,   379,    -1,   387,    -1,   393,    -1,   394,    -1,   396,
      -1,   397,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   680,   680,   687,   694,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   819,
     829,   840,   841,   850,   851,   855,   856,   860,   865,   869,
     874,   879,   883,   887,   892,   896,   950,   952,   956,   960,
     964,   968,   982,  1000,  1011,  1012,  1016,  1024,  1042,  1054,
    1075,  1082,  1101,  1108,  1125,  1143,  1154,  1155,  1167,  1174,
    1191,  1204,  1214,  1232,  1250,  1251,  1255,  1262,  1270,  1271,
    1272,  1273,  1274,  1275,  1289,  1295,  1301,  1310,  1318,  1326,
    1330,  1338,  1346,  1353,  1360,  1368,  1379,  1387,  1395,  1406,
    1414,  1422,  1429,  1438,  1448,  1449,  1456,  1457,  1460,  1462,
    1466,  1467,  1468,  1469,  1473,  1474,  1475,  1481,  1493,  1497,
    1501,  1516,  1539,  1540,  1541,  1545,  1546,  1547,  1551,  1552,
    1556,  1563,  1570,  1577,  1584,  1594,  1595,  1600,  1601,  1606,
    1612,  1618,  1624,  1630,  1640,  1650,  1651,  1655,  1656,  1664,
    1679,  1685,  1691,  1697,  1715,  1724,  1733,  1742,  1751,  1760,
    1769,  1778,  1787,  1796,  1808,  1809,  1814,  1822,  1830,  1839,
    1847,  1855,  1864,  1873,  1882,  1891,  1901,  1914,  1928,  1937,
    1945,  1953,  1963,  1973,  1980,  1987,  1995,  2003,  2011,  2019,
    2027,  2034,  2041,  2049,  2056,  2063,  2071,  2079,  2087,  2095,
    2103,  2111,  2121,  2128,  2136,  2144,  2152,  2159,  2169,  2170,
    2174,  2175,  2176,  2180,  2188,  2192,  2193,  2197,  2200,  2201,
    2205,  2206,  2211,  2215,  2219,  2224,  2239,  2252,  2253,  2258,
    2267,  2277,  2287,  2312,  2318,  2348,  2377,  2399,  2400,  2404,
    2405,  2414,  2415,  2416,  2419,  2420,  2425,  2426,  2430,  2434,
    2438,  2442,  2446,  2450,  2454,  2458,  2462,  2466,  2470,  2474,
    2478,  2487,  2491,  2495,  2499,  2503,  2507,  2511,  2512,  2517,
    2521,  2528,  2535,  2536,  2537,  2538,  2539,  2543,  2547,  2555,
    2566,  2581,  2597,  2613,  2642,  2643,  2644,  2645,  2646,  2653,
    2660,  2661,  2665,  2666,  2670,  2671,  2675,  2679,  2686,  2690,
    2697,  2698,  2699,  2703,  2704,  2707,  2727,  2747,  2748,  2752,
    2760,  2761,  2762,  2793,  2800,  2807,  2818,  2829,  2839,  2848,
    2881,  2888,  2895,  2902,  2913,  2923,  2924,  2925,  2929,  2930,
    2931,  2932,  2933,  2934,  2943,  2951,  2955,  2968,  2983,  2997,
    3012,  3026,  3044,  3065,  3066,  3070,  3071,  3075,  3076,  3079,
    3085,  3089,  3097,  3102,  3108,  3109,  3113,  3118,  3125,  3126,
    3136,  3138,  3140,  3142,  3145,  3148,  3151,  3155,  3156,  3157,
    3158,  3159,  3162,  3163,  3168,  3169,  3170,  3171,  3174,  3175,
    3176,  3177,  3180,  3181,  3184,  3185,  3188,  3203,  3218,  3232,
    3233,  3234,  3246,  3261,  3274,  3275,  3287,  3306,  3318,  3326,
    3337,  3338,  3341,  3342,  3345,  3349,  3353,  3357,  3361,  3365,
    3369,  3373,  3377,  3381,  3385,  3389,  3395,  3396,  3400,  3401,
    3406,  3409,  3410,  3422,  3434,  3449,  3450,  3458,  3459,  3463,
    3464,  3468,  3469,  3473,  3474,  3478,  3489,  3502,  3503,  3513,
    3523,  3524,  3537,  3544,  3561,  3569,  3580,  3583,  3587,  3591,
    3595,  3607,  3617,  3620,  3624,  3637,  3647,  3657,  3666,  3675,
    3684,  3694,  3703,  3713,  3723,  3733,  3742,  3751,  3760,  3769,
    3778,  3787,  3796,  3805,  3814,  3823,  3832,  3841,  3850,  3868,
    3879,  3880,  3881,  3882,  3886,  3887,  3891,  3892,  3902,  3913,
    3933,  3941,  3953,  3954,  3958,  3962,  3970,  3974,  3978,  3985,
    3989,  3994,  3999,  4006,  4013,  4018,  4028,  4042,  4043,  4048,
    4049,  4053,  4054,  4064,  4075,  4095,  4104,  4112,  4129,  4144,
    4169,  4178,  4196,  4208,  4209,  4210,  4220,  4228,  4245,  4264,
    4284,  4309,  4310,  4311,  4315,  4317,  4339,  4341,  4343,  4345,
    4347,  4352,  4357,  4367,  4368,  4372,  4373,  4377,  4378,  4382,
    4383,  4384,  4388,  4394,  4395,  4396,  4400,  4401,  4406,  4407,
    4434,  4435,  4436,  4437,  4438,  4439,  4444,  4455,  4478,  4488,
    4502,  4504,  4509,  4514,  4516,  4521,  4531,  4532,  4533,  4534,
    4546,  4566,  4589,  4599,  4610,  4620,  4630,  4641,  4650,  4657,
    4664,  4673,  4682,  4691,  4700,  4709,  4720,  4723,  4724,  4727,
    4731,  4738,  4739,  4740,  4741,  4742,  4745,  4746,  4749,  4752,
    4753,  4761,  4768,  4769,  4772,  4774,  4785,  4795,  4805,  4817,
    4818,  4834,  4849,  4850,  4854,  4864,  4875,  4884,  4894,  4903,
    4904,  4907,  4908,  4911,  4912,  4913,  4916,  4930,  4935,  4945,
    4954,  4966,  4967,  4971,  4979,  4991,  5002,  5016,  5027,  5050,
    5060,  5078,  5089,  5100,  5111,  5125,  5126,  5127,  5128,  5129,
    5130,  5131,  5132,  5133,  5134,  5135,  5136,  5137,  5138,  5139,
    5140,  5141,  5145,  5146,  5149,  5150,  5153,  5155,  5168,  5179,
    5180,  5181,  5213,  5222,  5231,  5240,  5249,  5258,  5267,  5277,
    5286,  5295,  5304,  5313,  5322,  5334,  5335,  5336,  5337,  5338,
    5339,  5340,  5341,  5342,  5343,  5344,  5345,  5346,  5347,  5348,
    5349,  5350,  5351,  5352,  5353,  5354,  5355,  5356,  5360,  5361,
    5375,  5386,  5397,  5408,  5419,  5432,  5433,  5437,  5438,  5439,
    5440,  5441,  5442,  5443,  5444,  5445,  5446,  5447,  5448,  5449,
    5452,  5453,  5463,  5469,  5477,  5485,  5493,  5501,  5509,  5517,
    5525,  5533,  5541,  5549,  5557,  5565,  5573,  5581,  5589,  5597,
    5607,  5608,  5611,  5612,  5622,  5638,  5652,  5678,  5680,  5682,
    5684,  5691,  5700,  5701,  5704,  5711,  5718,  5725,  5739,  5747,
    5755,  5763,  5771,  5779,  5787,  5795,  5803,  5811,  5819,  5827,
    5835,  5843,  5851,  5859,  5871,  5872,  5875,  5885,  5899,  5900,
    5904,  5905,  5910,  5926,  5939,  5949,  5961,  5962,  5965,  5966,
    5976,  5986,  5987,  5991,  5995,  5999,  6010,  6023,  6037,  6054,
    6055,  6056,  6057,  6069,  6096,  6097,  6101,  6102,  6106,  6107,
    6111,  6112,  6115,  6116,  6124,  6135,  6146,  6159,  6160,  6163,
    6164,  6165,  6168,  6169,  6170,  6173,  6174,  6175,  6191,  6203,
    6216,  6231,  6232,  6235,  6236,  6240,  6241,  6249,  6250,  6254,
    6255,  6270,  6279,  6288,  6297,  6306,  6318,  6319,  6320,  6321,
    6322,  6328,  6332,  6347,  6348,  6354,  6364,  6368,  6373,  6383,
    6384,  6391,  6395,  6399,  6403,  6407,  6411,  6415,  6419,  6423,
    6427,  6431,  6435,  6439,  6443,  6447,  6455,  6459,  6463,  6467,
    6473,  6474,  6481,  6482,  6485,  6497,  6501,  6516,  6527,  6528,
    6533,  6534,  6549,  6560,  6574,  6585,  6599,  6610,  6624,  6632,
    6634,  6636,  6641,  6643,  6656,  6665,  6666,  6670,  6674,  6686,
    6697,  6708,  6721,  6722,  6723,  6727,  6740,  6741,  6755,  6763,
    6773,  6786,  6787,  6790,  6791,  6801,  6811,  6820,  6829,  6838,
    6847,  6857,  6866,  6876,  6885,  6894,  6904,  6914,  6923,  6932,
    6942,  6952,  6962,  6972,  6982,  6992,  7002,  7012,  7022,  7032,
    7042,  7052,  7063,  7074,  7085,  7096,  7106,  7117,  7128,  7138,
    7148,  7156,  7165,  7174,  7183,  7192,  7201,  7210,  7219,  7228,
    7237,  7246,  7260,  7261,  7264,  7265,  7275,  7285,  7294,  7303,
    7312,  7321,  7331,  7341,  7351,  7361,  7370,  7379,  7388,  7397,
    7406,  7415,  7424,  7433,  7442,  7451,  7460,  7469,  7478,  7487,
    7504,  7513,  7521,  7529,  7537,  7545,  7554,  7562,  7570,  7579,
    7588,  7597,  7605,  7613,  7621,  7629,  7637,  7645,  7653,  7670,
    7687,  7688,  7689,  7694,  7700,  7709,  7710,  7711,  7712,  7713,
    7717,  7718,  7721,  7722,  7723,  7724,  7728,  7729,  7730,  7735,
    7746,  7768,  7778,  7779,  7782,  7791,  7797,  7816,  7823,  7830,
    7837,  7844,  7851,  7858,  7866,  7874,  7882,  7890,  7898,  7905,
    7912,  7921,  7922,  7923,  7927,  7930,  7933,  7936,  7939,  7946,
    7948,  7950,  7955,  7957,  7969,  7981,  7993,  8005,  8020,  8026,
    8032,  8038,  8048,  8064,  8074,  8075,  8079,  8083,  8087,  8091,
    8095,  8099,  8103,  8107,  8111,  8115,  8119,  8123,  8127,  8131,
    8135,  8139,  8149,  8150,  8161,  8168,  8179,  8190,  8191,  8195,
    8209,  8216,  8233,  8246,  8255,  8263,  8271,  8280,  8291,  8302,
    8312,  8313,  8324,  8334,  8344,  8354,  8364,  8374,  8382,  8403,
    8426,  8434,  8443,  8454,  8455,  8467,  8483,  8499,  8513,  8533,
    8558,  8559,  8563,  8564,  8565,  8566,  8570,  8584,  8601,  8602,
    8606,  8607,  8610,  8611,  8614,  8615,  8619,  8620,  8633,  8640,
    8650,  8657,  8667,  8668,  8669,  8670,  8671,  8672,  8673,  8674,
    8675,  8679,  8683,  8690,  8697,  8698,  8702,  8703,  8704,  8714,
    8724,  8725,  8729,  8730,  8731,  8732,  8742,  8749,  8767,  8768,
    8778,  8784,  8790,  8796,  8812,  8822,  8828,  8834,  8843,  8845,
    8850,  8861,  8862,  8873,  8887,  8888,  8899,  8910,  8911,  8914,
    8915,  8916,  8917,  8918,  8919,  8920,  8921,  8924,  8925,  8936,
    8954,  8955,  8959,  8960,  8964,  8972,  9000,  9011,  9012,  9022,
    9033,  9036,  9037,  9038,  9039,  9040,  9043,  9044,  9045,  9093,
    9094,  9098,  9099,  9114,  9115,  9122,  9130,  9138,  9146,  9154,
    9162,  9173,  9174,  9201,  9216,  9217,  9236,  9240,  9244,  9259,
    9266,  9276,  9277,  9280,  9292,  9293,  9297,  9309,  9317,  9322,
    9327,  9332,  9337,  9345,  9353,  9358,  9363,  9370,  9371,  9374,
    9375,  9376,  9383,  9384,  9385,  9386,  9390,  9391,  9395,  9399,
    9400,  9403,  9412,  9425,  9426,  9427,  9428,  9432,  9433,  9437,
    9439,  9449,  9454,  9457,  9462,  9463,  9471,  9481,  9482,  9483,
    9491,  9495,  9496,  9499,  9500,  9505,  9506,  9510,  9511,  9515,
    9516,  9520,  9521,  9525,  9526,  9530,  9541,  9542,  9543,  9544,
    9548,  9549,  9554,  9560,  9578,  9579,  9583,  9584,  9590,  9595,
    9604,  9613,  9648,  9673,  9677,  9703,  9707,  9719,  9732,  9746,
    9757,  9772,  9778,  9783,  9789,  9796,  9797,  9805,  9809,  9813,
    9819,  9826,  9831,  9832,  9833,  9834,  9838,  9839,  9851,  9852,
    9857,  9864,  9871,  9878,  9889,  9890,  9903,  9907,  9914,  9924,
    9929,  9930,  9935,  9936,  9944,  9949,  9950,  9954,  9958,  9964,
    9993,  9998, 10005, 10010, 10016, 10021, 10030, 10032, 10035, 10039,
   10040, 10041, 10042, 10043, 10044, 10049, 10079, 10080, 10081, 10082,
   10093, 10099, 10107, 10108, 10114, 10119, 10124, 10129, 10134, 10139,
   10144, 10149, 10155, 10161, 10167, 10174, 10196, 10205, 10209, 10217,
   10221, 10229, 10241, 10262, 10266, 10272, 10276, 10289, 10308, 10331,
   10333, 10335, 10337, 10339, 10341, 10346, 10347, 10351, 10352, 10359,
   10368, 10376, 10385, 10396, 10404, 10405, 10406, 10410, 10412, 10414,
   10416, 10418, 10420, 10422, 10427, 10432, 10438, 10446, 10451, 10458,
   10465, 10469, 10473, 10503, 10504, 10506, 10514, 10536, 10538, 10540,
   10542, 10544, 10546, 10548, 10550, 10552, 10554, 10556, 10559, 10561,
   10563, 10566, 10568, 10570, 10573, 10575, 10588, 10590, 10603, 10605,
   10618, 10620, 10634, 10647, 10660, 10673, 10696, 10703, 10710, 10717,
   10724, 10728, 10735, 10742, 10749, 10756, 10763, 10770, 10774, 10782,
   10786, 10796, 10803, 10810, 10823, 10836, 10855, 10876, 10886, 10893,
   10909, 10914, 10932, 10934, 10936, 10938, 10940, 10942, 10944, 10946,
   10948, 10950, 10952, 10954, 10956, 10958, 10960, 10962, 10964, 10968,
   10973, 10977, 10981, 10986, 11003, 11004, 11005, 11020, 11032, 11034,
   11036, 11046, 11069, 11079, 11089, 11097, 11116, 11129, 11142, 11155,
   11168, 11181, 11198, 11211, 11234, 11247, 11273, 11283, 11296, 11313,
   11326, 11336, 11349, 11359, 11372, 11385, 11398, 11411, 11424, 11437,
   11450, 11452, 11465, 11483, 11497, 11513, 11535, 11551, 11564, 11577,
   11590, 11594, 11601, 11609, 11617, 11621, 11625, 11629, 11633, 11637,
   11652, 11656, 11665, 11669, 11673, 11678, 11692, 11694, 11698, 11700,
   11702, 11705, 11708, 11711, 11712, 11715, 11723, 11733, 11734, 11737,
   11738, 11739, 11744, 11748, 11752, 11756, 11767, 11768, 11772, 11773,
   11778, 11786, 11788, 11802, 11805, 11832, 11833, 11836, 11837, 11848,
   11866, 11873, 11882, 11899, 11944, 11952, 11960, 11968, 11976, 11997,
   11998, 11999, 12002, 12003, 12004, 12007, 12008, 12011, 12012, 12013,
   12014, 12015, 12016, 12017, 12018, 12019, 12022, 12024, 12029, 12031,
   12036, 12038, 12040, 12042, 12044, 12046, 12058, 12062, 12069, 12073,
   12079, 12083, 12094, 12095, 12098, 12102, 12106, 12112, 12113, 12118,
   12122, 12129, 12130, 12131, 12132, 12133, 12134, 12135, 12136, 12146,
   12150, 12157, 12164, 12165, 12181, 12185, 12190, 12194, 12209, 12214,
   12218, 12221, 12224, 12225, 12226, 12229, 12236, 12246, 12260, 12261,
   12265, 12276, 12277, 12280, 12281, 12284, 12288, 12295, 12299, 12303,
   12310, 12320, 12321, 12325, 12326, 12329, 12330, 12341, 12342, 12351,
   12352, 12360, 12371, 12372, 12375, 12391, 12399, 12407, 12429, 12430,
   12441, 12445, 12472, 12474, 12479, 12482, 12485, 12487, 12489, 12491,
   12501, 12503, 12514, 12518, 12522, 12526, 12530, 12539, 12546, 12571,
   12575, 12581, 12598, 12602, 12606, 12612, 12613, 12614, 12616, 12618,
   12622, 12623, 12624, 12640, 12641, 12642, 12647, 12648, 12649, 12654,
   12655, 12656, 12657, 12663, 12664, 12665, 12666, 12667, 12687, 12688,
   12689, 12690, 12691, 12692, 12693, 12694, 12695, 12696, 12697, 12698,
   12699, 12700, 12701, 12702, 12703, 12704, 12705, 12706, 12707, 12708,
   12709, 12710, 12711, 12712, 12713, 12714, 12715, 12716, 12717, 12718,
   12719, 12720, 12721, 12722, 12723, 12724, 12725, 12726, 12727, 12728,
   12729, 12730, 12731, 12732, 12733, 12734, 12735, 12736, 12737, 12738,
   12739, 12740, 12741, 12742, 12743, 12744, 12745, 12746, 12747, 12748,
   12749, 12750, 12751, 12752, 12753, 12754, 12755, 12756, 12757, 12758,
   12759, 12760, 12761, 12762, 12763, 12764, 12765, 12766, 12767, 12768,
   12769, 12770, 12771, 12772, 12773, 12774, 12775, 12776, 12777, 12778,
   12779, 12780, 12781, 12782, 12783, 12784, 12785, 12786, 12787, 12788,
   12789, 12790, 12791, 12792, 12793, 12794, 12795, 12796, 12797, 12798,
   12799, 12800, 12801, 12802, 12803, 12804, 12805, 12806, 12807, 12808,
   12809, 12810, 12811, 12812, 12813, 12814, 12815, 12816, 12817, 12818,
   12819, 12820, 12821, 12822, 12823, 12824, 12825, 12826, 12827, 12828,
   12829, 12830, 12831, 12832, 12833, 12834, 12835, 12836, 12837, 12838,
   12839, 12840, 12841, 12842, 12843, 12844, 12845, 12846, 12847, 12848,
   12849, 12850, 12851, 12852, 12853, 12854, 12855, 12856, 12857, 12858,
   12859, 12860, 12861, 12862, 12863, 12864, 12865, 12866, 12867, 12868,
   12869, 12870, 12871, 12872, 12873, 12874, 12875, 12876, 12877, 12878,
   12879, 12880, 12881, 12882, 12883, 12884, 12885, 12886, 12887, 12888,
   12889, 12890, 12891, 12892, 12893, 12894, 12895, 12896, 12897, 12898,
   12899, 12900, 12901, 12902, 12903, 12904, 12905, 12906, 12907, 12908,
   12909, 12910, 12911, 12912, 12913, 12914, 12915, 12916, 12917, 12918,
   12919, 12920, 12921, 12922, 12923, 12924, 12925, 12926, 12927, 12928,
   12929, 12930, 12931, 12932, 12933, 12934, 12935, 12936, 12937, 12938,
   12939, 12940, 12954, 12955, 12956, 12957, 12958, 12959, 12960, 12961,
   12962, 12963, 12964, 12965, 12966, 12967, 12968, 12969, 12970, 12971,
   12972, 12973, 12974, 12975, 12976, 12977, 12978, 12979, 12980, 12981,
   12982, 12983, 12984, 12985, 12986, 12987, 12988, 12989, 12990, 12991,
   12992, 12993, 12994, 12995, 12996, 12997, 12998, 12999, 13000, 13014,
   13015, 13016, 13017, 13018, 13019, 13020, 13021, 13022, 13023, 13024,
   13025, 13026, 13027, 13028, 13029, 13030, 13031, 13032, 13033, 13034,
   13035, 13036, 13046, 13047, 13048, 13049, 13050, 13051, 13052, 13053,
   13054, 13055, 13056, 13057, 13058, 13059, 13060, 13061, 13062, 13063,
   13064, 13065, 13066, 13067, 13068, 13069, 13070, 13071, 13072, 13073,
   13074, 13075, 13076, 13077, 13078, 13079, 13080, 13081, 13082, 13083,
   13084, 13085, 13086, 13087, 13088, 13089, 13090, 13091, 13092, 13093,
   13094, 13095, 13096, 13097, 13098, 13099, 13100, 13101, 13102, 13103,
   13104, 13105, 13106, 13107, 13108, 13109, 13110, 13111, 13112, 13113,
   13114, 13115, 13116, 13117, 13118, 13119, 13120, 13121, 13122
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LATERAL_P", "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH",
  "MATERIALIZED", "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P",
  "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO",
  "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING",
  "PLANS", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETOF",
  "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC",
  "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE",
  "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS",
  "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P",
  "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'",
  "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "xmlexists_argument",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,    61,    60,
      62,   673,    43,    45,    42,    47,    37,    94,   674,    91,
      93,    40,    41,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   437,   438,   439,   439,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     441,   442,   442,   443,   443,   444,   444,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   446,   446,   446,   446,
     446,   446,   447,   448,   449,   449,   450,   450,   451,   452,
     453,   453,   454,   454,   455,   456,   457,   457,   458,   458,
     459,   459,   459,   459,   460,   460,   461,   461,   462,   462,
     462,   462,   462,   462,   463,   463,   463,   464,   464,   464,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   466,   466,   467,   467,   468,   468,
     469,   469,   469,   469,   470,   470,   470,   470,   471,   471,
     471,   471,   471,   471,   471,   472,   472,   472,   473,   473,
     474,   474,   474,   474,   474,   475,   475,   476,   476,   477,
     477,   477,   477,   477,   478,   479,   479,   480,   480,   481,
     482,   482,   482,   482,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   484,   484,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   486,   486,
     487,   487,   487,   488,   488,   489,   489,   490,   491,   491,
     492,   492,   493,   493,   493,   493,   494,   495,   495,   496,
     496,   496,   496,   497,   497,   498,   498,   499,   499,   500,
     500,   501,   501,   501,   502,   502,   503,   503,   504,   504,
     504,   504,   504,   504,   504,   504,   504,   504,   504,   504,
     504,   505,   505,   506,   506,   507,   507,   508,   508,   509,
     509,   510,   511,   511,   511,   511,   511,   512,   512,   513,
     514,   514,   514,   514,   515,   515,   515,   515,   515,   515,
     515,   515,   516,   516,   517,   517,   518,   518,   519,   519,
     520,   520,   520,   521,   521,   522,   523,   524,   524,   525,
     525,   525,   525,   526,   526,   526,   526,   526,   526,   526,
     527,   527,   527,   527,   528,   529,   529,   529,   530,   530,
     530,   530,   530,   530,   531,   531,   532,   532,   532,   532,
     532,   532,   532,   533,   533,   534,   534,   535,   535,   536,
     537,   537,   537,   537,   538,   538,   539,   539,   540,   540,
     541,   541,   541,   541,   541,   542,   543,   544,   544,   544,
     544,   544,   545,   545,   546,   546,   546,   546,   547,   547,
     547,   547,   548,   548,   549,   549,   550,   551,   552,   553,
     553,   553,   554,   555,   556,   556,   557,   558,   559,   559,
     560,   560,   561,   561,   562,   562,   562,   562,   562,   562,
     562,   562,   562,   562,   562,   562,   563,   563,   564,   564,
     564,   565,   565,   566,   566,   567,   567,   568,   568,   569,
     569,   570,   570,   571,   571,   572,   572,   573,   573,   574,
     575,   575,   576,   576,   577,   577,   578,   578,   579,   579,
     579,   580,   581,   581,   582,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   584,
     585,   585,   585,   585,   586,   586,   587,   587,   588,   588,
     589,   589,   590,   590,   591,   591,   592,   593,   593,   594,
     594,   594,   594,   595,   596,   597,   598,   599,   599,   600,
     600,   601,   601,   602,   602,   603,   603,   603,   604,   604,
     605,   605,   606,   607,   607,   607,   608,   608,   609,   610,
     610,   611,   611,   611,   612,   612,   613,   613,   613,   613,
     613,   614,   614,   615,   615,   616,   616,   617,   617,   618,
     618,   618,   619,   619,   619,   619,   620,   620,   621,   621,
     622,   622,   622,   622,   622,   622,   623,   623,   624,   624,
     625,   625,   626,   627,   627,   628,   629,   629,   629,   629,
     630,   631,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   633,   634,   634,   635,
     635,   636,   636,   636,   636,   636,   637,   637,   638,   639,
     639,   640,   641,   641,   642,   642,   643,   643,   643,   644,
     644,   645,   646,   646,   647,   647,   647,   647,   647,   648,
     648,   649,   649,   650,   650,   650,   651,   651,   652,   653,
     653,   654,   654,   655,   655,   656,   656,   657,   657,   658,
     659,   660,   660,   660,   660,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   662,   662,   663,   663,   664,   664,   665,   666,
     666,   666,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   669,   669,
     670,   670,   670,   670,   670,   671,   671,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     673,   673,   674,   674,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     676,   676,   677,   677,   678,   679,   679,   680,   680,   680,
     680,   680,   681,   681,   682,   682,   682,   682,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   684,   684,   685,   685,   686,   686,
     687,   687,   688,   689,   690,   690,   691,   691,   692,   692,
     693,   694,   694,   695,   695,   695,   696,   696,   696,   697,
     697,   697,   697,   698,   699,   699,   700,   700,   701,   701,
     702,   702,   703,   703,   704,   704,   704,   705,   705,   706,
     706,   706,   707,   707,   707,   708,   708,   708,   709,   709,
     709,   710,   710,   711,   711,   712,   712,   713,   713,   714,
     714,   715,   715,   715,   715,   715,   716,   716,   716,   716,
     716,   717,   718,   719,   719,   719,   720,   720,   720,   721,
     721,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   723,   723,   723,   723,
     724,   724,   725,   725,   726,   727,   727,   728,   729,   729,
     730,   730,   731,   731,   732,   732,   733,   733,   734,   734,
     734,   734,   735,   735,   736,   737,   737,   738,   738,   739,
     739,   739,   740,   740,   740,   741,   742,   742,   743,   743,
     743,   744,   744,   745,   745,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   747,   747,   748,   748,   749,   749,   749,   749,
     749,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     749,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   751,
     752,   752,   752,   753,   753,   754,   754,   754,   754,   754,
     755,   755,   756,   756,   756,   756,   757,   757,   757,   758,
     758,   759,   760,   760,   761,   762,   762,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   764,   764,   764,   765,   765,   765,   765,   765,   766,
     766,   766,   767,   767,   768,   768,   768,   768,   769,   769,
     769,   769,   770,   771,   772,   772,   773,   773,   773,   773,
     773,   773,   773,   773,   773,   773,   773,   773,   773,   773,
     773,   773,   774,   774,   775,   775,   776,   777,   777,   778,
     779,   779,   780,   781,   781,   781,   781,   781,   781,   781,
     782,   782,   783,   784,   784,   784,   784,   784,   784,   785,
     786,   786,   786,   787,   787,   788,   788,   788,   788,   788,
     789,   789,   790,   790,   790,   790,   791,   791,   792,   792,
     793,   793,   794,   794,   795,   795,   796,   796,   797,   797,
     797,   797,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   799,   799,   800,   801,   801,   802,   802,   802,   803,
     804,   804,   805,   805,   805,   805,   806,   806,   807,   807,
     808,   808,   808,   808,   809,   810,   810,   810,   811,   811,
     812,   813,   813,   814,   815,   815,   816,   817,   817,   818,
     818,   818,   818,   818,   818,   818,   818,   819,   819,   820,
     821,   821,   822,   822,   823,   824,   825,   826,   826,   827,
     828,   829,   829,   829,   829,   829,   830,   830,   830,   831,
     831,   832,   832,   833,   833,   833,   833,   833,   833,   833,
     833,   834,   834,   835,   835,   835,   835,   835,   835,   836,
     836,   837,   837,   838,   839,   839,   840,   840,   841,   841,
     841,   841,   841,   841,   841,   841,   841,   842,   842,   843,
     843,   843,   844,   844,   844,   844,   845,   845,   846,   847,
     847,   848,   848,   849,   849,   849,   849,   850,   850,   851,
     851,   851,   852,   852,   853,   853,   854,   855,   855,   855,
     856,   857,   857,   858,   858,   859,   859,   860,   860,   861,
     861,   862,   862,   863,   863,   864,   865,   865,   865,   865,
     866,   866,   867,   867,   868,   868,   869,   869,   870,   870,
     870,   870,   870,   870,   870,   871,   871,   871,   871,   871,
     871,   872,   872,   872,   872,   873,   873,   874,   874,   874,
     874,   874,   875,   875,   875,   875,   876,   876,   877,   877,
     878,   878,   878,   878,   879,   879,   880,   880,   880,   881,
     882,   882,   883,   883,   883,   884,   884,   885,   885,   886,
     887,   887,   887,   887,   887,   887,   888,   888,   888,   889,
     889,   889,   889,   889,   889,   889,   890,   890,   890,   890,
     891,   891,   892,   892,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   894,   894,   895,   895,   896,
     896,   897,   898,   899,   899,   900,   900,   901,   902,   903,
     903,   903,   903,   903,   903,   904,   904,   905,   905,   906,
     906,   906,   906,   907,   908,   908,   908,   909,   909,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     909,   910,   910,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   913,   913,   913,   913,   913,   913,
     913,   913,   913,   913,   913,   913,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   915,   915,   916,   916,
     916,   916,   917,   918,   918,   919,   919,   920,   920,   921,
     921,   921,   922,   922,   922,   922,   923,   923,   924,   924,
     925,   926,   926,   926,   927,   928,   928,   929,   929,   930,
     930,   930,   931,   931,   932,   932,   932,   932,   932,   933,
     933,   933,   934,   934,   934,   935,   935,   936,   936,   936,
     936,   936,   936,   936,   936,   936,   937,   937,   938,   938,
     939,   939,   939,   939,   939,   939,   940,   940,   941,   941,
     942,   942,   943,   943,   944,   944,   944,   945,   945,   946,
     946,   947,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   949,   950,   950,   951,   951,   951,   951,   951,   951,
     952,   953,   954,   954,   954,   955,   955,   956,   957,   957,
     958,   959,   959,   960,   960,   961,   961,   962,   962,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   967,
     967,   968,   969,   969,   970,   970,   970,   970,   971,   971,
     972,   972,   973,   973,   974,   975,   976,   977,   978,   979,
     980,   980,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   982,   983,   984,   985,   985,
     986,   986,   986,   987,   987,   987,   988,   988,   988,   989,
     989,   989,   989,   990,   990,   990,   990,   990,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       5,     1,     0,     2,     0,     2,     0,     2,     2,     3,
       3,     1,     3,     3,     2,     1,     1,     2,     2,     2,
       3,     3,     5,     5,     0,     3,     5,     5,     5,     4,
       3,     5,     3,     5,     5,     6,     1,     1,     3,     5,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     1,     3,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     3,     4,     3,     2,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     6,     4,     6,     4,     6,
       4,     6,     5,     7,     1,     3,     2,     3,     4,     6,
       6,     6,     5,     5,     6,     6,     4,     8,     4,     2,
       3,     6,     4,     3,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     2,
       3,     2,     2,     3,     3,     2,     2,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     3,     2,     0,
       1,     3,     3,     1,     5,     3,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    11,     7,     1,     1,     1,
       0,     1,     1,     1,     1,     3,     2,     0,     1,     1,
       1,     3,     3,     1,     1,     3,     3,     3,     3,     4,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,     5,     2,
       3,     0,     8,     4,     1,     0,     5,     5,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     5,     7,     1,     0,     6,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     5,     2,     0,     2,     7,    10,     6,     6,     6,
       6,     7,     7,     9,     9,     6,     7,     6,     8,     8,
       8,     8,     6,     6,     7,     7,     8,     6,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     6,     8,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,     2,     0,     2,
       2,     1,     0,     4,     6,     5,     4,     4,    10,    13,
       5,     7,     8,     1,     1,     1,     7,     9,     8,    15,
      20,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       3,     0,     1,     1,     1,     1,     2,     0,     0,     2,
       2,     1,     2,     2,     2,     2,     6,     8,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     4,     5,     4,     4,     4,     3,     7,     8,     6,
       6,     6,     6,     6,     4,     5,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     3,
       0,    13,     1,     3,     5,     6,     4,     7,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     5,     7,     1,     1,     1,     2,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     1,     2,     2,     3,     5,     2,
       2,     0,     6,     7,     7,     7,     8,     8,     6,     8,
       9,     9,     7,    10,     7,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     3,     2,     3,     3,     3,     3,     1,     1,
       8,     9,     9,     9,     9,     2,     0,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     2,     3,     2,     2,
       2,     5,     5,     5,     1,     3,     1,     2,     3,     0,
       1,     3,     2,     6,     6,     9,     3,     0,     3,     0,
       5,     2,     0,     3,     3,     3,     7,     7,    10,     1,
       1,     1,     1,    14,     1,     0,     1,     0,     1,     0,
       2,     0,     1,     3,     5,     5,     7,     2,     0,     1,
       2,     0,     1,     1,     0,     1,     1,     0,     9,    12,
       7,     2,     0,     3,     2,     1,     3,     3,     2,     1,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     4,     5,     1,     3,     3,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     1,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     5,     1,     2,
       1,     0,     5,     7,     5,     7,     5,     7,     3,     5,
       5,     5,     1,     3,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,     4,     4,
       4,     1,     1,     1,     0,     7,     6,     6,     6,     6,
       8,     8,     6,     6,     7,     9,     9,     6,     6,     6,
       8,     6,     8,     6,     8,     7,     9,     6,     8,     7,
       9,     8,    10,     9,    11,     8,     9,    11,     8,     8,
       7,     6,     6,     6,     5,     5,     8,     8,     8,     8,
       6,     9,     1,     0,     2,     0,     7,     6,     6,     6,
       6,     6,     7,     9,     9,     6,     8,     8,     8,     8,
       8,     6,     8,     6,     8,     7,     9,     7,     9,     6,
       7,     6,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,     7,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     6,
       8,     3,     2,     0,     2,     2,     2,     2,     3,     3,
       2,     2,     2,     2,     3,     2,     5,     4,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     2,     1,
       3,     2,     1,     0,     9,    11,    11,    13,     3,     4,
       4,     0,     2,     5,     2,     0,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       3,     3,     1,     0,     5,     6,     4,     2,     0,     4,
       3,     5,     6,     4,     6,     6,     5,     7,     9,     6,
       1,     0,     6,    11,    11,    11,    13,     9,    11,    10,
       4,     2,     5,     2,     0,     4,     5,     5,     4,     6,
       1,     3,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     0,     1,     0,     1,     0,     3,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,     3,     0,
       2,     3,     2,     3,     6,     1,     4,     2,     1,     3,
       2,     2,     0,     7,     2,     0,     5,     3,     0,     2,
       2,     2,     3,     1,     3,     1,     2,     1,     0,     8,
       1,     3,     1,     1,     3,     5,     2,     1,     3,     7,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     1,     2,     4,     4,     4,     2,
       3,     1,     3,     6,     1,     0,     2,     0,     3,     3,
       4,     4,     4,     4,     3,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     0,     3,     1,
       3,     4,     3,     2,     2,     1,     1,     1,     0,     2,
       4,     5,     2,     3,     1,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     1,     3,     0,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     2,
       3,     2,     3,     1,     4,     3,     4,     5,     4,     5,
       4,     5,     2,     4,     1,     1,     0,     1,     4,     5,
       4,     0,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     1,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     2,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     3,     3,     2,     3,     5,     4,     6,     3,     5,
       4,     6,     4,     6,     5,     7,     3,     2,     4,     2,
       3,     3,     4,     3,     4,     3,     4,     5,     6,     6,
       7,     6,     7,     6,     7,     3,     4,     4,     6,     2,
       3,     4,     1,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     5,     6,
       6,     7,     3,     4,     1,     1,     2,     4,     1,     1,
       1,     2,     2,     2,     2,     1,     4,     5,     6,     8,
       6,     7,     7,     5,     5,     1,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     4,     4,     6,     5,     5,     5,     4,
       6,     4,     4,     4,     4,     5,     7,     7,     9,     5,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     2,     4,     4,     6,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     2,
       2,     0,     1,     4,     2,     2,     2,     2,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     4,
       1,     4,     1,     2,     1,     2,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     3,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     2,     3,     0,     3,     3,     2,     2,     1,     0,
       2,     2,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     2,     0,     2,     1,     0,     1,     1,     1,
       3,     3,     1,     3,     3,     2,     1,     1,     1,     3,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     5,     2,
       3,     6,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1375,  1173,   528,  1259,  1258,  1173,   239,     0,  1261,     0,
    1173,   352,   942,     0,     0,     0,     0,   528,  1173,     0,
    1375,     0,     0,     0,     0,  1388,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1173,     0,     0,  1395,     0,
       0,     0,     0,  1388,     0,  1263,     0,     0,     0,     0,
       2,     4,    59,    60,    24,    23,    29,    28,    82,    83,
      47,    17,    73,    53,   116,   115,   117,    35,    31,    67,
      21,    22,    32,    36,    55,    37,    48,    94,    54,    20,
      52,    77,    56,    80,    42,    11,    12,    43,    71,    13,
      44,    72,    14,    45,    15,    61,    84,    27,    57,    81,
      58,     5,    38,    69,    65,    10,    49,    50,    51,    74,
      75,    76,    99,    79,   111,    34,   108,    88,    89,   105,
      90,   106,     8,    91,    46,    16,   102,   101,   103,    68,
      39,    70,   100,   104,    18,    19,   107,    78,    97,    93,
     112,   110,   118,    95,    62,     6,     7,    85,    41,     9,
      26,    25,    40,    33,   114,    30,  1261,    87,    98,    86,
      63,    92,    66,    96,   113,    64,   109,  1362,  1349,  1397,
    1361,  1374,     0,  1364,  1172,  1171,  1157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1183,  1903,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,   324,  1926,  1927,  1928,
    1929,  1930,  1931,  1932,  1933,  1934,  1935,  2172,  2173,  2174,
    2175,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  2176,  2177,
    1943,  1944,  1945,  1946,  1947,  2178,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  2179,  2180,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  2181,  1993,  1994,  1995,  2182,  1996,  1997,
    2183,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2184,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2185,  2021,  2022,  2023,  2024,
    2186,  2187,  2188,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2189,  2035,  2036,  2037,  2038,  2039,  2040,
    2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2190,  2191,  2052,  2053,  2192,  2054,  2055,  2056,  2193,
    2057,  2194,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2195,
    2196,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2197,
    2073,  2198,  2076,  2074,  2075,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2199,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,
    2101,  2102,  2103,  2200,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2201,  2118,
    2119,  2120,  2202,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2203,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,  2139,  2204,  2205,  2140,  2206,  2141,  2207,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,
    2153,  2154,  2155,  2156,  2157,  2158,  2208,  2209,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2210,  2211,
    2212,  2213,  2214,  2215,  2216,  2217,  2218,  2169,  2170,  2171,
     323,  1340,  1874,  1904,  1905,  1260,  1241,   528,     0,  1160,
     351,     0,     0,     0,     0,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     165,     0,     0,   375,   374,     0,     0,     0,   914,   380,
       0,     0,     0,     0,     0,   516,  1302,  2074,  1300,  1341,
     240,   243,   241,   242,  1896,     0,  1014,  1015,  1017,     0,
       0,  1027,   754,   755,     0,   753,     0,   757,     0,     0,
       0,   749,     0,     0,     0,     0,     0,   756,   746,     0,
     745,     0,     0,     0,   752,     0,   747,     0,     0,  1161,
    1299,   381,  1375,     0,  1277,  1278,  1279,  1261,  1268,  1280,
    1273,  1275,  1274,  1276,  1272,  1895,  1919,   853,   853,   853,
     853,   850,   851,   853,   853,   853,  2091,     0,     0,   832,
       0,   834,  1900,   853,   858,   436,   436,   436,     0,   857,
     862,   436,  1154,  1192,  1879,  1387,     0,   833,  1153,  2140,
    1291,     0,     0,     0,  1031,     0,  1032,     0,  2106,  1165,
     224,  2116,  2204,  2140,   220,   194,  1923,     0,     0,   857,
       0,  1162,  1163,   816,  1394,  1392,     0,  1941,  1954,  2038,
     217,  2102,  2107,  2116,  2204,  2140,  2168,   174,   179,     0,
     233,  2116,  2204,  2140,   229,  1183,     0,  1365,  1480,  1870,
       0,  1156,  1155,  1262,     0,  1265,     0,  1442,  2087,  1369,
    1371,  1267,  1362,     0,     0,     1,  1375,  1256,  1391,  1391,
       0,  1391,     0,  1354,  1362,  1357,  1361,     0,     0,     0,
       0,  1903,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,
    2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,
    2237,  2238,  2239,  2240,  2241,     0,     0,  1880,  1904,  1908,
       0,   764,     0,   122,  1875,   902,     0,     0,     0,     0,
    1874,     0,     0,     0,     0,  1909,     0,  1897,  1910,  1911,
    1912,  2010,     0,     0,     0,  1775,  1945,  1996,  1785,  1783,
    1784,  1777,  1778,  1779,  1780,  1781,  1782,     0,  1012,  1776,
       0,   144,   122,     0,     0,  2010,     0,     0,  2010,     0,
       0,     0,     0,     0,  2041,   122,  2010,     0,     0,  1177,
       0,     0,     0,  1179,  1182,  1158,  1244,     0,  1870,     0,
       0,   795,   785,     0,   796,   786,   791,     0,   798,     0,
       0,   788,     0,     0,     0,   799,     0,   787,   789,   801,
     790,   797,     0,     0,   792,   793,     0,     0,  1169,   436,
     330,     0,     0,     0,     0,     0,   122,  1231,     0,  2010,
     122,     0,     0,   379,   378,   122,   377,   376,  1945,  1996,
       0,   941,   122,  2010,     0,   167,   598,   531,     0,     0,
     676,  2041,   122,     0,     0,     0,     0,     0,     0,   917,
       0,     0,   515,   528,  1303,  1301,     0,  1018,   219,   218,
    1016,  2010,     0,   302,     0,     0,  2010,  1220,   751,     0,
     750,  2010,     0,  2010,  1898,   158,     0,   748,  1945,  1996,
    2010,     0,     0,  2010,   150,  2010,     0,  2010,   302,  2010,
     532,     0,  2010,     0,  2010,  2041,   152,     0,  2010,   302,
     762,     0,  1296,     0,  1270,  2208,  1285,     0,  1281,  1288,
    1284,  1375,   853,   852,     0,   853,     0,   853,     0,   853,
       0,   853,     0,     0,     0,   853,  1901,  1902,   835,     0,
     859,     0,     0,   866,   865,   864,     0,     0,     0,   867,
    1484,  1318,     0,  1151,  1168,     0,     0,     0,     0,  1034,
    1034,  1034,  1164,   223,   221,     0,     0,     0,     0,     0,
       0,  1170,     0,     0,     0,     0,  1883,  1885,  1886,  1786,
    1853,     0,  2173,  2174,  2175,  1844,     0,  2176,  2177,  2178,
    2221,  1698,  1685,  1694,  1699,  1686,  1688,  1695,  2179,  2180,
    1980,  2181,  2182,  1893,  2183,  2184,  2186,  2187,  2188,  2189,
    1690,  1692,  2190,  2191,     0,  1894,  2193,  2194,  2062,  2196,
    2197,  2199,  2200,  1696,  2202,  2203,  2204,  2205,  2206,  2207,
    1892,     0,  1697,  2209,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,     0,     0,  1867,     0,  1670,     0,  1516,  1517,
    1539,  1540,  1518,  1545,  1546,  1558,  1519,     0,  1866,  1583,
    1669,  1675,     0,  1668,  1664,  1377,  1862,     0,  1665,  1882,
    1884,  1845,   186,   235,     0,   236,  1868,  2116,   175,   216,
     188,   215,   189,   187,     0,  1943,   176,     0,     0,   177,
       0,     0,     0,     0,   232,   230,     0,  1159,     0,  1482,
    1481,     0,     0,  1851,  1871,   771,  1254,  1255,  1253,     0,
    1250,  1252,  1264,  1261,  1858,  1857,  1859,     0,  1370,     0,
       0,     0,  1352,  1351,     3,  1267,  1389,  1390,     0,     0,
       0,     0,     0,     0,     0,     0,  1432,  1405,  1406,  1408,
    1429,  1433,  1441,     0,  1358,     0,     0,  1486,     0,  1443,
       0,     0,  1881,     0,     0,     0,     0,   765,     0,     0,
       0,     0,     0,     0,   121,  1218,   226,  1216,     0,     0,
       0,     0,     0,     0,     0,  1223,     0,     0,   156,   157,
     543,   528,     0,  2010,     0,     0,     0,     0,   974,   981,
       0,     0,     0,     0,     0,     0,     0,   975,   973,   976,
     228,   985,   998,  1001,     0,   892,     0,     0,     0,     0,
    1083,     0,     0,  1083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   246,   254,   297,   508,     0,
       0,   510,  2010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   126,     0,     0,     0,     0,     0,     0,   495,
     507,     0,     0,     0,     0,     0,   504,     0,   122,   248,
     488,   492,     0,     0,     0,   607,   606,     0,  1083,     0,
     244,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   316,   317,     0,     0,
       0,   126,   149,     0,     0,     0,   250,     0,     0,  1178,
    1175,  1176,     0,  1181,     0,  1240,     0,     0,     0,     0,
     803,     0,   800,     0,     0,   794,  1945,  1996,     0,     0,
       0,     0,     0,     0,   354,   329,     0,     0,     0,   673,
       0,  1906,  1527,  1556,  1534,  1556,  1556,  1523,  1523,  1536,
    1524,  1525,  1563,     0,  1556,  1523,  1528,     0,  1526,  1566,
    1566,  1551,     0,  1508,  1509,  1510,  1511,  1537,  1538,  1512,
    1543,  1544,  1513,  1580,  1523,  1907,     0,     0,   684,     0,
    1195,  1230,     0,     0,     0,   537,     0,  2010,     0,   124,
     720,     0,   674,   380,     0,   124,     0,     0,   161,     0,
     602,     0,     0,     0,     0,     0,     0,   622,   621,     0,
       0,     0,   675,     0,   124,     0,   491,  2010,     0,   436,
     436,     0,     0,   916,   919,     0,     0,     0,  1344,  1346,
    1345,     0,  1343,     0,   302,   300,   301,   671,  1026,     0,
       0,     0,     0,   302,     0,     0,  2010,   302,  2010,     0,
    2010,     0,     0,   302,   302,     0,     0,     0,     0,   603,
       0,   761,   759,   758,   760,     0,     0,     0,     0,     0,
    2010,   302,     0,     0,   742,  1796,     0,     0,  1375,     0,
     205,   206,   204,  1286,   207,  1287,  1283,  1269,     0,   843,
       0,   847,     0,   838,     0,   844,     0,   839,   836,   837,
       0,   842,     0,     0,   437,   439,     0,     0,  1965,  1979,
       0,  2001,  2029,  2030,  2107,  2112,     0,  2135,  2144,     0,
     868,   897,   863,     0,     0,  1328,  1152,  1802,     0,  1375,
       0,   481,  1033,  1030,  1029,  1028,   222,   195,     0,     0,
       0,   899,  2106,  1167,   815,   528,     0,  1666,     0,  1673,
    1674,  1555,  1542,  1843,     0,     0,  1550,  1549,     0,     0,
       0,     0,     0,  1532,  1531,  1530,  1672,  1810,     0,  1529,
       0,     0,     0,     0,  1556,  1556,  1554,  1603,     0,  1533,
       0,     0,  1823,     0,  1829,     0,     0,     0,  1562,     0,
    1560,     0,     0,  1639,     0,     0,     0,     0,     0,     0,
       0,     0,  1587,  1588,  1670,  1796,     0,  1671,  1889,     0,
       0,  1548,     0,  1580,  1865,  1786,     0,     0,     0,     0,
    1856,     0,  1794,     0,     0,  1617,  1792,     0,  1619,     0,
       0,     0,  1785,  1783,  1784,  1777,  1778,  1779,  1780,  1781,
    1782,  1790,  1600,     0,     0,  1599,     0,     0,  1445,     0,
    1887,  1846,   237,   238,   234,     0,     0,   191,   190,     0,
     209,   213,   214,   185,   212,     0,   208,   193,  1738,  1737,
     192,   184,   182,   180,   196,   198,   199,   183,   181,   231,
       0,     0,  1913,  2242,  2243,  2244,  2245,  2246,  2247,  2248,
    2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,  2258,
    2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,
    2269,  2270,  2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,
    2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,
    2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,
    2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,
    2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    1848,  1847,  1877,  1914,  1915,  1916,  1917,  1852,     0,     0,
     302,  1248,     0,  1245,  1861,     0,  1372,     0,  1872,     0,
    1257,  1368,  1367,  1398,  1399,   934,  1366,  1423,  1424,  1419,
       0,     0,     0,  1438,  1436,  1415,  1409,  1414,  1412,     0,
    1416,  1583,  1431,  1356,  1403,  1404,  1407,  1355,     0,  1434,
       0,  1328,  1432,  1408,  1315,     0,     0,  1487,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   766,     0,     0,
       0,     0,     0,     0,  2135,   225,  1214,     0,     0,     0,
       0,   901,   900,     0,     0,   921,     0,     0,     0,  1226,
     425,     0,   299,     0,     0,     0,     0,     0,     0,     0,
       0,   669,   666,     0,     0,   665,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   577,     0,  1083,     0,
     610,     0,   983,     0,   982,     0,     0,     0,   984,   979,
     980,  2107,  2116,  2140,   227,  1000,     0,   999,   997,   956,
     958,   957,     0,   960,   944,     0,   945,     0,     0,   955,
     963,   961,     0,     0,     0,     0,  1989,   256,   269,     0,
    1082,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   289,     0,   292,   291,     0,     0,     0,     0,   296,
       0,     0,     0,   295,     0,     0,   509,     0,     0,  1083,
       0,   252,     0,     0,     0,     0,     0,     0,  1013,     0,
     147,     0,   143,   146,     0,     0,     0,     0,   494,   506,
       0,   498,   499,   496,   500,   501,     0,     0,     0,     0,
       0,     0,   493,     0,     0,   600,   599,   605,     0,     0,
       0,     0,     0,     0,     0,  1075,  1074,     0,     0,     0,
       0,     0,     0,   710,     0,     0,     0,     0,     0,     0,
       0,   613,   614,     0,   615,     0,   148,     0,     0,     0,
       0,     0,     0,     0,   203,  1174,  1180,  1243,  1878,  1242,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
       0,   804,   805,   806,   807,     0,     0,     0,     0,     0,
     332,   333,   122,   331,  1906,     0,   699,   672,     0,  1508,
       0,  1504,  1500,  1569,  1570,  1571,  1568,  1581,  1567,     0,
    1514,  1572,  1523,  1520,   685,     0,   687,   690,     0,  1193,
     398,     0,     0,   534,   577,     0,   383,   154,     0,     0,
       0,     0,   120,   165,   167,   381,     0,   166,   168,   170,
     171,   172,   169,   173,   597,   601,     0,   530,     0,     0,
       0,     0,     0,   623,   627,   626,   630,   628,     0,   624,
       0,     0,  1496,     0,   142,     0,   487,   490,     0,     0,
       0,   383,   467,   309,     0,   436,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,  1004,     0,
    1221,  2010,   302,     0,  1002,   159,  1899,     0,   743,     0,
       0,     0,     0,     0,  1006,   739,   151,     0,   302,   302,
     533,     0,   302,   153,     0,     0,     0,   525,   302,   763,
    1298,     0,   436,  1271,  1282,   840,   849,   848,   846,   845,
     841,     0,   860,     0,   435,     0,     0,     0,   874,   875,
       0,     0,   873,   890,   876,     0,   878,   870,   869,   879,
     880,     0,     0,   899,     0,  1325,     0,  1323,     0,  1485,
    1327,  1316,  1290,     0,  1289,  1293,  1295,  1294,  1292,     0,
       0,   486,     0,     0,   857,     0,     0,   302,  1166,     0,
     817,   818,   824,     0,     0,     0,     0,     0,   825,   821,
     822,   823,   826,   827,   828,     0,     0,     0,  1854,  1806,
       0,  1807,     0,     0,     0,  1842,  1838,     0,     0,     0,
       0,     0,     0,  1811,  1814,  1815,  1816,  1813,  1817,  1812,
       0,     0,  1818,     0,     0,     0,     0,     0,  1553,  1552,
       0,     0,     0,     0,     0,     0,     0,  1642,  1675,     0,
       0,  1770,     0,  1796,  1828,     0,     0,  1564,     0,     0,
       0,     0,     0,     0,     0,  1796,  1834,     0,     0,     0,
       0,  1736,     0,  1733,     0,     0,     0,     0,  1853,     0,
       0,     0,     0,  1890,  1584,  1601,  1864,     0,  1855,     0,
       0,  1585,  1608,     0,  1835,  1635,     0,  1640,  1623,     0,
    1616,     0,  1621,  1625,  1604,  1856,  1795,     0,  1793,     0,
       0,  1602,     0,  1597,  1595,  1596,  1589,  1590,  1591,  1592,
    1593,  1594,  1598,  1774,  1772,  1773,     0,     0,     0,  1620,
    2003,  2038,     0,  1388,  1388,  1388,  1376,  1386,  1863,     0,
    1491,     0,     0,     0,     0,  1753,     0,  1800,     0,  1798,
    1880,  1869,     0,     0,  1580,     0,  1483,  1849,     0,   769,
     770,   768,  1267,  1251,  1247,  1246,  1860,  1266,     0,  1375,
       0,   932,   933,     0,   937,     0,     0,  1417,  1439,     0,
    1430,     0,  1421,  1422,  1413,  1440,  1435,  1360,  1359,     0,
    1494,     0,     0,  1312,  1305,  1488,     0,  1445,  1330,  1332,
    1333,     0,  1853,   697,   696,     0,     0,     0,  1111,  1036,
    1087,   767,  1112,  1037,  1088,  1113,  1038,  1215,     0,  1217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   648,  2010,   302,  1224,  1114,     0,
    1039,   298,  1225,  1089,  1229,   668,   667,     0,     0,  1090,
       0,   542,     0,     0,   547,   548,   549,     0,     0,     0,
     550,     0,  1945,  1996,     0,   555,   562,   567,   557,     0,
     568,   563,     0,     0,     0,     0,     0,     0,   574,   581,
       0,     0,     0,     0,     0,     0,   977,   978,  1115,  1042,
       0,  1091,   959,  1523,   943,     0,     0,   954,     0,   953,
    1523,  1523,  1043,   155,     0,   247,   257,   583,  1085,   275,
     288,   283,   284,   282,  2010,   302,  2010,   302,     0,     0,
       0,     0,   285,   280,   281,   277,   290,  1922,  1981,  2117,
       0,   587,   589,     0,   594,   293,  1057,     0,   310,   313,
     294,   273,   276,   274,   270,   255,     0,     0,     0,     0,
       0,     0,  1876,     0,     0,  1008,     0,     0,     0,   145,
    1071,   135,     0,     0,   131,     0,     0,     0,     0,   125,
       0,  1121,  1047,     0,     0,   249,   489,   497,   502,  1051,
     505,  1101,   503,  1127,  1048,  1083,     0,   245,     0,  1049,
       0,  1095,  1123,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,     0,     0,     0,     0,   302,
       0,     0,     0,  1085,  2010,   302,  1122,     0,  1080,  1109,
       0,   318,     0,  1072,     0,     0,   251,  1053,  1103,     0,
       0,   201,   200,   202,     0,     0,     0,     0,     0,     0,
       0,     0,   809,   778,   808,     0,     0,     0,   772,   353,
     327,   328,   330,   337,     0,   698,     0,     0,  1505,  1501,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1521,
     686,     0,     0,     0,     0,  1213,  1213,  1213,  1213,  1213,
    1213,  1213,  1194,  1222,     0,   122,     0,     0,     0,   536,
     576,   583,     0,     0,     0,   382,   386,   390,   391,   392,
       0,     0,     0,     0,   136,   123,     0,   728,     0,   436,
       0,   167,   160,     0,     0,     0,   529,   683,   681,   680,
     682,     0,     0,     0,   703,   679,     0,  1495,  1497,     0,
       0,     0,     0,   481,   385,     0,   439,     0,     0,   471,
       0,     0,     0,   309,     0,     0,   948,     0,   966,   949,
       0,     0,     0,   988,   993,   989,   969,     0,   513,  1347,
    1348,     0,   302,     0,     0,   578,   302,   302,     0,   302,
       0,   302,   302,     0,  1149,   604,     0,   656,     0,     0,
     302,   741,  1797,   861,   438,     0,     0,     0,     0,   872,
       0,   511,   877,     0,   889,   884,   886,     0,   893,  1326,
    1319,  1321,  1320,     0,     0,  1317,  1803,   740,   479,     0,
       0,     0,   302,     0,   894,     0,   819,   820,     0,     0,
     829,     0,     0,  1393,  1804,  1805,     0,     0,     0,     0,
    1839,     0,     0,  1711,     0,  1687,  1689,  1522,  1701,     0,
    1535,  1712,  1713,  1691,  1693,     0,  1787,     0,     0,  1702,
    1644,  1645,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1657,  1656,  1703,  1769,     0,
       0,  1826,  1827,  1704,  1565,  1566,  1566,     0,     0,  1833,
       0,     0,     0,  1709,  1714,     0,     0,     0,     0,  1720,
       0,  1741,     0,     0,     0,  1667,  1797,  1557,  1558,     0,
       0,     0,     0,     0,     0,     0,     0,  1641,  1624,  1618,
       0,  1622,  1626,     0,     0,     0,     0,  1610,  1636,  1606,
       0,     0,  1612,     0,  1637,  1388,  1388,  1388,  1388,  1385,
       0,     0,     0,     0,     0,  1466,  1444,  1446,  1453,  1466,
    1471,  1489,     0,  1870,     0,  1426,  1397,  1397,     0,  1753,
       0,  1676,     0,  1753,     0,     0,   178,     0,   210,   197,
       0,  1249,  1873,     0,  1400,     0,  1788,   937,   935,   936,
    1402,     0,     0,  1437,  1410,  1314,     0,  1312,  1307,     0,
    1308,  1853,     0,  1304,  1337,     0,     0,  1494,     0,  1336,
    1110,  1035,  1086,  1213,   904,   905,     0,   903,     0,     0,
       0,   424,   920,     0,     0,     0,   648,     0,     0,   428,
       0,  1227,     0,  1128,  1070,   544,   545,     0,   556,     0,
     565,   564,     0,     0,   552,     0,     0,     0,     0,   551,
     570,   517,   571,   573,     0,     0,   572,   575,   580,  1083,
       0,   611,  1059,     0,  1107,   971,     0,  1523,   946,   951,
     952,     0,     0,     0,   398,     0,     0,     0,   258,   268,
       0,     0,   272,     0,   266,   286,   278,   287,   279,   591,
     592,   590,   586,     0,   593,   595,   307,     0,     0,     0,
    1117,  1083,     0,   253,  1055,     0,  1105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,  1092,
       0,     0,   128,   127,     0,   134,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   319,
     304,     0,   706,     0,     0,     0,   321,     0,     0,     0,
       0,  1116,  1044,   773,     0,     0,   774,   782,     0,     0,
     775,     0,     0,   784,     0,     0,   326,   334,  2062,  1777,
    1778,   694,   701,   691,   693,   695,   692,     0,   700,   648,
       0,     0,     0,  1506,     0,  1574,  1575,  1576,  1577,  1578,
    1579,     0,  1573,  1580,   688,   689,     0,  1213,  1212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     410,     0,     0,   404,     0,     0,   993,   397,   400,   401,
       0,     0,   537,   540,   538,   539,   569,     0,   417,     0,
       0,   138,     0,     0,   139,   137,     0,     0,   309,     0,
     163,   381,     0,     0,   629,   632,   625,     0,   702,   704,
     677,     0,   583,     0,     0,  1299,   477,     0,   467,   463,
     465,   464,   466,     0,   473,   308,     0,   481,   473,     0,
     921,   947,     0,     0,     0,   986,   990,   987,     0,     0,
     962,     0,   970,   940,  1144,  1145,  1142,  1143,     0,     0,
    1339,  1005,     0,   302,  1003,   744,     0,   735,     0,   737,
    1007,   302,   302,   616,     0,   526,     0,     0,     0,   871,
     891,     0,   887,     0,     0,   854,   896,  1324,  1322,   480,
     899,     0,   855,   898,     0,     0,     0,     0,     0,  1808,
    1541,     0,  1841,  1837,     0,  1684,  1809,     0,  1821,  1820,
    1643,  1822,     0,  1662,     0,     0,  1654,  1652,  1653,  1646,
    1647,  1648,  1649,  1650,  1651,  1655,  1831,  1830,  1824,  1825,
    1561,  1559,     0,  1706,  1707,  1708,  1832,  1715,     0,  1936,
    1742,  1719,  1735,  1734,     0,     0,     0,  1722,     0,     0,
    1731,     0,  1771,  1547,  1580,  1586,     0,     0,  1609,  1836,
    1627,     0,     0,     0,  1605,     0,     0,     0,     0,  1614,
    1787,     0,     0,     0,     0,     0,     0,  1379,  1378,  1384,
    1466,  1471,  1362,     0,  1453,     0,  1465,  1451,  1464,     0,
       0,  1477,  1475,     0,  1477,     0,  1477,     0,  1448,     0,
    1467,  1449,  1464,     0,  1871,  1490,     0,  1428,     0,     0,
    1396,     0,  1753,  1683,  1756,  1751,  1752,  1801,  1677,  1888,
       0,  1799,  1753,     0,  1850,  1373,     0,  1401,  1418,  1411,
    1961,  1492,  1313,     0,     0,  1310,  1311,     0,     0,  1331,
    1312,  1334,     0,   910,   911,   909,   912,     0,     0,     0,
     648,     0,     0,   444,     0,   928,   928,     0,     0,   430,
     476,   993,   651,     0,     0,     0,   649,   302,  1040,     0,
     566,     0,     0,   561,   559,   558,   560,   518,  1126,  1041,
       0,     0,     0,     0,   972,     0,   964,  1058,     0,   395,
       0,   263,  1084,     0,     0,     0,   262,     0,   302,   302,
     588,   311,   312,   315,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   729,   712,     0,     0,   730,   731,
       0,     0,     0,  1010,  1011,  1009,   132,   129,   130,   133,
    1068,  1052,  1102,  1050,     0,  1096,  1065,  1061,     0,     0,
       0,     0,     0,  1125,  1079,  1100,  1124,  1077,  1098,  1076,
    1097,  1078,  1099,  1069,     0,  1499,   709,     0,     0,     0,
     302,   302,   618,  1054,  1104,     0,   776,     0,     0,   777,
     779,   356,     0,   359,   366,   338,   343,  1231,     0,  1231,
       0,   340,   344,  1231,   339,  1231,   336,   670,     0,     0,
       0,  1502,  1507,  1582,  1515,   647,     0,  1204,  1203,  1202,
    1206,  1205,  1208,  1207,  1199,  1198,  1211,  1210,  1197,  1196,
    1201,  1200,     0,   402,     0,   408,   412,   413,   411,   403,
     993,   436,   475,     0,     0,   660,     0,   535,   383,   414,
       0,   387,   141,   140,     0,     0,     0,   167,     0,     0,
     634,   638,   678,     0,  1498,   612,   309,     0,   383,   481,
       0,   388,   393,   394,     0,   471,     0,   467,     0,     0,
     478,  1191,   482,   483,     0,     0,   950,   967,   968,     0,
       0,   993,   992,     0,   520,   302,   579,   302,   302,  1150,
     657,     0,   883,   882,   881,   512,     0,   885,   302,     0,
       0,     0,     0,     0,   831,   810,   830,  1840,  1700,  1710,
    1819,     0,     0,  1663,     0,     0,  1705,  2210,     0,     0,
       0,     0,  1739,  1740,  1721,     0,  2053,  1726,     0,     0,
       0,  1891,  1633,  1631,  1628,     0,  1629,     0,     0,  1611,
    1607,     0,  1613,  1638,  1383,  1382,  1381,  1380,  1452,  1450,
    1455,  1462,     0,  1447,     0,  1476,  1472,     0,  1473,     0,
       0,  1474,     0,     0,  1462,     0,     0,     0,     0,  1747,
    1753,  1753,  1678,  1758,  1755,     0,  1680,  1580,     0,     0,
    1306,  1309,     0,  1338,  1329,  1219,     0,     0,     0,   426,
       0,   993,     0,     0,     0,   931,   931,     0,   993,   475,
     653,   652,   655,   650,   654,  1228,     0,   553,   554,  1060,
       0,  1108,  1066,   965,     0,   584,   259,   260,   261,   264,
     304,   271,   265,     0,  1056,     0,  1106,  1063,  1119,  1045,
    1093,     0,     0,   718,     0,     0,     0,     0,  1120,  1046,
    1094,     0,     0,     0,     0,  1237,     0,   303,   708,   707,
     304,   320,  1081,     0,   780,   781,   357,   122,     0,   335,
       0,   364,     0,   362,   361,   363,     0,   350,     0,     0,
       0,     0,     0,  1503,     0,  1024,  1024,     0,   648,  1209,
       0,     0,   399,   475,   443,     0,   405,     0,     0,     0,
       0,     0,     0,     0,   583,     0,     0,     0,   162,   383,
     583,   633,     0,     0,     0,   705,     0,   385,     0,  1297,
     384,     0,     0,   473,     0,   471,     0,   468,     0,   472,
       0,  1184,     0,     0,   991,     0,   995,     0,   961,   938,
    1491,     0,   524,  1025,   736,   738,   617,   888,   895,   302,
     811,   812,   813,   814,  1658,     0,     0,     0,     0,  1716,
       0,  1717,  1744,  1743,  1723,  1727,     0,  1724,  1725,  1630,
    1634,  1632,  1615,  1454,     0,     0,  1456,     0,     0,  1458,
    1460,     0,     0,     0,     0,     0,  1874,  1753,  1425,  1427,
       0,  1363,  1681,  1682,     0,  1397,  1753,   211,  1789,  1493,
    1335,   889,     0,   302,   928,   475,   445,  2062,   446,   927,
       0,   929,   934,   934,     0,   475,   648,   546,     0,   582,
       0,   306,   314,     0,     0,     0,   725,   713,     0,     0,
     732,  1062,     0,     0,     0,     0,     0,   302,   783,   337,
       0,   360,   369,     0,   367,   341,   346,     0,   348,   347,
     342,   345,  1024,     0,  1021,  1020,   646,     0,   434,   406,
       0,   454,     0,     0,   661,     0,     0,     0,   423,   422,
     419,   418,   420,   421,   416,   415,   608,   722,   309,  1191,
     596,   635,   636,   631,     0,     0,     0,   467,   463,   389,
     398,   372,     0,   473,   469,   470,     0,     0,     0,  1239,
       0,   922,   994,     0,     0,     0,   519,     0,     0,   523,
     514,   856,  1659,     0,  1660,     0,     0,     0,  1729,  1728,
       0,  1463,  1479,     0,  1459,  1457,  1468,     0,  1470,  1746,
    1748,     0,     0,  1761,  1679,   906,     0,   907,   931,   449,
       0,   930,   937,   937,   436,   648,   427,  1067,   585,     0,
     267,  1064,     0,   716,     0,   727,   725,     0,     0,  1233,
       0,  1234,  1235,  1238,   322,   325,   355,   365,     0,   349,
    1019,  1023,  1022,     0,     0,   407,   440,   441,   442,     0,
     409,   450,   451,     0,   658,     0,   663,     0,     0,     0,
       0,     0,  1185,     0,     0,  1186,   471,   467,   396,   462,
     370,     0,  1188,     0,   309,     0,   993,   996,  1148,   522,
     521,  1661,  1732,  1718,  1745,  1730,  1461,     0,  1469,     0,
       0,  1757,     0,     0,     0,     0,   934,     0,   648,     0,
     925,   924,   443,   429,   305,     0,     0,   723,   726,   714,
     727,   734,   733,     0,   368,     0,   433,     0,     0,     0,
     452,     0,   453,   474,     0,   662,     0,   583,   721,     0,
       0,   637,     0,   473,   471,  1189,  1190,   473,   923,   939,
    1147,  1146,  1375,  1478,  1749,  1750,  2172,  1961,  2146,     0,
    1759,  1762,  1760,  1754,   302,   937,     0,   431,   447,   454,
       0,     0,   715,  1236,   638,   459,     0,   458,     0,   456,
     455,   659,   664,   609,   711,  1187,   641,   373,   473,  1491,
    1130,  1375,  1129,  1131,  1139,  1136,  1138,  1137,  1135,     0,
    1766,  1765,  1764,  1768,  1767,   908,   926,     0,   648,   717,
     724,     0,   457,   461,   460,   643,     0,   639,   642,   644,
     645,   371,   913,     0,  1140,  1134,  1362,  1349,     0,   448,
     432,     0,   619,     0,  1132,  1375,  1763,     0,   640,  1133,
       0,   641,     0,   620
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1205,  2127,  2002,  2794,  2795,
      53,    54,  1280,    55,    56,    57,    58,    59,    60,    61,
    1221,    62,    63,   884,  1428,  2137,    64,  1865,   688,   689,
    1703,  1704,  2065,  1705,  1693,  1120,  1514,  1240,  1207,  1241,
      66,    67,  1114,  1684,    68,    69,    70,  1265,  1266,  1215,
    1467,  3665,  4240,  1983,  2831,  2627,  2628,    71,  1326,  1327,
      72,    73,  2742,  1366,  2092,  3246,  3247,  3696,   521,  2089,
    3957,  3958,  3682,  3683,  3964,  4133,  4134,  2138,  1424,  2825,
    3338,  2785,  3760,  2786,  3761,  2787,  3762,  2773,  3297,  3298,
    3299,  2788,  3739,  4164,  2789,  1880,  4265,  2172,  1536,  1534,
    4151,  3562,  3563,  4318,  4270,  4271,  4272,  4389,  3767,  2829,
    3344,  3770,  3986,  2524,   604,  1448,  2271,   605,  2174,   552,
     606,  2139,    79,  2166,  1300,  1301,  2010,  3251,  2882,    80,
     903,  3120,  4032,  4199,  4200,    81,   205,    82,  1432,    83,
      84,  2123,  2779,    85,  1897,  2541,    86,    87,  2568,  2569,
    2570,    88,    89,  3144,  3914,  1267,  2620,  2621,  2622,  2623,
    3164,    90,  1430,  1306,  2146,    91,    92,    93,    94,    95,
    2053,    96,    97,  2140,  1440,  2158,  2159,  3751,  4002,  4173,
    4004,  4426,  4427,  3978,  3099,  3576,    99,   100,  3734,  3735,
    4277,   101,  1895,   102,   103,   104,  1408,  2115,  2116,  3252,
    1191,  1369,  2095,  2096,  3327,  3328,   105,  2702,   106,  3624,
    3625,   553,  4280,  4245,  4329,   107,   108,  3628,  3629,   109,
     110,   111,   112,   113,   598,   949,   950,  1197,   114,  1800,
     115,   857,  2733,   116,  1014,  2296,  3805,   117,   629,   963,
     964,  2141,   119,   638,  2274,   640,  1549,  2884,  2885,  3395,
    2242,   773,   120,   121,  2253,  2277,   122,  1208,  1871,  1872,
    3557,  2142,   554,  1454,  2177,  2519,  4190,  3564,  3895,  4102,
    2464,  3060,   124,   555,  1245,  1945,  2180,  2837,  2838,  1947,
    2436,  3359,  1949,  2839,  2844,  2845,  2846,  3355,  3363,  4026,
    4027,   125,  1243,  1938,   126,   127,   128,  1277,   797,   129,
     566,   567,   130,  4144,   131,   915,   132,   657,  1563,   133,
    1961,  3150,   134,   135,   136,  4402,  4433,  4434,  4435,  3368,
    4362,   137,  4404,   993,   139,   140,   141,   176,   823,   824,
     825,  2143,  4021,   143,   144,  2119,  2772,  3279,   145,   146,
    1866,  2509,   147,   148,   149,  1412,   150,   151,   152,   153,
    1345,   154,  1149,  1150,   155,   156,   516,   705,  1153,  1161,
     157,   608,   957,   958,   959,  1516,   158,   996,  2264,   609,
     952,   160,   610,  2483,  3069,  3070,  3073,   611,  2480,   163,
    1555,  2258,  2261,   612,  2487,  2488,  2489,  2490,  2491,  3075,
     613,   631,   906,  2185,   614,  1086,   168,   169,   170,   714,
     709,   710,   172,  1678,  2426,   646,  1168,   676,   722,  3520,
    1813,  1814,  1836,  1837,  1177,  1178,  1826,  1828,  2466,  1829,
    2474,  1819,  3517,  3869,  1832,  1833,  1180,  1181,  1182,  1841,
     173,  2430,  3026,  3027,  3028,  3496,  3497,  3511,  3507,  3856,
    4069,  3029,   991,  1188,  3030,  3035,  3067,  2816,  2817,  2818,
    1950,  2102,  1393,  1087,  1394,  2113,  1088,  1599,  1396,  1089,
    1090,  1091,  1399,  1092,  1093,  1094,  1095,  1582,  1641,  1096,
    1097,  1618,  2110,  2111,  1505,  2336,  1099,  1100,  3460,  3829,
    3818,  2362,  2363,  1700,  3456,  2977,  4081,  4219,  4220,  3528,
    3525,  3873,  4085,  4314,  4370,  4371,  1101,  2416,  1671,   799,
    1102,  3254,  1673,  2356,  2438,  2439,  1850,  1580,  2302,  2320,
    2321,  2333,  2938,  2340,  2345,  2961,  2962,  2357,  2385,  1103,
    2305,  2306,  2921,  1584,  1104,  1143,  1144,  1577,  2380,  1156,
    1157,   707,  1105,  1106,  1550,   698,  4065,   511,   763,  2641,
    1791,   827,   643,  1107,  1108,  1109,  1110,   924,   925,  1271,
     512,   757,   777,  2624,   513,   514,   759,  1796
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -4044
static const int yypact[] =
{
    5677,   873, 11610, -4044, -4044,   873, -4044, 51579,   -38,   115,
     575,   132, 11248, 51991, 58995,   222,   271, 11357,   873, 58995,
    2195, 38395, 49107, 58995,  1104,   854, 38395, 58995, 59407,  1087,
    1070,   736, 59819, 52403, 47871,   851, 58995,  1137,   282, 60231,
   52815,  1002, 53227,   854, 35531,   108,  1015, 60643,  1295,  1493,
    1065, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,   -38, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,   343, -4044,   663,
     347,  1606,   722,  1331, -4044, -4044, -4044, 43339, 58995, 58995,
   58995,  1310, 58995,  1396, 58995,   632, 43339, 43751, 61055,  1532,
    1409, 32155, -4044, 41691, 58995, 58995, 61467, 58995, 53639, 58995,
    1495, 58995, 58995, 44163, 61879,  1669,  1466, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, 58995,  5198,  1104, -4044,
   -4044, 58995,  1460, 43339, 58995,  1449, 58995,  1479, 58995, -4044,
   58995,  1526, 62291,   699,   595, 43751,  1172, 32580,  1616, 43751,
   62703, 58995, 58995, -4044, -4044,  1612, 58995, 58995, -4044,  1724,
   44575,   952,  1736,  1883,  1822,   762, -4044, 54051, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, 42103,   271, -4044, -4044, 44987,
   58995,  1885, -4044, -4044, 63115, -4044,  1694, -4044,   713, 45399,
   45811,  1988,  1682, 33005,  2032, 46223, 63527, -4044, -4044, 63939,
   -4044, 64351,  1776, 64763, -4044, 46635, -4044,  1897, 65175, -4044,
    1677,  1393,  1471, 28804, -4044, -4044, -4044,   -38, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,   287,  1562,   309,   175,
     363, -4044, -4044,   182,   187,   188,   287,  2125,  2125, -4044,
   58995, -4044, -4044,  1562,     6,  1717,  1717,  1717,  1903,   -20,
   -4044,  1717, -4044, -4044, -4044, -4044, 53227, -4044,  1732,  1104,
    1728,  2127,  1842, 58995, -4044, 58995, -4044, 58995, 58995, -4044,
   -4044,  2200,  1830,  2062,  1846, -4044,  2014,  2035,  2051,    96,
    1104,  1951, -4044,  2185, -4044,  2088, 19460,  1104, 54463, 65587,
     335, 42103,  1104, 54875,  1924,   855,  2110, -4044, -4044,   640,
   -4044,  2325,  1956,  2175,  1846,  1466, 30058, -4044,  1952,   500,
   53227, -4044, -4044, -4044,   192,  2230, 19889, -4044, 58995,  1950,
   -4044,  1960,  1961,  1982,  1606, -4044,  5677, 58995,   286,   286,
    2344,   286,   173,  1619, -4044,  1451, -4044,  2264,  2242, 53227,
    1015,   195, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,  1989,   500, -4044,   197, -4044,
    1480,  2000,  1575,  1363, -4044, -4044,   225, 58995,  2114,   353,
     -29,  2049, 55287,  5152,  2011, -4044,   783, -4044, -4044, -4044,
   -4044,  2312,  2927,   303, 65999, -4044, 58995, 58995, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2036, -4044, -4044,
    2043,  2298,    82,  2234,   622,  2346,  8562,  1337,  2356,  4294,
    1312,   744,  2244,  1027,  2351,  1199,  2364,  6202, 58995, -4044,
    2300,  2404,   735, -4044,   141, -4044,  2134,  2270,   963, 43339,
    2091, -4044, -4044, 58995, -4044, -4044, -4044,  2166, -4044,   714,
   43339, -4044,  2293,  2148, 33430, -4044, 58995, -4044, -4044, -4044,
   -4044, -4044,  2235, 58995, -4044, -4044,  2350, 58995, -4044,  1717,
    2274,  2132,  2496, 74607,   324, 58995,  2168,  2541, 58995,  2342,
    2168,  2178, 66411, -4044, -4044,  2168, -4044, -4044, 58995, 58995,
    2157,  1684,  2168,  2355,  2557,  2563,  2237,  2345,   838,   258,
     158,  2463,  2168,  2223, 58995, 66823, 58995,  2224, 58995,  2545,
   43339, 58995, -4044,  2340, -4044, -4044,  1162, -4044, -4044, -4044,
   -4044,  2492,  1989,   715,  2493,  2198,  2497, -4044, -4044,  2231,
   -4044,  2498,  2011,  2499, -4044,  2203, 67235, -4044, 67647, 68059,
    2500,  2036, 43751,  2504,  2203,  2505,  2381,  2508,   715,  2509,
   -4044,  1076,  2511,  2401,  2516,  1115,  2203, 42515,  2517,   393,
   -4044, 21605, -4044,  2306, -4044,  1015, -4044,  1538, -4044, 37983,
   -4044,  1471,  1562, -4044, 58995,  1562, 58995,  1562, 58995,  1562,
   58995,  1562, 58995, 58995, 58995,  1562, -4044, -4044, -4044, 58995,
    2225, 58995, 58995, -4044, -4044, -4044, 49519, 43751, 49931, -4044,
   -4044,    80,  1104, -4044, -4044, 74607,  2623, 43751, 58995,  2512,
    2512,  2512, -4044, -4044, -4044,  2450, 58995,  2514,  2519, 49519,
   43751, -4044, 68471, 42103,  2413,  2240, -4044, -4044, -4044, -4044,
   -4044,  1259,  2658,   220,  2663, 21605,  2241,   169,   169,  2243,
    2527, -4044, -4044, -4044,   226,  2247,  2248, -4044,   230,   230,
    2408,  2254,  2255, -4044,   235,  2257,  2684,  2685,   252,  2262,
    2263,  2266,  1683,   169, 21605, -4044,  2268,   230,  2271,  2272,
    2273,  2690,  2275, -4044,  2691,  2276,   201,   284,  2277,  2278,
   -4044,  2254, -4044,   227,  2279,  2280,  2284,  2288,  2289,  2291,
    2294,  2295, 21605, 21605, -4044, 18602,   500,  1104, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,   121, -4044,   253,  4647, -4044,
   -4044,  2465, 21605, -4044, -4044,   598, -4044,   254, -4044, -4044,
   -4044,   500, -4044, -4044,   221,  2296, -4044,   314, -4044, -4044,
   -4044, -4044, -4044, -4044, 40455,  2697, -4044,   822,  1104,   141,
    1263,  2646, 37159, 37571, -4044, -4044,  2525, -4044, 58995, -4044,
   -4044, 21605, 35119, -4044,   500,   124, -4044, -4044, -4044,  1557,
   -4044, -4044, -4044,   -38, -4044, 10913, -4044,  1597,  1950, 58995,
   58995,  2704, -4044, -4044, -4044,  1960, -4044, -4044,  1606,  1606,
   21605,  1606,   816,  1207, 20318, 21605,  2591,  2491,  1092,  1194,
    2595, -4044,  2501,   173,  1619, 53227, 58995, 68883,  2419, -4044,
   36355,  1642,   500,  2387,  2388,  2435, 39219,  2315,  2394,  2397,
    2443,  2399,  2400, 69295, -4044, -4044, -4044, -4044,  1288,   881,
     207,  2403,   190,   935,  2687, -4044,  1212,  2452, -4044, -4044,
   -4044,  3453, 58995,  2634,  6278,  2521,   303,  2455, -4044, -4044,
    2568,  2417,  2418,  2536,   303,   209, 69707, -4044, -4044, -4044,
   -4044, -4044, -4044,  2265, 17371, -4044,  2420,  2405, 58995, 47047,
    2710,  2532,  1237,   289,   179, 58995,  2606,  2540, 58995,  2357,
    2430,  2432,  2361,  1218,  2717,  2366, -4044, -4044, -4044,  1505,
    2534, -4044,  2665,  6372,  2423,  2424, 73393,    51, 33855,  2708,
      50,  2453, -4044,    50, 58995,  2457,  2458, 58995,   303, -4044,
    2759,   303,   303,  1687,  2761,  2459,   351,  1274,  2168,  2366,
    1322, -4044,  2460,  2466,   810, -4044,  2559, 53227,   331,  1381,
    2366,  2467,  2468,  2361,  2361, 58995, 58995, 58995, 58995, 58995,
     193,  2790,  2792,  2477,   172,  2523,  2402, -4044, 40867,  2479,
   65587, -4044, -4044, 58995,  2481,  1766,  2366,  1477,  1595, -4044,
   -4044, -4044,  1466, -4044, 58995, -4044, 58995,  1989, 74607,  2592,
   -4044,  2442, -4044,  2011,   303, -4044, 58995, 58995,  2036,  1017,
    1102,  2594, 58995,  2652,  2448, -4044,   194, 36757,  2157, -4044,
    2427, -4044, -4044,  2461, -4044,  2461,  2461,  2431,  2431,  2433,
   -4044, -4044, -4044,  1683,  2461,  2431, -4044, 75409, -4044,  1291,
    1507, -4044,  2817,  2820, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,   915,  1465, -4044, 58995, 39219, -4044,  2834,
   -4044, -4044, 74607,  2612,  2720, -4044, 58995,  2632,  2437, -4044,
    2767,  2494, -4044, -4044,    36, -4044,  2737, 43751,   223,  1104,
    2485, 58995,  2664, 58995, 58995, 58995, 58995, -4044, -4044,  2636,
     840,    95, -4044, 40867, -4044, 58995,  1322,  2644,  2852,    43,
    1717, 58995,  2739, -4044, 58995,  2456,  2855,  2692, -4044,  1522,
   -4044,  2575, -4044, 43339,   715, -4044, -4044, -4044, -4044, 74607,
   58995, 70119, 43339,   715, 43751, 43751,  2756,   393,  2757,  2515,
    2760,  2524, 33855,   715,   406, 43751, 58995, 58995, 58995, -4044,
   58995, -4044, -4044, -4044, -4044, 58995, 58995, 43751, 40867,  2763,
    2765,   715, 58995, 58995, -4044, 10913,  1608, 58995,  1471, 41279,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, 58995, -4044,
   58995, -4044, 58995, -4044, 58995, -4044, 58995, -4044, -4044, -4044,
   58995, -4044, 58995,  1615, -4044, -4044,  1633,  1049, 58995, 58995,
     704, 43339, 58995,  2660, 58995, 58995, 58995, 58995, 58995,  2549,
    2296,  1091, -4044,   234, 53227,  2668, -4044, -4044,  1656,  1295,
     919,  2513, -4044, -4044, -4044, -4044, -4044, -4044, 49931, 49107,
    2751,    67, 58995, -4044, -4044,  3384, 21605,   500, 19031, -4044,
   -4044, -4044,  2480, 10913,  2522, 21605, -4044, -4044, 21605,  2483,
    2125,  2125, 21605, -4044, -4044, -4044, -4044,   916,  2125, -4044,
   21605, 21605,  2125,  2125,  2461,  2461, -4044,  5596, 21605, -4044,
   33855, 21605, 24179, 16531, 21605,  2561,  2503,  2125, -4044,  2125,
   -4044, 21605, 18173, -4044, 21605,  2693, 25031, 21605,  1263,  2694,
   21605,  1263,  2901,  2901,  2495,  5161,  2484,   500, -4044,  2601,
    2125, -4044,  2125,   837, -4044,   185, 74607, 21605, 39219,  2574,
     181, 58995, 21605,  2487,  1193, -4044, 21605,   213, -4044,  2518,
   21605,  2578, 21605, 21605, 21605, 21605, 21605, 21605, 21605, 21605,
   21605, -4044, 25867,   246,   -21,  2135, 55699, 19460,  2780, 16101,
   -4044,   275, -4044, -4044, -4044, 58995,  2697, -4044, -4044,  2573,
   -4044, -4044, -4044, -4044, -4044,   259, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  2507, -4044, -4044, -4044, -4044,  2507, -4044,
    2528,  4569, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2771,  2778,
     715, 58995,   192, 50343, -4044, 19889, -4044,  1657, -4044,  2531,
   -4044,  2758, -4044,  2520, -4044,  8876,  2758, -4044, -4044,   327,
    2618,  2752,  2700, -4044, -4044, -4044,  2529, 10913, -4044,  1627,
   10913,  1833, -4044, -4044, -4044, -4044, -4044, -4044,  1073, -4044,
   58995,  2668,  2591,  1194,  2584,   828, 58995, -4044, 30476,  2533,
    1688,  2590,  2596,  2642, 43751, 58995, 58995, -4044, 39219, 43751,
   58995, 58995, 43751, 58995, 58995, -4044,  2893,     8, 49107,  2657,
   48283, -4044, -4044,  2542, 58995,  2597,  2779,  2782,  1047, -4044,
   -4044, 70531, -4044,  2734, 43751, 58995, 58995, 21605,  2740, 58995,
   58995, -4044,   407,  2624,  2625, -4044, 58995,  2627, 43339,  2555,
   58995, 58995, 58995,  2628,   728, 43339,  2599, 34280, 58995, 58995,
   58995, 58995,  2678, 58995, 58995,  2796,  1442, 53227,   231,  1871,
    2366,  2755, -4044,  1153, -4044, 43751, 58995,  2747, -4044, -4044,
   -4044, 56111,  2963,  2671, -4044, -4044, 70943, -4044, -4044,  2748,
   -4044, -4044, 75409, -4044, -4044,  1704, -4044, 75008, 71355, -4044,
   -4044,   476, 43751, 43751,  7199, 58995,  1294, -4044, -4044, 74607,
   -4044, 58995, 58995, 58995, 50755, 71756, 72168,  1356,  1359, 58995,
   51167, -4044, 58995, -4044, -4044, 39631, 43751, 58995, 39219, -4044,
   58995,  2762,   860, -4044, 58995,  6909, -4044,  2648, 58995,   378,
    1923,  2366, 58995, 58995,  2571,  1733,  2650,  2699, -4044, 58995,
   -4044, 43751,  1445, -4044,  2714, 43751, 58995, 12006, -4044, -4044,
     303, -4044, -4044, -4044, -4044, -4044, 58995, 58995,   303, 58995,
     303,  1260, -4044, 43751, 58995, -4044, -4044, -4044,  7231, 58995,
   58995, 58995, 58995, 43751, 58995, -4044, -4044,  1029,  1177,   618,
    1195,  2719, 58995,  2837, 58995, 72580, 43751, 58995, 58995, 58995,
     922, -4044, -4044,  2696, -4044, 43751,  1445,  7597, 58995, 58995,
    2662,  2669,   184,  2731, -4044, -4044, -4044, -4044, -4044, -4044,
    2828,  2990, 58995, -4044,  2830,  2833,  2649,  2651,  2835,   814,
   58995, -4044, -4044, -4044, -4044, 58995,  2839,   814,  2784,   737,
   -4044, -4044,  2168, -4044,  2616,  1742, -4044, -4044, 21605,  3007,
   74607,  2609,  2613,  2686,  2689,  2698, -4044,  2610,  2701,  2125,
   -4044, -4044,  1578, -4044, -4044,  1761, -4044,  2626,   840,  1709,
   -4044, 39219, 58995,   684,    89,  2913, 47459,  1457,  2903, 58995,
    2666, 58995,  1457, 58995, -4044,  1482, 49107, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,  2905, -4044,  1104,  2157,
    2157,  2157,  2157, -4044, -4044, -4044, -4044,  2806,  1453, -4044,
    2630,  2157, 58995,  2733,  1457,  2631, -4044,  1322,  2921,   796,
   58995, 47459,  1801,  2667,  3028,  1717,  1104,  2814, -4044, 17772,
    2736,  2816, 42103,  2904,  2907,  2920, -4044,  1989, -4044,  3037,
   -4044,  2936,   715,  2011, -4044,  2203, -4044, 58995, -4044, 58995,
   58995, 58995, 58995,  2036, -4044, -4044,  2203,  2823,   715,   715,
   -4044,  2825,   715,  2203,  2764,  2932, 42103, -4044,   393, -4044,
   -4044, 21605,  1717, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044,  1768, -4044, 58995, -4044,  2908,  2909,  2911,  2656,  2659,
    2683, 58995,  2661, -4044,  2656,   303,  2656,  2296,  2296,  2656,
    2659, 42927,  3068,  2935,   683, -4044,   799,    21,  2869, -4044,
   -4044, -4044, -4044, 74607, -4044, -4044, -4044, -4044, -4044, 58995,
     196, -4044,   103,  2846,  2670, 42927,  3050,   715, -4044, 43339,
   -4044, -4044, -4044,  2743,  2753, 43339,  2862,  2716, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,  2910, 58995,  1778, -4044, -4044,
    1429, -4044,  1487, 21605, 21605,   126, -4044,  9141,  1794, 21605,
    2677,  2679,  1795, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
    2680,  2959, -4044,  2681,  1796,  1807,  2682,  2688, -4044, -4044,
    4941,  2695,  9837,  2703, 24179, 24179,   772, -4044, -4044, 24179,
    2705, -4044,  1808,  9243,  2706,  2707,  2709, -4044,  2711,  2712,
    9967, 20747, 21605, 20747, 20747, 10087,  2706,  2713,  1813, 39219,
    2849, 10427,  1819, -4044, 21605, 39219,  5013, 21605, -4044, 21605,
   58995,  2715,  2718, -4044, -4044,  5596, -4044,  2722, -4044, 24179,
   24179, -4044,  1986, 18602, -4044, -4044,  2966, -4044, -4044,  1247,
   -4044,  2702, -4044, -4044,  5936,   199, 21605,  2487, 21605,  2768,
   33855,  6527, 21605,  3200,  3219,  3219,   412,   412,   266,   266,
     266,  1864,  2135, -4044, -4044, -4044,  2724,  2275, 21605, -4044,
    1722,  1772, 58995,  2365,  3766,  4091, -4044, -4044, -4044, 27132,
    2725, 21605, 21605, 21605,  2721,  2860,  3108, 10913,   966, -4044,
    3109, -4044,  1466,  2125,   837, 37983, -4044, -4044, 21605, -4044,
   -4044, -4044,  1960, -4044, -4044, -4044, -4044, -4044, 58995,  1295,
   21605, -4044, -4044,   987,  1789, 21605,  1627, -4044, -4044,  2754,
   -4044, 21605, -4044, -4044, -4044,  2296, -4044, -4044, -4044, 27132,
    2730,  2744, 29640,  2836, -4044, -4044, 58995,   110, -4044, -4044,
   -4044,  2728, -4044, -4044, -4044, 43751, 58995, 58995, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2930, -4044,
   43751, 43751,  2881, 58995,  2896,  2902, 21605,   891, 58995,  2732,
    2735,  1298,  2985, 58995, -4044,  3026,   715, -4044, -4044,  2807,
   -4044, 10913, -4044, -4044, -4044, -4044, -4044, 43751, 58995, -4044,
   42103, -4044,  1989, 74607, -4044, -4044, -4044, 58995,  2769, 58995,
   -4044, 58995, 58995, 58995,  2036, -4044, -4044, -4044, -4044,  1110,
   -4044, -4044, 58995, 58995,    85,  2810,  2813, 58995, -4044,    68,
    2559,  7706, 58995, 58995, 58995,  2989, -4044, -4044, -4044, -4044,
    2933, -4044, -4044,  1465, -4044, 71355, 75008, -4044, 75008, -4044,
    1465,  1452, -4044,  2203,  2818,  2366, -4044,  2924,   980, -4044,
   -4044, -4044, -4044, -4044,  3039,   715,  3043,   715, 58995, 58995,
   58995, 58995, -4044, -4044, -4044, -4044, -4044, 39219, 39219, 39219,
    1820, -4044, -4044,  1104, -4044, -4044, -4044,  1828, -4044,   997,
   -4044, -4044, -4044, -4044, -4044, -4044, 43751,  8117, 58995, 58995,
   58995,  1645, -4044,  1098, 74607, -4044, 73794, 43751, 58995, -4044,
   -4044, -4044,  2969,  2915, -4044,   817,  2918, 43751,  2811, -4044,
    2831, -4044, -4044,  2841,  1935,  2366,  1322, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,   425,  1937,  2366,  2843, -4044,
    2848, -4044, -4044, -4044,  2972,  2973,  2974,  2850,  2853,  2894,
    2857,  2858,  2897, -4044,  2863,  2900,  2864,  2912,  2866,   715,
   74607,  2993,  1104,  2919,  3094,   715, -4044,  2876, -4044, -4044,
    3198, -4044, 58995, -4044,  2880,  1946,  2366, -4044, -4044, 43751,
   58995, -4044, -4044, -4044,   814, 74607,  3047,   814,   814, 58995,
   58995,   814, -4044, -4044, -4044,  3052,  3053,   814, -4044, -4044,
   -4044, -4044,  2274,  2815, 31730, -4044,  3244,  5458,  2819,  2613,
    2821,  2125,   229,  1093,   638,  2934,  2125,  3025,  2822, -4044,
   -4044, 39219, 31730,  1678,  3042,  2838,  2838,  2838,  2838,  2838,
    2838,  2838, -4044,   176,   377,  2168, 42103, 58995, 42103, -4044,
      89,  2924, 58995, 58995,  2826,  2824, -4044, -4044, -4044, -4044,
   43751,   127, 43751,  2125, -4044, -4044,  2891, -4044, 58995,  1717,
    3224,  2563,   223,  2967,  1376,  3167, -4044, -4044, -4044, -4044,
   -4044, 58995, 58995,   840,  1104, -4044,  2842,  2847, -4044, 58995,
   58995, 58995, 58995,  2513,  2856,  2854, 74607,    52,  3017,  3032,
    2361,  3261,  1295,  2667,  2937, 58995, -4044,  1829,   118, -4044,
    1104, 42103, 72992, -4044,  2560, -4044, -4044,   781,  3135, -4044,
   -4044,  1295,   715, 74607, 58995, -4044,   715,   393,  2923,   715,
    2925,   715,   715, 58995, -4044, -4044, 58995, -4044, 58995, 40867,
     715, -4044, 10913, -4044, -4044,  2986,  2988,  2991, 58995,  2656,
   43339, -4044,  2870, 43751,  1156, -4044, -4044,  3054, -4044, -4044,
   -4044, -4044, -4044,  3175,  3177, -4044, -4044, -4044, -4044,  3215,
   43751, 49519,   446, 43751, -4044,  1989, -4044, -4044,  2011,   303,
   -4044, 58995,  3120, -4044, -4044, -4044,  2884,  1835, 10691, 21605,
   -4044,  3189, 74607, -4044,  5887, -4044, -4044, -4044, -4044, 21605,
   -4044, -4044, -4044, -4044, -4044, 21605, -4044, 21605,  3165, -4044,
    3306,  3306, 74607, 24179,  1420,  2271, 24179, 24179, 24179, 24179,
   24179, 24179, 24179, 24179, 24179, 26296,   420, -4044, -4044, 21605,
   21605,  3172,  3165, -4044, -4044,   -48,   -48, 74607,  2887,  2706,
    2888,  2890, 21605, -4044, -4044,  1839, 25449,  2892, 39219, -4044,
   21605,  9488,  1848,  2938, 10735,   500,  6232, -4044,  3265,  1104,
   21605,   473,  1329, 21605,  1861, 21605,  3174, -4044, -4044, -4044,
    2895, -4044, -4044, 74607, 21605, 24179, 24179,  7230, -4044,  7686,
   21605,  2899,  7820, 18602, -4044,   854,   854,   854,   854, -4044,
   58995, 58995, 58995, 27550, 26714, 56523,  2898,  1721, -4044, 56523,
   56935, -4044,  2906,   500, 21605,  3170,    18,    18,  2916,  2860,
   30894, -4044, 21605,   224, 21176,  2928,   141,  2931, -4044, -4044,
    5607, -4044, -4044,  2941, -4044,  2914, -4044,  1789, -4044, -4044,
   -4044,  6637,  3084, -4044, -4044,  2898, 22034,  2836, -4044,  1866,
   -4044, -4044, 19460, -4044, -4044,  1872, 30476,  2730, 19889,   500,
   -4044, -4044, -4044,  2838,  2203,  2203,  1011,  2656,  3194,  1011,
    6664, -4044, -4044, 27968, 58995, 58995, -4044, 58995,  1874,  1051,
   58995, -4044, 58995, -4044, -4044, -4044, -4044,  3304, -4044, 58995,
   -4044, -4044,  2962,  2965, -4044, 58995, 58995, 58995, 58995, -4044,
   -4044,  2000, -4044, -4044, 43751, 58995, -4044, -4044, -4044,   427,
    2047,  2366, -4044,  2995, -4044, -4044,  3168,  1555, -4044, -4044,
   -4044,  2987, 58995,  2926, -4044,   200,  2361,   784, -4044, -4044,
    2996, 58995, -4044, 58995, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, 39631, -4044, -4044, -4044, 39219, 31730, 39219,
   -4044,   430,  2087,  2366, -4044,  2998, -4044,  2999,  3002,  3056,
     749,   152,  3008,  3009,  3058,  2942,  2943,  2944, -4044, -4044,
     287,  1104, -4044, -4044,  1104,  2203,  1104, 58995, 58995, 58995,
   58995, 58995, 58995, 58995, 58995,  3218,   880,  1623, 43751, 58995,
   58995, 43751, 58995, 58995, 58995, 58995, 58995, 58995, 58995, -4044,
    3311,  3243,  1841,  3283,  3014, 58995, -4044, 58995,  2559, 58995,
   58995, -4044, -4044, -4044,  2950,   814, -4044, -4044,  3191,  3192,
   -4044,   814,   814, -4044,   194, 39219, -4044,  2232,  2914,  2125,
    1505, -4044, -4044, -4044, -4044, -4044, -4044,  2616, -4044, -4044,
    2125,  1928,  2955, -4044,  2958, -4044, -4044, -4044, -4044, -4044,
   -4044,  2964, -4044,   837, -4044, -4044, 58995,  2838, -4044,   917,
     835,   934,  1272, 57347, 57759, 58171,  2960, 58995, 58995, 24179,
   -4044,  1149,   743, -4044,  3199, 58995,  2997, -4044, -4044, -4044,
    3117, 58995, -4044, -4044, -4044, -4044, -4044,  2968, -4044,  3079,
   47459,  2203, 43751, 43751,  2203, -4044, 74607,  2975,  2667, 43751,
     223,  1166, 66823,  3010,  2978,  3268, -4044,  2984,  2982, -4044,
   -4044, 58995,  2924,  1884,   584,  1677, -4044, 48695,  1801,  3230,
   -4044, -4044, -4044,  3347,  3072, -4044,  1295,  2513,  3072,  1104,
    2597, -4044, 71355, 21605, 21605, -4044,  2992, -4044,  2994,  4468,
   -4044,  2157, -4044, -4044, -4044, -4044, -4044, -4044,  3065, 58995,
   -4044, -4044,  3000,   715, -4044, -4044, 58995, -4044, 58995, -4044,
   -4044,   715,   715, -4044,  3102, -4044, 58995, 58995, 58995,  2656,
   -4044,   303, -4044,  3270, 42927, -4044, -4044, -4044, -4044, -4044,
      67,  3278, -4044, -4044,  3239,  3241,  3248,  3250,   844, -4044,
   -4044, 21605, 10913, -4044,  3012, -4044, 10913,  7176, 10913,  3172,
   -4044,  1762,  3295, -4044,  1232,  3016,  1762,  2031,  2031,   379,
     379,   174,   174,   174,  3306,   420, 10913, 10913, -4044, -4044,
   -4044, -4044,  3018, -4044, -4044, -4044,  2706, -4044, 22463,  3160,
    3406, -4044, -4044, -4044,  3061,  3063,  3030, -4044, 21605, 22892,
    3029, 75409, -4044, -4044,   837,   890, 24179, 24179,  1593, -4044,
    1792, 21605, 74607,  1904,  1593,  1523,  1999, 21605, 21605, 10359,
     365, 21605,  7480, 58995, 58995, 58995, 58995, -4044, -4044, -4044,
   56523, 56935, 16952,  1721,  3031, 58995, -4044, -4044,  3034, 27132,
    3271,  3203, -4044, 27132,  3203,  1564,  3203,  3273, -4044, 31312,
   -4044, -4044,  3038, 16101,  1571, 10913,  3423,  3312, 21605,  3040,
   -4044,  3044,  2860, -4044, 74195, -4044, -4044, 10913, -4044, -4044,
   21605, -4044,  2860,  1104, -4044, -4044, 33855, -4044, -4044, -4044,
    3232, 10913, -4044,  1295, 58995,   500,  3045,  3057, 58995, -4044,
    2836, -4044,   287, -4044, -4044, -4044, -4044,  3121, 49107,  3328,
   -4044, 21605,  1913, -4044,  3085,  3417,   117,  1914,  1920,  1051,
   -4044,  2997, -4044,  1318,  3309,   107, -4044,   715, -4044, 74607,
   -4044, 58995, 58995, -4044, -4044, -4044, -4044,  2315, -4044, -4044,
   58995, 58995, 58995, 58995, -4044,  3122, -4044, -4044, 39219,   176,
    3247, -4044, -4044,  3260,   287, 58995, -4044, 74607,   715,   715,
   -4044, -4044, -4044,  3083, 58995, 58995, 58995, 58995, 43751, 58995,
   58995,  2125,  2125, 74607,  3069, -4044,  2125,  2125,  3070, -4044,
   43751, 58995, 58995, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044,  3149, -4044, -4044, -4044, 58995, 58995,
   58995, 58995,  3373, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, 58995, -4044, -4044,  1104,  1104, 74607,
     715,   715, -4044, -4044, -4044,  3317, -4044,   814,   814, -4044,
   -4044,   131,  1926, -4044, 28386, -4044, -4044,  2541,  1104,  2541,
     106, -4044, -4044,  2541, -4044,  2541, -4044,  1051,  3080,  1112,
    3358, -4044, -4044, -4044, -4044,  3361,   287, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, 21605, -4044,   214,  1762, -4044, -4044, -4044, -4044,
    2997,  1717,  3136, 43339,   262, -4044,  3343,   684, 47459,   198,
   58995, -4044,  2203,  2203,  3137, 58995,  3486, -4044,   587, 58995,
    3397,  3126, -4044,  1104, -4044, -4044,  2667, 58995, 47459,  2513,
    1932, -4044, -4044, -4044,  3124,  3032,  3091,  1801,  1108, 58995,
   -4044,  3127, -4044, -4044,  3374,  3095, -4044, 10913, 10913,  1104,
   75810,  2560, -4044, 58995,  3348,   715, -4044,   715,   715, -4044,
   -4044, 58995,  2656,  2656,  2656, -4044,  3277, -4044,   715, 42927,
     844,   844,   844,   844, -4044, -4044, -4044, 10913, -4044, -4044,
   -4044, 24179,  3379, -4044,  3100, 74607, -4044,  3103,  1939,  1943,
   25031,  3246, -4044, -4044, -4044,  7880,  3152, 10913,  3204,  3107,
    3110, -4044,  1044,  1044,  1792,  1949, -4044, 24179, 24179,  1593,
    1593, 21605,  1593, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   56523,  3114, 58995,  1721, 27132, -4044, -4044,  2123, -4044, 27132,
    3345, -4044, 27132, 58995,  3115, 58995,   988, 21605, 21605,  3154,
    2860,  2860, -4044,  3286, -4044,  3123, -4044,   837,  3125, 58995,
   -4044, -4044,  1015, -4044, -4044, -4044, 42927,  3303, 42927,  1051,
    7982,  2997, 27968, 34705, 58995, 58583, 58583,  3263,  2997,  3136,
   -4044, -4044, -4044, -4044, -4044, -4044,  3128, -4044, -4044, -4044,
    3197, -4044, -4044, -4044,  1955, -4044, -4044, -4044, -4044, -4044,
    3311, -4044, -4044, 31730, -4044,  3201, -4044, -4044, -4044, -4044,
   -4044, 29222, 33855, -4044,   749,  3130,  3131,   152, -4044, -4044,
   -4044, 58995,  1299,  1182,  3159,  2656,  3413, -4044, -4044, -4044,
    3311, -4044, -4044,   814, -4044, -4044, -4044,  2168,  3454, -4044,
   39219, -4044, 40043, -4044, -4044, -4044,  1104, -4044,  1104,  3325,
   35943,  1104,  1104, -4044, 43339,  3536,  3536, 58995, -4044, -4044,
    8280,  3329, -4044,  3136,  3349,  3396, -4044,  3141, 58995,  3293,
    3143,  3144,   901,   901,  2924, 58995,  1966,  1295,   223, 47459,
    2924, -4044,  1264,  3146,  3444, -4044,  3548,  2856,  3153, -4044,
   -4044, 48695,  3331,  3072, 58995,  3032,  3272, -4044,  3279, -4044,
     946, -4044, 58995, 27968, -4044, 75008, -4044,  1995, -4044, -4044,
    2725, 58995,    78, -4044, -4044, -4044, -4044, -4044, -4044,   446,
   -4044, -4044, -4044, -4044,   642, 24179, 74607,  2005, 21605, -4044,
   21605, -4044,  3538, -4044, -4044, -4044,    49, -4044, -4044, -4044,
    1044,  1044,  1593, -4044, 58995,  2033, -4044, 21605,  3158, -4044,
   -4044, 27132,  2123,  2042, 58995,  2055, 74607,  2860,  2706, 10913,
   58995, -4044, -4044, -4044,  3542,  3336,  2860, -4044, -4044, -4044,
   -4044,  1156,  1011,   446,  3417,  3136, -4044,  3161, -4044, -4044,
   58995, -4044,   825,   825, 58995,  3136, -4044, -4044, 58995, -4044,
   39219,  3214, -4044, 58995, 74607,  2011,    69, -4044, 74607, 74607,
   -4044, -4044, 58995, 58995, 58995, 58995, 58995,   715, -4044,  2815,
    1104, -4044, -4044,  2057, -4044, -4044, -4044, 58995, -4044,  2978,
   -4044, -4044,  3536,   832, -4044, -4044, -4044,  1696,  3362, -4044,
     626,  3350,  3245,  3164, -4044, 43339,  3592,  3281, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  3457,  2667,  3127,
   -4044, -4044, -4044, -4044, 21605,  3320,  1295,  1801,  3230, -4044,
   -4044, -4044,  2066,  3072, -4044, -4044,  3543,  3353,  3547, -4044,
    2085, -4044, -4044,  4468, 75810,  3492, -4044,  3226, 58995, -4044,
   -4044, -4044,   642,  2096, -4044,  2097,  2101,  3321,  3227, -4044,
    2103, -4044, 10913, 58995, -4044, -4044, -4044,  2111, -4044,  3178,
   -4044,  3581, 21605,   645, -4044, -4044,  3463, -4044, 58583,  3222,
   33855, -4044,  1789,  1789,  1717, -4044,  1051, -4044, -4044, 21605,
   -4044, -4044,  2141, -4044,    79,  3330,  3475,  2150,  2151,  2659,
    3233,  2659, -4044,  2656, -4044, -4044, -4044, -4044, 40043,  2978,
   -4044, -4044, -4044,  3508,  3455, -4044, -4044, -4044, -4044,   659,
   -4044,  3385,  3386, 58995, -4044,  3202, -4044,  2164, 58995, 58995,
    3605,  3609, -4044,  8330, 43339, -4044,  3032,  1801,   176, -4044,
   -4044,  3395, -4044,  3399,  2667, 27968,  2560, -4044,   270, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2165, -4044, 58995,
    3221,  2706, 23321, 23321,  3229, 42927,   825,  3225, -4044,  3234,
   -4044, -4044,  3349,  1051, 10913, 43339,  3611, -4044, -4044, -4044,
    3330, -4044, -4044, 58995, -4044,  3356, -4044,   918,   918,  3545,
   -4044,  3288, -4044, -4044,  3237, -4044,  3665,  2924, -4044,   749,
    1295, -4044,  3240,  3072,  3032, -4044, -4044,  3072, -4044, -4044,
   -4044, -4044,  1463, -4044, -4044, -4044, 24608,  3364,   733,  9826,
   -4044, -4044, -4044, -4044,   446,  1789, 21605,  1051, -4044,  3350,
    2011, 58995, -4044, -4044,  3126, -4044,  3658, -4044,   999, -4044,
   -4044, -4044, -4044, -4044,  3069, -4044, 38807, -4044,  3072,  2725,
   -4044,  1697, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  3648,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  8412, -4044, -4044,
   -4044,  3546, -4044, -4044, -4044, -4044,  2170, -4044, -4044, -4044,
   -4044, -4044, -4044,  1760, -4044, -4044,  1777,  1982, 23750, -4044,
    1051,  3401, -4044, 38807, -4044,  1697, -4044, 43339, -4044, -4044,
    3251, 38807,  2176, -4044
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4044, -4044, -4044,  2961, -4044,  -774,   242,  2348, -1674, -4044,
   -4044, -4044,  2882, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
    2917, -4044, -4044,  1550, -2064, -4044, -4044,   113, -1078,   328,
    2552,  1241, -4044,  -944, -4044, -4044,  -519,   105,  -604, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  -719,  1703,  1096,
    -712, -2137, -4044, -1186, -2726, -4044,   522, -4044, -4044,  1641,
   -4044, -4044, -4044,   955,   454,  -430, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  -260, -4044, -4044,  -555,   143,    41, -2047,
    -300, -4044, -4044,   398,  -302, -1100, -4044, -3027, -4044,   -13,
   -4044, -4044, -4044,  -280, -1183,  1198, -4044,  -597,  -934,  1486,
    -602, -4044,  -171, -4044,  -657,  -549,  -547,  -612,  -451, -3196,
   -3597, -3211, -2481,  1208,   145, -4044, -2667,   146, -4044, -4044,
     147,   148, -4044, -4044, -1280, -1201, -4044,  -668, -4044, -4044,
   -4044, -2495, -4044, -4044, -4044, -4044,    77, -4044, -4044, -4044,
   -4044,   426, -4044, -4044, -4044, -4044, -4044, -4044, -1749,  1611,
    1614, -4044, -4044, -2668, -4044,  -762, -4044,   567, -2535,  1118,
   -4044, -4044, -4044,  2314, -4044, -4044, -4044, -4044, -4044, -4044,
   -1358, -4044, -4044,   151, -4044,  1624,   932, -4044, -4044, -4044,
    -638,  -704,  -694, -4044, -2987, -4044, -4044, -4044, -4044,  -237,
   -4044, -4044, -4044, -4044, -4044, -4044,  -838, -4044,   991, -2652,
    -796, -4044, -4044,  1007, -4044, -4044, -4044, -4044, -4044,  -595,
    -179,  2338, -4044,  -487,  -570, -4044, -4044, -4044,  -176, -4044,
   -4044, -4044, -4044, -4044, -4044,  -905,  1188, -1315, -4044, -4044,
   -4044, -4044, -1968, -4044, -4044, -4044, -1824, -4044,  3736,  1938,
     487,   153, -4044,   -17,    66,  2775,  -949, -2204,   373,  -323,
   -4044, -1486, -4044, -4044, -4044, -2142, -4044, -4044, -4044, -4044,
   -2977,   154, -4044, -4044, -4044,   422, -4044, -3556, -3399, -3691,
   -3220, -2932, -4044, -4044,  -913, -4044, -4044, -4044, -1149,  1831,
   -1209, -4044, -1890,   418, -3218,  -603, -2771, -4044, -3162,  -418,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  -900,  -524, -4044,
   -4044,  3211, -4044, -3706, -4044, -4044, -4044, -4044,  1350, -4044,
   -1172,  1078, -4044, -4044, -4044, -4044, -4044,  -580,  -661, -4044,
   -4044, -4044,   155, -4044, -4044, -4044, -4044,  2052,  -781,  -618,
    3093,   157,  -383, -4044, -4044, -4044, -4044, -2574, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -1568, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  1987,  1992,    60,   -23, -4044, -4044, -1063,
   -4044,  -476, -4044,  2287, -4044, -4044, -4044, -4044,  1339,   159,
     464, -4044,     3, -4044, -4044,   257, -2898,     4, -4044, -4044,
   -4044, -4044,  1962,     5, -4044,   726, -4044, -4044, -2366, -4044,
     163,    20, -4044, -4044,     1,     0,   -41,   -40,   -36,     2,
    3097,  2653, -4044, -4044, -4044,   -18,  1573, -4044,  -713,  -161,
   -4044,  1348,  -545,  1967,  2637,  2639, -4044,  1338, -4044, -4044,
    1351, -4044, -4044, -4044,  -536,  1972, -4044,  2638, -4044, -4044,
   -4044,  1333,  1342, -2886,   798, -2906, -2849,   332,   319, -1102,
    -247,    22,  3133,  2643,   804, -3829,   753, -4044, -3598, -1945,
    1167,  1735, -1331, -4044, -4044,  -964,  5041, -4044, -4044, -4044,
   10988, 11175, -4044, -4044, 11386, 11681, -4044,  -863,   847, 12014,
    9348,  -998, -1592,  -730, 10206,   543,  -850, -2216, -4044, -4044,
   -4044,  -211,   858,   482, -4044, -4044, -4044, -4044,  -470, -2358,
    -469, -4044, -4044, -4044,  -471, -4043, -1156, -4044,  -175, -4044,
   10358,  1383, -4044,  -901, -2302, -2310,  -962, -1487, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -1353, -2789,  -270,  1450, -4044,
   -4044,  1543, -4044, -4044, -4044, -1114,  -720, -2195,  1455, -1701,
   -4044,  -706,   779,  2180,  -660,   -82, -1097,  8934,  -442, -1931,
   -1035, -1276, -4044,  -167, -4044,    28,   -10,   -43,  -404,    11,
    3257,  7007,  -542, -1113,  6263,    30,  9220, -2641
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2225
static const yytype_int16 yytable[] =
{
     167,   166,   171,   161,   162,   164,   568,   713,   723,  1473,
     755,   522,  1183,   880,   644,  1513,   798,   668,  1115,   774,
     167,  1477,   171,   909,  1189,   700,  1879,   510,  1282,  1792,
    1797,  1483,   633,  1558,   559,  1948,  1192,   633,   983,   984,
     985,  1331,  1422,  1343,   989,  1305,   907,  1533,   712,   632,
    1506,  2373,  1442,   551,   632,  2243,  2099,  2587,  2589,   931,
    1570,   960,  2643,  1807,   697,  1368,  1958,  1129,  2067,  1620,
    2802,  2902,  3126,  3362,  1593,  1594,  1979,  3041,  1797,  2784,
     607,  1966,  3159,  1792,  3161,  2163,   866,  1299,   639,  2112,
    1310,  2301,  1410,  1609,   597,  1946,  1415,  2699,  1336,  2022,
     669,  1419,  1810,  3256,  2456,    65,   782,  3348,  1425,  3569,
    3275,  2888,  3559,  3306,   806,  1270,  1464,  3599,  1444,  2738,
    3074,  3256,   817,  3038,  3510,  3537,   954,  2035,  2036,  3036,
    3037,   725,   917,   717,  3732,   726,  2031,  3773,  3493,   909,
    2214,  3781,  3765,    74,   776,    75,    76,    77,    78,  1957,
     802,    98,   687,   118,   123,   138,  3336,   142,  1934,   159,
     815,  1857,  1122,   165,  1586,  1587,  2167,  3896,  4013,  3542,
    1242,   724,  3438,  2985, -1556, -1997,   520,  1176,  2178,  1639,
    3508,   934, -2031,  3894,  1636,  2942,  1179, -2052, -2077,  1441,
    1606,   946,  3280,  3281,  3282,  3283,  3284,  3285,  2797,   564,
   -1906,  4195, -1907,  1798,  1967,  4103, -1566, -1775, -1906,  2047,
   -1907,  1332,  3903,  3031, -1775,  4244,  2378,   779,     3,     4,
     809,  3353,  2160,   779,  2276, -1556,  1489, -1556,  2563,   564,
    2042, -2224, -1551,   779,  2378, -1523,  3286,  1504,   615, -2224,
   -1536,  -358,  3287,  1209,   560,  3122,   819,  1010,  2919,  2563,
    2254,  1553,  3288,  1279,  2900,  2395,  2721, -1563,   564,   564,
     703,  2429,  1364,  3031,   564,  4073,  1885,  4075,  2413,  2859,
    4145,  2861,  3697,   720,  3286,  2414,   564,  1646,  1437,  3289,
   -1881,  3290,  4208,  1881,   980, -1551,  3312,  2417,  2170, -1566,
    3988,  1515,  2898,  4360,  2117,  -764,   615,  3079,  1438,  1960,
    3340,  2564,  1649,  1882,   674,  3626,  2135,  1268,  1166, -1933,
    1882,  4197,   615,  1996,  2510,  1172,  1929,  3289,   615,  1173,
    1358,  -576,  2564,  4409,  2130,  1831,   621,  1682,  2659,  2893,
    3992,   965,  1651,   621,  4326,   820,   615,   987,   621,   621,
     564,  3969,  1146, -1350,  1147,  1210,   622, -1353,  1343,    33,
    1615,   515,  1124,   622,  3291,  -122,   861,  1960,   622,   622,
    -122,   664,   798, -2000,   517,  1965,  1637,  2255,   694,  1616,
    3993,  1218,   615,  1686,  1330,  1997,   821,  1281,  2161,  2136,
    2396,  -144,  2659,  1174,  2397,   969,  2511, -1791,  3970,  1683,
    2942,  1681,  1620,  4327, -1791,  4446,  3989,   675,  2894,  1960,
    1930,  1167,   912,  3627,  1196,   909,  -144,  2029,   798,  3899,
    2418,  3292,   922,  1593,  1594,   988,  3293,   909,  4183,  2550,
    1175,  1609,  2398,  1646,  1799,   822, -1350,  2131,  1501,  2899,
   -1353,  2942,  2535,  3313,   826,  3600,  4260,   981,  1119,   859,
    2074,  2238,  1883,  1439,  1465,  2244,  1960,  2246,  1649,  3981,
    2249,  2567,  3294,  3518,  3293,  4361,  2338,  1465,  2078,  1694,
     621,  4198,  4209,  2298,  1706,  1706,  3295,  4191,  3123,   565,
    2338,   909,  2567,  1219,  2171,  1406,  4217,  1968,  1651,  1204,
     622,  1019,  3040,  1978,  2942,  1517, -2051,  1211,  3904,  1969,
    3294,   561,   875,  1960,  1574,  1960,   882,  1465,  1960, -1350,
    1276,  3466,  1475, -1353,  3295,  1920, -1523,   892,   858,  3552,
    3956,  3300,  1586,  1587,   621,  1554,  3612, -1775,  2419,  2304,
    1212,  1606,  2018,  1797,  2020,  2379,  2162,  3256,  1484,  2048,
    2097,   988,  2090,  2091,   622,  2376,  3354,  4316,   988,   704,
    1970,  2399,  2256,  3005,  2027,  3076,  1141,  1886,  3296,  1213,
    1142,  2070,  1640,  2722,  1991,   908,   568,  1581,  1922,  1554,
    2257,  2066,   713,    48,  1184,   779,  1928,  1797,  3983,   779,
    4432,  4015,   562,  3889,   563,  1001,  1342,  2043,  2415, -1523,
     779,  1148,   909,  1551,   961,  3510,  3296,  3092,  2572,  1407,
     909,   909,  3746,  1560,   856,   779,  1116,  2218,  2231,  1615,
   -1556,  2954,   167,   712,   171,  1688,  1571,  1214,  1581, -1997,
     779,  2099,  2944,  3853,  1139,   779, -2031,  3857,  1616,  4029,
    2008, -2052, -2077,  2011,  2012,   779, -1906,   962, -1907,   967,
    3810,   971,  1617,   779,  2239,  1165,  2591,   975,  1842,   994,
    1937,  3848,   953,  2250,   632, -1350,   632,  1843,   632, -1353,
     978, -1556,  3884,  2942,   632,   976,   977, -2224, -1551,  3263,
    1011,  1592,  1347,   956,  3755,  2944,  1598,  1112,   990,   798,
    1121,   908,  1123,  1353,   725,  2297,  2000,  2300,   726,  2003,
    3772,  3523,  1615, -1563,  1642,  1679,  2075,  2308,  2030,  4353,
    2443,  2312, -2051,  1670,  1466,  4228,  3139, -1791,  3140,  2324,
    2325,  1616,  1273,  3706,  1141,  2536, -1881,  1466,  1142,   627,
     628,   779,  2342,  2344,   724,  1619,   167,   166,   171,   161,
     162,   164,   990,  2358,  2945,   627,  1269,  2666,   771,  4095,
    1220,   627,   628,  1455,  3531,  2638,  4105,  3320,  2586,  4358,
   -1350,  2328,  2329, -1933, -1353,  1792,  2573,  1466,  1204,   627,
     628,  1187,  2188, -2051,  1998,  1407,  3233,  4398,  2465,  3236,
    3237,  2194,  2337,  3240,  1151,  2198,  1465,  4337, -2051,  3243,
    3301,  2204,  2205,  -122,  -122, -1350,  2360, -1350,  4266, -1353,
    1019, -1353,  3200,  2942,  3590,   627,   628,  3614,  1676,  2217,
    1418,  1131,  1118,   718,  1224,   871,  1126, -2000,  3238,  3239,
    2240,  1218,  4181,  2951,  2952,  2953,  2954,  3031,  3031,   919,
    1351,   632,  1446,  1449,  1450,   564,  2889,  2639,  1315,   564,
    3127,    65,   564,  2501,  2548,  1690,  1268,   564,  1503,  3757,
     727,   615,  2170,   653, -2225,  2776,  1667,  1668,  1669,  1670,
     564,  1475,  2949,  2950,  2951,  2952,  2953,  2954,  3728,   564,
     518,   719,  3048,  2173,  3253,  2596,  1316,  2461,  1934,    74,
    3268,    75,    76,    77,    78,  2629,  4261,    98,  1206,   118,
     123,   138,  3253,   142,  3784,   159,  3545,  3565,  4411,   165,
    3602,  3394,  4232,  4233,  1285,  2247,  2248,  1887,  2740,  3364,
    4267,  2946,  2947,  2948, -1523,  2949,  2950,  2951,  2952,  2953,
    2954,  1646,  3621,  1219,  1116, -1523,   728,  1592, -1523,  1196,
     654, -1523,  1433,  2694,  1637,   900,  1561,  1286,   720,  2313,
    1206,   564,   564,  4158,  2632,  1691,   615,  1116,  4312,  1141,
    2822,  2481,  2891,  1142,   174,  2103,  2462,   908,  3710,   564,
    2710,  1873,  2695,  2943,  4063,   873,  1321,   874,  2154,   908,
    1434,  1873,  3360,  2107,  4313,  4268,  1651,  1874,  2203,  1817,
     819,   167,   779,   171,  2944,  3365,  2022,   960,  4066,  4385,
    1948,  4159,  4290,  4070,   175,  4296,  4072,   779,  4160,   772,
    1457,  4286,  1556,  3729,  1519,  1340,  1521,   632,  1523,   779,
    1525,  4147,  1527,  1528,  1529,   785,  2777,  1132,  4186,  1531,
    3622,  2104,  4262,   908,  4412,  4161,  4187,  1317,  2774,  2890,
    3362,  1382,  1875,  2103,  2314,  3758,  1466,   779,  3999,  3603,
    3707,  1579,  1875,  2945,  2155,  2241,  3649,   779,  2190,  1876,
    4006,  3127,  2223,  1677,   721,  1692,  4338,  3712,  1887,  1876,
     779,  1596,  1322,   779,   713,  1320,   872,  2684,  1818,   820,
    2025,  1321,  1019,  2685,  2732,  2942,  1710,  3192,  1133,  2105,
     920,  1352,  2106,  3915,  2949,  2950,  2951,  2952,  2953,  2954,
    2195,  1623,   901,  1006,  2778,  2549,  4162,  1638,  1246,  2104,
    2315,  2206,   655,   656,  3804,  1634,  2331,  1643,  2451,  3623,
     821,  4354,  4009,  2213,  2741,  1318,  4375,  1680,  3366,   729,
    3145,  1435,  4423,   798,  1845,   966,   968,   970,  2633,   564,
     972,   973,   974,    38,   908,  4226,  3180,  1696,  1697,  4236,
     979,  3604,   908,   908,  3605,  2892,   670,   902,  1811,  1812,
    1803,  1816,   726,   726,  4359,   726,  1341,  2105,  2316,   822,
    2106,  2317,  4397,    42,  2879,    38,  4399,  1322,  2759,  2686,
    1491,  4386,  2107,  4288,   779,   632,  3572,  1877,  3367,  4188,
     632,   632,   779,   779,  3872,  3553,  1954,  1877,   724,   724,
    1888,   724,  1794,  1971,  3876,    42,  2081,  3650,  2338,  2338,
    2475,    46,  3883,  2338,  3115,  4214,  1128,  4431,  1492,  1436,
    2946,  2947,  2948,    47,  2949,  2950,  2951,  2952,  2953,  2954,
    2693,   645,  2004,  2235,  2156,  2007,  1458,  1187,  3531,  2079,
     174,  3866, -1878,    46,  2082,  1978,  4016,  2157,  3181,  4387,
    3875,   720,  3116,  2338,  2338,    47,  1794,    48,  4017,  3573,
    2107,  2318,   174,  1259,  1172,  2595,  2944,  2041,  3055,  4424,
     893,  4163,  4388,   720,   627,  1269,  2975,  1889,  4323,  2108,
     175,  2057,  2982,  1878,   632,  3726,  1459,  3265,  3798,  2482,
    2576,  1498,   632,  1878,  2069,  3974,  2080,  3676,  3137,  1820,
     894,  4112,   175,  3679,  3680,  2591,  2269,   564,  3253,  3146,
    2856,  1499,  3256,  3031,  3574,  2054,  3575,  3031,  2665,  1323,
     652,  2687,  2857,  3975,  2026,  2945,  2187,   977,  1915,   895,
    4320,  4321,  1174,  2862,  3147,  2193,  1821,   798,  2386,  2677,
    2387,  2807,  2808,  2809,  2810,  3266,   632,  3727,  2743,   632,
     632,   534,  1324,  2815,  2688,  1891,  4166,  2108,  2319,  2028,
    3554,  4377,  4170,  2388,   673,  1892,  1172,  1019,  2716,  1493,
    2942,  1698,  2667,   896,  2577,  1460,  2109,  3812,   651,  3813,
    2670,  1325,  2672,  2689,  1475,  2013,  2093,  3467,   779,  3555,
    3182,   695,  2996,  2165,  2997,  2083,   760,   762,  2236,  2175,
     766,  1288,   768,  3117,   774,  3714,  1948,  3551,  3556,   536,
    1699,  4018,   632,  2554,  2134,  1206,  3754,  2998,  1206,  3051,
     813,  2852,  1141,  3183,  3390,  1461,  1142,  2237,  3043,  1823,
    2054,  3044,  2917,  1820,  1174,   788,   789,   790,  2107,   791,
     792,   793,   794,   795,   796,  3168,  3087,  1289,  4106,  2144,
    4077,  2506,  3184,  3044,  3900,  2222,  2522,  1494,  2389,  3409,
    3169,  4440,  2196,  2390,  1867,   798,  3138,  1794,  2391,  2690,
    1821,  1175,  4281,  4416,  1868,  3787,   706,  3788,  2651,  1518,
    1824,  2969,  1520,  2084,  1522,  2054,  1524,   779,  1526,  1869,
    2651,  3118,  1530,  1116,  1116,  2022,  2949,  2950,  2951,  2952,
    2953,  2954,  2691,   779,  1893,  1462,  2790,  3814,  2523,  4123,
    2855,  2014,  2994,  2015,  2337,  2337,  3901,  2999,  2252,  2337,
    2696,  1822,  3000,   715,  1329,  1290,  2864,  2865,    33,   716,
    2867,  2692,  4149,  3201,   779,   779,  2871,  1894,   167,  1986,
     171,  3384,  4082,  4083,   615,   779,   543,  1636,   544,  2697,
    2652,  2944,   876,  1330,   877,  3362,  1475,   779,   779,  2337,
    2337,  1019,  2652,  1823,  2942,  3422,  4196,  3423,  2225,   779,
    2226,  1423,  2227,  1291,  2228,  1292,  2229,  1963,   534,  2593,
    2230,  3837,  2273,  3393,   601,  2021,  2392,  2649,   527,   167,
    2268,   171,  2265,  2266,  2267,  2904,  2393,  1980,  4357,   956,
    2653,   819,  4171,    14,  1311,  4238,  2259,  2881,  2833,  4124,
    2945,   718,  2653,  1294,  1824,  3419,  2019,  2322,   765,  3098,
    1259,  3394,  1870, -1397,  2427,  4039,  1204, -1397,  1964,  1302,
    4172,  1645,  2563,  2441,  1646,    19,   536,  1312,  1407,  3439,
    3001,  1313,    38,  -485,  4229,  1981,  1982,  2458,  2310,  2311,
    3002,  2654,  1296,  1980,  4235,  1201,  2323,  2759,  2791,  1649,
    2326,  2327,  1303,  2654,  2272,  1650,  1314,   534,  3031,   719,
     909,  3341,    42,  3031,  3345,  2348,  3031,  2349,  2117,  1978,
    3907,  3908,  2295,  2384,  3114,  3424,  -915,  1298,  1202,  1651,
     820, -1397,    33,  2848,   893,  3425,  2608,  2132,  2371,  2610,
    2372,  1981,  1982,  2518,   909,  2564,  3565,  2522,  1794,  4393,
      46,  3704,  4091,  3998,  4093,  2444,  2164,  1203,  1578,  1615,
      48,  3991,    47,  2032,   894,   536,  4122,  2870, -1397,  4400,
      27,   821,  2812,  4300,  2565,  1978,   720,  2813,  1616,  3954,
    3955,  4008,  2655,   621,   864,  2944,  3501,  2609,   867,  2452,
    2611,  2455,  1617,  3322,  2655,  -921,    48,  1304,  4224,  3095,
    1980,  2542,   798,   622,  2458,   890,  2803,  2566,   774,  2060,
    1604,  1605,  1193,   543,  3502,   544,  3106,  2946,  2947,  2948,
     822,  2949,  2950,  2951,  2952,  2953,  2954,   767,  1116,  3859,
    1204, -1396,    30,  2792,  1653, -1396,   730,   896,   549,  3651,
    1019,  3504,  2061,  2942,  2945,  1194,   783,  1706,  1981,  1982,
      38,  3389,  2013,  4111,  2764,  1654,  1655,  2338,    38,  3652,
    2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,
     784,  3572,  2793,  1646,  1195,  3500,  3587,  3565,  3128,   811,
      42,  2498,  1978,  4127,  3101,  2656,  2502,   860,    42,  2505,
    2338,  3570,   721,  2657,  3046,  2567,  2658,  2656,  1649, -1396,
    2467,  1658,   543,  2765,   544,  2657,  3149,  1198,  2658,   534,
     865,  2528,  4263,   546,  1659,   167,  2484,   632,    46,  2338,
    2338,  2512,  3131,  2515,   548,  3031,    46,  1423,  1651,  2914,
      47,  3667,  1151,  1972,  2221,  3452, -1396,   818,    47,  3506,
    1199,  2298,  3831,  3501,  3573,  1646,  3011,  3324,  3141,  2062,
     863,  3668,  2578,  1592,   779,  1858,  3333,   868,  1794,   779,
    2616,  2063,   779,  3152,  4401,  3154,  1592,   536,  1196,  1200,
    1649,  3502,    48,   909,  1851,  1615,  2637,  3177,  2014,  2592,
    2015,  2766,  2767,   881,   779,  2064,  3503,  2915,  3173,  2183,
    2184,  1123,  2916,    38,  1616,  2768,   888,  3276,  3504,  3574,
    1651,  3575,  2813,  2625,    27,  2472,  2473,  1852,  1619,  2571,
    3178,  2946,  2947,  2948,  -484,  2949,  2950,  2951,  2952,  2953,
    2954,  3505,  3401,    42,  2944,   779,   897,  3591,  2650,   630,
    3601,  3606,  2661,   898,   630,  2298,  1853,  3440,  3441,  3179,
    1508,  2769,  -381,  1509,  1274,  1275,  4040,  4041,  4042,  4043,
    2673,  3595,   779,   779, -2225,  4128,  1592,  3219,  1858,  1801,
    2682,    46,  1802,  3226,  1645,  3405,   899,  1646,   909,  3615,
    1141,  3302, -1881,  2706,  1142,  1794,   779,  1019,  1794,  1592,
    2942,  1858,  2713,  2945,    38,  1665,  1666,  1667,  1668,  1669,
    1670,  3105,  1649,  3267,  3269,  3270,  3506,  3838,  1650,  1804,
    1392,   779,  1805,  3253,   543,   779,   544,    48,   632,  1019,
    2220,  3473,  2942,  2221,    42,  1363,   632,  2232,   632,  2799,
    2233,   914,  1651,   779,  2629,   918,  3613,   206,  2770,  1423,
    2771,   926,   519,   779,  4167,  2234,  1420,  1421,  2233,  2734,
     599,  3446,  3015,   927,  3016,  -381,   779,  2734,  2059,  3565,
     932,  2968,    46,  2970,  2971,   779,  1452,   671,  2262,  2457,
     941,  2263,  2458,  2337,    47,   947,  2337,  2337,  2337,  2337,
    2337,  2337,  2337,  2337,  2337,  2337,  3084,  3085,   951,  3404,
    2364,  4374,  2905,  2367,  2993,  1980,  1479,  1481,  2908,  3966,
    2494,  3968,  3017,  2263,  3018,  3971,  3450,  3972,    48, -1141,
    3830, -1141,  3684,  2338,   615,  4192,  2584,  2758,  2806,  2585,
    3371, -1420, -1420,  1948,  3374,  3375,  1646,  3377,   982,  3379,
    3380,  1794,   986, -2225,  3763,  2337,  2337,  1653,  3385,   995,
    3567,  3568,  1557,  1981,  1982,  2645,  2834,   992,  2646,   167,
    2823,  1649,   908,  2759,  2745,   997,  2804,  2746,  1654,  1655,
    2946,  2947,  2948,  2574,  2949,  2950,  2951,  2952,  2953,  2954,
    3402,  2944,  4444,  2760,  4445, -2225,  2761,  1978,  2827,  2828,
    2873,  1651,  3318,  2233,  3058,  3059,   908,  3500,  2886,  1162,
    2913, -1350,   779,  2221,  1665,  1666,  1667,  1668,  1669,  1670,
    1980,     3,     4,  2944,  1658,   798,  2923,  2927,  2931,  2221,
    2221,  2221,  2886,   998,   909,  2640,   909,  1659,  1003,  2932,
    2958,  3406,  2221,  2221,  1004,  2974,   779,  3199,  2221,  3202,
    2945,  2979,  3162,  3195,  2980,  3163,  1005,  3303,  3230,  3305,
    3166,  3351,  3032,  3167,  3352,  1343,  1007,  3410,  1981,  1982,
    2221,  3447,  1980,   632,  3448,  3501,  3685,  3045,   601,  1006,
    3457,   779,  2945,  3458,  1980,  4087,  1980,  1008,  3056,  3792,
    3793,  3794,  1169,  3469,  1171,  1980,  2221,    14,  3543,   909,
    1009,  3544,  1978,  3502,  3547,   779,  3571,  3548,  1012,  2233,
    2338,  2338,  3032,  3514, -2225,  1225,  3756,  3686,  3503,  2233,
    1981,  1982,  3357,  3519,  3521,  3699,  3700,  1654,  1655,    19,
    3504,  1013,  1981,  1982,  1981,  1982,  3836,  1015,  1127,  2263,
    3019,  3687,   713,  1981,  1982,  3891,  3897,  1226,  3892,  2233,
    1564,  1565,  3898,  3505,  1978,  2233,  3688,  1557,  3959,  3592,
    3689,  3960,  1130,  1134,  4010, -2136,  1978,  4011,  1978,  1136,
    1135,  4049,  4067,  1658,  4050,  4051,  1140,  1978,  2221,  3690,
    1152,  4059,  3691,  1634,  2263,  1159,  3311,  4109,  3314,  1794,
    4110,  1160,  1170,  1162,  3692,  1794,  1980,  2384,  4168,  3616,
    1797,  2233,  3858,  1227,  3861,  3020,  3021,  3022,  1665,  1666,
    1667,  1668,  1669,  1670,  1163,  1185,  3014,  2946,  2947,  2948,
    1190,  2949,  2950,  2951,  2952,  2953,  2954,  4193,  3506,  3025,
    4194,  2298,  1186,  1196,  1228,   908,  1980,  4204,  1217,  2337,
    2263,   713,  1244,  1995,  1981,  1982,  1974,  1248, -2136,  1222,
   -2225, -2225,  3080,  2949,  2950,  2951,  2952,  2953,  2954,   167,
    2268,   171,  2265,  2266,  2267,  4211,  3672,  1276,  2458,  1279,
    1229,  3047,  3693,   632,  4216,   779,  1278,  3331,  1978,  3025,
    3694,  1287,   712,  1284,  1981,  1982,    30,  4218,  4142,  4257,
    3331,  1307,  4258,  1319,  3103, -2136,  3400,  1328,  4289,  1333,
    1230,  1685,  4068,  2037,  2038,  2039,  2040, -2136,  1338,  1339,
    3835, -2136,    38,  1344,  3695,  2071, -2136,  4294,  1978,  1346,
    4295, -2136,  1348,  3782, -2136,   779, -2136,  1350,  4301,  4302,
     908,  2263,  2980,  4303,  1557,  4306,  2221,  1354,  2458,  1355,
     779,   779,    42,  4308,  2076,  2077,  3331,  3819,  1362,  1360,
    2086,  3942,  3943, -2136,  3945,  1365,  1370,  1665,  1666,  1667,
    1668,  1669,  1670,  1367,    33,  1204,  1935,   779,  1233,  3056,
     779,  4025,  1411,  4325,  1234, -2136,  2263,  1414,  1416,  2120,
      46,  1235,  4331,  4332,   602,  2263,  2263,  3056,  1407,  1936,
    1426,  2840,    47,  3170,  2114,  1427,  4345,  4363,  1237,  4346,
    2458,  -164,  4442,  1429,  3188,  4443,  1238,  1431,  4453,  1443,
    1225,  4443, -2136,  3165,  1445,  1451,  2337,  2337,  1453,   192,
   -2136,  2149,  2150,  2151,  2152, -1362,   603,  1463,  1468,  1469,
    1487,  1471,  1470,  1472,  1474,  1482,  2189, -1362,  1475,  1485,
    1486, -1362,  1226,  1488,  1490,  3193,  1495,  1794,  1794,  1794,
    1496,  1497,  1502,  1507,  1559,  2338,  1532,  1239,  1566,  1562,
    1568,  3786,  1575, -1527,  2338,  1569,   779, -2136, -1534,  3789,
    3790,  1576,  1585,  1589,  1588,  2208,  3231,   779,  1590,  1591,
    1595,  2338,  2338, -1362,  2212,    48,  1597,   779,  1600, -1524,
   -1525,  2219,  3222,  1601,  1602, -1528, -1526,  1603,  1227,  1608,
    3307,  3308,  1610,  1611,  1612, -1362,  1613,  1614,  1621,  1622,
    1624,  1625,   645,   774,  2734,  1626,  3317,  2734,  2734,  1627,
    1628,  2734,  1629,  3795,  1674,  1630,  1631,  2734,  1689,  1228,
    3325,  1685,  1701,  1709,  3255,  1809, -2136,  1173,  1175,  3334,
    3963,  1838, -1362,  1848,  1854,  1855,  1840,  1856,  1858,   779,
   -1362,  1859,  3255,  3350,  1860,  1861,  1862,  1863,  2841, -2136,
    1884, -2136, -2136,  1890,  1896,  1229,   908,  2840,   908,  1917,
    1921,  1923,   632,  1924,  1925,  1926,  1927,  1952,  1960,  3262,
    3264,  1962,  1972,  1953,  3271,  1973,  1225,  1976,  1975,  1977,
     632,  1794,  1978,  1984, -2136,  1230,  1987, -2136, -2136, -2136,
    1988,  1985,  1992,  1993,  3329,  1999,   779,  2009,   779,  2016,
    2001,  3996,  1259,  2374,  2005,  2006,  2017,  2023,  1226,  1116,
     779,  3315,   779,  2024,  2033,  2034,  2054,  2044,  3763,  2045,
    3356,   908,   167,  3347,  2046,  2049,  2055,  2050,  2058,  2381,
    3392,  2072,  2073,  2085,  2087,  2088,  1192,  3684,  2100,  1581,
    2101,   167,  3370,  4047,  2118,  2122,  3032,  3032,  2098,    33,
    3403,  2121,  1592,  1233,  1598,  3905, -1362,  2125,  2126,  1234,
     529,   779,  2133,  2129,  1227,  1304,  1235,  2940,  2941,  2168,
    2148,  2153,  2956,  2169,  1936,  2176,  2181,  2179,  2186,  2338,
    2182,  2197,  2199,  1237,  2200,  2201,  3921,  3922,  2215,   779,
    2216,  1238,  2275,  2202,  2245,  1228,  2251,  2260,  3742,  3743,
    2270,  2303,  1646,   779,  2309,  2304,  2346,  2347,  2383,  2369,
    2359,  2365,  2991,  2992,  1141,  2370,  3032,  1162,  1142,  2377,
     779,  2429,  2442,   779,  2841,  2402,  2449,   632,  3487,  3488,
    3489,  1229,  2445,  2450,  2468,  1249,   719,  2495,  2469,  2400,
    2470,  1250,  1239,  2496,  2497,  2460,  2843,  3361,  3951,  3952,
    2446,  2337,  2459,  2479,  2471,  2493,  4078,  4210,  2508,  2513,
    4052,  1230,   713,  2516,  2527,  2520,  2518,  4210,  2521,  3464,
    2532,  2537,  2538,   713,  2540,  4025,  2543,  2337,  2337,  2547,
    2551,  1251,  2559,  3056,  2562,  2575,  2580,  3483,  3484,  3485,
    3486,  1124,  1128,  2701,  2582,  2636,  2644,  2647,  1794,  2660,
    2631,  2648,  3878,  1634,  2698,  2723,  3965,  2712,  4132,  2719,
    2724,  2725,  2727,  3490,  3492,  2728,  2720,  2731,  2729,  4253,
    2730,  2737,  2739,  3529,  2744,    33,  4139,  2748,  2751,  2842,
    1252,  2756,  2752,  2753,  2762,  1234,  2754,  1253,  2782,  2796,
    1254,  2811,  1235,  2805,  2819,  2755,  2821,  2798,  2757,  2832,
    1936,  2814,  2820,  2835,  2830,  2847,  2851,  2849,  2853,  1237,
    2850,  2854,  2863,  4033,  2866,  4034,  4035,  1238,  2869,  2875,
    2876,  3588,  2877,  2878,  4203,  2868,  4038,  2887,  2544,  2545,
    2546,  2458,  2276,  2895,  1503,  2901,  2880,  2556,  2903,  2558,
    2907,  2560,  2561,  1255,  2906,   988,  2909,  2910,  2911,  2925,
    2929,  2926,  2928,  2930,  2933,  2976,  4307,  2995,  3040,  3034,
    2934,  3042,  -961,  2964,  3066,  3010,  2597,  2936,  1239,  3068,
    3086,  3063,  2843,  3003,  3984,  2939,  2990,  2957,  3072,  2963,
    3083,  2221,   909,  2965,  2966,  2973,  3078,  2988,  3088,  4206,
    2989,  3089,  4242,  3039,   779,  3013,  4247,  4248,  3255,  3097,
    1256,  3100,  1257,  3093,  3102,  3653,  3094,  3124,  3656,  3109,
    3125,  3135,  1258,  3136,  3151,  3142,  4090,  3143,  3153,  3190,
    1259,  3637,  3191,  4129,  3638,  3194,  3639,  3196,  3197,  1260,
    3205,  3206,  3207,  1794,  3705,  2337,   632,  1794,  3198,  1794,
    3203,  3636,  4243,  4259,  2668,  3204,  3210,  3208,  1645,  3213,
    3209,  1646,  3215,  3731,  3211,  3212,  4246,  4249,   632,  4251,
    3214,  3216,  1261,  3218,  3217,  2734,  1262,  1645,  3221,  3225,
    1646,  2734,  2734,  3227,  2093,  2042,  1649,  3229,   779,  3235,
    3748,   779,  1650,  3223,  3241,  3242,  3245,  3257,  3260,  2107,
    3272,  1263,  3277,  3261,  3273,  1649,  3278,  3316,  3309,  3310,
    2726,  1650,  3319,  3323,  3321,  3342,  1651,  2750,  2735,  3709,
    3711,  3713,  3715,  2736,  3330,  1794,  3747,   976,   977,   641,
     642,  3343,  3331,  4430,   648,  1651,  3339,  3337,  3698,   659,
     665,   641,  3346,   672,  3349,  3369,   665,   665,  3386,   699,
    3387,   702,  3376,  3388,  3378,  3391,  3396,  3708,  3397,  1264,
    3398,  3399,  3408,  1578,  4132,  3413,  2960,  2942,  2959,  3443,
    3444,  4311,  3445,  1639,  3451,  3471,  3472,  4201,  3459,  3516,
    4430,  3480,  3032,  3499,  3539,  3579,  3032,  3513,  4430,  3774,
    3558,  3581,   779,   779,  3582,  3536,   167,  3771,  3522,   779,
    3594,  2886,  3593,  3596,  4182,  3617,  3618,  3598,  2824,  3619,
    3532,   798,  3607,  3533,  3648,  3630,  3631,  1652,  3620,  4098,
    3632,  1653,  4223,  3535,  3633,  3634,  3635,  3664,  3666,  3602,
    3669,  4227,  3675,  3677,  3678,  3701,  1652,  2858,  3702,  2860,
    1653,  3722,  1654,  1655,  3361,  3730,  3703,  3733,  3806,  3738,
    3740,  3844,  3845,  3846,  3847,  2279,  3745,  3766,  4116,  1656,
    3749,  1654,  1655,  2233,  3750,  4254,  3752,  3753,  3768,   632,
     909,  3769,  3783,  3791,   779,  3780,  3796,  3779,  1656,  3799,
    2896,  3800,  3785,  3801,   756,   761,   761,   764,  1658,   761,
    3802,   770,  3803,   756,  3808,   699,  3811,  3815,   800,  3820,
    3816,  1659,  2280,   699,  3821,   699,  3822,  1658,  3823,   761,
    3855,   699,  3824,  3850,  3828,  3852,  3854,  4419,  3862,  3865,
    1659,  3867,  3870,  3868,  1898,  3882,  3871,  3879,  3886,  3888,
    1677,  2281,  3893,  3894,  2912,  3902,  3421,  3916,  3913,  3426,
    3427,  3428,  3429,  3430,  3431,  3432,  3433,  3434,  3435,  3025,
    3917,  3923,  2282,  3025,  3934,  3937,  3941,  1899,  3946,  3953,
    3973,  3976,  3977,  2283,  3990,  3985,  3995,  3997,  4001,  4003,
    1900,  4012,  4014,  3877,  4020,  4022,  4023,  4031,  1661,  4037,
    4045,  4046,  2284,  1901,  4048,  4053,  4055,  2285,  4056,  4057,
    4071,  3887,  4058,   167,  3880,  4064,  4074,  1661,  3475,  3476,
    4080,  4084,  4092,  4104,  4108,  4086,  4125,  4088,  4113,  4126,
    4107,  4118,  4119,  3885,  4130,  4137,  3987,  4143,  4150,  3729,
    4152,  1902,  4153,  4155,  4156,  3928,  4157,  4174,  4175,  4176,
     632,  4184,  1903,  2286,  4180,  4178,  4207,  3938,  4185,  4213,
    4222,   720,  4230,  4239,  4273,  4264,  4274,  4276,  4279,  4269,
    4284,  1904,  4278,  4291,  2287,  4292,  1905,  4293,  4298,  4299,
    4304,  4305,  4310,  4309,  4315,  3918,  4317,  4328,  1662,  1663,
    1664,  4244,  1665,  1666,  1667,  1668,  1669,  1670,  1794,  4335,
    4333,  4336,   632,  4344,  4339,  4341,  4349,  4322, -2225, -2225,
    4350,  1665,  1666,  1667,  1668,  1669,  1670,  4355,   779,  3931,
    3932,  4356,  3524,  4337,  3935,  3936,  4376,  3948,  3949,  4381,
     779,  4373,  4415,   192,  4384,  4338,  4378,  2734,  2734,  4391,
    4392,  4396,  4410,  1906,   908,  4422,  4438,  1164,  3967,  2056,
    4441,  4447,  4451,  2800,  1283,  1708,  3049,  3032,  2635,  3611,
    2288,  2711,  3032,  1247,  3148,  3032,  2289,  3244,  3681,  4255,
    4131,  4030,  2290,  4334,  1907,  3045,  4319,  4177,  3741,  4179,
    3107,  3982,   632,  4165,   779,  3091,   909,  3979,   798,  2874,
    4379,  4096,  4418,  4342,  4340,  3032,  4390,  4287,  3737,  3096,
    3610,  2291,   192,  2292,   632,  2780,  3160,  3110,  2781,  3111,
    3112,  3113,  2763,  4005,  2145,  3326,  4421,  4452,  3056,  4448,
    2293,  4154,  3274,  3258,  4394,  4117,  2886,   798,  2128,  4330,
    4382,  4120,   647,  1552,  4115,  1908, -2138,  3797,  4225,  4024,
    3776,  1909,  3775,   828,  1910,  2294,  4297,   910,   699,  2588,
     756,  3224,  4403,   761,  4449,   764,  4282,   761,  1137,  2453,
    3806,  3806,  3806,  3806,   800,  2454,  2224,   885,  3053,  3759,
    1911,  3881,  3549,  2476,   761,  1158,  1912,   774,  3054,  3064,
    2478,  3185,  1806,  3187,  2477,  1835,  1834,  3062,  1839,  1913,
    3077,  3065,  3494,  3849,  3860,  4215,   756,  3491,  1844,   779,
    3550,   764,  3725,  1145,  2749,  3463,   756,  4205,  3453,  4364,
     800,  4365,  4372,  2886,  1914,  2886,  3057,  3008,  2920, -2138,
    3006,  3546,     0,     0,  3025,   761,  3032,  2428,     0,  3025,
       0,     0,  3025,     0,     0,     0,     0,  3220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3234,     0,     0,  4146, -2138,     0,     0,  4089,
       0,     0,     0,   699,  3032,     0,     0,     0, -2138,     0,
       0,     0, -2138,  3255,   699,  1002,   779, -2138,   779,     0,
       0,     0, -2138,     0,     0, -2138,     0, -2138,     0,     0,
       0,     0,  1116,  1111,     0,   699,   665,     0,     0,     0,
     665,     0,     0,  2734,     0,     0,     0,     0,     0,     0,
       0,   632,   908,   699, -2138,     0,  4135,   699,  4136,     0,
       0,  4140,  4141,  1111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   699,     0, -2138,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   699,     0,  4275,     0,
    1794,     0,   779,  2597,     0,     0,     0,   167,  4169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3832,
    3833,     0,     0, -2138,     0,     0,     0,     0,     0,     0,
    3372, -2138,  4234,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,   761,   761,     0,     0,     0,     0,     0,
       0,  3381,     0,     0,  3382,   798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2138,     0,
       0,  3025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,  3414,
       0, -2151,     0,     0,     0,     0,     0,   756,     0,  3407,
       0,   800,     0,     0,     0,     0,     0,     0,     0,  3420,
       0,     0,     0,   645,   761,     0,     0,  4352,     0,     0,
    4256,     0,     0,     0,     0,     0,     0,     0,  3032,   699,
       0,     0,     0,     0,  3442,   761,   761, -2138,     0,     0,
    1794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,   699,   699,     0,   761,     0,   756,  4380,     0,
   -2138,     0, -2138, -2138,     0,     0,     0,     0,     0,     0,
    1557,     0,     0,     0, -2151,     0,   167,  4285,     0,     0,
       0,     0,     0,   761,     0,   761,   761,     0,     0,     0,
       0,     0,     0,     0,     0, -2138,     0,     0, -2138, -2138,
   -2138,     0,     0,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2151,     0,     0,     0, -2151,  1535,  1535,
       0,     0, -2151,   699,     0,   641,     0, -2151,   908,     0,
   -2151,     0, -2151,     0,     0,   699,     0,     0,     0,     0,
       0,     0,     0,  1567,     0,     0,   699,     0,     0,  1573,
       0,     0,  2886,     0,     0,     0,     0,     0,     0, -2151,
    4450,     0,  1111,     0,     0,     0,     0,     0,   779,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2151,     0,  3583,  3584,  3585,  3586,     0,     0,     0,
       0,  1111,  1249,     0,     0,     0,     0,     0,  1250,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2151,  1111,
    1111,     0,  1111,     0,     0,   779, -2151,     0,     0,     0,
     167,  4395,     0,     0,  4044,     0,     0,     0,  1251,  1111,
    4437,     0,   167,  4408,   171,  4405,  4406,  4407,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4060,  4061,     0,     0,     0,     0,  4429,     0,     0,     0,
       0,     0,     0, -2151,     0,   699,     0,     0,  1111,     0,
       0,  4436,  4408,   171,  4405,  4406,  4407,  1252,     0,     0,
       0,     0,     0,     0,  1253,     0,     0,  1254,     0,     0,
       0,     0,     0,     0,  4428,     0,  1794,  1111,     0,     0,
       0,  1111,  1111,  4429,     0,     0,     0,     0,   645,     0,
       0,  4429,   699,   699,  1847,   167,  4408,   171,  4405,  4406,
    4407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     665,     0, -2151,     0,     0,     0,     0,     0,     0,     0,
    1255,  4428,     0,  1794,     0,  3723,     0,     0,     0,  4428,
       0,  1794,     0,  3744,     0, -2151,     0, -2151, -2151,     0,
       0,     0,     0,   665,     0,     0,     0,     0,     0,  2840,
       0,     0,     0,     0,     0,   699,  1959,     0,     0,     0,
       0,     0,   699,     0,     0,   761,     0,     0,  1225,     0,
   -2151,     0,     0, -2151, -2151, -2151,     0,  1256,     0,  1257,
       0,     0,     0,     0,     0,   800,     0,     0,     0,  1258,
       0,   699,     0,     0,   699,     0,     0,  1259,     0,     0,
    1226,     0,     0,     0,     0,     0,  1260,     0,     0,     0,
       0,     0,     0,     0,   699,     0,     0,     0,     0,     0,
       0,     0,   761,   761,   761,   761,   699,  1645,     0,     0,
    1646,     0,     0,     0,     0,     0,     0,   665,  4202,  1308,
     699,     0,     0,  1262,     0,     0,     0,  1647,     0,     0,
       0,  2068,     0,   699,     0,  1649,  1227,     0,     0,     0,
       0,  1650,     0,   761,   761,     0,     0,     0,  1309,   761,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1651,     0,  1228,     0,  1557,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1644,     0,     0,     0,     0,  1645,     0,     0,  1646,     0,
       0,     0,     0,   761,     0,     0,  2841,     0,     0,     0,
       0,     0,     0,  1229,     0,  1647,  1264,     0,  1648,     0,
       0,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
     761,   761,   761,   761,     0,     0,     0,     0,     0,     0,
       0,     0,   699,  1230,     0,     0,     0,     0,   699,     0,
       0,  2068,     0,  1651,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,     0,     0,   764,     0,   756,
       0,     0,     0,     0,     0,     0,  1652,     0,     0,   800,
    1653,     0,     0,     0,   761,     0,  3906,     0,     0,     0,
       0,     0,     0,   761,     0,     0,     0,     0,     0,   761,
     761,  1654,  1655,     0,   699,     0,     0,    33,     0,     0,
       0,  1233,     0,     0,  3920,     0,     0,  1234,  1656,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,  1535,
    3933,     0,  1936,     0,     0,     0,   761,     0,   756,     0,
       0,  1237,   699,   699,  1657,   761,     0,  1658,     0,  1238,
       0,   699,     0,     0,  1652,     0,     0,     0,  1653,     0,
    1659,     0,     0,  1660,     0,   641,   641,     0,     0,  2278,
       0,     0,     0,  1111,     0,  1111,  3950,     0,  3944,  1654,
    1655,     0,  1111,     0,     0,  1111,     0,     0,     0,  1111,
       0,     0,  3947,     0,     0,     0,  1656,  1111,  1111,     0,
    1239,     0,     0,     0,  2843,  1111,     0,   800,  1111,  1111,
    1111,  1111,     0,     0,     0,     0,     0,     0,  1111,  1111,
       0,  1111,  1657,  1111,  1111,  1658,     0,  1111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1661,  1659,     0,
       0,  1660,     0,     0,  1111,     0,     0,     0,   761,  1111,
       0,     0,     0,  1111,     0,     0,     0,  1111,     0,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,     0,  1111,
       0,     0,     0,   699,  1111,     0,  1111,     0,     0,     0,
       0,     0,   699,     0,     0,  4007,     0,     0,     0,  1645,
       0,     0,  1646,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1647,
       0,     0,     0,     0,     0,  1661,     0,  1649,     0,     0,
       0,     0,  1557,  1650,     0,     0,     0,  1662,  1663,  1664,
       0,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,  2447,
       0,     0,     0,     0,     0,  2448,     0,  1651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1645,     0,     0,  1646,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1647,     0,     0,     0,     0,     0,     0,     0,  1649,
       0,     0,     0,     0,     0,  1650,     0,     0,   699,     0,
     699,     0,  1111,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,  1651,
       0,     0,  4099,  4101,  4101,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   699,     0,     0,
       0,     0,     0,  2485,     0,  2492,     0,     0,  1652,     0,
       0,     0,  1653,     0,     0,     0,     0,     0,     0,     0,
     764,     0,     0,     0,     0,   641,     0,   641,     0,     0,
       0,     0,     0,  1654,  1655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1111,     0,     0,     0,     0,     0,
    1656,     0,     0,     0,     0,   756,     0,   761,   761,   761,
       0,     0,   756,     0,   800,     0,   761,     0,   761,  1645,
     761,   761,  1646,     0,   699,     0,  1657,     0,     0,  1658,
    1652,     0,     0,     0,  1653,     0,     0,     0,     0,  1647,
       0,     0,  1659,   665,     0,  1660,     0,  1649,     0,     0,
       0,     0,  1225,  1650,     0,  1654,  1655,     0,     0,     0,
    4189,     0,  1959,  1557,     0,     0,     0,     0,  2598,   829,
       0,     0,  1656,  2607,     0,     0,     0,  1651,     0,   699,
       0,     0,     0,     0,  1226,     0,     0,     0,     0,     0,
       0,     0,     0,  3220,     0,   699,     0,     0,  1657,  2642,
    2642,  1658,   830,     0,     0,     0,   764,     0,     0,     0,
       0,     0,     0,     0,  1659,   831,   832,  1660,     0,  1661,
       0,     0,     0,   761,   833,     0,     0,     0,   834,     0,
       0,  1557,     0,     0,     0,  1557,  1557,     0,  4231,     0,
    1227,     0,     0,     0,     0,   835,     0,     0,     0,  2700,
       0,  2703,  2705,     0,     0,     0,     0,     0,     0,     0,
       0,  4250,     0,  4252,     0,     0,   836,     0,     0,     0,
       0,  1228,     0,     0,     0,     0,     0,   837,  1652,   761,
       0,     0,  1653,     0,     0,   838,     0,   761,     0,     0,
       0,  1661,   761,     0,     0,     0,   839,     0,     0,     0,
       0,   840,     0,  1654,  1655,  1111,     0,  1229,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
    1656,     0,   841,     0,     0,     0,  2935,     0,     0,     0,
       0,     0,     0,  1959,     0,     0,  2642,  1230,   699,     0,
    2801,     0,     0,   641,     0,     0,  1657,   842,     0,  1658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1659,     0,  1231,  1660,  4101,     0,   843,  2700,
       0,     0,     0,     0,     0,     0,     0,   761,  2826,     0,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,     0,     0,     0,     0,     0,     0,  1232,  2983,   844,
       0,    33,     0,     0,   761,  1233,   761,  2642,   761,  2642,
       0,  1234,     0,     0,     0,     0,  1645,  4348,  1235,  1646,
       0,     0,     0,     0,     0,     0,  1236,   192,  1111,     0,
       0,     0,     0,     0,     0,  1237,  1647,     0,     0,  1661,
    1535,     0,     0,  1238,  1649,     0,     0,     0,     0,     0,
    1650,     0,     0,     0,   845,     0,     0,     0,   846,     0,
     847,     0,     0,     0,     0,     0,   848,     0,     0,   849,
       0,  4383,     0,     0,  1651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,     0,
       0,     0,   756,     0,  1239,   850,     0,   851,     0,     0,
       0,   852,     0,   761,     0,     0,     0,     0,     0,   853,
    1111,  1111,     0,     0,   854,     0,  1111,     0,     0,  4420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   855,
       0,  1111,  1111,  2368,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,  1111,  1111,
    1111,  1111,     0,     0,     0,  1645,     0,     0,  1646,     0,
       0,  1111,     0,     0,  1111,  1652,  1111,  2987,     0,  1653,
       0,     0,  1649,     0,     0,  1647,  1111,  1111,  1650,     0,
    1111,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
    1654,  1655,     0,  1111,     0,  1111,     0,   800,     0,  1111,
       0,     0,  1651,     0,     0,     0,     0,  1656,     0,     0,
       0,     0,     0,  1651,     0,  1111,     0,  -119,     0,   699,
       0,     0,     0,     0,     0,     0,  3033,     0,  1111,  1111,
    1111,     1,     0,  1657,     0,     0,  1658,     0,     0,     0,
       0,     2,     0,     3,     4,  1111,     0,     0,     0,  1659,
       0,     0,  1660,     0,     0,     0,     0,  1111,     5,     0,
       0,     0,  1111,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,  3033,     0,     6,  3071,
       7,     8,     0,  2492,     0,     0,     9,     0,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,     0,
      12,     0,     0,  1652,     0,     0,     0,  1653,     0,     0,
       0,     0,     0,  1111,  1652,  2642,    13,     0,  1653,    14,
    1535,     0,     0,     0,     0,     0,  1661,     0,  1654,  1655,
       0,    15,     0,    16,     0,     0,     0,    17,     0,  1654,
    1655,     0,     0,    18,     0,  1656,   761,     0,   761,   761,
     761,    19,     0,    20,     0,     0,  1656,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1657,     0,    22,  1658,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,     0,  1658,     0,  1659,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1662,  1663,  1664,     0,
    1665,  1666,  1667,  1668,  1669,  1670,     0,     0,    23,    24,
    3259,     0,     0,     0,    25,  1645,     0,     0,  1646,     0,
       0,     0,     0,    26,  1395,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,  1647,     0,     0,     0,     0,
       0,     0,     0,  1649,  1661,     0,     0,     0,     0,  1650,
       0,     0,     0,     0,     0,  1661,     0,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,     0,     0,
       0,    28,     0,  1651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,     0,     0,     0,    30,    31,
       0,    32,  1649,     0,     0,     0,    33,     0,  1650,     0,
       0,    34,     0,     0,    35,     0,  2642,  2642,    36,     0,
       0,     0,     0,    37,    38,     0,     0,     0,     0,     0,
       0,    39,  1651,     0,    40,     0,     0,     0,     0,     0,
       0,     0,    41,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,    42,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,  1395,  3534,     0,   699,
     699,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,     0,  1652,   699,     0,    45,  1653,     0,
       0,     0,    46,     0,  3004,     0,     0,     0,  1535,   699,
       0,     0,     0,     0,    47,     0,     0,  1535,   699,  1654,
    1655,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,     0,     0,     0,  1656,     0,     0,     0,
       0,     0,     0, -2225,     0,     0,     0,  1653,    48,     0,
       0,  -119,     0,     0,     0,     0,     0,     0,     0,     0,
     761,     0,  1657,   761,     0,  1658,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,   756,  1659,     0,
       0,  1660,     0,     0,     0, -2225,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   761,     0,
       0,     0,     0,     0,  1658,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1111,  1659,     0,     0,
       0,     0,  1111,     0,  1111,     0,     0,     0,     0,     0,
    1111,     0,     0,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,  1111,  1111,     0,     0,  1661,  1111,  1111,     0,     0,
    1249,     0,     0,     0,     0,     0,  1250,     0,     0,  1111,
       0,  1395,     0,  1111,     0,     0,     0,  1111,     0,     0,
    1645,     0,     0,  1646,     0,     0,     0,  1111,     0,     0,
    1111,     0,  1111,     0,     0,     0,     0,     0,     0,     0,
    1647,  1111,  1111,  1111, -2225,     0,  1251,  1111,  1649,     0,
    1111,     0,     0,     0,  1650,     0,     0,   699,   699,   699,
     756,  3033,  3498,     0,     0,  1395,  3498,  3512,     0,     0,
       0,  1111,     0,     0,     0,     0,  1249,  3526,  1651,  1111,
       0,  1111,  1250,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,  1252,     0,  1395,     0,  3415,
       0,     0,  1253,  1111,     0,  1254,     0,     0,     0,  1111,
       0,     0,     0,  2492,     0,  1111,     0,     0,     0,     0,
       0,     0,  1251,     0,     0,     0,     0,     0,     0,     0,
    3566,  1535,  1535,     0,  2068,     0,     0,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,     0,
       0,     0,   761,   761,   761,   761,     0,     0,  1255,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1395,
    1249,  1252,     0,     0,     0,     0,  1250,     0,  1253,  1652,
       0,  1254,     0,  1653,     0,     0,     0,     0,  1395,     0,
    3609,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1654,  1655,     0,     0,  1395,     0,
       0,     0,     0,     0,     0,  1256,  1251,  1257,     0,     0,
     758,  1656,     0,     0,     0,     0,     0,  1258,     0,   758,
     778,     0,     0,  1395,  1255,  1259,   778,     0,     0,     0,
       0,     0,     0,     0,  1260,     0,   778,  1657,     0,     0,
    1658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3670,  1659,     0,  1252,  1660,     0,     0,     0,
       0,     0,  1253,     0,     0,  1254,     0,  1334,     0,     0,
       0,  1262,     0,     0,     0,     0,     0,     0,     0,     0,
    1395,  1256,     0,  1257,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1258,     0,     0,  1335,     0,     0,     0,
       0,  1259,     0,   699,     0,  1645,     0,     0,  1646,     0,
    1260,     0,     0,     0,   761,     0,  1111,     0,  1255,     0,
       0,     0,   699,     0,     0,  1647,     0,     0,  3736,     0,
    1661,     0,     0,  1649,     0,     0,     0,  1959,     0,  1650,
       0,     0,     0,  1918,     0,     0,     0,  1262,     0,   699,
       0,     0,     0,     0,  1264,     0,     0,     0,  2700,     0,
       0,     0,     0,  1651,  3764,     0,     0,     0,     0,     0,
       0,     0,  1919,     0,     0,  1256,     0,  1257,     0,     0,
    1111,  1111,     0,     0,     0,     0,     0,  1258,     0,     0,
       0,     0,     0,     0,     0,  1259,     0,     0,     0,     0,
       0,     0,     0,  2642,  1260,  2642,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1645,     0,     0,  1646,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
    1264,     0,     0,     0,  3462,  1647,     0,  1989,  1111,     0,
       0,  1262,  1645,  1649,     0,  1646,     0,     0,     0,  1650,
       0,     0,     0,     0,     0,     0,     0,  1395,     0,     0,
       0,     0,  1647,     0,  1652,     0,  1990,     0,  1653,     0,
    1649,     0,     0,  1651,     0,  1111,  1650,     0,     0,     0,
       0,     0,     0,     0,     0,  1111,  1111,     0,     0,  1654,
    1655,     0,     0,  1111,  1111,     0,     0,     0,  1111,     0,
    1651,     0,     0,     0,  1111,  1111,  1656,     0,  1111,     0,
     699,   699,   699,   699,     0,     0,     0,  3498,  3512,  3498,
       0,     0,  3851,     0,  1264,     0,  3033,     0,     0,     0,
    3033,     0,  1657,     0,     0,  1658,  3864,     0,     0,     0,
    1111,     0,     0,     0,     0,  1111,     0,     0,  1659,     0,
       0,  3874,     0,     0,     0,     0,   758,  1111,     0,     0,
       0,     0,     0,   800,     0,     0,     0,     0,   778,     0,
       0,  3071,   778,     0,  1652,  2492,     0,     0,  1653,     0,
       0,     0,     0,   778,     0,   641,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   778,  1654,
    1655,  1652,   758,     0,     0,  1653,     0,     0,  2642,  2642,
       0,     0,   758,   778,     0,     0,  1656,     0,   778,     0,
       0,     0,     0,     0,     0,  1661,  1654,  1655,   778,     0,
       0,     0,  3919,     0,     0,     0,   778,     0,     0,     0,
       0,     0,  1657,  1656,     0,  1658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0,     0,     0,  1657,
       0,     0,  1658,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,  1659,     0,     0,  1660,     0,
       0,   761,     0,     0,     0,     0,     0,  1249,     0,     0,
       0,     0,     0,  1250,     0,     0,     0,     0,     0,   758,
       0,     0,     0,     0,   778,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,     0,     0,     0,   758,
       0,     0,     0,  1251,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,  1395,     0,     0,     0,     0,  1395,  1395,
     756,     0,  1661,     0,     0,  1959,     0,     0,     0,     0,
    1395,     0,  1535,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   761,  1959,     0,     0,     0,     0,
       0,     0,  1252,     0,     0,     0,     0,     0,     0,  1253,
       0,     0,  1254,     0,     0,     0,     0,     0,     0,     0,
     699,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,  1111,  3538,
       0,     0,     0,     0,     0,     0,     0,  1111,     0,     0,
       0,     0,  1662,  1663,  1664,  1255,  1665,  1666,  1667,  1668,
    1669,  1670,   758,     0,  1111,  1111,  3560,     0,  1111,     0,
       0,     0,     0,   758,     0,     0,     0,  3498,     0,     0,
       0,  3033,     0,     0,     0,     0,  3033,     0,     0,  3033,
    2700,     0,  4076,     0,  1111,  1111,  1405,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1395,  1256,     0,  1257,     0,     0,     0,     0,  3566,
     800,   761,   761,   761,  1258,     0,     0,     0,     0,     0,
       0,     0,  1259,   758,     0,     0,     0,     0,     0,     0,
       0,  1260,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,   756,   800,
       0,     0,     0,     0,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,  1647,     0,     0,     0,  1262,     0,
     778,     0,  1649,     0,   758,     0,     0,  1249,  1650,     0,
    1395,     0,   778,  1250,     0,     0,     0,  1535,     0,     0,
       0,   756,     0,  1263,   699,     0,     0,     0,  1645,     0,
       0,  1646,  1651,     0,     0,  3736,     0,     0,     0,  1249,
     778,     0,  2642,     0,     0,  1250,  1959,     0,  1405,     0,
     778,     0,     0,  1251,     0,     0,  1649,     0,  3764,     0,
       0,   699,  1650,   778,     0,     0,   778,     0,     0,   761,
    3566,     0,     0,     0,     0,     0,     0,     0,   758,     0,
       0,  1264,     0,     0,     0,  1251,  1651,     0,     0,     0,
       0,     0,  1111,     0,  1395,  1111,     0,  1111,     0,     0,
       0,     0,  1252,     0,     0,     0,     0,   758,     0,  1253,
       0,     0,  1254,     0,  1111,     0,     0,     0,  3033,     0,
       0,  4076,     0,     0,     0,     0,     0,  4221,     0,     0,
       0,     0,     0,  1652,  1252,   758,   758,  1653,   758,     0,
       0,  1253,     0,     0,  1254,     0,     0,   761,  3477,     0,
       0,   699,     0,     0,     0,   758,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,  1255,     0,     0,     0,   761,
     761,   761,   761,     0,     0,  1656,     0,   778,     0,     0,
       0,     0,     0,     0,  1535,   778,   778, -2225,     0,     0,
       0,  1653,     0,     0,   758,  1793,     0,  1255,     0,     0,
       0,  1657,   756,     0,  1658,     0,     0,     0,     0,     0,
       0,     0,  1654,  1655,     0,     0,     0,  1659,     0,     0,
    1660,  1111,  1256,   758,  1257,     0,     0,   758,   758, -2225,
       0,     0,     0,     0,  1258,     0,     0,     0,     0,     0,
       0,     0,  1259,  1405,     0,     0,     0,     0,     0,  1793,
       0,  1260,     0,     0,  1256,     0,  1257,     0,  1658,     0,
       0,     0,     0,     0,     0,     0,  1258,     0,     0,  1111,
       0,  1659,     0,     0,  1259,   761,     0,   800,  1645,     0,
       0,  1646,     0,  1260,  2594,     0,  1111,     0,  1262,     0,
       0,     0,     0,     0,  1661,     0,     0,  1405,  1647,     0,
       0,     0,     0,     0,     0,     0,  1649,     0,     0,     0,
       0,     0,  1650,  1263,     0,     0,  2675,     0,     0,     0,
    1262,     0,     0,     0,     0,     0,   761,     0,     0,  1405,
       0,   756,     0,     0,     0,     0,  1651,     0,     0,     0,
       0,     0,  3566,     0,     0,  2676,     0,     0, -2225,     0,
       0,     0,     0,     0,     0,     0,  4221,     0,     0,  1111,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1264,   756,     0,  1395,     0,     0,     0,     0,     0,
     761,   778,     0,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,     0,     0,     0,  3809,     0,
       0,  1405,     0,  1264,     0,  1249,     0,     0,     0,     0,
       0,  1250,     0,  1111,     0,     0,  1395,  1395,     0,  1395,
    1405,     0,     0,  1111,     0,     0,     0,     0,   761,     0,
       0,     0,     0,     0,     0,     0,     0,  1652,     0,     0,
    1405,  1653,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,
       0,  1251,     0,     0,     0,     0,     0,     0,     0,     0,
    1793,     0,  1654,  1655,     0,  1405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1395,     0,  1395,     0,  1656,
     778,     0,     0,     0,  1645,  1111,     0,  1646,     0,     0,
       0,     0,     0,     0,   756,     0,   778,     0,     0,     0,
    1252,     0,     0,     0,     0,  1657,     0,  1253,  1658,     0,
    1254,     0,  1649,     0,  1249,     0,   758,     0,  1650,     0,
    1250,  1659,  1405,     0,  1660,   758,     0,   778,   778,     0,
       0,  1395,     0,     0,     0,     0,     0,     0,   778,     0,
       0,     0,  1651,     0,     0,     0,     0,     0,     0,     0,
     778,   778,     0,     0,     0,     0,  1395,     0,     0,     0,
    1251,     0,   778,  1255,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1395,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,   758,     0,     0,     0,  1661,     0,
       0,     0,     0,     0,  3478,     0,     0,     0,     0,  1252,
       0,     0,     0,     0,     0,     0,  1253,     0,  1645,  1254,
    1256,  1646,  1257,     0,     0,     0,     0,     0,     0,   758,
       0,   758,  1258,     0,     0,     0,     0,     0,   758,     0,
    1259,   758,     0, -2225,     0,   758,  1649,  1653,     0,  1260,
       0,     0,  1650,   758,   758,     0,     0,  1395,     0,     0,
    1404,   758,     0,     0,   758,   758,   758,   758,  1654,  1655,
       0,     0,  1255,  1395,   758,   758,  1651,   758,  1645,   758,
     758,  1646,  2714,   758,  1395, -2225,  1262,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,  1647,  1405,
     758,  1793,  3843,     0,     0,   758,  1649,     0,     0,   758,
       0,  2715,  1650,   758,  1658,   758,   758,   758,   758,   758,
     758,   758,   758,   758,     0,   758,     0,  1659,     0,  1256,
     758,  1257,   758,     0,     0,     0,  1651,     0,  3481,     0,
       0,  1258,     0,     0,     0,     0,     0,     0,     0,  1259,
       0,     0,     0,  1395,     0,     0,     0,     0,  1260,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1264,
       0,     0,     0,  1395,     0,     0,     0, -2225,     0,     0,
    1645,  1653,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,  3129,  1404,     0,     0,  1262,     0,     0,  1395,     0,
    1647,     0,  1654,  1655, -2225,     0,     0,     0,  1649,     0,
       0,     0,     0,     0,  1650,     0,     0,     0,     0, -2225,
    3130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1395,     0,     0,  1652,  1651,     0,
       0,  1653,     0,     0,     0,     0,     0,     0,  1658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,     0,
       0,  1659,  1654,  1655,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1264,  1656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,  1657,     0,   778,  1658,     0,
       0,  1793,   778,     0,     0,   778,     0,     0,     0,     0,
       0,  1659,     0,     0,  1660,  1249,     0,     0,     0,     0,
       0,  1250,     0,     0,     0,     0,     0,   778, -2225,  1652,
     758,     0,     0,  1653,     0,     0,     0,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,  1654,  1655,     0,     0,     0,     0,
       0,  1251,     0,     0,     0,     0,     0,     0,   778,     0,
       0,  1656,     0,     0,     0,     0,     0,  1404,     0,     0,
       0,     0,     0,     0,     0,  1405,     0,     0,  1661,  1395,
    1405,  1405,     0,     0,     0,   778,   778,  1657,     0,     0,
    1658,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
    1252,     0,     0,  1659,     0,     0,  1660,  1253,  1793,   778,
    1254,  1793,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,
       0,  1951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   778,     0,     0,     0,   778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,   778,     0,  1645,     0,
       0,  1646,     0,  1255,     0,     0,   778,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,  1647,   778,
    1661,     0,  4054,     0,     0,     0,  1649,     0,   778,     0,
       0,     0,  1650,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1645,     0,
       0,  1646,     0,     0,     0,     0,  1651,     0,     0,     0,
    1256,     0,  1257,     0,     0,  1404,     0,  1395,  1647,     0,
       0,   758,  1258,  1405,     0,     0,  1649,     0,     0,     0,
    1259,     0,  1650,     0,  1404,     0,     0,     0,     0,  1260,
       0,     0,     0,     0,  1793,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,  1404,     0,  1651,     0,     0,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
       0,     0,  3171,     0,  4094,     0,  1262,     0,     0,  1404,
    1645,     0,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1647,  3172,  1405,     0,     0,   778,     0,  1652,  1649,     0,
       0,  1653,     0,     0,  1650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1654,  1655,     0,     0,  1404,     0,  1651,   778,
       0,     0,     0,     0,   758,     0,     0,     0,     0,  1656,
       0,     0,     0,     0,     0,     0,     0,  1652,     0,  1264,
       0,  1653,  1395,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,   778,  1657,     0,     0,  1658,     0,
       0,     0,  1654,  1655,     0,     0,  1405,     0,     0,     0,
       0,  1659,     0,     0,  1660,     0,     0,     0,   778,  1656,
       0,     0,   758,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1657,   758,   758,  1658,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,  1652,
    1249,  1659,     0,  1653,  1660,     0,  1250,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   758,   758,     0,
       0,     0,   758,     0,  1654,  1655,     0,     0,  1661,     0,
       0,  1288,     0,     0,   758,   758,   758,   758,     0,     0,
    1395,  1656,  1793,     0,     0,     0,  1251,   758,  1793,     0,
     758,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   758,   758,     0,     0,   758,  1657,  1395,     0,
    1658,     0,     0,  1404,     0,     0,     0,  1289,  1661,   758,
       0,   758,     0,  1659,  1395,   758,  1660,     0,     0,     0,
       0,     0,     0,     0,     0,  1252,     0,     0,     0,     0,
       0,   758,  1253,     0,     0,  1254,  2440,     0,     0,     0,
       0,     0,   758,     0,   758,   758,   758,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   778,     0,
    1395,   758,  4148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,   758,  1290,     0,     0,  1255,     0,
    1661,     0,   758,     0,     0,     0,     0,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   778,     0,
       0,     0,  4351,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   778,   778,     0,     0,     0,     0,   758,
       0,     0,     0,  1291,     0,  1292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1293,     0,  1257,     0,     0,
     778,     0,     0,   778,     0,     0,  1405,  1258,     0,     0,
       0,     0,     0,     0,     0,  1259,     0,     0,     0,     0,
       0,     0,     0,  1294,  1260,     0,     0,     0,     0,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
       0,     0,     0,     0,  4439,     0,     0,     0,  1405,  1405,
       0,  1405,     0,     0,     0,     0,  1395,  1295,     0,     0,
       0,  1262,  1296,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1793,  1793,  1793,     0,  1645,     0,  1297,  1646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1298,     0,   778,
       0,     0,     0,     0,  1647,     0,     0,  1405,  2461,  1405,
     778,     0,  1649,     0,     0,     0,     0,     0,  1650,     0,
     778,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1651,     0,  1264,     0,     0,   558,     0,  2583,
       0,     0,     0,   600,  1951,  2590,     0,     0,     0,     0,
       0,     0,   650,  1405,  1395,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   711,   778,     0,     0,     0,     0,  2462,  1405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1405,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1793,  1405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   778,
       0,   778,     0,  1652,     0,     0,     0,  1653,     0,     0,
       0,     0,     0,   778,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1395,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1656,     0,  1395,     0,  1405,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   778,  1405,     0,  1404,     0,     0,
       0,  1657,     0,     0,  1658,     0,  1405,  1395,   769,     0,
       0,     0,     0,     0,     0,     0,     0,  1659,   803,   804,
    1660,   807,   778,   810,     0,   812,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,   778,     0,     0,  1645,
       0,     0,  1646,     0,     0,  1395,     0,     0,     0,  1395,
    1395,     0,     0,   778,     0,     0,   778,     0,     0,  1647,
       0,     0,  2922,     0,     0,     0,     0,  1649,     0,     0,
       0,     0,   758,  1650,     0,  1405,  1951,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,   758,     0,
     758,     0,     0,     0,  1661,  1405,   758,  1651,     0,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,     0,
       0,     0,   758,   758,     0,     0,     0,     0,     0,     0,
    1405,     0,     0,     0,     0,   758,     0,     0,     0,   758,
       0,  1793,     0,   758,     0,     0,     0,     0,     0,     0,
       0,  1645,     0,   758,  1646,  2463,   758,     0,   758,     0,
       0,     0,     0,     0,     0,     0,  1405,   758,   758,   758,
    1404,  1647,     0,   758,     0,     0,   758,     0,     0,  1649,
       0,     0,     0,     0,     0,  1650,   758,   758,     0,     0,
       0,     0,     0,     0,  1662,  1663,  1664,   758,  1665,  1666,
    1667,  1668,  1669,  1670,     0,   758,     0,   758,  1652,  1651,
       0,     0,  1653,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   758,
       0,     0,     0,  1654,  1655,   758,     0,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
    1656,     0,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1657,     0,     0,  1658,
       0,     0,     0,     0,     0,     0,     0,   778,     0,  2959,
       0,     0,  1659,     0,  2960,  1660,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
    1652,     0,     0,   780,  1653,     0,     0,     0,     0,     0,
       0,     0,     0,   780,     0,     0,  1793,     0,     0,     0,
    1793,  1405,  1793,     0,     0,  1654,  1655,     0,  2440,  2440,
    2440,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1656,     0,     0,     0,     0,     0,   862,     0,
       0,     0,     0,     0,     0,     0,   870,     0,     0,  1661,
       0,   778,     0,     0,   778,   886,   887,     0,  1657,     0,
     889,  1658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   905,     0,     0,  1659,     0,  1645,  1660,     0,  1646,
       0,     0,     0,     0,   913,     0,     0,     0,  1793,     0,
       0,     0,     0,     0,     0,     0,  1647,     0,     0,     0,
     936,     0,     0,   938,  1649,   940,     0,   943,     0,     0,
    1650,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,   758,     0,  1651,     0,     0,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
       0,  1661,     0,     0,     0,   778,   778,     0,     0,  1405,
       0,     0,   778,     0,     0,     0,     0,   999,     0,  1000,
       0,     0,  1951,  2590,     0,  2590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1405,   758,   758,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   711,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,  1404,     0,  1652,     0,   778,     0,  1653,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,     0,     0,     0,   758,     0,     0,     0,     0,     0,
    1654,  1655,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1656,     0,     0,
       0,  1216,     0,     0,     0,     0,     0,  1404,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,   758,  1657,  1405,     0,  1658,     0,     0,   758,
     758,     0,  1404,     0,   758,  1405,     0,     0,     0,  1659,
     758,   758,  1660,     0,   758,     0,     0,     0,     0,     0,
       0,  2590,  1337,     0,     0,   780,     0,     0,     0,   780,
       0,  3454,   758,     0,     0,     0,   758,  1349,     0,  2590,
     780,     0,     0,     0,     0,     0,   758,     0,     0,     0,
    1359,   758,     0,     0,     0,   780,     0,  1361,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,  1409,
     780,     0,  1413,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   780,  1661,     0,     0,     0,
       0,     0,     0,   780,   758,     0,     0,     0,     0,     0,
    3455,     0,     0,  1404,  1645,  1456,     0,  1646,     0,     0,
       0,     0,  1405,     0,     0,  1645,     0,     0,  1646,  2590,
       0,     0,     0,     0,  1647,     0,     0,     0,     0,     0,
    1404,  1793,  1649,     0,     0,  1647,     0,     0,  1650,     0,
    1405,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
       0,   778,     0,     0,     0,     0,  1405,     0,     0,     0,
       0,     0,  1651,   778,     0,     0,     0,     0,     0,     0,
       0,   780,     0,  1651,     0,     0,  1662,  1663,  1664,     0,
    1665,  1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   778,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4413,     0,     0,  1404,  1645,     0,     0,  1646,     0,
       0,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,  1652,     0,  1647,   758,  1653,  2967,     0,
       0,     0,     0,  1649,  1652,     0,     0,     0,  1653,  1650,
    1404,     0,     0,     0,     0,     0,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1654,
    1655,     0,     0,  1651,     0,  1656,     0,     0,     0,     0,
       0,     0,     0,  1405,     0,     0,  1656,     0,     0,     0,
       0,  2440,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1657,   778,     0,  1658,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,   758,  1658,     0,  1659,  1405,     0,
    1660,     0,     0,   758,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,   711,  1808,  1645,     0,  4414,  1646,     0,
     758,   758,     0,     0,   758,  2937,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1647,     0,   758,     0,     0,
       0,     0,   758,  1649,     0,   758,     0,     0,     0,  1650,
     758,   758,     0,     0,  1652,     0,     0,     0,  1653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   778,
       0,   778,   780,  1651,  1661,   758,  1916,     0,     0,  1654,
    1655,     0,     0,     0,     0,  1661,     0,   780,     0,     0,
       0,     0,     0,     0,     0,  2590,  1656,     0,     0,   780,
       0,     0,     0,     0,     0,     0,  1405,     0,     0,     0,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,     0,  1658,     0,   780,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,   780,  1659,     0,
       0,  1660,     0,  1793,     0,   778,     0,     0,     0,     0,
     780,     0,     0,   780,     0,     0,     0,   758,  2972,     0,
       0,     0,     0,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,  1652,  1662,  1663,  1664,  1653,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1654,
    1655,     0,     0,     0,     0,     0,   758,     0,  1405,     0,
       0,     0,     0,     0,     0,  1661,  1656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,  1405,
       0,   758,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,  1657,  1404,     0,  1658,     0,     0,     0,     0,
     758,     0,     0,     0,   758,     0,     0,     0,  1659,  1405,
       0,  1660,     0,  1403,   780,     0,     0,     0,     0,     0,
    2124,     0,   780,   780,     0,     0,     0,     0,     0,  1951,
       0,     0,  1795,     0,     0,  2147,     0,  1645,     0,     0,
    1646,     0,     0,  1793,     0,     0,     0,  1405,     0,     0,
       0,  1405,  1405,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,  1649,     0,     0,     0,     0,
       0,  1650,     0,     0,     0,  2192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,  1795,     0,   758,     0,
    2207,     0,  2209,     0,  2210,  1651,     0,     0,     0,  2211,
       0,     0,     0,     0,     0,  1645,     0,   758,  1646,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1647,     0,  1405,  2978,     0,
       0,     0,     0,  1649,     0,     0,     0,     0,  1404,  1650,
       0,     0,  1808,     0,     0,  1695,  1808,     0,  1808,  1404,
       0,  1808,     0,     0,     0,   758,     0,  3841,     0,     0,
       0,     0,     0,  1651,     0,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
    2440,   778,     0,     0,     0,  2440, -2225,     0,     0,     0,
    1653,     0,     0,     0,     0,     0,     0,  2440,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,   758,   780,     0,
       0,  1654,  1655,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2225,     0,
       0,     0,     0,     0,     0,   758,   758,     0,   778,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,   758,     0,
       0,     0,  1403,     0,  1652,     0,     0,  1658,  1653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1659,     0,     0,     0,  1404,     0,     0,     0,     0,  1654,
    1655,     0,     0,     0,  1403,     0,     0,  1795,     0,   758,
    1404,     0,     0,     0,     0,     0,  1656,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1793,
       0,     0,  1657,   780,     0,  1658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0, -2225,     0,     0,
       0,     0,     0,     0,   780,   780,  1403,     0,     0,  1645,
       0,   758,  1646,     0,     0,   780,  1793,     0,     0,     0,
     758,     0,     0,     0,  1793,  1403,     0,   780,   780,  1647,
       0,     0,     0,     0,     0,     0,     0,  1649,     0,   780,
       0,     0,     0,  1650,     0,  1403,     0,     0,     0,     0,
       0,     0,     0,  1645,     0,     0,  1646,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,     0,  1651,     0,     0,
    1403,     0,     0,  1647,     0,     0,  3461,     0,     0,     0,
       0,  1649,     0,     0,     0,     0,     0,  1650,     0,     0,
       0,  1665,  1666,  1667,  1668,  1669,  1670,  4028,     0,  2499,
    2500,     0,     0,     0,  2503,  2504,     0,     0,  2507,     0,
       0,  1651,     0,     0,     0,     0,     0,     0,  2517,     0,
       0,     0,     0,     0,     0,  2526,     0,  1403,     0,  2529,
    2530,     0,  1404,  2533,  2534,     0,     0,     0,     0,     0,
    2539,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2555,     0,  2557,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,  1652,     0,
    2579,     0,  1653,     0,     0,  2581,     0,     0,  1795,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1654,  1655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2599,  2600,  2603,  2605,
    1656,     0,  1652,  2612,  2615,     0,  1653,     0,     0,     0,
       0,  2626,  1155,     0,  2630,     0,     0,     0,  2634,     0,
       0,  1645,     0,     0,  1646,     0,  1657,  1654,  1655,  1658,
    2590,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2662,  1647,  1659,     0,  1656,  1660,     0,     0,     0,  1649,
       0,  2669,     0,  2671,     0,  1650,     0,     0,  2674,     0,
       0,     0,     0,  2678,  2679,  2680,  2681,     0,  2683,     0,
    1657,     0,     0,  1658,     0,     0,     0,     0,     0,  1651,
       0,  2707,  2708,  2709,     0,     0,  1659,     0,     0,  1660,
       0,     0,  2717,  2718,  1403,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1661,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2590,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3411,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,  2775,     0,     0,     0,
       0,     0,     0,  1661,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,  1795,   780,
    1652,     0,   780,  1404,  1653,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,  1654,  1655,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
       0,  1404,  1656,     0,     0,  1404,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   780,     0,     0,  1657,     0,
       0,  1658,     0,  1662,  1663,  1664,     0,  1665,  1666,  1667,
    1668,  1669,  1670,     0,  1659,     0,     0,  1660,     0,     0,
       0,     0,   780,   780,     0,  1808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1795,   780,     0,  1795,     0,
       0,  4028,     0,  2897,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   780,     0,     0,     0,   780,     0,     0,     0,     0,
       0,  1583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1661,     0,   780,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   780,     0,     0,     0,     0,     0,     0,
    1607,     0,     0,     0,     0,     0,   780,     0,     0,   523,
       0,     0,     0,     0,     0,   780,     0,     0,     0,     0,
       0,   524,     0,     0,     0,     0,     0,     0,  1632,  1633,
    1403,  1635,     0,     0,     0,  1403,  1403,     0,     0,     0,
       0,     0,   525,     0,     0,     0,     0,  1403,  1675,     0,
       0,     0,     0,     0,     0,   526,     0,     0,     0,     0,
       0,     0,     0,     0,   527,     0,     0,     0,  -720,     0,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,  1795,     0,     0,     0,   528,     0,  1711,     0,     0,
       0,   529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,   531,   569,     0,
    1827,  1830,     0,     0,     0,   532,     0,     0,     0,     0,
     570,     0,  3052,     0,     0,     0,   533,     0,     0,     0,
       0,     0,   780,   534,     0,     0,     0,   535,     0,     0,
       0,   571,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -915,     0,   572,     0,     0,     0,     0,     0,
    3081,  3082,     0,     0,     0,     0,   780,   573,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1808,  1403,     0,
       0,     0,     0,     0,   574,     0,  1672,     0,     0,     0,
       0,   536,     0,     0,     0,     0,     0,     0,  -485,     0,
       0,   780,  3104,     0,     0,   575,     0,     0,     0,     0,
       0,  3108,     0,     0,     0,     0,   576,     0,     0,     0,
       0,     0,     0,     0,   577,   780,  3119,  3121,     0,   537,
       0,  3121,   538,     0,     0,   578,  3132,  3133,  3134,     0,
     579,     0,     0,  1672,     0,     0,   580,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1403,     0,     0,
       0,   581,     0,     0,     0,     0,  -381,     0,     0,     0,
       0,     0,  3155,  3156,  3157,  3158,     0,     0,     0,     0,
       0,     0,     0,     0,   539,     0,     0,     0,     0,     0,
     540,     0,     0,     0,     0,     0,  -381,     0,     0,   541,
       0,     0,  3174,  3175,  3176,     0,     0,   582,     0,  1795,
       0,     0,  3189,     0,     0,  1795,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -381,     0,   542,   543,     0,
     544,   545,     0,     0,     0,     0,     0,     0,   583,   546,
       0,  1403,     0,     0,   547,     0,     0,     0,   584,     0,
     548,     0,     0,   549,     0,     0,   550,     0,     0,     0,
       0,   177,     0,     0,     0,     0,   192,     0,     0,  -381,
       0,     0,     0,     0,     0,     0,  3228,     0,     0,     0,
       0,     0,     0,     0,  3232,     0,     0,     0,     0,     0,
       0,     0,     0,   585,     0,   780,     0,   586,     0,   587,
       0,     0,     0,     0,     0,   588,     0,   178,   589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     179,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   590,     0,   591,   180,     0,     0,
     592,  3304,     0,   181,     0,   780,     0,     0,   593,     0,
       0,     0,     0,   594,     0,     0,     0,     0,   182,     0,
     780,   780,     0,     0,     0,   595,     0,     0,     0,   183,
       0,     0,     0,     0,     0,     0,     0,   184,   596,     0,
       0,     0,     0,  3332,     0,     0,  3335,   780,   185,     0,
     780,     0,     0,   186,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,     0,     0,     0,  3373,     0,
       0,  2307,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3383,     0,     0,     0,     0,     0,     0,   189,
       0,     0,  1808,     0,  2330,     0,     0,  2332,     0,     0,
    2343,     0,     0,     0,     0,     0,     0,  2350,  2355,     0,
     190,     0,     0,  2361,     0,     0,  2366,  1795,  1795,  1795,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,  2375,     0,     0,   780,     0,  2382,     0,
       0,   191,  2394,  1672,     0,     0,  2401,   780,  2403,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,  2411,   780,  2412,     0,
       0,     0,     0,  1098,     0,  2437,     0,     0,     0,   192,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,     0,     0,     0,
     194,     0,   195,     0,     0,     0,     0,     0,   196,     0,
       0,   197,     0,  1403,  1403,     0,  1403,     0,     0,   780,
       0,  1672,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   198,     0,   199,
       0,     0,     0,   200,     0,  1672,     0,     0,     0,     0,
    2339,   201,     0,     0,     0,     0,   202,     0,     0,     0,
       0,  1795,     0,  1397,     0,     0,     0,     0,   203,     0,
    1672,  1672,  1403,  1672,  1403,     0,   780,     0,   780,     0,
       0,   204,     0,     0,     0,     0,     0,     0,     0,     0,
     780,  1155,   780,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1249,     0,     0,     0,     0,     0,
    1250,     0,     0,  1672,  3577,     0,  3578,     0,  1398,     0,
       0,     0,     0,  3580,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,  1288,     0,     0,     0,  3589,
       0,   780,     0,     0,     0,     0,     0,     0,     0,  1672,
    1251,     0,     0,  1403,     0,     0,  3597,     0,     0,     0,
       0,     0,     0,     0,     0,  3608,     0,     0,     0,   780,
       0,     0,  1403,  2531,     0,     0,     0,     0,     0,     0,
       0,  1289,     0,   780,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,  1252,
     780,     0,     0,   780,     0,     0,  1253,     0,     0,  1254,
       0,  3640,  3641,  3642,  3643,  3644,  3645,  3646,  3647,     0,
       0,     0,     0,  3654,  3655,     0,  3657,  3658,  3659,  3660,
    3661,  3662,  3663,     0,     0,     0,     0,     0,     0,     0,
       0,  3671,     0,  3673,  3674,     0,     0,     0,     0,     0,
    1398,     0,     0,  1672,  1403,     0,     0,     0,  1397,  1290,
       0,     0,  1255,     0,     0,  1672,     0,     0,  1672,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,  1795,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3717,  3719,  3721,
       0,     0,  3724,     0,     0,     0,     0,  1291,     0,  1292,
       0,     0,  1397,     0,     0,     0,     0,     0,     0,  1293,
       0,  1257,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,  1258,     0,     0,     0,     0,     0,     0,     0,  1259,
       0,     0,     0,     0,  1397,     0,     0,  1294,  1260,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2663,     0,  3121,  2747,  1262,  1296,     0,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,     0,     0,     0,
    1808,  1808,  1808,     0,     0,     0,     0,     0,     0,     0,
    2664,     0,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,  1298,     0,     0,   780,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,  1397,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,     0,     0,     0,     0,
       0,  1400,     0,  1795,     0,     0,     0,  1795,  1264,  1795,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,  2872,   780,     0,
       0,   780,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,  1397,     0,     0,
       0,     0,     0,     0,     0,  1795,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2918,     0,     0,     0,     0,  2924,  1403,     0,     0,     0,
       0,     0,     0,  1398,  3909,  3910,  3911,  3912,     0,     0,
       0,     0,   780,   780,     0,     0,     0,     0,     0,   780,
       0,     0,  1398,     0,  1401,     0,     0,     0,  3924,  3925,
    3926,  3927,     0,  3929,  3930,     0,     0,  2355,     0,  2355,
    2355,     0,  1398,     0,     0,  3939,  3940,     0,     0,     0,
    2981,     0,     0,  2984,     0,  2986,  1400,     0,     0,     0,
       0,     0,  1808,  1808,     0,  1808,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3007,     0,  3009,     0,     0,     0,  3012,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1400,     0,     0,     0,  1397,     0,     0,  2437,  2437,  2437,
       0,     0,     0,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3050,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,  1403,  1672,  1815,     0,     0,     0,
       0,  3061,     0,     0,  3994,     0,  1401,  1830,     0,     0,
       0,     0,     0,  4000,     0,     0,     0,     0,  1672,     0,
    1672,     0,  2339,  2339,  2955,     0,     0,  2339,     0,     0,
    1403,  1672,     0,  4019,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,  1672,     0,     0,     0,     0,     0,  1672,
       0,     0,  3090,     0,  1672,  4036,     0,     0,     0,     0,
       0,     0,     0,  1672,  1400,     0,     0,  2339,  2339,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,  1400,     0,     0,     0,     0,     0,  1672,
       0,  1672,  1672,  1672,  1672,  1672,  1672,  1672,  1672,  1672,
    1672,     0,     0,  1400,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1808,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,  1400,  1808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1403,
       0,     0,     0,     0,     0,     0,     0,     0,  1795,     0,
    1403,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     780,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1401,     0,     0,     0,  4121,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,  1403,     0,     0,
    1397,     0,     0,     0,     0,  1397,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1397,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,  3121,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,  1402,
       0,     0,     0,     0,     0,     0,     0,  1403,     0,   780,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1401,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4237,     0,     0,     0,     0,  4241,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,     0,     0,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1397,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,   780,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,  1398,  1398,     0,  3412,     0,     0,     0,     0,
       0,     0,  3121,     0,  1398,  3416,     0,     0,     0,     0,
       0,  3417,     0,  3418,     0,     0,     0,  1808,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,     0,  3436,  3437,  1397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1795,     0,   780,     0,     0,     0,  2361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3465,     0,     0,  3468,
       0,  3470,     0,     0,  1402,     0,     0,  4343,     0,     0,
    3474,     0,  4347,     0,     0,     0,  3479,     0,     0,  3482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3515,     0,     0,     0,     0,     0,     0,     0,  3527,     0,
    2437,  1397,     0,     0,     0,     0,     0,     0,  1402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,  3541,     0,     0,  1398,  1672,     0,  1098,     0,
       0,     0,  1672,     0,  1155,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,  2955,  2955,
       0,  2339,     0,     0,  2339,  2339,  2339,  2339,  2339,  2339,
    2339,  2339,  2339,  2339,  2955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,  1400,     0,
    1795,     0,     0,  1400,  1400,     0,     0,     0,     0,  1672,
       0,     0,  1672,     0,  1672,  1400,     0,     0,     0,  2955,
    2955,     0,     0,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,  1402,  2339,  2339,  1672,     0,  1672,     0,     0,
    1672,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,     0,     0,     0,  1403,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,  1403,  1403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,  1402,     0,     0,  1400,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3777,
    3778,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,  1397,  1397,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1795,  3807,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,  1401,  1401,
       0,     0,  1397,     0,  1397,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,  2339,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,  1795,  3825,  3827,     0,     0,     0,     0,
       0,  1795,     0,     0,     0,     0,     0,  3834,     0,     0,
       0,     0,     0,  3839,  3840,     0,     0,  3842,  1397,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,  1398,  2437,
       0,     0,     0,     0,  2437,     0,     0,     0,     0,     0,
       0,     0,  1397,     0,     0,     0,  2437,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,  1398,     0,  1398,     0,     0,     0,  3890,     0,     0,
    1672,     0,     0,     0,  1672,  1672,  1672,     0,     0,  2955,
       0,  1401,     0,     0,  2955,  2955,  2955,  2955,  2955,  2955,
    2955,  2955,  2955,  2955,  1672,  1672,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,     0,  1398,
       0,  1398,     0,  1672,  2339,  2339,  1672,     0,  1672,     0,
    1397,     0,  1672,  2955,  2955,     0,     0,  1672,     0,     0,
    1672,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1672,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
    1398,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,     0,  3980,  1400,
    1397,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,  1402,     0,     0,     0,
       0,  1402,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,  1400,  1402,  1400,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
    1400,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4079,     0,     0,     0,     0,     0,
       0,     0,     0,  2955,     0,     0,  1400,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,     0,     0,  1402,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1400,     0,     0,     0,     0,  1672,  1672,     0,     0,     0,
       0,     0,  1398,     0,     0,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,     0,  2339,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,  1672,     0,  1672,     0,     0,     0,     0,
    2955,  2955,  1672,  1402,     0,  2339,  2339,  1672,  1672,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,  2361,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,  1401,     0,  1401,
       0,     0,     0,  4212,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,  1401,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
    1397,     0,     0,  1398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1400,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4283,  1401,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2955,  2339,     0,     0,  1401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2955,  2955,
    1672,     0,     0,     0,     0,  1401,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1672,     0,     0,
       0,     0,     0,  1401,     0,  4324,     0,     0,     0,  1397,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4369,  4369,
       0,     0,     0,  1401,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1400,     0,     0,  1402,     0,     0,
    2955,     0,     0,     0,     0,     0,     0,  1397,     0,     0,
    1672,     0,  4369,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4417,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,     0,     0,     0,  1402,
    1402,     0,  1402,  1401,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1398,     0,     0,     0,
       0,  1672,     0,     0,  4369,     0,     0,  1398,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,  1397,  1402,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1402,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1672,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1400,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1398,     0,     0,     0,  1402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,  1402,     0,     0,     0,
       0,     0,  1398,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,  1398,     0,     0,  1400,     0,  1401,
       0,     0,     0,     0,     0,     0,  1402,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,     0,     0,  1400,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,  1397,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,  1397,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,  1397,     0,     0,     0,  1397,  1397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1401,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,  1400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1401,  1398,
       0,     0,     0,  1398,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1402,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,     0,
    1400,     0,     0,     0,  1400,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,     0,     0,  1401,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,  2431,   217,   218,   219,     0,  1402,     0,
       0,  1021,  1402,  1402,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,  2432,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,  2433,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,  2434,     0,     0,     0,     0,
       0,     0,  1085,  2435,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,   207,     0,     0,     0,     0,
       0,     0,  1085,  2341,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,  3495,     0,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,     0,
       0,   246,   247,   248,   249,     0,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0, -1466,   258,   259,     0,
       0,     0,     0,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,     0,     0, -1466,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,     0,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324, -1466,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,     0,     0,   334, -1466,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343, -1466,
     344,     0,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361, -1466,   362,   363,   364,   365,     0,   366,   367,
       0,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,     0,
       0,     0,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420, -1466,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
       0,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,     0,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1162,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,     0,  1372,   733,  1373,  1374,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,  1375,  1376,
     240,     0,   241,   242,   243,   244,     0,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,  1377,  1378,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,     0,   294,   295,   296,
       0,     0,   298,     0,   299,  1379,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,     0,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,  1939,   318,   319,   320,   321,   322,   323,     0,
     324,   741,  1940,   326,   327,   328,   329,  1380,  1381,     0,
    1382,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,     0,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1383,   747,  1384,   363,   364,     0,     0,   366,   367,   748,
     368,     0,     0,   370,  1385,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,  1941,   749,   750,
     751,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   390,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1386,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,     0,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,  1942,   439,   440,   753,
     441,  1388,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,     0,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1389,  1390,     0,     0,
     465,     0,   467,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,     0,  1391,  1943,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,     0,  1371,     0,     0,     0,     0,
       0,     0,     0,   507,   508,   509,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,  1944,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,     0,  1372,   733,  1373,  1374,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,  1375,
    1376,   240,     0,   241,   242,   243,   244,     0,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,  1377,  1378,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,     0,   294,   295,
     296,     0,     0,   298,     0,   299,  1379,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
       0,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,  1939,   318,   319,   320,   321,   322,   323,
       0,   324,   741,  1940,   326,   327,   328,   329,  1380,  1381,
       0,  1382,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,     0,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1383,   747,  1384,   363,   364,     0,     0,   366,   367,
     748,   368,     0,     0,   370,  1385,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,  1941,   749,
     750,   751,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   390,     0,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1386,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
       0,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,  1942,   439,   440,
     753,   441,  1388,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,  1389,  1390,     0,
       0,   465,     0,   467,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,     0,  1391,  1943,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,     0,   731,  1016,   564,  1017,
    1018,  1019,   615,  1020,   507,   508,   509,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,  1021,  2836,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,  1022,   733,  1023,  1024,
    2351,   231,   232,   233,   234,   235,  1025,  1026,   236,   237,
    1027,  1028,   240,     0,   241,   242,   243,   244,  1029,     0,
    1030,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,
     263,   264,   265,  1038,  1039,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,  1041,   294,
     295,   296,  1042,  1043,   298,     0,   299,  1044,   301,     0,
     302,     0,   303,   738,  2352,   739,   304,   305,   306,     0,
     307,  1045,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,  1046,
    1047,     0,  1048,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,  2353,   342,  1049,
     745,   344,   746,     0,   345,   346,   347,  1050,  1051,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1052,   747,  1053,   363,   364,   365,  1054,   366,
     367,   748,   368,  1055,  1056,   370,  1057,   372,   373,   374,
       0,   375,     0,     0,  1058,   377,   378,     0,     0,   379,
     749,   750,   751,  1059,   381,   382,   383,   384,   385,   386,
     387,     0,   388,  1060,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1061,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,  1062,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,  1063,   437,   438,   439,
     440,   753,   441,  1064,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,  1065,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1066,  1067,
       0,  2354,   465,  1068,   467,  1069,  1070,   469,   470,   471,
     472,   473,   474,   475,     0,  1071,   476,   477,   478,   479,
     480,  1072,     0,   481,   482,   483,   484,   485,   486,  1073,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,
       0,     0,     0,     0,     0,  1082,  1083,     0,     0,     0,
       0,     0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,
    1019,   615,  1020,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,  1021,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,  1022,   733,  1023,  1024,     0,
     231,   232,   233,   234,   235,  1025,  1026,   236,   237,  1027,
    1028,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,  1038,  1039,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,  1041,   294,   295,
     296,  1042,  1043,   298,     0,   299,  1044,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,  1046,  1047,
       0,  1048,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1052,   747,  1053,   363,   364,   365,  1054,   366,   367,
     748,   368,  1055,  1056,   370,  1057,   372,   373,   374,     0,
     375,     0,     0,  1058,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1061,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
    1062,   424,   425,   426,   427,   428,   429,   430,   431,    38,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,  1064,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,    42,
     457,   458,   459,   460,   461,   462,     0,  1066,  1067,     0,
       0,   465,  1068,   467,  1069,  1070,   469,   470,   471,   472,
     473,   474,   475,     0,  1071,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   955,  1073,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,    47,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1082,  1083,     0,     0,     0,     0,
       0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,     0,     0,     0,     0,     0,
    1578,  2299,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,
    1020,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
    1021,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,  1022,   733,  1023,  1024,     0,   231,   232,
     233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
    1038,  1039,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,  1040,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,  1041,   294,   295,   296,  1042,
    1043,   298,     0,   299,  1044,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,  1046,  1047,     0,  1048,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1052,
     747,  1053,   363,   364,   365,  1054,   366,   367,   748,   368,
    1055,  1056,   370,  1057,   372,   373,   374,     0,   375,     0,
       0,  1058,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,  1061,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,  1062,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
    1064,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,  1066,  1067,     0,     0,   465,
    1068,   467,  1069,  1070,   469,   470,   471,   472,   473,   474,
     475,     0,  1071,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,  1073,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,     0,  1082,  1083,  1084,     0,     0,     0,     0,     0,
       0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,   231,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,  1154,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,  1054,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
    1058,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,  1071,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
       0,  1082,  1083,     0,     0,     0,     0,     0,     0,     0,
    1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
    1825,   217,   218,   219,     0,     0,     0,     0,  1021,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
     227,  1022,   733,  1023,  1024,     0,   231,   232,   233,   234,
     235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,  1038,  1039,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,  1041,   294,   295,   296,  1042,  1043,   298,
       0,   299,  1044,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,  1046,  1047,     0,  1048,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,   746,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1052,   747,  1053,
     363,   364,   365,  1054,   366,   367,   748,   368,  1055,  1056,
     370,  1057,   372,   373,   374,     0,   375,     0,     0,  1058,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1061,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,  1062,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,   753,   441,  1064,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1066,  1067,     0,     0,   465,  1068,   467,
    1069,  1070,   469,   470,   471,   472,   473,   474,   475,     0,
    1071,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,  1073,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,     0,
    1082,  1083,     0,     0,     0,     0,     0,     0,     0,  1085,
     731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,  1021,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
    1022,   733,  1023,  1024,     0,   231,   232,   233,   234,   235,
    1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,   242,
     243,   244,  1029,     0,  1030,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   260,   261,   262,   263,   264,   265,  1038,  1039,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,  1041,   294,   295,   296,  1042,  1043,   298,     0,
     299,  1044,   301,     0,   302,     0,   303,   738,  2352,   739,
     304,   305,   306,     0,   307,  1045,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,  1046,  1047,     0,  1048,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,  1049,   745,   344,   746,     0,   345,   346,
     347,  1050,  1051,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1052,   747,  1053,   363,
     364,   365,  1054,   366,   367,   748,   368,  1055,  1056,   370,
    1057,   372,   373,   374,     0,   375,     0,     0,  1058,   377,
     378,     0,     0,   379,   749,   750,   751,  1059,   381,   382,
     383,   384,   385,   386,   387,     0,   388,  1060,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1061,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,  1062,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
    1063,   437,   438,   439,   440,   753,   441,  1064,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
    1065,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,
    1070,   469,   470,   471,   472,   473,   474,   475,     0,  1071,
     476,   477,   478,   479,   480,  1072,     0,   481,   482,   483,
     484,   485,   486,  1073,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,
     508,   509,     0,     0,     0,     0,     0,     0,     0,  1082,
    1083,     0,     0,     0,     0,     0,     0,     0,  1085,   731,
    1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,  1021,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,   227,  1022,
     733,  1023,  1024,     0,   231,   232,   233,   234,   235,  1025,
    1026,   236,   237,  1027,  1028,   240,     0,   241,   242,   243,
     244,  1029,     0,  1030,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
     260,   261,   262,   263,   264,   265,  1038,  1039,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,  1040,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,  1041,   294,   295,   296,  1042,  1043,   298,     0,   299,
    1044,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,  1045,     0,   309,     0,   310,   311,
     312,   313,   314,   740,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,  1046,  1047,     0,  1048,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,  1049,   745,   344,   746,     0,   345,   346,   347,
    1050,  1051,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1052,   747,  1053,   363,   364,
     365,  1054,   366,   367,   748,   368,  1055,  1056,   370,  1057,
     372,   373,   374,     0,   375,     0,     0,  1058,   377,   378,
       0,     0,   379,   749,   750,   751,  1059,   381,   382,   383,
     384,   385,   386,   387,     0,   388,  1060,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,  1061,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,  1062,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,  1063,
     437,   438,   439,   440,   753,   441,  1064,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,  1065,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,
     469,   470,   471,   472,   473,   474,   475,     0,  1071,   476,
     477,   478,   479,   480,  1072,     0,   481,   482,   483,   484,
     485,   486,  1073,  3530,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,
     509,     0,     0,     0,     0,     0,     0,     0,  1082,  1083,
       0,     0,     0,     0,     0,     0,     0,  1085,   731,  1016,
     564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,  1021,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,  1022,   733,
    1023,  1024,     0,   231,   232,   233,   234,   235,  1025,  1026,
     236,   237,  1027,  1028,   240,     0,   241,   242,   243,   244,
    1029,     0,  1030,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,
     261,   262,   263,   264,   265,  1038,  1039,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
    1041,   294,   295,   296,  1042,  1043,   298,     0,   299,  1044,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,  1045,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,  1046,  1047,     0,  1048,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,  1049,   745,   344,   746,     0,   345,   346,   347,  1050,
    1051,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1052,   747,  1053,   363,   364,   365,
    1054,   366,   367,   748,   368,  1055,  1056,   370,  1057,   372,
     373,   374,     0,   375,     0,     0,  1058,   377,   378,     0,
       0,   379,   749,   750,   751,  1059,   381,   382,   383,   384,
     385,   386,   387,     0,   388,  1060,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1061,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,  1062,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,  1063,   437,
     438,   439,   440,   753,   441,  1064,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,  1065,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,   469,
     470,   471,   472,   473,   474,   475,     0,  1071,   476,   477,
     478,   479,   480,  1072,     0,   481,   482,   483,   484,   485,
     486,  1073,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,
       0,     0,     0,     0,     0,     0,     0,  1082,  1083,     0,
       0,     0,     0,     0,     0,     0,  1085,   731,  1016,   564,
    1017,  1018,  1019,   615,  1020,     0,     0,     0,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,  1021,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,  1022,   733,  1023,
    1024,     0,   231,   232,   233,   234,   235,  1025,  1026,   236,
     237,  1027,  1028,   240,     0,   241,   242,   243,   244,  1029,
       0,  1030,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
    3540,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,
     262,   263,   264,   265,  1038,  1039,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,  1040,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,  1041,
     294,   295,   296,  1042,  1043,   298,     0,   299,  1044,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,  1045,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
    1046,  1047,     0,  1048,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
    1049,   745,   344,   746,     0,   345,   346,   347,  1050,  1051,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,  1052,   747,  1053,   363,   364,   365,  1054,
     366,   367,   748,   368,  1055,  1056,   370,  1057,   372,   373,
     374,     0,   375,     0,     0,  1058,   377,   378,     0,     0,
     379,   749,   750,   751,  1059,   381,   382,   383,   384,   385,
     386,   387,     0,   388,  1060,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,  1061,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,  1062,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,  1063,   437,   438,
     439,   440,   753,   441,  1064,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,  1065,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,  1066,
    1067,     0,     0,   465,  1068,   467,  1069,  1070,   469,   470,
     471,   472,   473,   474,   475,     0,  1071,   476,   477,   478,
     479,   480,  1072,     0,   481,   482,   483,   484,   485,   486,
    1073,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,   498,  1074,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,
       0,     0,     0,     0,     0,     0,  1082,  1083,     0,     0,
       0,     0,     0,     0,     0,  1085,   731,  1016,   564,  1017,
    1018,  1019,   615,  1020,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,  1021,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,  1022,   733,  1023,  1024,
       0,   231,   232,   233,   234,   235,  1025,  1026,   236,   237,
    1027,  1028,   240,     0,   241,   242,   243,   244,  1029,     0,
    1030,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,
     263,   264,   265,  1038,  1039,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,  1041,   294,
     295,   296,  1042,  1043,   298,     0,   299,  1044,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,  1045,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,  1046,
    1047,     0,  1048,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,  1049,
     745,   344,   746,     0,   345,   346,   347,  1050,  1051,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1052,   747,  1053,   363,   364,   365,  1054,   366,
     367,   748,   368,  1055,  1056,   370,  1057,   372,   373,   374,
       0,   375,     0,     0,  1058,   377,   378,     0,     0,   379,
     749,   750,   751,  1059,   381,   382,   383,   384,   385,   386,
     387,     0,   388,  1060,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1061,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,  1062,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,  1063,   437,   438,   439,
     440,   753,   441,  1064,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,  1065,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1066,  1067,
       0,     0,   465,  1068,   467,  1069,  1070,   469,   470,   471,
     472,   473,   474,   475,     0,  1071,   476,   477,   478,   479,
     480,  1072,     0,   481,   482,   483,   484,   485,   486,  1073,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,  3817,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,
       0,     0,     0,     0,     0,  1082,  1083,     0,     0,     0,
       0,     0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,
    1019,   615,  1020,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,  1021,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,  1022,   733,  1023,  1024,     0,
     231,   232,   233,   234,   235,  1025,  1026,   236,   237,  1027,
    1028,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,  1038,  1039,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,  1041,   294,   295,
     296,  1042,  1043,   298,     0,   299,  1044,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,  1046,  1047,
       0,  1048,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1052,   747,  1053,   363,  3826,   365,  1054,   366,   367,
     748,   368,  1055,  1056,   370,  1057,   372,   373,   374,     0,
     375,     0,     0,  1058,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1061,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
    1062,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,  1064,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,  1066,  1067,     0,
       0,   465,  1068,   467,  1069,  1070,   469,   470,   471,   472,
     473,   474,   475,     0,  1071,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   486,  1073,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1082,  1083,     0,     0,     0,     0,
       0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,  4366,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,  4367,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,  4368,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,     0,     0,     0,     0,     0,
       0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,
    1020,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
    1021,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,  1022,   733,  1023,  1024,     0,   231,   232,
     233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,  4367,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
    1038,  1039,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,  1040,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,  1041,   294,   295,   296,  1042,
    1043,   298,     0,   299,  1044,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,  1046,  1047,     0,  1048,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1052,
     747,  1053,   363,   364,   365,  1054,   366,   367,   748,   368,
    1055,  1056,   370,  1057,   372,   373,   374,     0,   375,     0,
       0,  1058,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,  1061,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,  1062,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
    1064,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,  1066,  1067,     0,     0,   465,
    1068,   467,  1069,  1070,   469,   470,   471,   472,  4368,   474,
     475,     0,  1071,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,  1073,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,     0,  1082,  1083,     0,     0,     0,     0,     0,     0,
       0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,   231,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,     0,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
    1058,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
       0,  2334,  2335,     0,     0,     0,     0,     0,     0,     0,
    1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,  1021,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
   -2225,  1022,   733,  1023,  1024,     0,   231,   232,   233,   234,
     235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,  4367,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,  1038,  1039,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,  1041,   294,   295,   296,  1042,  1043,   298,
       0,   299,  1044,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,  1046,  1047,     0,  1048,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,     0,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1052,   747,  1053,
     363,   364,   365,     0,   366,   367,   748,   368,  1055,  1056,
     370,  1057,   372,   373,   374,     0,   375,     0,     0,  1058,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1061,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,  1062,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,     0,   441,  1064,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1066,  1067,     0,     0,   465,  1068,   467,
    1069,  1070,   469,   470,   471,   472,  4368,   474,   475,     0,
    1071,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,  1073,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,     0,
    1082,  1083,     0,     0,   731,  1016,   564,  1017,  1018,  1085,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,     0,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,   731,  1016,   564,  1017,  1018,     0,   615,  1020,
       0,     0,  1085,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,  3449,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,     0,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
     731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,
    1085,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,  1021,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1022,   733,  1023,  1024,     0,   231,   232,   233,   234,   235,
    1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,   242,
     243,   244,  1029,     0,  1030,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   260,   261,   262,   263,   264,   265,  1038,  1039,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,     0,   288,     0,   289,   290,
     291,   292,  1041,   294,   295,   296,  1042,  1043,   298,     0,
     299,  1044,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,  1045,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,  1046,  1047,     0,  1048,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,  1049,   745,   344,     0,     0,   345,   346,
     347,  1050,  1051,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1052,   747,  1053,   363,
     364,   365,     0,   366,   367,   748,   368,  1055,  1056,   370,
    1057,   372,   373,   374,     0,   375,     0,     0,  1058,   377,
     378,     0,     0,   379,   749,   750,   751,  1059,   381,   382,
     383,   384,   385,   386,   387,     0,   388,  1060,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1061,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,  1062,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
    1063,   437,   438,   439,   440,     0,   441,  1064,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
    1065,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,
    1070,   469,   470,   471,   472,   473,   474,   475,     0,  1071,
     476,   477,   478,   479,   480,  1072,     0,   481,   482,   483,
     484,   485,   486,  1073,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,
     508,   509,     0,     0,     0,     0,     0,     0,     0,  1082,
    1083,     0,     0,     0,     0,     0,     0,     0,  1085,   731,
    1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,  1021,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,     0,  1022,
     733,  1023,  1024,     0,   231,   232,   233,   234,   235,  1025,
    1026,   236,   237,  1027,  1028,   240,     0,   241,   242,   243,
     244,  1029,     0,  1030,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
     260,   261,   262,   263,   264,   265,  1038,  1039,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,  1040,   281,   282,     0,   283,
     284,   285,     0,   286,     0,   288,     0,   289,   290,   291,
     292,  1041,   294,   295,   296,  1042,  1043,   298,     0,   299,
    1044,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,  1045,     0,   309,     0,   310,   311,
     312,   313,   314,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,  1046,  1047,     0,  1048,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,  1049,   745,   344,     0,     0,   345,   346,   347,
    1050,  1051,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1052,   747,  1053,   363,   364,
     365,     0,   366,   367,   748,   368,  1055,  1056,   370,  1057,
     372,   373,   374,     0,   375,     0,     0,  1058,   377,   378,
       0,     0,   379,   749,   750,   751,  1059,   381,   382,   383,
     384,   385,   386,   387,     0,   388,  1060,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,  1061,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,  1062,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,  1063,
     437,   438,   439,   440,     0,   441,  1064,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,  1065,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,  1072,     0,   481,   482,   483,   484,
     485,   486,  1073,     0,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   731,  2334,  2335,
       0,     0,     0,     0,     0,     0,     0,  1085,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,   228,   733,   229,
     230,     0,   231,   232,   233,   234,   235,     0,  1026,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,  1029,
       0,  1030,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,  1042,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,  1045,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,  3023,   340,   341,     0,   342,
    1049,   745,   344,   746,     0,   345,   346,   347,  1050,  1051,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   747,   362,   363,   364,   365,     0,
     366,   367,   748,   368,     0,  1056,   370,   371,   372,   373,
     374,     0,   375,     0,   696,   376,   377,   378,     0,     0,
     379,   749,   750,   751,  1059,   381,   382,   383,   384,   385,
     386,   387,     0,   388,  1060,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    38,   432,   433,   434,   435,   436,  1063,   437,   438,
     439,   440,   753,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,  1065,     0,   455,
     456,    42,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,  1068,   467,  1069,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,  1072,     0,   481,   482,   483,   484,   485,   955,
     487,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,    47,   493,   494,   495,   496,   497,   498,  1074,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3024,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,   228,   733,   229,   230,     0,
     231,   232,   233,   234,   235,     0,  1026,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,  1042,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,  3023,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   747,   362,   363,   364,   365,     0,   366,   367,
     748,   368,     0,  1056,   370,   371,   372,   373,   374,     0,
     375,     0,   696,   376,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,  1068,   467,  1069,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,   731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3024,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,   228,   733,   229,   230,     0,   231,   232,
     233,   234,   235,     0,  1026,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,  1042,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     747,   362,   363,   364,   365,     0,   366,   367,   748,   368,
       0,  1056,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
    1068,   467,  1069,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,   731,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
     227,   228,   733,   229,   230,     0,   231,   232,   233,   234,
     235,     0,  1026,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,  1042,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,   746,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   747,   362,
     363,   364,   365,     0,   366,   367,   748,   368,     0,  1056,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,   753,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,  1068,   467,
    1069,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,   775,
    1268,   564,     0,     0,     0,   615,     0,     0,     0,  3561,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,   227,   228,
     733,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   734,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,     0,     0,     0,   737,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,  1510,   298,     0,   299,
     300,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,   314,   740,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,   745,   344,   746,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   747,   362,   363,   364,
     365,     0,   366,   367,   748,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,  1511,     0,   376,   377,   378,
       0,     0,   379,   749,   750,   751,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,   753,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,  1512,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   775,   627,  1269,
    3961,     0,     0,     0,     0,     0,     0,  3962,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       3,     4,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,   228,   733,   229,
     230,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   734,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,     0,     0,     0,   737,     0,     0,     0,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,   297,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,   308,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
     343,   745,   344,   746,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   747,   362,   363,   364,   365,     0,
     366,   367,   748,   368,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
     379,   749,   750,   751,   380,   381,   382,   383,   384,   385,
     386,   387,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    38,   432,   433,   434,   435,   436,     0,   437,   438,
     439,   440,   753,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,    42,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,   466,   467,   468,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,   955,
     487,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,    47,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    48,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,   228,   733,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   747,   362,   363,   364,   365,     0,   366,   367,
     748,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,   749,
     750,   751,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
     753,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4114,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    38,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,    42,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   955,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,    47,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,   229,   230,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,     0,     0,   246,   247,   248,
     249,     0,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,     0,   258,   259,     0,     0,     0,     0,     0,
       0,     0,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,   297,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,     0,     0,
       0,   304,   305,   306,     0,   307,   308,     0,   309,     0,
     310,   311,   312,   313,   314,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
       0,     0,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,   343,     0,   344,     0,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,   365,     0,   366,   367,     0,   368,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,     0,     0,     0,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,   439,   440,     0,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,   466,   467,
     468,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,     0,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1138,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,     0,     0,   246,   247,   248,   249,     0,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
       0,   258,   259,     0,     0,     0,     0,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,     0,   298,     0,   299,
     300,   301,     0,   302,     0,   303,     0,     0,     0,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,   314,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,     0,     0,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,     0,   344,     0,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
     365,     0,   366,   367,     0,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,     0,   376,   377,   378,
       0,     0,   379,     0,     0,     0,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,     0,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,     0,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,     0,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2486,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,   229,
     230,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,     0,     0,   246,   247,   248,   249,     0,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,     0,   258,
     259,     0,     0,     0,     0,     0,     0,     0,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,   297,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,     0,     0,     0,   304,   305,   306,
       0,   307,   308,     0,   309,     0,   310,   311,   312,   313,
     314,     0,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,     0,     0,   334,     0,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
     343,     0,   344,     0,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,   365,     0,
     366,   367,     0,   368,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
     379,     0,     0,     0,   380,   381,   382,   383,   384,   385,
     386,   387,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
     439,   440,     0,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,   466,   467,   468,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,     0,   488,     0,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3524,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,     0,
       0,   246,   247,   248,   249,     0,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,     0,   258,   259,     0,
       0,     0,     0,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,     0,     0,     0,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,     0,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,     0,     0,   334,     0,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343,     0,
     344,     0,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,   365,     0,   366,   367,
       0,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,     0,
       0,     0,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
       0,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,     0,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,  1371,  1268,   564,     0,     0,   785,   615,
       0,     0,     0,  3863,   208,   209,   210,   211,   212,   213,
     214,   215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,   220,   221,  1721,   222,   223,   732,   224,
     225,   226,     0,  1372,   733,  1373,  1374,  1722,   231,   232,
     233,   234,   235,  1723,  1724,   236,   237,  1375,  1376,   240,
    1725,   241,   242,   243,   244,     0,  1726,   734,  1727,   246,
     247,   248,   249,   735,   250,   251,  1728,   252,   253,   254,
     255,   256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,
     737,  1733,  1734,  1735,   260,   261,   262,   263,   264,   265,
    1377,  1378,   268,  1736,   269,  1737,   270,   271,   272,   273,
     274,  1738,   275,   276,   277,  1739,  1740,   278,   279,  1040,
     281,   282,  1741,   283,   284,   285,  1742,   286,   287,   288,
    1743,   289,   290,   291,   292,     0,   294,   295,   296,     0,
    1744,   298,  1745,   299,  1379,   301,  1746,   302,  1747,   303,
     738,  1748,   739,   304,   305,   306,  1749,   307,     0,  1750,
     309,  1751,   310,   311,   312,   313,   314,   740,   315,   316,
     317,  1752,   318,   319,   320,   321,   322,   323,  1753,   324,
     741,     0,   326,   327,   328,   329,  1380,  1381,  1754,  1382,
    1755,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,  1756,   340,   341,  1757,   342,     0,   745,   344,   746,
    1758,   345,   346,   347,  1759,  1760,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1383,
     747,  1384,   363,   364,     0,  1761,   366,   367,   748,   368,
    1762,     0,   370,  1385,   372,   373,   374,  1763,   375,  1764,
    1765,  3248,   377,   378,  1766,  1767,     0,   749,   750,   751,
       0,   381,   382,   383,   384,   385,   386,   387,  1768,   388,
       0,   390,     0,   392,   393,   394,  1769,   395,   396,   397,
     398,   399,   400,   401,   402,  1386,   404,   405,   406,   407,
    1770,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,  1771,   419,   420,   752,   421,   422,     0,   424,
     425,   426,   427,   428,   429,   430,   431,  1772,   432,   433,
     434,   435,   436,  1773,   437,  1942,   439,   440,   753,   441,
    1388,   443,  1774,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,     0,  1775,   455,   456,  1776,   457,   458,
     459,   460,   461,   462,  1777,  1389,  1390,  1778,  1779,   465,
       0,   467,     0,  1780,   469,   470,   471,   472,   473,   474,
     475,  1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,
     481,   482,   483,   484,   485,     0,  1391,  1785,   488,   754,
     489,   490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,  3249,  3250,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   786,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   787,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   878,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   879,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   928,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   929,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   930,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,  1356,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,  1357,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,  2552,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,  2553,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,  4097,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,  1712,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   208,   209,   210,   211,   212,   213,   214,
     215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,   220,   221,  1721,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,  1722,   231,   232,   233,
     234,   235,  1723,  1724,   236,   237,   238,   239,   240,  1725,
     241,   242,   243,   244,   245,  1726,   734,  1727,   246,   247,
     248,   249,   735,   250,   251,  1728,   252,   253,   254,   255,
     256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,   737,
    1733,  1734,  1735,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1736,   269,  1737,   270,   271,   272,   273,   274,
    1738,   275,   276,   277,  1739,  1740,   278,   279,   280,   281,
     282,  1741,   283,   284,   285,  1742,   286,   287,   288,  1743,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1744,
     298,  1745,   299,   300,   301,  1746,   302,  1747,   303,   738,
    1748,   739,   304,   305,   306,  1749,   307,   308,  1750,   309,
    1751,   310,   311,   312,   313,   314,   740,   315,   316,   317,
    1752,   318,   319,   320,   321,   322,   323,  1753,   324,   741,
     325,   326,   327,   328,   329,   330,   331,  1754,   332,  1755,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
    1756,   340,   341,  1757,   342,   343,   745,   344,   746,  1758,
     345,   346,   347,  1759,  1760,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,  1761,   366,   367,   748,   368,  1762,
     369,   370,   371,   372,   373,   374,  1763,   375,  1764,  1765,
     376,   377,   378,  1766,  1767,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,  1768,   388,   389,
     390,   391,   392,   393,   394,  1769,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,  1770,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,  1771,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,  1772,   432,   433,   434,
     435,   436,  1773,   437,   438,   439,   440,   753,   441,   442,
     443,  1774,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1775,   455,   456,  1776,   457,   458,   459,
     460,   461,   462,  1777,   463,   464,  1778,  1779,   465,   466,
     467,   468,  1780,   469,   470,   471,   472,   473,   474,   475,
    1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,   481,
     482,   483,   484,   485,   486,   487,  1785,   488,   754,   489,
     490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,  1790,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,   701,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,  1371,     0,
       0,     0,     0,     0,     0,     0,     0,  4138,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,     0,  1372,   733,
    1373,  1374,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,  1375,  1376,   240,     0,   241,   242,   243,   244,
       0,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,  1377,  1378,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
       0,   294,   295,   296,     0,     0,   298,     0,   299,  1379,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,     0,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,     0,   326,   327,   328,
     329,  1380,  1381,     0,  1382,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,     0,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1383,   747,  1384,   363,   364,     0,
       0,   366,   367,   748,   368,     0,     0,   370,  1385,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,     0,   749,   750,   751,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   390,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1386,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,     0,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
    1387,   439,   440,   753,   441,  1388,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1389,  1390,     0,     0,   465,     0,   467,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
       0,  1391,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,     0,     0,
    2094,     0,     0,     0,     0,     0,     0,   507,   508,   509,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  1849,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1372,   733,  1373,  1374,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,  1375,  1376,   240,     0,   241,   242,
     243,   244,     0,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,  1377,  1378,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,     0,   294,   295,   296,     0,     0,   298,     0,
     299,  1379,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,     0,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,     0,   326,
     327,   328,   329,  1380,  1381,     0,  1382,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,     0,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1383,   747,  1384,   363,
     364,     0,     0,   366,   367,   748,   368,     0,     0,   370,
    1385,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,     0,   749,   750,   751,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   390,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1386,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,     0,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,  1387,   439,   440,   753,   441,  1388,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
       0,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1389,  1390,     0,     0,   465,     0,   467,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,     0,  1391,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
       0,     0,   775,  1268,   564,     0,     0,     0,   615,   507,
     508,   509,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1849,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1702,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1510,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,  1511,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,  1512,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,  1268,   564,     0,     0,     0,
     615,   627,  1269,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  1707,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,  1510,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
    1511,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,  1512,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,  1268,   564,     0,
       0,     0,   615,   627,  1269,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,  1510,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,  1511,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,  1512,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,   615,   627,  1269,     0,     0,   208,
     616,   210,   211,   212,   213,   214,   215,   617,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   618,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   619,   300,
     301,     0,   302,     0,   620,     0,   621,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,   622,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   623,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   624,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   625,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   626,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
    1712,  4425,   564,     0,     0,     0,   615,   627,   628,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  1713,
     217,   218,   219,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
     220,   221,  1721,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,  1722,   231,   232,   233,   234,   235,
    1723,  1724,   236,   237,   238,   239,   240,  1725,   241,   242,
     243,   244,   245,  1726,   734,  1727,   246,   247,   248,   249,
     735,   250,   251,  1728,   252,   253,   254,   255,   256,   257,
    1729,   736,   258,   259,  1730,  1731,  1732,   737,  1733,  1734,
    1735,   260,   261,   262,   263,   264,   265,   266,   267,   268,
    1736,   269,  1737,   270,   271,   272,   273,   274,  1738,   275,
     276,   277,  1739,  1740,   278,   279,   280,   281,   282,  1741,
     283,   284,   285,  1742,   286,   287,   288,  1743,   289,   290,
     291,   292,   293,   294,   295,   296,   297,  1744,   298,  1745,
     299,   300,   301,  1746,   302,  1747,   303,   738,  1748,   739,
     304,   305,   306,  1749,   307,   308,  1750,   309,  1751,   310,
     311,   312,   313,   314,   740,   315,   316,   317,  1752,   318,
     319,   320,   321,   322,   323,  1753,   324,   741,   325,   326,
     327,   328,   329,   330,   331,  1754,   332,  1755,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,  1756,   340,
     341,  1757,   342,   343,   745,   344,   746,  1758,   345,   346,
     347,  1759,  1760,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,  1761,   366,   367,   748,   368,  1762,   369,   370,
     371,   372,   373,   374,  1763,   375,  1764,  1765,   376,   377,
     378,  1766,  1767,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,  1768,   388,   389,   390,   391,
     392,   393,   394,  1769,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,  1770,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,  1771,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,  1772,   432,   433,   434,   435,   436,
    1773,   437,   438,   439,   440,   753,   441,   442,   443,  1774,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1775,   455,   456,  1776,   457,   458,   459,   460,   461,
     462,  1777,   463,   464,  1778,  1779,   465,   466,   467,   468,
    1780,   469,   470,   471,   472,   473,   474,   475,  1781,  1782,
     476,   477,   478,   479,   480,  1783,  1784,   481,   482,   483,
     484,   485,   486,   487,  1785,   488,   754,   489,   490,   491,
    1786,  1787,   492,  1788,  1789,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,  1712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,   220,   221,  1721,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,  1722,   231,   232,   233,
     234,   235,  1723,  1724,   236,   237,   238,   239,   240,  1725,
     241,   242,   243,   244,   245,  1726,   734,  1727,   246,   247,
     248,   249,   735,   250,   251,  1728,   252,   253,   254,   255,
     256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,   737,
    1733,  1734,  1735,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1736,   269,  1737,   270,   271,   272,   273,   274,
    1738,   275,   276,   277,  1739,  1740,   278,   279,   280,   281,
     282,  1741,   283,   284,   285,  1742,   286,   287,   288,  1743,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1744,
     298,  1745,   299,   300,   301,  1746,   302,  1747,   303,   738,
    1748,   739,   304,   305,   306,  1749,   307,   308,  1750,   309,
    1751,   310,   311,   312,   313,   314,   740,   315,   316,   317,
    1752,   318,   319,   320,   321,   322,   323,  1753,   324,   741,
     325,   326,   327,   328,   329,   330,   331,  1754,   332,  1755,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
    1756,   340,   341,  1757,   342,   343,   745,   344,   746,  1758,
     345,   346,   347,  1759,  1760,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,  1761,   366,   367,   748,   368,  1762,
     369,   370,   371,   372,   373,   374,  1763,   375,  1764,  1765,
     376,   377,   378,  1766,  1767,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,  1768,   388,   389,
     390,   391,   392,   393,   394,  1769,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,  1770,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,  1771,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,  1772,   432,   433,   434,
     435,   436,  1773,   437,   438,   439,   440,   753,   441,   442,
     443,  1774,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1775,   455,   456,  1776,   457,   458,   459,
     460,   461,   462,  1777,   463,   464,  1778,  1779,   465,   466,
     467,   468,  1780,   469,   470,   471,   472,   473,   474,   475,
    1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,   481,
     482,   483,   484,   485,   486,   487,  1785,   488,   754,   489,
     490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,  1712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,  2617,
     213,   214,   215,  1713,   217,   218,   219,  1714,  1715,  1716,
    1717,  1718,  1719,  1720,   220,   221,  1721,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,  1722,   231,
     232,   233,   234,   235,  1723,  1724,   236,   237,   238,   239,
     240,  1725,   241,   242,   243,   244,   245,  1726,   734,  1727,
     246,   247,   248,   249,   735,   250,   251,  1728,   252,   253,
     254,   255,   256,   257,  1729,   736,   258,   259,  1730,  1731,
    1732,   737,  1733,  1734,  1735,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  1736,   269,  1737,   270,   271,   272,
     273,   274,  1738,   275,   276,   277,  1739,  1740,   278,   279,
     280,  2618,   282,  1741,   283,   284,   285,  1742,   286,   287,
     288,  1743,   289,   290,   291,   292,   293,   294,   295,   296,
     297,  1744,   298,  1745,   299,   300,   301,  1746,   302,  1747,
     303,   738,  1748,   739,   304,   305,   306,  1749,   307,   308,
    1750,   309,  1751,   310,   311,   312,   313,   314,   740,   315,
     316,   317,  1752,   318,   319,   320,   321,   322,   323,  1753,
     324,   741,   325,   326,   327,   328,   329,   330,   331,  1754,
     332,  1755,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,  1756,   340,   341,  1757,   342,   343,   745,   344,
     746,  1758,   345,   346,   347,  1759,  1760,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,  1761,   366,   367,   748,
     368,  1762,   369,   370,   371,   372,   373,   374,  1763,   375,
    1764,  1765,   376,   377,   378,  1766,  1767,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,  1768,
     388,   389,   390,   391,   392,   393,   394,  1769,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,  1770,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,  1771,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,  1772,   432,
     433,   434,   435,   436,  1773,  2619,   438,   439,   440,   753,
     441,   442,   443,  1774,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  1775,   455,   456,  1776,   457,
     458,   459,   460,   461,   462,  1777,   463,   464,  1778,  1779,
     465,   466,   467,   468,  1780,   469,   470,   471,   472,   473,
     474,   475,  1781,  1782,   476,   477,   478,   479,   480,  1783,
    1784,   481,   482,   483,   484,   485,   486,   487,  1785,   488,
     754,   489,   490,   491,  1786,  1787,   492,  1788,  1789,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,   564,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,  1510,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,  1511,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,  1512,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
     564,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,  1687,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
    2051,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,  2052,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     3,     4,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   801,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,   564,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
     564,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,  1500,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,  2883,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   814,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   891,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     731,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   911,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   921,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   923,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   933,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   944,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   945,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,  1873,   241,   242,
     243,   244,   245,     0,     0,  1955,   246,   247,   248,   249,
       0,   250,   251,  1874,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,  1956,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,  1876,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,  1877,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,  1878,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,  1873,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,  1874,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
    1956,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,  1876,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,  2783,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,  1877,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,  1878,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     666,   214,   215,   634,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,   635,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,   667,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   636,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   637,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,   634,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,   635,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,  2514,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   636,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     637,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,  1873,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,  1874,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,  1956,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,  1876,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,  1877,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,  1878,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,   634,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
     635,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   636,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   637,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1537,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,  1538,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,  1539,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,  1540,   303,     0,
       0,     0,  1541,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,  1542,  1543,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,  1544,   428,   429,   430,   431,     0,  1545,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,  1546,   457,  1547,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,  1548,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,   635,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   636,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   637,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     3,
       4,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,  2601,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,  2602,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  2613,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,  2614,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   556,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   557,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,   660,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   661,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   662,   464,
       0,     0,   663,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,   690,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   691,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     692,   464,     0,     0,   693,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   696,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   808,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,   696,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   904,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,  1113,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,  1124,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     677,   237,   238,   239,  1125,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   680,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   681,   422,   423,   424,   425,   426,   682,   428,   429,
     430,   431,     0,   432,   433,   434,   435,  1117,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     684,   464,     0,     0,   685,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   686,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,  1223,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   696,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,  2420,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,  2421,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,  2422,   457,   458,  2423,
     460,  2424,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,  2425,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,   564,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,  3495,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,  3509,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
    3716,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  3718,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  3720,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,  4100,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   649,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     658,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   677,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   678,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   679,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   680,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   681,   422,   423,
     424,   425,   426,   682,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   683,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   684,   464,     0,     0,
     685,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   686,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   708,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   781,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   805,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   816,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   869,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   883,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   916,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   935,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   937,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   939,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   942,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   948,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   677,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   680,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   681,   422,   423,   424,   425,   426,   682,
     428,   429,   430,   431,     0,   432,   433,   434,   435,  1117,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   684,   464,     0,     0,   685,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   686,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  1272,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,  1417,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,  1447,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,  1476,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,  1478,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  1480,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,  1572,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,  1846,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,     0,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     677,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   680,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   681,   422,   423,   424,   425,   426,   682,   428,   429,
     430,   431,     0,   432,   433,   434,   435,  1117,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,  1864,   459,   460,   461,   462,     0,
     684,   464,     0,     0,   685,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   686,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   677,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   680,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   681,   422,   423,   424,   425,   426,  1931,
     428,   429,   430,   431,     0,   432,   433,   434,   435,  1932,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   684,   464,     0,     0,  1933,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   686,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  2191,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,  2525,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   677,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   680,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   681,
     422,   423,   424,   425,   426,   682,   428,   429,   430,   431,
       0,   432,   433,   434,   435,  1932,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   684,   464,
       0,     0,  1933,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   686,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,  1371,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,     0,  1372,   733,
    1373,  1374,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,  1375,  1376,   240,     0,   241,   242,   243,   244,
       0,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,  1377,  1378,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
       0,   294,   295,   296,     0,     0,   298,     0,   299,  1379,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,     0,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,  1939,   318,   319,   320,
     321,   322,   323,     0,   324,   741,  1940,   326,   327,   328,
     329,  1380,  1381,     0,  1382,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,     0,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1383,   747,  1384,   363,   364,     0,
       0,   366,   367,   748,   368,     0,     0,   370,  1385,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,  1941,   749,   750,   751,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   390,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1386,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,     0,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
    1942,   439,   440,   753,   441,  1388,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1389,  1390,     0,     0,   465,     0,   467,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
       0,  1391,  1943,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,     0,   207,
       0,     0,     0,     0,     0,     0,     0,   507,   508,   509,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,     0,     0,   246,   247,   248,   249,     0,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
       0,   258,   259,     0,     0,     0,     0,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,     0,   298,     0,   299,
     300,   301,     0,   302,     0,   303,     0,     0,     0,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,  2604,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,     0,     0,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,     0,   344,     0,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
     365,     0,   366,   367,     0,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,     0,   376,   377,   378,
       0,     0,   379,     0,     0,     0,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,     0,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,     0,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,     0,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,   229,   230,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,     0,     0,   246,   247,   248,
     249,     0,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,     0,   258,   259,     0,     0,     0,     0,     0,
       0,     0,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,   297,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,     0,     0,
       0,   304,   305,   306,     0,   307,   308,     0,   309,     0,
     310,   311,   312,   313,  2606,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
       0,     0,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,   343,     0,   344,     0,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,   365,     0,   366,   367,     0,   368,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,     0,     0,     0,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,   439,   440,     0,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,   466,   467,
     468,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,     0,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,  2704,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,  1371,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,     0,  1372,   733,  1373,  1374,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,  1375,
    1376,   240,     0,   241,   242,   243,   244,     0,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,  1377,  1378,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,     0,   294,   295,
     296,     0,     0,   298,     0,   299,  1379,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
       0,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,     0,   326,   327,   328,   329,  1380,  1381,
       0,  1382,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,     0,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1383,   747,  1384,   363,   364,     0,     0,   366,   367,
     748,   368,  1927,     0,   370,  1385,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,     0,   749,
     750,   751,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   390,     0,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1386,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
       0,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,  1942,   439,   440,
     753,   441,  1388,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   455,   456,  3358,
     457,   458,   459,   460,   461,   462,     0,  1389,  1390,     0,
       0,   465,     0,   467,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,     0,  1391,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,     0,  1371,     0,     0,     0,
       0,     0,     0,     0,   507,   508,   509,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,     0,  1372,   733,  1373,  1374,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
    1375,  1376,   240,     0,   241,   242,   243,   244,     0,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,  1377,  1378,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,     0,   294,
     295,   296,     0,     0,   298,     0,   299,  1379,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,     0,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,     0,   326,   327,   328,   329,  1380,
    1381,     0,  1382,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,     0,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1383,   747,  1384,   363,   364,  1994,     0,   366,
     367,   748,   368,     0,     0,   370,  1385,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,     0,
     749,   750,   751,     0,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   390,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1386,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,     0,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,  1387,   439,
     440,   753,   441,  1388,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,     0,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1389,  1390,
       0,     0,   465,     0,   467,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,     0,  1391,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,     0,  1371,     0,     0,
       0,     0,     0,     0,     0,   507,   508,   509,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,     0,  1372,   733,  1373,
    1374,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,  1375,  1376,   240,     0,   241,   242,   243,   244,     0,
       0,   734,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,     0,     0,     0,   737,     0,     0,     0,   260,   261,
     262,   263,   264,   265,  1377,  1378,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,  1040,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,     0,
     294,   295,   296,     0,     0,   298,     0,   299,  1379,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,     0,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,     0,   326,   327,   328,   329,
    1380,  1381,     0,  1382,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
       0,   745,   344,   746,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,  1383,   747,  1384,   363,   364,  3186,     0,
     366,   367,   748,   368,     0,     0,   370,  1385,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
       0,   749,   750,   751,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   390,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,  1386,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,     0,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,  1387,
     439,   440,   753,   441,  1388,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,     0,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,  1389,
    1390,     0,     0,   465,     0,   467,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,     0,
    1391,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,     0,   207,     0,
       0,     0,     0,     0,     0,     0,   507,   508,   509,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
       0,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,     0,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,     0,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
    1371,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1372,   733,  1373,  1374,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,  1375,  1376,   240,     0,   241,   242,
     243,   244,     0,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,  1377,  1378,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,     0,   294,   295,   296,     0,     0,   298,     0,
     299,  1379,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,     0,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,     0,   326,
     327,   328,   329,  1380,  1381,     0,  1382,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,     0,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1383,   747,  1384,   363,
     364,     0,     0,   366,   367,   748,   368,     0,     0,   370,
    1385,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,     0,   749,   750,   751,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   390,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1386,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,     0,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,  1387,   439,   440,   753,   441,  1388,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
       0,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1389,  1390,     0,     0,   465,     0,   467,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,     0,  1391,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
       0,  1371,     0,     0,     0,     0,     0,     0,     0,   507,
     508,   509,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
       0,  1372,   733,  1373,  1374,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,  1375,  1376,   240,     0,   241,
     242,   243,   244,     0,     0,   734,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,     0,     0,     0,   737,     0,
       0,     0,   260,   261,   262,   263,   264,   265,  1377,  1378,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,     0,   294,   295,   296,     0,     0,   298,
       0,   299,  1379,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,     0,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,     0,
     326,   327,   328,   329,  1380,  1381,     0,  1382,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,     0,   745,   344,   746,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1383,   747,  1384,
     363,   364,     0,     0,   366,   367,   748,   368,     0,     0,
     370,  1385,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,     0,   749,   750,   751,     0,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   390,
       0,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1386,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,     0,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,  1942,   439,   440,   753,   441,  1388,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,     0,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1389,  1390,     0,     0,   465,     0,   467,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,     0,  1391,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,     0,  1371,     0,     0,     0,     0,     0,     0,     0,
     507,   508,   509,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,     0,  1372,   733,  1373,  1374,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,  1375,  1376,   240,     0,
     241,   242,   243,   244,     0,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,  1377,
    1378,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,     0,   294,   295,   296,     0,     0,
     298,     0,   299,  1379,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,     0,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
       0,   326,   327,   328,   329,  1380,  1381,     0,  1382,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,     0,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1383,   747,
    1384,   363,   364,     0,     0,   366,   367,   748,   368,     0,
       0,   370,  1385,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,     0,   749,   750,   751,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     390,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1386,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,     0,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,     0,   439,   440,   753,   441,  1388,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,     0,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1389,  1390,     0,     0,   465,     0,
     467,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,     0,  1391,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,     0,  1371,     0,     0,     0,     0,     0,     0,
       0,   507,   508,   509,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,     0,     0,   733,     0,     0,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,     0,     0,   240,
       0,   241,   242,   243,   244,     0,     0,   734,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,     0,     0,     0,
     737,     0,     0,     0,   260,   261,   262,   263,   264,   265,
       0,     0,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,     0,   294,   295,   296,     0,
       0,   298,     0,   299,     0,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,     0,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,     0,   326,   327,   328,   329,     0,     0,     0,     0,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,     0,   745,   344,   746,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     747,     0,   363,   364,     0,     0,   366,   367,   748,   368,
       0,     0,   370,     0,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,     0,   749,   750,   751,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   390,     0,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,     0,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,     0,   439,   440,   753,   441,
       0,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,     0,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,     0,     0,     0,     0,   465,
       0,   467,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,     0,     0,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,   508,   509
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-4044))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-2225))

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,    48,   169,   922,
     177,    11,   725,   537,    24,   959,   191,    34,   678,   186,
      20,   926,    20,   565,   730,    43,  1209,     7,   802,  1142,
    1144,   931,    21,   995,    14,  1244,   756,    26,   635,   636,
     637,   815,   880,   824,   641,   807,   565,   981,    48,    21,
     951,  1643,   890,    12,    26,  1541,  1387,  1947,  1948,   583,
    1009,   603,  1993,  1160,    42,   861,  1249,   685,  1344,  1067,
    2134,  2275,  2567,  2844,  1038,  1039,  1262,  2435,  1192,  2126,
      20,  1253,  2617,  1196,  2619,  1443,   528,   806,    22,  1404,
     809,  1578,   866,  1057,    17,  1244,   870,  2042,   817,  1300,
      34,   875,  1165,  2744,  1805,     0,   188,  2833,   882,  3096,
    2762,  2253,  3089,  2781,   196,   783,   912,  3144,   892,  2087,
    2486,  2762,   204,  2433,  3030,  3057,   602,  1313,  1314,  2431,
    2432,   171,   574,   156,  3296,   171,  1308,  3348,  3024,   681,
    1498,  3359,  3338,     0,   187,     0,     0,     0,     0,  1249,
     193,     0,    39,     0,     0,     0,  2823,     0,  1236,     0,
     203,  1196,   681,     0,  1027,  1028,  1446,  3566,  3765,  3067,
     773,   171,  2961,  2368,     5,     0,    44,   722,  1454,    58,
    3029,   585,     0,    66,  1085,    11,   722,     0,     0,    31,
    1053,   595,  2766,  2767,  2768,  2769,  2770,  2771,  2129,     5,
       5,  4030,     5,    79,    25,  3896,     5,    22,    13,    37,
      13,   815,   105,  2429,    29,   146,    35,   187,    26,    27,
     198,   103,   127,   193,   157,     5,   938,    58,   160,     5,
      37,     5,     5,   203,    35,     5,    60,   949,     9,    13,
       5,   110,    66,    18,    22,   160,   105,   151,   122,   160,
      16,   171,    76,   171,   151,    42,    72,     5,     5,     5,
     152,   151,   859,  2479,     5,  3863,    76,  3865,    22,  2200,
    3976,  2202,  3259,   255,    60,    29,     5,    11,    20,   103,
       5,   105,   233,    76,   278,    58,   159,   308,   245,     5,
      28,   959,    96,    23,  1407,   324,     9,  2492,    40,    68,
     248,   233,    36,   103,    22,   153,    83,     4,    22,     0,
     103,   233,     9,   262,   306,   142,   107,   103,     9,   146,
     844,   253,   233,  4366,   288,  1175,   151,   106,  2002,   308,
     132,    22,    66,   151,   255,   194,     9,   357,   151,   151,
       5,   235,   150,     0,   152,   120,   171,     0,  1129,   299,
     398,   389,    38,   171,   178,     4,   523,    68,   171,   171,
       9,    33,   537,     0,   249,    76,  1086,   133,    40,   417,
     172,    18,     9,    59,   324,   324,   235,   295,   283,   156,
     167,   299,  2056,   210,   171,    22,   378,    22,   282,   168,
      11,  1111,  1390,   314,    29,  4438,   134,   115,   377,    68,
     191,   115,   569,   251,   433,   947,   324,    76,   583,  3571,
     431,   235,   579,  1377,  1378,   435,   240,   959,  4015,  1905,
     247,  1385,   209,    11,   300,   284,    83,   391,   947,   233,
      83,    11,    25,   306,   516,   235,  4142,   431,   103,   521,
    1353,  1538,   235,   185,    51,  1542,    68,  1544,    36,   235,
    1547,   383,   276,   435,   240,   185,  1612,    51,  1358,  1127,
     151,   383,   413,  1577,  1132,  1133,   290,  4023,   383,   198,
    1626,  1013,   383,   120,   431,   151,  4074,   298,    66,   397,
     171,     8,   258,   431,    11,   961,   151,   262,   381,   310,
     276,   269,   535,    68,  1013,    68,   539,    51,    68,   156,
     431,    28,   435,   156,   290,  1224,    30,   550,   518,  3083,
     379,   134,  1375,  1376,   151,   435,  3168,   332,  1674,   393,
     295,  1384,  1296,  1637,  1298,   344,   431,  3168,   932,   357,
    1368,   435,   338,   339,   171,  1648,   418,  4228,   435,   431,
     361,   328,   308,   344,  1306,   435,   429,   357,   372,   324,
     433,  1347,   431,   369,  1273,   565,   566,   388,  1226,   435,
     326,  1342,   603,   431,   725,   535,  1234,  1681,  3730,   539,
    4399,  3767,   350,  3560,   352,   657,   435,   384,   332,   103,
     550,   389,  1124,   987,   607,  3491,   372,  2518,   357,   431,
    1132,  1133,  3318,   997,   517,   565,   678,  1502,  1532,   398,
     431,   427,   602,   603,   602,  1124,  1010,   382,   388,   434,
     580,  1942,   192,  3499,   696,   585,   434,  3503,   417,  3781,
    1288,   434,   434,  1291,  1292,   595,   431,   616,   431,   618,
    3419,   620,   431,   603,  1539,   717,  1951,   626,  1183,   649,
    1243,  3490,   601,  1548,   616,   302,   618,  1183,   620,   302,
     630,   431,  3550,    11,   626,   627,   628,   431,   431,   430,
     670,   431,   829,   603,  3332,   192,   431,   677,   646,   844,
     680,   681,   682,   840,   714,  1576,  1280,  1578,   714,  1283,
    3347,  3039,   398,   431,   431,   431,  1354,  1588,   357,  4286,
     431,  1592,   357,   427,   301,  4094,  2586,   332,  2588,  1600,
    1601,   417,   784,  3277,   429,   298,   431,   301,   433,   422,
     423,   681,  1613,  1614,   714,   431,   716,   716,   716,   716,
     716,   716,   700,  1624,   251,   422,   423,  2007,    96,  3891,
     377,   422,   423,   900,  3044,   357,  3898,  2801,  1947,  4295,
     397,  1604,  1605,   434,   397,  1858,  1918,   301,   397,   422,
     423,   729,  1464,   418,  1278,   431,  2724,  4354,   431,  2727,
    2728,  1473,  1612,  2731,   704,  1477,    51,   108,   433,  2737,
     393,  1483,  1484,   422,   423,   432,  1626,   434,   152,   432,
       8,   434,   357,    11,   357,   422,   423,   357,   190,  1501,
     872,   151,   679,   130,   772,    96,   683,   434,  2729,  2730,
      96,    18,  4013,   424,   425,   426,   427,  3023,  3024,    96,
      96,   783,   894,   895,   896,     5,   133,  1989,    74,     5,
    2569,   716,     5,  1858,    96,     3,     4,     5,   435,   245,
     108,     9,   245,    97,   192,   151,   424,   425,   426,   427,
       5,   435,   422,   423,   424,   425,   426,   427,   105,     5,
     275,   188,  2444,  1450,  2744,  1955,   112,    32,  1936,   716,
     222,   716,   716,   716,   716,  1978,    34,   716,   763,   716,
     716,   716,  2762,   716,  3369,   716,  3071,  3093,   145,   716,
      96,   435,  4102,  4103,   262,  1545,  1546,   103,   151,   108,
     264,   418,   419,   420,   418,   422,   423,   424,   425,   426,
     427,    11,   153,   120,   986,   429,   184,   431,   432,   433,
     174,   435,    74,   295,  1634,   153,   998,   295,   255,     3,
     815,     5,     5,    22,    64,   103,     9,  1009,   283,   429,
     134,   103,   133,   433,   359,    98,   111,   947,   103,     5,
      18,    60,   324,   171,  3850,   350,    24,   352,   108,   959,
     112,    60,  2842,   315,   309,   329,    66,    76,  1482,   143,
     105,   961,   932,   961,   192,   184,  2167,  1509,  3854,    51,
    2179,    70,  4183,  3859,   399,  4193,  3862,   947,    77,   347,
     903,  4177,   992,   240,   964,   250,   966,   959,   968,   959,
     970,  3978,   972,   973,   974,     8,   312,   357,    52,   979,
     251,   164,   170,  1013,   271,   104,    60,   263,  2121,   326,
    3781,   189,   131,    98,    98,   431,   301,   987,   431,   235,
     103,  1021,   131,   251,   184,   321,   146,   997,  1470,   148,
    3756,  2780,  1508,   435,   371,   213,   377,   103,   103,   148,
    1010,  1041,   120,  1013,  1085,    18,   347,    18,   232,   194,
     240,    24,     8,    24,   240,    11,  1138,   240,   418,   222,
     347,   347,   225,  3598,   422,   423,   424,   425,   426,   427,
    1474,  1071,   310,   433,   390,   347,   175,  1087,   295,   164,
     164,  1485,   346,   347,   240,  1085,  1610,  1097,  1800,   340,
     235,  4287,  3759,  1497,   357,   351,  4316,  1107,   317,   377,
     120,   263,   103,  1278,  1186,   618,   619,   620,   248,     5,
     623,   624,   625,   317,  1124,  4092,    18,  1127,  1128,  4106,
     633,   337,  1132,  1133,   340,   326,   275,   365,  1168,  1169,
    1153,  1171,  1168,  1169,  4296,  1171,   401,   222,   222,   284,
     225,   225,  4353,   347,  2241,   317,  4357,   120,  2112,   120,
      74,   233,   315,  4180,  1124,  1127,   105,   276,   377,   213,
    1132,  1133,  1132,  1133,  3522,   154,  1248,   276,  1168,  1169,
     235,  1171,  1142,  1255,  3532,   347,    74,   297,  2334,  2335,
    1840,   385,  3548,  2339,    74,  4071,   331,  4398,   112,   351,
     418,   419,   420,   397,   422,   423,   424,   425,   426,   427,
    2038,   347,  1284,   154,   364,  1287,    44,  1185,  3518,   192,
     359,  3513,   249,   385,   112,   431,   108,   377,   120,   301,
    3530,   255,   112,  2379,  2380,   397,  1196,   431,   120,   178,
     315,   315,   359,   253,   142,  1954,   192,  1319,   251,   240,
     288,   340,   324,   255,   422,   423,  2359,   312,  4235,   412,
     399,  1333,  2365,   372,  1226,   106,    94,   164,  3400,   431,
     107,   146,  1234,   372,  1346,   153,   249,  3235,  2583,   196,
     318,  3923,   399,  3241,  3242,  2590,   357,     5,  3168,   299,
    2193,   166,  3923,  3499,   233,  1328,   235,  3503,  2007,   262,
     220,   262,  2197,   181,  1304,   251,  1463,  1269,  1221,   347,
    4232,  4233,   210,  2203,   324,  1472,   233,  1482,   115,  2028,
     117,  2149,  2150,  2151,  2152,   222,  1288,   168,  2092,  1291,
    1292,   155,   295,  2161,   295,   113,  3994,   412,   412,  1307,
     319,  4318,  4000,   140,   197,   123,   142,     8,  2057,   263,
      11,    78,  2010,   391,   191,   183,   431,   115,   261,   117,
    2018,   324,  2020,   324,   435,    95,  1366,    28,  1328,   348,
     262,   359,   115,  1445,   117,   263,   178,   179,   319,  1451,
     182,    49,   184,   263,  1541,   103,  2585,  3078,   367,   213,
     117,   273,  1354,  1907,  1427,  1280,  3331,   140,  1283,  2452,
     202,  2187,   429,   295,  2880,   233,   433,   348,   432,   326,
    1443,   435,  2303,   196,   210,   418,   419,   420,   315,   422,
     423,   424,   425,   426,   427,   418,  2513,    95,  3899,  1429,
     432,  1863,   324,   435,   106,  1507,   379,   351,   235,  2916,
     433,  4418,  1475,   240,   146,  1610,  2585,  1407,   245,   262,
     233,   247,  4168,  4375,   156,  3376,   431,  3378,     3,   962,
     377,  2352,   965,   351,   967,  1498,   969,  1427,   971,   171,
       3,   351,   975,  1545,  1546,  2666,   422,   423,   424,   425,
     426,   427,   295,  1443,   262,   313,    19,   245,   431,   297,
    2192,   221,  2383,   223,  2334,  2335,   168,   240,   397,  2339,
     295,   284,   245,     0,   295,   173,  2208,  2209,   299,   434,
    2212,   324,  3983,  2675,  1474,  1475,  2218,   295,  1508,     4,
    1508,  2869,  3870,  3871,     9,  1485,   350,  2418,   352,   324,
      75,   192,   350,   324,   352,  4296,   435,  1497,  1498,  2379,
    2380,     8,    75,   326,    11,   115,  4031,   117,  1518,  1509,
    1520,   375,  1522,   221,  1524,   223,  1526,   310,   155,  1953,
    1530,    28,  1569,   397,    83,   233,   363,  1999,    76,  1559,
    1559,  1559,  1559,  1559,  1559,  2277,   373,   349,  4294,  1509,
     125,   105,   308,   102,   262,  4110,  1554,  2245,  2175,   397,
     251,   130,   125,   261,   377,  2938,   312,  1597,   278,  2523,
     253,   435,   304,   142,  1676,  3799,   397,   146,   361,   262,
     336,     8,   160,  1685,    11,   134,   213,   295,   431,  2962,
     363,   299,   317,   220,  4095,   397,   398,   435,  1590,  1591,
     373,   176,   300,   349,  4105,   262,  1598,  2591,   171,    36,
    1602,  1603,   295,   176,  1568,    42,   324,   155,  3854,   188,
    2182,  2827,   347,  3859,  2830,  1617,  3862,  1619,  2761,   431,
    3581,  3582,  1575,  1653,  2554,   235,   174,   335,   295,    66,
     194,   210,   299,  2182,   288,   245,   310,  1425,  1640,   310,
    1642,   397,   398,   379,  2216,   233,  3892,   379,  1648,  4347,
     385,  3273,  3886,  3747,  3888,  1695,  1444,   324,   429,   398,
     431,  3738,   397,   312,   318,   213,   397,  2216,   247,   236,
     237,   235,   249,  4198,   262,   431,   255,   254,   417,  3677,
    3678,  3758,   267,   151,   526,   192,   152,   361,   530,  1801,
     361,  1803,   431,   347,   267,   431,   431,   390,  4086,   431,
     349,  1898,  1907,   171,   435,   547,   254,   295,  1905,   262,
      57,    58,   262,   350,   180,   352,  2542,   418,   419,   420,
     284,   422,   423,   424,   425,   426,   427,   361,  1840,   195,
     397,   142,   291,   306,   171,   146,   435,   391,   375,   146,
       8,   207,   295,    11,   251,   295,   244,  2445,   397,   398,
     317,  2878,    95,  3920,    75,   192,   193,  2943,   317,   166,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
     391,   105,   345,    11,   324,    84,  3121,  4023,  2570,   314,
     347,  1854,   431,  3950,  2526,   370,  1859,   357,   347,  1862,
    2976,  3097,   371,   378,  2442,   383,   381,   370,    36,   210,
    1819,   238,   350,   124,   352,   378,  2598,   262,   381,   155,
     361,  1884,   146,   361,   251,  1845,  1845,  1819,   385,  3005,
    3006,  1868,  2571,  1870,   372,  4071,   385,   375,    66,   430,
     397,    20,  1802,   176,   435,  2978,   247,   198,   397,   305,
     295,  2985,  3464,   152,   178,    11,  2400,  2811,   426,   284,
     431,    40,  1925,   431,  1854,   433,  2820,   361,  1858,  1859,
    1972,   296,  1862,  2605,   431,  2607,   431,   213,   433,   324,
      36,   180,   431,  2445,   262,   398,  1988,   262,   221,  1952,
     223,   202,   203,   297,  1884,   320,   195,   430,  2637,   397,
     398,  1931,   435,   317,   417,   216,   314,   249,   207,   233,
      66,   235,   254,  1976,   237,   308,   309,   295,   431,  1917,
     295,   418,   419,   420,   220,   422,   423,   424,   425,   426,
     427,   230,  2901,   347,   192,  1925,   220,  3129,  2001,    21,
    3146,  3147,  2005,    80,    26,  3079,   324,  2965,  2966,   324,
     432,   262,   288,   435,   786,   787,  3800,  3801,  3802,  3803,
    2023,   426,  1952,  1953,   192,  3953,   431,  2699,   433,   432,
    2033,   385,   435,  2705,     8,  2908,   174,    11,  2540,  3171,
     429,  2775,   431,  2046,   433,  1975,  1976,     8,  1978,   431,
      11,   433,  2055,   251,   317,   422,   423,   424,   425,   426,
     427,  2540,    36,  2753,  2754,  2755,   305,    28,    42,   432,
     863,  2001,   435,  3923,   350,  2005,   352,   431,  2010,     8,
     432,  3003,    11,   435,   347,   857,  2018,   432,  2020,  2131,
     435,   166,    66,  2023,  3167,   361,  3169,     5,   349,   375,
     351,    73,    10,  2033,  3995,   432,   878,   879,   435,  2079,
      18,  2972,   350,   391,   352,   391,  2046,  2087,   312,  4295,
      48,  2351,   385,  2353,  2354,  2055,   898,    35,   432,   432,
     314,   435,   435,  2943,   397,   198,  2946,  2947,  2948,  2949,
    2950,  2951,  2952,  2953,  2954,  2955,  2510,  2511,   431,  2905,
    1628,  4315,  2279,  1631,   128,   349,   928,   929,  2285,  3687,
     432,  3689,   350,   435,   352,  3693,  2976,  3695,   431,   432,
    3461,   434,  3245,  3289,     9,  4025,   432,  2109,  2148,   435,
    2852,   308,   309,  3352,  2856,  2857,    11,  2859,   431,  2861,
    2862,  2121,   249,   167,  3337,  3005,  3006,   171,  2870,   431,
    3094,  3095,   995,   397,   398,   432,  2176,   435,   435,  2169,
    2169,    36,  2182,  3137,   432,    48,  2135,   435,   192,   193,
     418,   419,   420,   312,   422,   423,   424,   425,   426,   427,
    2902,   192,   432,   432,   434,   209,   435,   431,   397,   398,
     432,    66,  2799,   435,   415,   416,  2216,    84,  2251,   432,
     432,   434,  2182,   435,   422,   423,   424,   425,   426,   427,
     349,    26,    27,   192,   238,  2400,   432,   432,   432,   435,
     435,   435,  2275,   391,  2776,   312,  2778,   251,    38,   432,
     432,  2909,   435,   435,   414,   432,  2216,   312,   435,   312,
     251,   432,   432,  2657,   435,   435,   194,  2776,   312,  2778,
     432,   432,  2429,   435,   435,  3046,   252,   432,   397,   398,
     435,   432,   349,  2245,   435,   152,    44,  2438,    83,   433,
     432,  2251,   251,   435,   349,  3877,   349,   252,  2463,  3386,
    3387,  3388,   719,   432,   721,   349,   435,   102,   432,  2841,
     249,   435,   431,   180,   432,  2275,   432,   435,   357,   435,
    3466,  3467,  2479,  3033,   328,    50,   432,    85,   195,   435,
     397,   398,  2841,  3036,  3037,   397,   398,   192,   193,   134,
     207,   146,   397,   398,   397,   398,   432,   249,   414,   435,
    2422,   109,  2383,   397,   398,   432,   432,    82,   435,   435,
    1000,  1001,   432,   230,   431,   435,   124,  1190,   432,   312,
     128,   435,   252,    38,   432,     0,   431,   435,   431,   194,
     414,   432,   249,   238,   435,   432,   424,   431,   435,   147,
     150,   432,   150,  2383,   435,   435,  2790,   432,  2792,  2359,
     435,   431,    48,   432,   162,  2365,   349,  2397,   432,   312,
    3514,   435,  3504,   138,  3506,  2423,  2424,  2425,   422,   423,
     424,   425,   426,   427,   432,   151,  2416,   418,   419,   420,
     431,   422,   423,   424,   425,   426,   427,   432,   305,  2429,
     435,  3545,   190,   433,   169,  2445,   349,   432,   324,  3289,
     435,  2482,   431,  1276,   397,   398,  1258,   135,    83,   400,
     419,   420,  2495,   422,   423,   424,   425,   426,   427,  2459,
    2459,  2459,  2459,  2459,  2459,   432,  3228,   431,   435,   171,
     205,  2443,   240,  2445,   432,  2445,   433,   435,   431,  2479,
     248,   135,  2482,   249,   397,   398,   291,   432,  3974,   432,
     435,   135,   435,   249,  2537,   130,  2900,   146,   432,   135,
     235,   435,   379,  1315,  1316,  1317,  1318,   142,   208,   105,
    3472,   146,   317,   379,   282,  1348,   151,   432,   431,   249,
     435,   156,   431,  3361,   159,  2495,   161,   361,   432,   432,
    2540,   435,   435,   432,  1367,   432,   435,   244,   435,   391,
    2510,  2511,   347,   432,  1356,  1357,   435,  3448,   198,   314,
    1362,  3648,  3649,   188,  3651,   281,    60,   422,   423,   424,
     425,   426,   427,   431,   299,   397,   301,  2537,   303,  2744,
    2540,  3780,    31,   432,   309,   210,   435,   235,   400,  1412,
     385,   316,   432,   432,   389,   435,   435,  2762,   431,   324,
     235,    31,   397,  2636,  1406,    38,   432,   432,   333,   435,
     435,    38,   432,   366,  2647,   435,   341,   262,   432,   146,
      50,   435,   247,  2623,   391,   391,  3466,  3467,    73,   279,
     255,  1433,  1434,  1435,  1436,   130,   431,   135,   135,   431,
     249,   400,   135,   135,   135,   135,  1469,   142,   435,   135,
     135,   146,    82,   135,   135,  2655,   135,  2617,  2618,  2619,
     249,   135,   135,   347,    31,  3811,   431,   392,   208,   147,
     146,  3373,   249,     5,  3820,   146,  2636,   302,     5,  3381,
    3382,   431,   431,   146,   431,  1487,  2719,  2647,   431,   431,
     272,  3837,  3838,   188,  1496,   431,   431,  2657,   431,     5,
       5,  1503,  2702,   431,   431,     5,     5,   431,   138,   431,
    2782,  2783,   431,   431,   431,   210,   431,   431,   431,   431,
     431,   431,   347,  2880,  2724,   431,  2798,  2727,  2728,   431,
     431,  2731,   431,  3391,   259,   431,   431,  2737,    31,   169,
    2812,   435,    86,   208,  2744,    31,   371,   146,   247,  2821,
    3684,   146,   247,   324,   357,   357,   245,   312,   433,  2719,
     255,   357,  2762,  2835,   357,   312,   357,   357,   198,   394,
     357,   396,   397,    76,   312,   205,  2776,    31,  2778,   135,
     249,   316,  2744,   205,   357,   357,   240,   357,    68,  2751,
    2752,   249,   176,   378,  2756,   245,    50,   357,   431,   357,
    2762,  2761,   431,    76,   429,   235,   262,   432,   433,   434,
     135,   435,   379,   379,  2814,    97,  2776,    48,  2778,    48,
     357,  3745,   253,  1646,   357,   357,   357,   357,    82,  2901,
    2790,  2793,  2792,   357,   357,   357,  2869,    37,  4011,    37,
    2840,  2841,  2832,  2832,   357,   312,   357,   435,   357,  1651,
    2883,   249,   400,   249,   192,   397,  3566,  3960,    31,   388,
      30,  2851,  2851,  3815,    20,   135,  3023,  3024,   431,   299,
    2903,   249,   431,   303,   431,  3577,   371,   235,   431,   309,
     103,  2841,   135,   379,   138,   390,   316,  2334,  2335,   235,
     216,   245,  2339,    31,   324,   146,    31,   431,   313,  4045,
     198,   135,   135,   333,   379,   135,  3608,  3609,   135,  2869,
     135,   341,   151,   379,   244,   169,   357,   239,  3312,  3313,
     397,   431,    11,  2883,   431,   393,   355,   414,   431,   435,
     227,   227,  2379,  2380,   429,   324,  3093,   432,   433,   355,
    2900,   151,   359,  2903,   198,   357,   165,  2909,  3020,  3021,
    3022,   205,   435,   165,   326,    18,   188,   357,   196,   431,
     250,    24,   392,   357,   312,   435,   396,   397,  3670,  3671,
     432,  3811,   431,   379,   435,   432,  3867,  4064,    75,   312,
    3820,   235,  3013,   431,   240,   196,   379,  4074,   196,  2989,
     240,   357,   357,  3024,   357,  4194,   431,  3837,  3838,   361,
     391,    64,   314,  3168,   198,   240,   249,  3015,  3016,  3017,
    3018,    38,   331,   166,   256,   357,   435,   357,  2978,   295,
     248,   312,  3536,  3013,   295,   284,  3684,   321,  3962,   357,
     192,    31,   192,  3023,  3024,   192,   357,   192,   379,  4126,
     379,   192,   248,  3043,   418,   299,  3970,    30,   429,   303,
     113,   431,   429,   357,   418,   309,   357,   120,   135,   146,
     123,   245,   316,   148,   321,   357,   135,   391,   357,    31,
     324,   431,   431,   249,   397,   249,   146,   163,    31,   333,
     163,   135,   249,  3785,   249,  3787,  3788,   341,   146,   171,
     171,  3124,   171,   400,  4046,   321,  3798,    19,  1900,  1901,
    1902,   435,   157,   224,   435,   249,   435,  1909,    48,  1911,
     347,  1913,  1914,   176,   361,   435,   244,   391,   198,   432,
     151,   432,   432,   432,   432,   266,  4213,   151,   258,   394,
     432,    13,    13,   414,   394,   357,  1959,   432,   392,   385,
     249,   377,   396,   431,  3731,   432,   414,   432,   302,   432,
     210,   435,  3684,   432,   432,   432,   418,   432,   252,  4050,
     432,   249,  4114,   432,  3124,   431,  4118,  4119,  3168,   174,
     233,   135,   235,   431,   357,  3208,   431,   357,  3211,   400,
     357,   182,   245,   240,   135,   357,  3882,   253,   135,   210,
     253,  3191,   267,  3957,  3194,   267,  3196,   376,   357,   262,
     218,   218,   218,  3163,  3276,  4045,  3168,  3167,   357,  3169,
     357,  3190,  4115,  4137,  2016,   357,   312,   357,     8,   312,
     357,    11,   312,  3295,   357,   357,  4116,  4122,  3190,  4124,
     357,   357,   295,   357,   312,  3235,   299,     8,   235,   135,
      11,  3241,  3242,   357,  3244,    37,    36,   357,  3208,   192,
    3322,  3211,    42,   324,   192,   192,   431,     3,   429,   315,
     225,   324,   210,   432,   432,    36,   418,   366,   432,   435,
    2072,    42,    38,    96,   297,   248,    66,  2100,  2080,  3279,
    3280,  3281,  3282,  2085,   432,  3245,  3319,  3249,  3250,    22,
      23,   249,   435,  4396,    27,    66,   432,   431,  3260,    32,
      33,    34,    31,    36,   357,   160,    39,    40,   312,    42,
     312,    44,   379,   312,   379,   435,   252,  3279,   133,   382,
     133,    96,   192,   429,  4258,   126,   151,    11,   146,   432,
     432,  4222,   432,    58,   432,   151,   431,  4039,   390,   159,
    4443,   432,  3499,   435,   250,    31,  3503,   431,  4451,  3349,
     146,   379,  3312,  3313,   379,   431,  3346,  3346,   432,  3319,
     182,  3394,   357,   366,  4014,   357,   357,   431,  2170,   357,
     432,  3536,   366,   432,   146,   357,   357,   167,   312,  3893,
     312,   171,  4085,   432,   432,   432,   432,    66,   135,    96,
     366,  4093,   432,   192,   192,   430,   167,  2199,   430,  2201,
     171,   431,   192,   193,   397,   196,   432,   280,  3408,   431,
     321,  3483,  3484,  3485,  3486,    21,   431,   177,  3932,   209,
     400,   192,   193,   435,   146,  4127,   432,   435,    71,  3391,
    3962,   349,   357,   321,  3394,   431,   156,   435,   209,   151,
    2263,   192,   432,   192,   177,   178,   179,   180,   238,   182,
     192,   184,   192,   186,   432,   188,   151,   431,   191,   289,
     432,   251,    68,   196,    48,   198,   395,   238,   395,   202,
     257,   204,   432,   432,   435,   431,   195,  4380,   195,   431,
     251,    48,   432,   161,    21,   418,   432,   245,   357,   151,
     435,    97,   397,    66,  2296,   176,  2943,   240,   366,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  3499,
     240,   418,   118,  3503,   435,   435,   357,    54,   135,   192,
     430,   153,   151,   129,   171,   379,   379,    31,   121,   393,
      67,   397,   431,  3533,   397,   151,   431,   179,   328,   252,
     151,   431,   148,    80,   431,   289,   384,   153,   334,   432,
     195,  3558,   432,  3543,  3543,   431,   431,   328,  3005,  3006,
     396,   265,   249,   290,   357,   432,   397,   432,   357,   146,
     432,   431,   431,  3552,   110,   240,  3733,    31,   219,   240,
     174,   118,   431,   280,   431,  3618,   432,   431,   134,    31,
    3552,   309,   129,   199,   253,   432,    48,  3630,   309,   431,
      48,   255,   431,   379,   349,   233,   432,     5,   141,   249,
     280,   148,   321,    60,   220,   252,   153,    60,   116,   383,
     289,   384,    31,   435,   151,  3604,   394,   287,   418,   419,
     420,   146,   422,   423,   424,   425,   426,   427,  3598,   121,
     397,   176,  3604,   431,   249,   249,    31,  4234,   419,   420,
      31,   422,   423,   424,   425,   426,   427,   252,  3618,  3621,
    3622,   252,   431,   108,  3626,  3627,   431,  3667,  3668,    48,
    3630,   432,  4374,   279,   308,   377,   432,  3677,  3678,   432,
       5,   431,   308,   220,  3684,    17,    28,   716,  3688,  1331,
     134,   280,   431,  2133,   802,  1133,  2445,  3854,  1985,  3167,
     306,  2050,  3859,   776,  2598,  3862,   312,  2742,  3244,  4129,
    3960,  3783,   318,  4258,   251,  3866,  4230,  4007,  3310,  4011,
    2543,  3724,  3684,  3993,  3684,  2517,  4258,  3706,  3893,  2233,
    4322,  3892,  4379,  4272,  4271,  3892,  4338,  4178,  3302,  2521,
    3163,   347,   279,   349,  3706,  2124,  2618,  2549,  2124,  2551,
    2552,  2553,  2118,  3753,  1430,  2813,  4384,  4451,  3923,  4443,
     366,  3988,  2761,  2746,  4349,  3934,  3799,  3932,  1420,  4246,
    4330,  3937,    26,   988,  3931,   312,     0,  3394,  4091,  3779,
    3352,   318,  3350,   516,   321,   391,  4194,   566,   521,  1948,
     523,  2703,  4362,   526,  4445,   528,  4169,   530,   695,  1802,
    3800,  3801,  3802,  3803,   537,  1803,  1509,   540,  2459,  3335,
     347,  3544,  3076,  1841,   547,   708,   353,  3974,  2460,  2471,
    1843,  2644,  1159,  2646,  1842,  1178,  1177,  2466,  1180,   366,
    2487,  2479,  3024,  3491,  3505,  4072,   569,  3023,  1185,  3799,
    3077,   574,  3289,   700,  2099,  2988,   579,  4048,  2980,  4309,
     583,  4310,  4313,  3886,   391,  3888,  2463,  2397,  2305,    83,
    2395,  3072,    -1,    -1,  3854,   598,  4023,  1677,    -1,  3859,
      -1,    -1,  3862,    -1,    -1,    -1,    -1,  2700,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2725,    -1,    -1,  3977,   130,    -1,    -1,  3879,
      -1,    -1,    -1,   646,  4071,    -1,    -1,    -1,   142,    -1,
      -1,    -1,   146,  3923,   657,   658,  3886,   151,  3888,    -1,
      -1,    -1,   156,    -1,    -1,   159,    -1,   161,    -1,    -1,
      -1,    -1,  4014,   676,    -1,   678,   679,    -1,    -1,    -1,
     683,    -1,    -1,  3953,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,  3962,   696,   188,    -1,  3966,   700,  3968,    -1,
      -1,  3971,  3972,   706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   717,    -1,   210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   729,    -1,  4155,    -1,
    3960,    -1,  3962,  2826,    -1,    -1,    -1,  3997,  3997,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3466,
    3467,    -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,
    2853,   255,  4104,    -1,    -1,    -1,    -1,    -1,    -1,   772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   784,    -1,   786,   787,    -1,    -1,    -1,    -1,    -1,
      -1,  2863,    -1,    -1,  2866,  4230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,
      -1,  4071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   829,    -1,    -1,  2922,
      -1,     0,    -1,    -1,    -1,    -1,    -1,   840,    -1,  2911,
      -1,   844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2942,
      -1,    -1,    -1,   347,   857,    -1,    -1,  4284,    -1,    -1,
    4130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4295,   872,
      -1,    -1,    -1,    -1,  2967,   878,   879,   371,    -1,    -1,
    4110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   894,   895,   896,    -1,   898,    -1,   900,  4325,    -1,
     394,    -1,   396,   397,    -1,    -1,    -1,    -1,    -1,    -1,
    3003,    -1,    -1,    -1,    83,    -1,  4176,  4176,    -1,    -1,
      -1,    -1,    -1,   926,    -1,   928,   929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   429,    -1,    -1,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   951,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   142,    -1,    -1,    -1,   146,   981,   982,
      -1,    -1,   151,   986,    -1,   988,    -1,   156,  4258,    -1,
     159,    -1,   161,    -1,    -1,   998,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1006,    -1,    -1,  1009,    -1,    -1,  1012,
      -1,    -1,  4315,    -1,    -1,    -1,    -1,    -1,    -1,   188,
    4447,    -1,  1025,    -1,    -1,    -1,    -1,    -1,  4258,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,  3115,  3116,  3117,  3118,    -1,    -1,    -1,
      -1,  1054,    18,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,  1082,
    1083,    -1,  1085,    -1,    -1,  4315,   255,    -1,    -1,    -1,
    4350,  4350,    -1,    -1,  3811,    -1,    -1,    -1,    64,  1102,
    4401,    -1,  4362,  4362,  4362,  4362,  4362,  4362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3837,  3838,    -1,    -1,    -1,    -1,  4396,    -1,    -1,    -1,
      -1,    -1,    -1,   302,    -1,  1138,    -1,    -1,  1141,    -1,
      -1,  4401,  4401,  4401,  4401,  4401,  4401,   113,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,    -1,  4396,    -1,  4396,  1170,    -1,    -1,
      -1,  1174,  1175,  4443,    -1,    -1,    -1,    -1,   347,    -1,
      -1,  4451,  1185,  1186,  1187,  4445,  4445,  4445,  4445,  4445,
    4445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1203,    -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,  4443,    -1,  4443,    -1,  3287,    -1,    -1,    -1,  4451,
      -1,  4451,    -1,  3316,    -1,   394,    -1,   396,   397,    -1,
      -1,    -1,    -1,  1236,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,  1248,  1249,    -1,    -1,    -1,
      -1,    -1,  1255,    -1,    -1,  1258,    -1,    -1,    50,    -1,
     429,    -1,    -1,   432,   433,   434,    -1,   233,    -1,   235,
      -1,    -1,    -1,    -1,    -1,  1278,    -1,    -1,    -1,   245,
      -1,  1284,    -1,    -1,  1287,    -1,    -1,   253,    -1,    -1,
      82,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1307,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1315,  1316,  1317,  1318,  1319,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,  1330,  4045,   295,
    1333,    -1,    -1,   299,    -1,    -1,    -1,    28,    -1,    -1,
      -1,  1344,    -1,  1346,    -1,    36,   138,    -1,    -1,    -1,
      -1,    42,    -1,  1356,  1357,    -1,    -1,    -1,   324,  1362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,   169,    -1,  3472,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,  1406,    -1,    -1,   198,    -1,    -1,    -1,
      -1,    -1,    -1,   205,    -1,    28,   382,    -1,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
    1433,  1434,  1435,  1436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1445,   235,    -1,    -1,    -1,    -1,  1451,    -1,
      -1,  1454,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
    1463,    -1,    -1,    -1,    -1,    -1,    -1,  1470,    -1,  1472,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,  1482,
     171,    -1,    -1,    -1,  1487,    -1,  3579,    -1,    -1,    -1,
      -1,    -1,    -1,  1496,    -1,    -1,    -1,    -1,    -1,  1502,
    1503,   192,   193,    -1,  1507,    -1,    -1,   299,    -1,    -1,
      -1,   303,    -1,    -1,  3607,    -1,    -1,   309,   209,    -1,
      -1,    -1,    -1,    -1,   316,    -1,    -1,    -1,    -1,  1532,
    3623,    -1,   324,    -1,    -1,    -1,  1539,    -1,  1541,    -1,
      -1,   333,  1545,  1546,   235,  1548,    -1,   238,    -1,   341,
      -1,  1554,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,
     251,    -1,    -1,   254,    -1,  1568,  1569,    -1,    -1,  1572,
      -1,    -1,    -1,  1576,    -1,  1578,  3669,    -1,  3650,   192,
     193,    -1,  1585,    -1,    -1,  1588,    -1,    -1,    -1,  1592,
      -1,    -1,  3664,    -1,    -1,    -1,   209,  1600,  1601,    -1,
     392,    -1,    -1,    -1,   396,  1608,    -1,  1610,  1611,  1612,
    1613,  1614,    -1,    -1,    -1,    -1,    -1,    -1,  1621,  1622,
      -1,  1624,   235,  1626,  1627,   238,    -1,  1630,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,   251,    -1,
      -1,   254,    -1,    -1,  1647,    -1,    -1,    -1,  1651,  1652,
      -1,    -1,    -1,  1656,    -1,    -1,    -1,  1660,    -1,  1662,
    1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,    -1,  1672,
      -1,    -1,    -1,  1676,  1677,    -1,  1679,    -1,    -1,    -1,
      -1,    -1,  1685,    -1,    -1,  3757,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    36,    -1,    -1,
      -1,    -1,  3815,    42,    -1,    -1,    -1,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,    -1,    -1,   430,
      -1,    -1,    -1,    -1,    -1,   436,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,  1801,    -1,
    1803,    -1,  1805,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    66,
      -1,    -1,  3894,  3895,  3896,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1840,    -1,    -1,
      -1,    -1,    -1,  1846,    -1,  1848,    -1,    -1,   167,    -1,
      -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1863,    -1,    -1,    -1,    -1,  1868,    -1,  1870,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1887,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,  1898,    -1,  1900,  1901,  1902,
      -1,    -1,  1905,    -1,  1907,    -1,  1909,    -1,  1911,     8,
    1913,  1914,    11,    -1,  1917,    -1,   235,    -1,    -1,   238,
     167,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,    28,
      -1,    -1,   251,  1936,    -1,   254,    -1,    36,    -1,    -1,
      -1,    -1,    50,    42,    -1,   192,   193,    -1,    -1,    -1,
    4022,    -1,  1955,  4046,    -1,    -1,    -1,    -1,  1961,    21,
      -1,    -1,   209,  1966,    -1,    -1,    -1,    66,    -1,  1972,
      -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4076,    -1,  1988,    -1,    -1,   235,  1992,
    1993,   238,    54,    -1,    -1,    -1,  1999,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    67,    68,   254,    -1,   328,
      -1,    -1,    -1,  2016,    76,    -1,    -1,    -1,    80,    -1,
      -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,  4100,    -1,
     138,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,  2042,
      -1,  2044,  2045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4123,    -1,  4125,    -1,    -1,   118,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,    -1,   129,   167,  2072,
      -1,    -1,   171,    -1,    -1,   137,    -1,  2080,    -1,    -1,
      -1,   328,  2085,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,   153,    -1,   192,   193,  2098,    -1,   205,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
     209,    -1,   174,    -1,    -1,    -1,   435,    -1,    -1,    -1,
      -1,    -1,    -1,  2126,    -1,    -1,  2129,   235,  2131,    -1,
    2133,    -1,    -1,  2136,    -1,    -1,   235,   199,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,   262,   254,  4228,    -1,   220,  2162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2170,  2171,    -1,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,    -1,    -1,    -1,    -1,    -1,    -1,   295,   435,   251,
      -1,   299,    -1,    -1,  2197,   303,  2199,  2200,  2201,  2202,
      -1,   309,    -1,    -1,    -1,    -1,     8,  4279,   316,    11,
      -1,    -1,    -1,    -1,    -1,    -1,   324,   279,  2221,    -1,
      -1,    -1,    -1,    -1,    -1,   333,    28,    -1,    -1,   328,
    2233,    -1,    -1,   341,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,   306,    -1,    -1,    -1,   310,    -1,
     312,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,   321,
      -1,  4333,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2279,    -1,    -1,    -1,
      -1,    -1,  2285,    -1,   392,   347,    -1,   349,    -1,    -1,
      -1,   353,    -1,  2296,    -1,    -1,    -1,    -1,    -1,   361,
    2303,  2304,    -1,    -1,   366,    -1,  2309,    -1,    -1,  4381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   391,
      -1,  2334,  2335,   432,    -1,    -1,  2339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  2351,  2352,
    2353,  2354,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,  2364,    -1,    -1,  2367,   167,  2369,  2370,    -1,   171,
      -1,    -1,    36,    -1,    -1,    28,  2379,  2380,    42,    -1,
    2383,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
     192,   193,    -1,  2396,    -1,  2398,    -1,  2400,    -1,  2402,
      -1,    -1,    66,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    66,    -1,  2418,    -1,     0,    -1,  2422,
      -1,    -1,    -1,    -1,    -1,    -1,  2429,    -1,  2431,  2432,
    2433,    14,    -1,   235,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    24,    -1,    26,    27,  2448,    -1,    -1,    -1,   251,
      -1,    -1,   254,    -1,    -1,    -1,    -1,  2460,    41,    -1,
      -1,    -1,  2465,    -1,    -1,    -1,    -1,    -1,  2471,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2479,    -1,    61,  2482,
      63,    64,    -1,  2486,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,  2516,   167,  2518,    99,    -1,   171,   102,
    2523,    -1,    -1,    -1,    -1,    -1,   328,    -1,   192,   193,
      -1,   114,    -1,   116,    -1,    -1,    -1,   120,    -1,   192,
     193,    -1,    -1,   126,    -1,   209,  2549,    -1,  2551,  2552,
    2553,   134,    -1,   136,    -1,    -1,   209,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   156,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,   238,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,    -1,    -1,   211,   212,
     432,    -1,    -1,    -1,   217,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   226,   863,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,   328,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,   274,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,   291,   292,
      -1,   294,    36,    -1,    -1,    -1,   299,    -1,    42,    -1,
      -1,   304,    -1,    -1,   307,    -1,  2729,  2730,   311,    -1,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    66,    -1,   327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   347,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,   995,   430,    -1,  2782,
    2783,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,   167,  2798,    -1,   380,   171,    -1,
      -1,    -1,   385,    -1,   128,    -1,    -1,    -1,  2811,  2812,
      -1,    -1,    -1,    -1,   397,    -1,    -1,  2820,  2821,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2835,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    -1,    -1,   171,   431,    -1,
      -1,   434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2863,    -1,   235,  2866,    -1,   238,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2880,   251,    -1,
      -1,   254,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2901,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2911,    -1,
      -1,    -1,    -1,    -1,   238,    -1,  2919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2929,   251,    -1,    -1,
      -1,    -1,  2935,    -1,  2937,    -1,    -1,    -1,    -1,    -1,
    2943,    -1,    -1,  2946,  2947,  2948,  2949,  2950,  2951,  2952,
    2953,  2954,  2955,    -1,    -1,   328,  2959,  2960,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,  2972,
      -1,  1190,    -1,  2976,    -1,    -1,    -1,  2980,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,  2990,    -1,    -1,
    2993,    -1,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,  3004,  3005,  3006,   328,    -1,    64,  3010,    36,    -1,
    3013,    -1,    -1,    -1,    42,    -1,    -1,  3020,  3021,  3022,
    3023,  3024,  3025,    -1,    -1,  1244,  3029,  3030,    -1,    -1,
      -1,  3034,    -1,    -1,    -1,    -1,    18,  3040,    66,  3042,
      -1,  3044,    24,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   113,    -1,  1276,    -1,   432,
      -1,    -1,   120,  3066,    -1,   123,    -1,    -1,    -1,  3072,
      -1,    -1,    -1,  3076,    -1,  3078,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3093,  3094,  3095,    -1,  3097,    -1,    -1,    -1,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3115,  3116,  3117,  3118,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1348,
      18,   113,    -1,    -1,    -1,    -1,    24,    -1,   120,   167,
      -1,   123,    -1,   171,    -1,    -1,    -1,    -1,  1367,    -1,
    3153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,  1387,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    64,   235,    -1,    -1,
     177,   209,    -1,    -1,    -1,    -1,    -1,   245,    -1,   186,
     187,    -1,    -1,  1412,   176,   253,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,   203,   235,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3225,   251,    -1,   113,   254,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,   295,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1469,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   245,    -1,    -1,   324,    -1,    -1,    -1,
      -1,   253,    -1,  3276,    -1,     8,    -1,    -1,    11,    -1,
     262,    -1,    -1,    -1,  3287,    -1,  3289,    -1,   176,    -1,
      -1,    -1,  3295,    -1,    -1,    28,    -1,    -1,  3301,    -1,
     328,    -1,    -1,    36,    -1,    -1,    -1,  3310,    -1,    42,
      -1,    -1,    -1,   295,    -1,    -1,    -1,   299,    -1,  3322,
      -1,    -1,    -1,    -1,   382,    -1,    -1,    -1,  3331,    -1,
      -1,    -1,    -1,    66,  3337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,   233,    -1,   235,    -1,    -1,
    3353,  3354,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3376,   262,  3378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     382,    -1,    -1,    -1,   432,    28,    -1,   295,  3411,    -1,
      -1,   299,     8,    36,    -1,    11,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,    -1,    -1,
      -1,    -1,    28,    -1,   167,    -1,   324,    -1,   171,    -1,
      36,    -1,    -1,    66,    -1,  3448,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3458,  3459,    -1,    -1,   192,
     193,    -1,    -1,  3466,  3467,    -1,    -1,    -1,  3471,    -1,
      66,    -1,    -1,    -1,  3477,  3478,   209,    -1,  3481,    -1,
    3483,  3484,  3485,  3486,    -1,    -1,    -1,  3490,  3491,  3492,
      -1,    -1,  3495,    -1,   382,    -1,  3499,    -1,    -1,    -1,
    3503,    -1,   235,    -1,    -1,   238,  3509,    -1,    -1,    -1,
    3513,    -1,    -1,    -1,    -1,  3518,    -1,    -1,   251,    -1,
      -1,  3524,    -1,    -1,    -1,    -1,   523,  3530,    -1,    -1,
      -1,    -1,    -1,  3536,    -1,    -1,    -1,    -1,   535,    -1,
      -1,  3544,   539,    -1,   167,  3548,    -1,    -1,   171,    -1,
      -1,    -1,    -1,   550,    -1,  3558,    -1,    -1,  3561,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   565,   192,
     193,   167,   569,    -1,    -1,   171,    -1,    -1,  3581,  3582,
      -1,    -1,   579,   580,    -1,    -1,   209,    -1,   585,    -1,
      -1,    -1,    -1,    -1,    -1,   328,   192,   193,   595,    -1,
      -1,    -1,  3605,    -1,    -1,    -1,   603,    -1,    -1,    -1,
      -1,    -1,   235,   209,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
      -1,    -1,   238,    -1,    -1,    -1,    -1,  3650,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,   254,    -1,
      -1,  3664,    -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,   676,
      -1,    -1,    -1,    -1,   681,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,  3722,
      -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,  1947,  1948,
    3733,    -1,   328,    -1,    -1,  3738,    -1,    -1,    -1,    -1,
    1959,    -1,  3745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3757,  3758,    -1,    -1,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3783,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,  3811,   432,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3820,    -1,    -1,
      -1,    -1,   418,   419,   420,   176,   422,   423,   424,   425,
     426,   427,   829,    -1,  3837,  3838,   432,    -1,  3841,    -1,
      -1,    -1,    -1,   840,    -1,    -1,    -1,  3850,    -1,    -1,
      -1,  3854,    -1,    -1,    -1,    -1,  3859,    -1,    -1,  3862,
    3863,    -1,  3865,    -1,  3867,  3868,   863,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2100,   233,    -1,   235,    -1,    -1,    -1,    -1,  3892,
    3893,  3894,  3895,  3896,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,   900,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  3931,  3932,
      -1,    -1,    -1,    -1,    -1,   932,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,   299,    -1,
     947,    -1,    36,    -1,   951,    -1,    -1,    18,    42,    -1,
    2179,    -1,   959,    24,    -1,    -1,    -1,  3970,    -1,    -1,
      -1,  3974,    -1,   324,  3977,    -1,    -1,    -1,     8,    -1,
      -1,    11,    66,    -1,    -1,  3988,    -1,    -1,    -1,    18,
     987,    -1,  3995,    -1,    -1,    24,  3999,    -1,   995,    -1,
     997,    -1,    -1,    64,    -1,    -1,    36,    -1,  4011,    -1,
      -1,  4014,    42,  1010,    -1,    -1,  1013,    -1,    -1,  4022,
    4023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1025,    -1,
      -1,   382,    -1,    -1,    -1,    64,    66,    -1,    -1,    -1,
      -1,    -1,  4045,    -1,  2263,  4048,    -1,  4050,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,  1054,    -1,   120,
      -1,    -1,   123,    -1,  4067,    -1,    -1,    -1,  4071,    -1,
      -1,  4074,    -1,    -1,    -1,    -1,    -1,  4080,    -1,    -1,
      -1,    -1,    -1,   167,   113,  1082,  1083,   171,  1085,    -1,
      -1,   120,    -1,    -1,   123,    -1,    -1,  4100,   128,    -1,
      -1,  4104,    -1,    -1,    -1,  1102,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,  4122,
    4123,  4124,  4125,    -1,    -1,   209,    -1,  1124,    -1,    -1,
      -1,    -1,    -1,    -1,  4137,  1132,  1133,   167,    -1,    -1,
      -1,   171,    -1,    -1,  1141,  1142,    -1,   176,    -1,    -1,
      -1,   235,  4155,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   192,   193,    -1,    -1,    -1,   251,    -1,    -1,
     254,  4174,   233,  1170,   235,    -1,    -1,  1174,  1175,   209,
      -1,    -1,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,  1190,    -1,    -1,    -1,    -1,    -1,  1196,
      -1,   262,    -1,    -1,   233,    -1,   235,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,  4222,
      -1,   251,    -1,    -1,   253,  4228,    -1,  4230,     8,    -1,
      -1,    11,    -1,   262,   295,    -1,  4239,    -1,   299,    -1,
      -1,    -1,    -1,    -1,   328,    -1,    -1,  1244,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,   324,    -1,    -1,   295,    -1,    -1,    -1,
     299,    -1,    -1,    -1,    -1,    -1,  4279,    -1,    -1,  1276,
      -1,  4284,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,  4295,    -1,    -1,   324,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,  4312,
    4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   382,  4325,    -1,  2543,    -1,    -1,    -1,    -1,    -1,
    4333,  1328,    -1,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,    -1,   432,    -1,
      -1,  1348,    -1,   382,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    24,    -1,  4366,    -1,    -1,  2585,  2586,    -1,  2588,
    1367,    -1,    -1,  4376,    -1,    -1,    -1,    -1,  4381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
    1387,   171,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1407,    -1,   192,   193,    -1,  1412,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2644,    -1,  2646,    -1,   209,
    1427,    -1,    -1,    -1,     8,  4438,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,  4447,    -1,  1443,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,   235,    -1,   120,   238,    -1,
     123,    -1,    36,    -1,    18,    -1,  1463,    -1,    42,    -1,
      24,   251,  1469,    -1,   254,  1472,    -1,  1474,  1475,    -1,
      -1,  2700,    -1,    -1,    -1,    -1,    -1,    -1,  1485,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1497,  1498,    -1,    -1,    -1,    -1,  2725,    -1,    -1,    -1,
      64,    -1,  1509,   176,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2762,  1541,    -1,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,   113,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,     8,   123,
     233,    11,   235,    -1,    -1,    -1,    -1,    -1,    -1,  1576,
      -1,  1578,   245,    -1,    -1,    -1,    -1,    -1,  1585,    -1,
     253,  1588,    -1,   167,    -1,  1592,    36,   171,    -1,   262,
      -1,    -1,    42,  1600,  1601,    -1,    -1,  2826,    -1,    -1,
     863,  1608,    -1,    -1,  1611,  1612,  1613,  1614,   192,   193,
      -1,    -1,   176,  2842,  1621,  1622,    66,  1624,     8,  1626,
    1627,    11,   295,  1630,  2853,   209,   299,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,    28,  1646,
    1647,  1648,   432,    -1,    -1,  1652,    36,    -1,    -1,  1656,
      -1,   324,    42,  1660,   238,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,    -1,  1672,    -1,   251,    -1,   233,
    1677,   235,  1679,    -1,    -1,    -1,    66,    -1,   128,    -1,
      -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,  2922,    -1,    -1,    -1,    -1,   262,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,
      -1,    -1,    -1,  2942,    -1,    -1,    -1,   167,    -1,    -1,
       8,   171,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,   995,    -1,    -1,   299,    -1,    -1,  2967,    -1,
      28,    -1,   192,   193,   328,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,   209,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3003,    -1,    -1,   167,    66,    -1,
      -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1805,    -1,
      -1,   251,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,
     424,   425,   426,   427,    -1,   235,    -1,  1854,   238,    -1,
      -1,  1858,  1859,    -1,    -1,  1862,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,   254,    18,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,  1884,   328,   167,
    1887,    -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1898,    -1,    -1,    -1,    -1,    -1,    -1,  1905,    -1,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,  1925,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,  1190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,   328,  3168,
    1947,  1948,    -1,    -1,    -1,  1952,  1953,   235,    -1,    -1,
     238,    -1,  1959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,   251,    -1,    -1,   254,   120,  1975,  1976,
     123,  1978,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,  1244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2001,    -1,    -1,    -1,  2005,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1276,    -1,    -1,  2023,    -1,     8,    -1,
      -1,    11,    -1,   176,    -1,    -1,  2033,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,    28,  2046,
     328,    -1,   432,    -1,    -1,    -1,    36,    -1,  2055,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
     233,    -1,   235,    -1,    -1,  1348,    -1,  3316,    28,    -1,
      -1,  2098,   245,  2100,    -1,    -1,    36,    -1,    -1,    -1,
     253,    -1,    42,    -1,  1367,    -1,    -1,    -1,    -1,   262,
      -1,    -1,    -1,    -1,  2121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3352,  1387,    -1,    66,    -1,    -1,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
      -1,    -1,   295,    -1,   432,    -1,   299,    -1,    -1,  1412,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,   324,  2179,    -1,    -1,  2182,    -1,   167,    36,    -1,
      -1,   171,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   192,   193,    -1,    -1,  1469,    -1,    66,  2216,
      -1,    -1,    -1,    -1,  2221,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,   382,
      -1,   171,  3461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3472,  2251,   235,    -1,    -1,   238,    -1,
      -1,    -1,   192,   193,    -1,    -1,  2263,    -1,    -1,    -1,
      -1,   251,    -1,    -1,   254,    -1,    -1,    -1,  2275,   209,
      -1,    -1,  2279,    -1,    -1,    -1,    -1,    -1,  2285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   235,  2303,  2304,   238,    -1,
      -1,    -1,  2309,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      18,   251,    -1,   171,   254,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2334,  2335,    -1,
      -1,    -1,  2339,    -1,   192,   193,    -1,    -1,   328,    -1,
      -1,    49,    -1,    -1,  2351,  2352,  2353,  2354,    -1,    -1,
    3579,   209,  2359,    -1,    -1,    -1,    64,  2364,  2365,    -1,
    2367,    -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2379,  2380,    -1,    -1,  2383,   235,  3607,    -1,
     238,    -1,    -1,  1646,    -1,    -1,    -1,    95,   328,  2396,
      -1,  2398,    -1,   251,  3623,  2402,   254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
      -1,  2418,   120,    -1,    -1,   123,  1679,    -1,    -1,    -1,
      -1,    -1,  2429,    -1,  2431,  2432,  2433,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,  2445,    -1,
    3669,  2448,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2460,    -1,    -1,    -1,    -1,  2465,    -1,
      -1,    -1,    -1,    -1,  2471,   173,    -1,    -1,   176,    -1,
     328,    -1,  2479,    -1,    -1,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,  2495,    -1,
      -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2510,  2511,    -1,    -1,    -1,    -1,  2516,
      -1,    -1,    -1,   221,    -1,   223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,   235,    -1,    -1,
    2537,    -1,    -1,  2540,    -1,    -1,  2543,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,    -1,    -1,    -1,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,  2585,  2586,
      -1,  2588,    -1,    -1,    -1,    -1,  3815,   295,    -1,    -1,
      -1,   299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2617,  2618,  2619,    -1,     8,    -1,   324,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,  2636,
      -1,    -1,    -1,    -1,    28,    -1,    -1,  2644,    32,  2646,
    2647,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,
    2657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,   382,    -1,    -1,    13,    -1,  1942,
      -1,    -1,    -1,    19,  1947,  1948,    -1,    -1,    -1,    -1,
      -1,    -1,    28,  2700,  3923,    -1,  1959,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,  2719,    -1,    -1,    -1,    -1,   111,  2725,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2744,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2761,  2762,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2776,
      -1,  2778,    -1,   167,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,  2790,    -1,  2792,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4025,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,  4046,    -1,  2826,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2841,  2842,    -1,  2100,    -1,    -1,
      -1,   235,    -1,    -1,   238,    -1,  2853,  4076,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,   194,   195,
     254,   197,  2869,   199,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2880,    -1,    -1,  2883,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,  4114,    -1,    -1,    -1,  4118,
    4119,    -1,    -1,  2900,    -1,    -1,  2903,    -1,    -1,    28,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,  2919,    42,    -1,  2922,  2179,    -1,    -1,    -1,
      -1,    -1,  2929,    -1,    -1,    -1,    -1,    -1,  2935,    -1,
    2937,    -1,    -1,    -1,   328,  2942,  2943,    66,    -1,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,    -1,
      -1,    -1,  2959,  2960,    -1,    -1,    -1,    -1,    -1,    -1,
    2967,    -1,    -1,    -1,    -1,  2972,    -1,    -1,    -1,  2976,
      -1,  2978,    -1,  2980,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,  2990,    11,   379,  2993,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3003,  3004,  3005,  3006,
    2263,    28,    -1,  3010,    -1,    -1,  3013,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,  3023,  3024,    -1,    -1,
      -1,    -1,    -1,    -1,   418,   419,   420,  3034,   422,   423,
     424,   425,   426,   427,    -1,  3042,    -1,  3044,   167,    66,
      -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3066,
      -1,    -1,    -1,   192,   193,  3072,    -1,    -1,    -1,    -1,
      -1,  3078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,  3093,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3124,    -1,   146,
      -1,    -1,   251,    -1,   151,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,
     167,    -1,    -1,   193,   171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,    -1,  3163,    -1,    -1,    -1,
    3167,  3168,  3169,    -1,    -1,   192,   193,    -1,  2431,  2432,
    2433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,   524,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   532,    -1,    -1,   328,
      -1,  3208,    -1,    -1,  3211,   541,   542,    -1,   235,    -1,
     546,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   557,    -1,    -1,   251,    -1,     8,   254,    -1,    11,
      -1,    -1,    -1,    -1,   570,    -1,    -1,    -1,  3245,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
     586,    -1,    -1,   589,    36,   591,    -1,   593,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2543,    -1,  3289,    -1,    66,    -1,    -1,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
      -1,   328,    -1,    -1,    -1,  3312,  3313,    -1,    -1,  3316,
      -1,    -1,  3319,    -1,    -1,    -1,    -1,   653,    -1,   655,
      -1,    -1,  2585,  2586,    -1,  2588,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3352,  3353,  3354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2644,    -1,  2646,    -1,   167,    -1,  3394,    -1,   171,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,    -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,   767,    -1,    -1,    -1,    -1,    -1,  2700,    -1,    -1,
      -1,  3448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3458,  3459,   235,  3461,    -1,   238,    -1,    -1,  3466,
    3467,    -1,  2725,    -1,  3471,  3472,    -1,    -1,    -1,   251,
    3477,  3478,   254,    -1,  3481,    -1,    -1,    -1,    -1,    -1,
      -1,  2744,   818,    -1,    -1,   535,    -1,    -1,    -1,   539,
      -1,   273,  3499,    -1,    -1,    -1,  3503,   833,    -1,  2762,
     550,    -1,    -1,    -1,    -1,    -1,  3513,    -1,    -1,    -1,
     846,  3518,    -1,    -1,    -1,   565,    -1,   853,    -1,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,   865,
     580,    -1,   868,    -1,    -1,   585,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   595,   328,    -1,    -1,    -1,
      -1,    -1,    -1,   603,  3561,    -1,    -1,    -1,    -1,    -1,
     342,    -1,    -1,  2826,     8,   901,    -1,    11,    -1,    -1,
      -1,    -1,  3579,    -1,    -1,     8,    -1,    -1,    11,  2842,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
    2853,  3598,    36,    -1,    -1,    28,    -1,    -1,    42,    -1,
    3607,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,  3618,    -1,    -1,    -1,    -1,  3623,    -1,    -1,    -1,
      -1,    -1,    66,  3630,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   681,    -1,    66,    -1,    -1,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2922,
      -1,    -1,  3669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3684,    -1,  2942,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,  2967,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,  3722,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    28,  3733,   171,    31,    -1,
      -1,    -1,    -1,    36,   167,    -1,    -1,    -1,   171,    42,
    3003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    66,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3780,    -1,    -1,   209,    -1,    -1,    -1,
      -1,  3044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,  3799,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,  3811,   238,    -1,   251,  3815,    -1,
     254,    -1,    -1,  3820,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,  1159,  1160,     8,    -1,   271,    11,    -1,
    3837,  3838,    -1,    -1,  3841,   268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  3854,    -1,    -1,
      -1,    -1,  3859,    36,    -1,  3862,    -1,    -1,    -1,    42,
    3867,  3868,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3886,
      -1,  3888,   932,    66,   328,  3892,  1222,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,   328,    -1,   947,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3168,   209,    -1,    -1,   959,
      -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,   238,    -1,   987,    -1,    -1,
      -1,   863,    -1,    -1,    -1,    -1,    -1,   997,   251,    -1,
      -1,   254,    -1,  3960,    -1,  3962,    -1,    -1,    -1,    -1,
    1010,    -1,    -1,  1013,    -1,    -1,    -1,  3974,   151,    -1,
      -1,    -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   167,   418,   419,   420,   171,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,  4023,    -1,  4025,    -1,
      -1,    -1,    -1,    -1,    -1,   328,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4045,  4046,
      -1,  4048,    -1,  4050,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,  3316,    -1,   238,    -1,    -1,    -1,    -1,
    4067,    -1,    -1,    -1,  4071,    -1,    -1,    -1,   251,  4076,
      -1,   254,    -1,   995,  1124,    -1,    -1,    -1,    -1,    -1,
    1416,    -1,  1132,  1133,    -1,    -1,    -1,    -1,    -1,  3352,
      -1,    -1,  1142,    -1,    -1,  1431,    -1,     8,    -1,    -1,
      11,    -1,    -1,  4110,    -1,    -1,    -1,  4114,    -1,    -1,
      -1,  4118,  4119,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,  1471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,  1196,    -1,  4155,    -1,
    1486,    -1,  1488,    -1,  1490,    66,    -1,    -1,    -1,  1495,
      -1,    -1,    -1,    -1,    -1,     8,    -1,  4174,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  4194,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,  3461,    42,
      -1,    -1,  1538,    -1,    -1,  1127,  1542,    -1,  1544,  3472,
      -1,  1547,    -1,    -1,    -1,  4222,    -1,   128,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4239,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
    3513,  4258,    -1,    -1,    -1,  3518,   167,    -1,    -1,    -1,
     171,    -1,    -1,    -1,    -1,    -1,    -1,  3530,  1190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4284,  1328,    -1,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,  4295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,  4312,  4313,    -1,  4315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3579,    -1,  4325,    -1,
      -1,    -1,  1244,    -1,   167,    -1,    -1,   238,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,  1276,    -1,    -1,  1407,    -1,  4366,
    3623,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,  4376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1427,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4396,
      -1,    -1,   235,  1443,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3669,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,
      -1,    -1,    -1,    -1,  1474,  1475,  1348,    -1,    -1,     8,
      -1,  4438,    11,    -1,    -1,  1485,  4443,    -1,    -1,    -1,
    4447,    -1,    -1,    -1,  4451,  1367,    -1,  1497,  1498,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,  1509,
      -1,    -1,    -1,    42,    -1,  1387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    66,    -1,    -1,
    1412,    -1,    -1,    28,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,   422,   423,   424,   425,   426,   427,  3780,    -1,  1855,
    1856,    -1,    -1,    -1,  1860,  1861,    -1,    -1,  1864,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,  1874,    -1,
      -1,    -1,    -1,    -1,    -1,  1881,    -1,  1469,    -1,  1885,
    1886,    -1,  3815,  1889,  1890,    -1,    -1,    -1,    -1,    -1,
    1896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1908,    -1,  1910,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,   167,    -1,
    1926,    -1,   171,    -1,    -1,  1931,    -1,    -1,  1648,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   676,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1962,  1963,  1964,  1965,
     209,    -1,   167,  1969,  1970,    -1,   171,    -1,    -1,    -1,
      -1,  1977,   706,    -1,  1980,    -1,    -1,    -1,  1984,    -1,
      -1,     8,    -1,    -1,    11,    -1,   235,   192,   193,   238,
    3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2006,    28,   251,    -1,   209,   254,    -1,    -1,    -1,    36,
      -1,  2017,    -1,  2019,    -1,    42,    -1,    -1,  2024,    -1,
      -1,    -1,    -1,  2029,  2030,  2031,  2032,    -1,  2034,    -1,
     235,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    66,
      -1,  2047,  2048,  2049,    -1,    -1,   251,    -1,    -1,   254,
      -1,    -1,  2058,  2059,  1646,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4046,    -1,    -1,  2122,    -1,    -1,    -1,
      -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,  1858,  1859,
     167,    -1,  1862,  4076,   171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1884,   192,   193,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
      -1,  4114,   209,    -1,    -1,  4118,  4119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1925,    -1,    -1,   235,    -1,
      -1,   238,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,    -1,   251,    -1,    -1,   254,    -1,    -1,
      -1,    -1,  1952,  1953,    -1,  2241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1975,  1976,    -1,  1978,    -1,
      -1,  4194,    -1,  2269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2001,    -1,    -1,    -1,  2005,    -1,    -1,    -1,    -1,
      -1,  1025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   328,    -1,  2023,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2033,    -1,    -1,    -1,    -1,    -1,    -1,
    1054,    -1,    -1,    -1,    -1,    -1,  2046,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,  2055,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,  1082,  1083,
    1942,  1085,    -1,    -1,    -1,  1947,  1948,    -1,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,  1959,  1102,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    80,    -1,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,  2121,    -1,    -1,    -1,    97,    -1,  1141,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1170,   129,    21,    -1,
    1174,  1175,    -1,    -1,    -1,   137,    -1,    -1,    -1,    -1,
      33,    -1,  2458,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,    -1,  2182,   155,    -1,    -1,    -1,   159,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   174,    -1,    67,    -1,    -1,    -1,    -1,    -1,
    2496,  2497,    -1,    -1,    -1,    -1,  2216,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2513,  2100,    -1,
      -1,    -1,    -1,    -1,    97,    -1,  1098,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,  2251,  2538,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,  2547,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   137,  2275,  2562,  2563,    -1,   251,
      -1,  2567,   254,    -1,    -1,   148,  2572,  2573,  2574,    -1,
     153,    -1,    -1,  1155,    -1,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2179,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,  2608,  2609,  2610,  2611,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,   321,
      -1,    -1,  2638,  2639,  2640,    -1,    -1,   220,    -1,  2359,
      -1,    -1,  2648,    -1,    -1,  2365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,    -1,   349,   350,    -1,
     352,   353,    -1,    -1,    -1,    -1,    -1,    -1,   251,   361,
      -1,  2263,    -1,    -1,   366,    -1,    -1,    -1,   261,    -1,
     372,    -1,    -1,   375,    -1,    -1,   378,    -1,    -1,    -1,
      -1,    21,    -1,    -1,    -1,    -1,   279,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,  2712,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2720,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   306,    -1,  2445,    -1,   310,    -1,   312,
      -1,    -1,    -1,    -1,    -1,   318,    -1,    67,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,   349,    97,    -1,    -1,
     353,  2777,    -1,   103,    -1,  2495,    -1,    -1,   361,    -1,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,   118,    -1,
    2510,  2511,    -1,    -1,    -1,   378,    -1,    -1,    -1,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,   391,    -1,
      -1,    -1,    -1,  2819,    -1,    -1,  2822,  2537,   148,    -1,
    2540,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,   159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,  2854,    -1,
      -1,  1585,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2868,    -1,    -1,    -1,    -1,    -1,    -1,   199,
      -1,    -1,  2878,    -1,  1608,    -1,    -1,  1611,    -1,    -1,
    1614,    -1,    -1,    -1,    -1,    -1,    -1,  1621,  1622,    -1,
     220,    -1,    -1,  1627,    -1,    -1,  1630,  2617,  2618,  2619,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   863,    -1,  1647,    -1,    -1,  2636,    -1,  1652,    -1,
      -1,   251,  1656,  1505,    -1,    -1,  1660,  2647,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  2657,  1672,    -1,
      -1,    -1,    -1,  1677,    -1,  1679,    -1,    -1,    -1,   279,
      -1,  2543,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,
     310,    -1,   312,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,   321,    -1,  2585,  2586,    -1,  2588,    -1,    -1,  2719,
      -1,  1583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,   349,
      -1,    -1,    -1,   353,    -1,  1607,    -1,    -1,    -1,    -1,
    1612,   361,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,  2761,    -1,   995,    -1,    -1,    -1,    -1,   378,    -1,
    1632,  1633,  2644,  1635,  2646,    -1,  2776,    -1,  2778,    -1,
      -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2790,  1805,  2792,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,  1675,  3100,    -1,  3102,    -1,   863,    -1,
      -1,    -1,    -1,  3109,    -1,    -1,    -1,    -1,  2700,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,  3125,
      -1,  2841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1711,
      64,    -1,    -1,  2725,    -1,    -1,  3142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3151,    -1,    -1,    -1,  2869,
      -1,    -1,  2744,  1887,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    -1,  2883,    -1,    -1,    -1,    -1,    -1,    -1,
    2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
    2900,    -1,    -1,  2903,    -1,    -1,   120,    -1,    -1,   123,
      -1,  3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,    -1,
      -1,    -1,    -1,  3209,  3210,    -1,  3212,  3213,  3214,  3215,
    3216,  3217,  3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3227,    -1,  3229,  3230,    -1,    -1,    -1,    -1,    -1,
     995,    -1,    -1,  1815,  2826,    -1,    -1,    -1,  1190,   173,
      -1,    -1,   176,    -1,    -1,  1827,    -1,    -1,  1830,    -1,
    2842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2978,    -1,
      -1,  2853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3283,  3284,  3285,
      -1,    -1,  3288,    -1,    -1,    -1,    -1,   221,    -1,   223,
      -1,    -1,  1244,    -1,    -1,    -1,    -1,    -1,    -1,   233,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   863,
      -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,    -1,  1276,    -1,    -1,   261,   262,    -1,
    2922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,  3369,  2098,   299,   300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2967,    -1,    -1,    -1,    -1,
    3386,  3387,  3388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,  1348,    -1,    -1,    -1,
      -1,   335,    -1,    -1,  3124,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,  1367,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1387,    -1,    -1,    -1,    -1,
      -1,   995,    -1,  3163,    -1,    -1,    -1,  3167,   382,  3169,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2221,  3208,    -1,
      -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1276,    -1,    -1,    -1,    -1,    -1,  1469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3245,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2304,    -1,    -1,    -1,    -1,  2309,  3168,    -1,    -1,    -1,
      -1,    -1,    -1,  1348,  3590,  3591,  3592,  3593,    -1,    -1,
      -1,    -1,  3312,  3313,    -1,    -1,    -1,    -1,    -1,  3319,
      -1,    -1,  1367,    -1,   863,    -1,    -1,    -1,  3614,  3615,
    3616,  3617,    -1,  3619,  3620,    -1,    -1,  2351,    -1,  2353,
    2354,    -1,  1387,    -1,    -1,  3631,  3632,    -1,    -1,    -1,
    2364,    -1,    -1,  2367,    -1,  2369,  1190,    -1,    -1,    -1,
      -1,    -1,  3648,  3649,    -1,  3651,    -1,  1412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2396,    -1,  2398,    -1,    -1,    -1,  2402,    -1,
      -1,    -1,    -1,    -1,  3394,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1244,    -1,    -1,    -1,  1646,    -1,    -1,  2431,  2432,  2433,
      -1,    -1,    -1,    -1,  1469,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2448,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1276,    -1,  3316,  2307,  2460,    -1,    -1,    -1,
      -1,  2465,    -1,    -1,  3740,    -1,   995,  2471,    -1,    -1,
      -1,    -1,    -1,  3749,    -1,    -1,    -1,    -1,  2330,    -1,
    2332,    -1,  2334,  2335,  2336,    -1,    -1,  2339,    -1,    -1,
    3352,  2343,    -1,  3769,    -1,    -1,    -1,    -1,  2350,    -1,
      -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,    -1,  2361,
      -1,    -1,  2516,    -1,  2366,  3791,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2375,  1348,    -1,    -1,  2379,  2380,    -1,
    2382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2394,  1367,    -1,    -1,    -1,    -1,    -1,  2401,
      -1,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,    -1,    -1,  1387,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3852,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2437,    -1,    -1,  1412,  3865,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3461,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3598,    -1,
    3472,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3618,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3630,    -1,    -1,    -1,    -1,  1469,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1190,    -1,    -1,    -1,  3941,    -1,   863,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2531,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1244,    -1,  3579,    -1,    -1,
    1942,    -1,    -1,    -1,    -1,  1947,  1948,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1959,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,  1276,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4031,    -1,    -1,    -1,    -1,
      -1,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4064,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4074,   995,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,    -1,  3799,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1348,
      -1,    -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4108,    -1,    -1,    -1,    -1,  4113,  1367,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1387,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2100,    -1,
      -1,    -1,    -1,  1412,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2747,  3886,    -1,  3888,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,
      -1,    -1,  1947,  1948,    -1,  2919,    -1,    -1,    -1,    -1,
      -1,    -1,  4198,    -1,  1959,  2929,    -1,    -1,    -1,    -1,
      -1,  2935,    -1,  2937,    -1,    -1,    -1,  4213,    -1,    -1,
    1469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3815,    -1,  2959,  2960,  2179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3960,    -1,  3962,    -1,    -1,    -1,  2980,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2990,    -1,    -1,  2993,
      -1,  2995,    -1,    -1,  1190,    -1,    -1,  4273,    -1,    -1,
    3004,    -1,  4278,    -1,    -1,    -1,  3010,    -1,    -1,  3013,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3042,    -1,
    3044,  2263,    -1,    -1,    -1,    -1,    -1,    -1,  1244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,  3066,    -1,    -1,  2100,  2918,    -1,  3072,    -1,
      -1,    -1,  2924,    -1,  3078,    -1,    -1,    -1,    -1,    -1,
    1276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2940,  2941,
      -1,  2943,    -1,    -1,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,  1942,    -1,
    4110,    -1,    -1,  1947,  1948,    -1,    -1,    -1,    -1,  2981,
      -1,    -1,  2984,    -1,  2986,  1959,    -1,    -1,    -1,  2991,
    2992,    -1,    -1,    -1,  2179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1348,  3005,  3006,  3007,    -1,  3009,    -1,    -1,
    3012,    -1,    -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4046,    -1,    -1,    -1,    -1,    -1,
      -1,  1387,    -1,    -1,    -1,    -1,    -1,    -1,  3050,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3061,
      -1,    -1,    -1,    -1,  4076,    -1,  1412,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4258,    -1,
      -1,    -1,    -1,  1469,    -1,    -1,  2100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2543,    -1,    -1,    -1,  4315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3353,
    3354,    -1,    -1,    -1,    -1,  2179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2585,  2586,    -1,  2588,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4396,  3411,    -1,    -1,
      -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,  1947,  1948,
      -1,    -1,  2644,    -1,  2646,    -1,    -1,    -1,    -1,    -1,
    1959,    -1,    -1,    -1,    -1,    -1,    -1,  3289,    -1,  2263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1646,    -1,    -1,  4443,  3458,  3459,    -1,    -1,    -1,    -1,
      -1,  4451,    -1,    -1,    -1,    -1,    -1,  3471,    -1,    -1,
      -1,    -1,    -1,  3477,  3478,    -1,    -1,  3481,  2700,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2725,    -1,    -1,    -1,    -1,  2543,  3513,
      -1,    -1,    -1,    -1,  3518,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2744,    -1,    -1,    -1,  3530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2585,  2586,    -1,  2588,    -1,    -1,    -1,  3561,    -1,    -1,
    3412,    -1,    -1,    -1,  3416,  3417,  3418,    -1,    -1,  3421,
      -1,  2100,    -1,    -1,  3426,  3427,  3428,  3429,  3430,  3431,
    3432,  3433,  3434,  3435,  3436,  3437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2826,    -1,    -1,    -1,    -1,  2644,
      -1,  2646,    -1,  3465,  3466,  3467,  3468,    -1,  3470,    -1,
    2842,    -1,  3474,  3475,  3476,    -1,    -1,  3479,    -1,    -1,
    3482,  2853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3515,    -1,  2700,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3527,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3541,
    2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2744,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3722,  2543,
    2942,    -1,    -1,    -1,    -1,    -1,    -1,  2762,    -1,    -1,
      -1,    -1,    -1,    -1,  2263,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2967,  1942,    -1,    -1,    -1,
      -1,  1947,  1948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2585,  2586,  1959,  2588,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2842,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,    -1,
    2644,    -1,  2646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3725,    -1,    -1,  2700,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2922,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2725,    -1,    -1,  2100,    -1,    -1,  2942,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2744,    -1,    -1,    -1,    -1,  3777,  3778,    -1,    -1,    -1,
      -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,  2762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3807,    -1,    -1,    -1,  3811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,
      -1,    -1,    -1,  3825,    -1,  3827,    -1,    -1,    -1,    -1,
    3832,  3833,  3834,  2179,    -1,  3837,  3838,  3839,  3840,    -1,
    3842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2543,    -1,    -1,    -1,  2842,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3890,    -1,
      -1,    -1,    -1,    -1,  4048,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2585,  2586,    -1,  2588,
      -1,    -1,    -1,  4067,    -1,    -1,    -1,  2263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3316,    -1,    -1,    -1,  2922,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2644,    -1,  2646,  2942,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3980,    -1,
    3352,    -1,    -1,  3168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4174,  2700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4044,  4045,    -1,    -1,  2725,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4060,  4061,
    4062,    -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4079,    -1,    -1,
      -1,    -1,    -1,  2762,    -1,  4239,    -1,    -1,    -1,  3461,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4312,  4313,
      -1,    -1,    -1,  2842,    -1,    -1,    -1,  3352,    -1,    -1,
      -1,    -1,    -1,    -1,  2853,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3168,    -1,    -1,  2543,    -1,    -1,
    4202,    -1,    -1,    -1,    -1,    -1,    -1,  3579,    -1,    -1,
    4212,    -1,  4366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,  2585,
    2586,    -1,  2588,  2922,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2942,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3461,    -1,    -1,    -1,
      -1,  4283,    -1,    -1,  4438,    -1,    -1,  3472,  2967,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,  2644,    -1,
    2646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4324,    -1,  3003,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2700,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4369,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3352,  2725,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3579,    -1,    -1,    -1,  2744,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4417,  2762,    -1,    -1,    -1,
      -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,    -1,
      -1,    -1,    -1,  3815,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2826,    -1,    -1,    -1,  3669,    -1,    -1,  3461,    -1,  3168,
      -1,    -1,    -1,    -1,    -1,    -1,  2842,    -1,  3472,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2922,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2942,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3579,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3815,    -1,    -1,  3607,    -1,    -1,    -1,  3316,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,
      -1,    -1,    -1,  4025,    -1,    -1,    -1,  3003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3352,  4046,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4076,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,
      -1,    -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4025,  3815,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,  4114,
      -1,    -1,    -1,  4118,  4119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3623,    -1,    -1,    -1,    -1,  3923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3815,    -1,    -1,    -1,
    4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3579,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3669,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4025,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4046,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4076,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4114,    -1,    -1,    -1,  4118,
    4119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3815,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4025,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,  4114,    -1,
      -1,    30,  4118,  4119,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,   115,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,   424,    -1,    -1,    -1,    -1,
      -1,    -1,   431,   432,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,     3,    -1,    -1,    -1,    -1,
      -1,    -1,   431,   432,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
      -1,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,    -1,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,    -1,    -1,   236,   237,   238,
     239,    -1,    -1,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,    -1,   271,    -1,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,    -1,   361,    -1,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   412,   413,   414,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,   432,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,    -1,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,    -1,    -1,   236,   237,
     238,   239,    -1,    -1,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,   412,   413,   414,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,   432,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,
     429,   430,   431,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   422,   423,   424,    -1,    -1,    -1,    -1,    -1,
      -1,   431,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     431,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   431,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   431,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     431,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,    -1,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,   423,    -1,    -1,     3,     4,     5,     6,     7,   431,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,    -1,     9,    10,
      -1,    -1,   431,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
     431,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,    -1,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,    -1,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,    -1,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   431,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,   422,   423,
     424,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,    -1,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,    -1,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,    -1,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,    -1,
     208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
      -1,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,     3,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,    -1,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
      -1,   236,   237,   238,   239,    -1,    -1,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,    -1,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
      -1,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,   424,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,    -1,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,    -1,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,    -1,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,    -1,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,   412,
     413,   414,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,   424,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,     4,     5,    -1,    -1,    -1,
       9,   422,   423,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,     4,     5,    -1,
      -1,    -1,     9,   422,   423,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,     9,   422,   423,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,     4,     5,    -1,    -1,    -1,     9,   422,   423,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    68,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,   148,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,   148,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,   148,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,   148,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,    -1,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,    -1,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
      -1,   236,   237,   238,   239,    -1,    -1,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,    -1,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,    -1,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,    -1,    -1,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,    -1,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,    -1,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,   413,   414,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,    -1,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,    -1,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,    -1,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,    -1,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,    -1,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   412,   413,   414,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
      -1,   207,   208,   209,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,    -1,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
      -1,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,    -1,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
      -1,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,    -1,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,    -1,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,    -1,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,    -1,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,    -1,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
     413,   414,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,    -1,   207,   208,   209,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,
      -1,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,    -1,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     412,   413,   414,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,    -1,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,    -1,    -1,   236,   237,   238,   239,    -1,
      -1,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,    -1,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,    -1,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,    -1,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,    -1,
     361,    -1,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,    -1,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   412,   413,   414,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    -1,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
      -1,   141,    -1,   143,    -1,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,   185,    -1,    -1,    -1,    -1,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,    -1,   207,   208,   209,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,    -1,
     230,    -1,   232,   233,    -1,    -1,   236,   237,   238,   239,
      -1,    -1,   242,    -1,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,    -1,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,    -1,   326,   327,   328,   329,
      -1,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,    -1,    -1,    -1,   359,
      -1,   361,    -1,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,    -1,    -1,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   134,
     136,   142,   156,   211,   212,   217,   226,   237,   274,   286,
     291,   292,   294,   299,   304,   307,   311,   316,   317,   324,
     327,   335,   347,   364,   374,   380,   385,   397,   431,   438,
     439,   440,   441,   447,   448,   450,   451,   452,   453,   454,
     455,   456,   458,   459,   463,   474,   477,   478,   481,   482,
     483,   494,   497,   498,   514,   551,   554,   557,   558,   559,
     566,   572,   574,   576,   577,   580,   583,   584,   588,   589,
     598,   602,   603,   604,   605,   606,   608,   609,   610,   623,
     624,   628,   630,   631,   632,   643,   645,   652,   653,   656,
     657,   658,   659,   660,   665,   667,   670,   674,   678,   679,
     689,   690,   693,   698,   709,   728,   731,   732,   733,   736,
     739,   741,   743,   746,   749,   750,   751,   758,   759,   761,
     762,   763,   768,   770,   771,   775,   776,   779,   780,   781,
     783,   784,   785,   786,   788,   791,   792,   797,   803,   806,
     808,   809,   814,   816,   820,   827,   831,   832,   833,   834,
     835,   836,   839,   867,   359,   399,   764,    21,    67,    80,
      97,   103,   118,   129,   137,   148,   153,   159,   174,   199,
     220,   251,   279,   306,   310,   312,   318,   321,   347,   349,
     353,   361,   366,   378,   391,   573,   764,     3,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      33,    34,    36,    37,    39,    40,    41,    42,    43,    45,
      46,    48,    49,    50,    51,    52,    55,    56,    57,    58,
      59,    61,    62,    63,    64,    65,    69,    70,    71,    72,
      74,    75,    77,    78,    79,    80,    81,    82,    85,    86,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   104,
     106,   107,   108,   109,   110,   112,   113,   114,   117,   118,
     119,   120,   121,   123,   124,   125,   127,   128,   129,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   141,   143,
     144,   145,   147,   149,   153,   154,   155,   157,   158,   160,
     162,   163,   164,   165,   166,   168,   169,   170,   172,   173,
     174,   175,   176,   177,   179,   181,   182,   183,   184,   185,
     186,   187,   189,   191,   194,   196,   197,   198,   199,   200,
     202,   203,   205,   206,   208,   211,   212,   213,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   231,   232,   233,   234,   236,   237,   239,   241,
     242,   243,   244,   245,   246,   248,   251,   252,   253,   256,
     260,   261,   262,   263,   264,   265,   266,   267,   269,   270,
     271,   272,   273,   274,   275,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   303,
     304,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   318,   319,   320,   321,   322,   324,   325,   326,
     327,   329,   330,   331,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   345,   346,   348,   349,   350,
     351,   352,   353,   355,   356,   359,   360,   361,   362,   364,
     365,   366,   367,   368,   369,   370,   373,   374,   375,   376,
     377,   380,   381,   382,   383,   384,   385,   386,   388,   390,
     391,   392,   395,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     828,   974,   987,   991,   992,   389,   793,   249,   275,   764,
      44,   505,   832,    21,    33,    54,    67,    76,    97,   103,
     118,   129,   137,   148,   155,   159,   213,   251,   254,   306,
     312,   321,   349,   350,   352,   353,   361,   366,   372,   375,
     378,   515,   556,   648,   699,   710,    22,   274,   974,   828,
      22,   269,   350,   352,     5,   198,   737,   738,   983,    21,
      33,    54,    67,    80,    97,   118,   129,   137,   148,   153,
     159,   174,   220,   251,   261,   306,   310,   312,   318,   321,
     347,   349,   353,   361,   366,   378,   391,   573,   661,   764,
     974,    83,   389,   431,   551,   554,   557,   792,   798,   806,
     809,   814,   820,   827,   831,     9,    15,    22,    39,   143,
     149,   151,   171,   200,   232,   277,   293,   422,   423,   675,
     676,   828,   982,   986,    22,    83,   290,   317,   680,   681,
     682,   987,   987,   979,   983,   347,   842,   675,   987,   359,
     974,   261,   220,    97,   174,   346,   347,   744,   311,   987,
      22,   322,   355,   359,   466,   987,    19,   156,   680,   681,
     275,   764,   987,   197,    22,   115,   844,    55,    77,   213,
     228,   306,   312,   322,   355,   359,   402,   464,   465,   466,
      22,   322,   355,   359,   466,   359,   250,   878,   972,   987,
     842,   424,   987,   152,   431,   794,   431,   968,   288,   837,
     838,   974,   832,   833,   836,     0,   434,   793,   130,   188,
     255,   371,   845,   846,   832,   834,   835,   108,   184,   377,
     435,     3,    38,    44,    67,    73,    84,    90,   150,   152,
     167,   180,   192,   193,   195,   207,   209,   230,   238,   257,
     258,   259,   305,   328,   389,   980,   987,   988,   991,   993,
     663,   987,   663,   975,   987,   278,   663,   361,   663,   974,
     987,    96,   347,   688,   980,     3,   984,   989,   991,   992,
     993,   166,   972,   244,   391,     8,    62,   141,   418,   419,
     420,   422,   423,   424,   425,   426,   427,   735,   935,   936,
     987,    22,   984,   974,   974,   166,   972,   974,   166,   878,
     974,   314,   974,   663,   218,   984,   166,   972,   198,   105,
     194,   235,   284,   765,   766,   767,   972,   978,   987,    21,
      54,    67,    68,    76,    80,    97,   118,   129,   137,   148,
     153,   174,   199,   220,   251,   306,   310,   312,   318,   321,
     347,   349,   353,   361,   366,   391,   573,   668,   983,   972,
     357,   980,   974,   431,   663,   361,   975,   663,   361,   166,
     974,    96,   347,   350,   352,   984,   350,   352,    62,   141,
     735,   297,   984,   166,   460,   987,   974,   974,   314,   974,
     663,   218,   984,   288,   318,   347,   391,   220,    80,   174,
     153,   310,   365,   567,    22,   974,   829,   473,   983,   989,
     738,   166,   980,   974,   166,   742,   166,   975,   361,    96,
     347,   166,   980,   166,   984,   985,    73,   391,    62,   141,
     166,   735,    48,   166,   985,   166,   974,   166,   974,   166,
     974,   314,   166,   974,   166,   218,   985,   198,   166,   662,
     663,   431,   807,   515,   798,   385,   792,   799,   800,   801,
     989,   793,   986,   676,   677,    22,   677,   986,   677,    22,
     677,   986,   677,   677,   677,   986,   982,   982,   828,   677,
     278,   431,   431,   534,   534,   534,   249,   357,   435,   534,
     878,   879,   435,   760,   983,   431,   804,    48,   391,   974,
     974,   972,   987,    38,   414,   194,   433,   252,   252,   249,
     151,   983,   357,   146,   671,   249,     4,     6,     7,     8,
      10,    30,    43,    45,    46,    53,    54,    57,    58,    65,
      67,    87,    88,    89,    90,    91,    92,    93,   100,   101,
     119,   135,   139,   140,   144,   158,   186,   187,   189,   206,
     214,   215,   229,   231,   235,   240,   241,   243,   251,   260,
     270,   285,   308,   323,   330,   343,   355,   356,   360,   362,
     363,   372,   378,   386,   404,   405,   406,   407,   408,   409,
     410,   411,   422,   423,   424,   431,   832,   890,   893,   896,
     897,   898,   900,   901,   902,   903,   906,   907,   911,   913,
     914,   933,   937,   956,   961,   969,   970,   980,   981,   982,
     983,   987,   983,    22,   479,   971,   972,   322,   464,   103,
     472,   983,   473,   983,    38,    59,   464,   414,   331,   766,
     252,   151,   357,   418,    38,   414,   194,   767,   431,   972,
     424,   429,   433,   962,   963,   879,   150,   152,   389,   789,
     790,   792,   150,   795,   103,   911,   966,   967,   837,   435,
     431,   796,   432,   432,   440,   972,    22,   115,   843,   843,
      48,   843,   142,   146,   210,   247,   849,   851,   852,   861,
     863,   864,   865,   845,   846,   151,   190,   878,   880,   968,
     431,   637,   963,   262,   295,   324,   433,   664,   262,   295,
     324,   262,   295,   324,   397,   442,   474,   475,   694,    18,
     120,   262,   295,   324,   382,   486,   974,   324,    18,   120,
     377,   457,   400,   166,   878,    50,    82,   138,   169,   205,
     235,   262,   295,   303,   309,   316,   324,   333,   341,   392,
     474,   476,   722,   729,   431,   711,   295,   457,   135,    18,
      24,    64,   113,   120,   123,   176,   233,   235,   245,   253,
     262,   295,   299,   324,   382,   484,   485,   592,     4,   423,
     564,   986,   166,   972,   663,   663,   431,   734,   433,   171,
     449,   295,   442,   449,   249,   262,   295,   135,    49,    95,
     173,   221,   223,   233,   261,   295,   300,   324,   335,   484,
     561,   562,   262,   295,   390,   592,   600,   135,   295,   324,
     484,   262,   295,   299,   324,    74,   112,   263,   351,   249,
      18,    24,   120,   262,   295,   324,   495,   496,   146,   295,
     324,   442,   475,   135,   295,   324,   484,   974,   208,   105,
     250,   401,   435,   765,   379,   787,   249,   980,   431,   974,
     361,    96,   347,   980,   244,   391,    62,   141,   735,   974,
     314,   974,   198,   663,   534,   281,   500,   431,   637,   638,
      60,     3,    43,    45,    46,    57,    58,   100,   101,   144,
     186,   187,   189,   229,   231,   243,   285,   325,   330,   355,
     356,   386,   887,   889,   891,   893,   895,   897,   898,   899,
     901,   902,   906,   907,   988,   991,   151,   431,   633,   974,
     442,    31,   782,   974,   235,   442,   400,   166,   972,   442,
     663,   663,   633,   375,   515,   442,   235,    38,   461,   366,
     599,   262,   575,    74,   112,   263,   351,    20,    40,   185,
     611,    31,   633,   146,   442,   391,   972,   166,   552,   972,
     972,   391,   663,    73,   700,   980,   974,   573,    44,    94,
     183,   233,   313,   135,   637,    51,   301,   487,   135,   431,
     135,   400,   135,   711,   135,   435,   166,   662,   166,   663,
     166,   663,   135,   734,   985,   135,   135,   249,   135,   487,
     135,    74,   112,   263,   351,   135,   249,   135,   146,   166,
     166,   473,   135,   435,   487,   911,   940,   347,   432,   435,
     140,   249,   363,   470,   473,   564,   802,   798,   677,   828,
     677,   828,   677,   828,   677,   828,   677,   828,   828,   828,
     677,   828,   431,   535,   536,   987,   535,    22,    97,   118,
     148,   153,   198,   199,   312,   318,   347,   349,   366,   683,
     971,   985,   682,   171,   435,   817,   983,   887,   943,    31,
     985,   972,   147,   745,   745,   745,   208,   987,   146,   146,
     683,   985,   311,   987,   473,   249,   431,   964,   429,   832,
     944,   388,   904,   911,   960,   431,   904,   904,   431,   146,
     431,   431,   431,   892,   892,   272,   832,   431,   431,   894,
     431,   431,   431,   431,    57,    58,   904,   911,   431,   892,
     431,   431,   431,   431,   431,   398,   417,   431,   908,   431,
     908,   431,   431,   832,   431,   431,   431,   431,   431,   431,
     431,   431,   911,   911,   832,   911,   940,   963,   983,    58,
     431,   905,   431,   983,     3,     8,    11,    28,    31,    36,
      42,    66,   167,   171,   192,   193,   209,   235,   238,   251,
     254,   328,   418,   419,   420,   422,   423,   424,   425,   426,
     427,   935,   937,   939,   259,   911,   190,   435,   840,   431,
     983,   963,   106,   168,   480,   435,    59,   103,   473,    31,
       3,   103,   213,   471,   564,   907,   983,   983,    78,   117,
     920,    86,   103,   467,   468,   470,   564,   103,   467,   208,
     972,   911,     3,    22,    26,    27,    28,    29,    30,    31,
      32,    35,    47,    53,    54,    60,    66,    68,    76,    83,
      87,    88,    89,    91,    92,    93,   103,   105,   111,   115,
     116,   122,   126,   130,   140,   142,   146,   148,   151,   156,
     159,   161,   171,   178,   188,   190,   201,   204,   210,   214,
     215,   235,   240,   247,   249,   250,   254,   255,   268,   276,
     290,   302,   317,   323,   332,   344,   347,   354,   357,   358,
     363,   371,   372,   378,   379,   387,   393,   394,   396,   397,
     424,   977,   990,   991,   992,   993,   994,   962,    79,   300,
     666,   432,   435,   793,   432,   435,   838,   973,   974,    31,
     796,   834,   834,   847,   848,   911,   834,   143,   232,   858,
     196,   233,   284,   326,   377,    22,   853,   911,   854,   856,
     911,   913,   861,   862,   852,   851,   849,   850,   146,   864,
     245,   866,   849,   861,   880,   972,    31,   987,   324,   424,
     943,   262,   295,   324,   357,   357,   312,   977,   433,   357,
     357,   312,   357,   357,   349,   464,   777,   146,   156,   171,
     304,   695,   696,    60,    76,   131,   148,   276,   372,   531,
     532,    76,   103,   235,   357,    76,   357,   103,   235,   312,
      76,   113,   123,   262,   295,   629,   312,   581,    21,    54,
      67,    80,   118,   129,   148,   153,   220,   251,   312,   318,
     321,   347,   353,   366,   391,   573,   974,   135,   295,   324,
     484,   249,   564,   316,   205,   357,   357,   240,   564,   107,
     191,   312,   322,   359,   465,   301,   324,   722,   730,   171,
     181,   256,   325,   387,   432,   712,   715,   716,   717,   719,
     887,   988,   357,   378,   972,    68,   131,   522,   531,   987,
      68,   747,   249,   310,   361,    76,   747,    25,   298,   310,
     361,   972,   176,   245,   663,   431,   357,   357,   431,   490,
     349,   397,   398,   490,    76,   435,     4,   262,   135,   295,
     324,   484,   379,   379,   234,   887,   262,   324,   735,    97,
     475,   357,   444,   475,   972,   357,   357,   972,   564,    48,
     563,   564,   564,    95,   221,   223,    48,   357,   442,   312,
     442,   233,   562,   357,   357,   240,   983,   592,   878,    76,
     357,   747,   312,   357,   357,   490,   490,   663,   663,   663,
     663,   972,    37,   384,    37,    37,   357,    37,   357,   312,
     435,    93,   378,   607,   984,   357,   444,   972,   357,   312,
     262,   295,   284,   296,   320,   469,   765,   978,   987,   972,
     637,   887,   249,   400,   711,   564,   663,   663,   734,   192,
     249,    74,   112,   263,   351,   249,   663,   192,   397,   506,
     338,   339,   501,   983,     3,   639,   640,   633,   431,   889,
      31,    30,   888,    98,   164,   222,   225,   315,   412,   431,
     909,   910,   664,   892,   663,   634,   635,   990,    20,   772,
     887,   249,   135,   578,   974,   235,   431,   443,   648,   379,
     288,   391,   443,   135,   984,    83,   156,   462,   514,   558,
     610,   678,   698,   768,   983,   600,   601,   974,   216,   663,
     663,   663,   663,   245,   108,   184,   364,   377,   612,   613,
     127,   283,   431,   607,   443,   972,   560,   561,   235,    31,
     245,   431,   534,   534,   555,   972,   146,   701,   978,   431,
     713,    31,   198,   397,   398,   830,   313,   980,   487,   887,
     975,   166,   974,   980,   487,   985,   984,   135,   487,   135,
     379,   135,   379,   735,   487,   487,   985,   974,   663,   974,
     974,   974,   663,   985,   607,   135,   135,   487,   662,   663,
     432,   435,   972,   798,   800,   828,   828,   828,   828,   828,
     828,   535,   432,   435,   432,   154,   319,   348,   973,   662,
      96,   321,   687,   688,   973,   244,   973,   971,   971,   973,
     662,   357,   397,   691,    16,   133,   308,   326,   818,   878,
     239,   819,   432,   435,   805,   809,   814,   820,   831,   357,
     397,   553,   681,   680,   681,   151,   157,   692,   987,    21,
      68,    97,   118,   129,   148,   153,   199,   220,   306,   312,
     318,   347,   349,   366,   391,   573,   672,   940,   962,   430,
     940,   944,   945,   431,   393,   957,   958,   911,   940,   431,
     982,   982,   940,     3,    98,   164,   222,   225,   315,   412,
     946,   947,   983,   982,   940,   940,   982,   982,   904,   904,
     911,   735,   911,   948,   422,   423,   912,   913,   933,   937,
     950,   432,   940,   911,   940,   951,   355,   414,   982,   982,
     911,    47,   151,   204,   358,   911,   940,   954,   940,   227,
     913,   911,   918,   919,   920,   227,   911,   920,   432,   435,
     324,   982,   982,   909,   887,   911,   990,   355,    35,   344,
     965,   663,   911,   431,   832,   955,   115,   117,   140,   235,
     240,   245,   363,   373,   911,    42,   167,   171,   209,   328,
     431,   911,   357,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,    22,    29,   332,   934,   308,   431,   933,
     155,   213,   347,   350,   352,   375,   841,   972,   970,   151,
     868,    22,   115,   387,   424,   432,   717,   911,   941,   942,
     988,   972,   359,   431,   983,   435,   432,   430,   436,   165,
     165,   487,   972,   790,   791,   972,   966,   432,   435,   431,
     435,    32,   111,   379,   707,   431,   855,   986,   326,   196,
     250,   435,   308,   309,   857,   971,   819,   862,   850,   379,
     815,   103,   431,   810,   831,   987,   431,   821,   822,   823,
     824,   825,   987,   432,   432,   357,   357,   312,   984,   974,
     974,   977,   984,   974,   974,   984,   975,   974,    75,   778,
     306,   378,   680,   312,   156,   680,   431,   974,   379,   702,
     196,   196,   379,   431,   550,   166,   974,   240,   984,   974,
     974,   911,   240,   974,   974,    25,   298,   357,   357,   974,
     357,   582,   980,   431,   663,   663,   663,   361,    96,   347,
     688,   391,    62,   141,   735,   974,   663,   974,   663,   314,
     663,   663,   198,   160,   233,   262,   295,   383,   585,   586,
     587,   878,   357,   747,   312,   240,   107,   191,   984,   974,
     249,   974,   256,   988,   432,   435,   717,   719,   716,   719,
     988,   664,   984,   985,   295,   484,   522,   887,   987,   974,
     974,    22,   378,   974,   166,   974,   166,   987,   310,   361,
     310,   361,   974,    22,   378,   974,   972,    18,   120,   324,
     593,   594,   595,   596,   990,   984,   974,   492,   493,   990,
     974,   248,    64,   248,   974,   485,   357,   972,   357,   747,
     312,   976,   987,   976,   435,   432,   435,   357,   312,   975,
     984,     3,    75,   125,   176,   267,   370,   378,   381,   445,
     295,   984,   974,   295,   324,   484,   561,   564,   663,   974,
     564,   974,   564,   984,   974,   295,   324,   484,   974,   974,
     974,   974,   984,   974,    18,    24,   120,   262,   295,   324,
     262,   295,   324,   633,   295,   324,   295,   324,   295,   886,
     987,   166,   644,   987,   166,   987,   984,   974,   974,   974,
      18,   496,   321,   984,   295,   324,   484,   974,   974,   357,
     357,    72,   369,   284,   192,    31,   663,   192,   192,   379,
     379,   192,   240,   669,   983,   663,   663,   192,   669,   248,
     151,   357,   499,   442,   418,   432,   435,   911,    30,   888,
     887,   429,   429,   357,   357,   357,   431,   357,   982,   892,
     432,   435,   418,   612,    75,   124,   202,   203,   216,   262,
     349,   351,   773,   524,   990,   974,   151,   312,   390,   579,
     586,   587,   135,   209,   516,   518,   520,   522,   528,   531,
      19,   171,   306,   345,   445,   446,   146,   976,   391,   972,
     460,   987,   461,   254,   515,   148,   983,   633,   633,   633,
     633,   245,   249,   254,   431,   633,   884,   885,   886,   321,
     431,   135,   134,   831,   663,   516,   987,   397,   398,   546,
     397,   491,    31,   534,   983,   249,   432,   714,   715,   720,
      31,   198,   303,   396,   721,   722,   723,   249,   473,   163,
     163,   146,   637,    31,   135,   487,   711,   662,   663,   976,
     663,   976,   734,   249,   487,   487,   249,   487,   321,   146,
     473,   487,   911,   432,   536,   171,   171,   171,   400,   973,
     435,   564,   565,   159,   684,   685,   984,    19,   692,   133,
     326,   133,   326,   308,   377,   224,   887,   974,    96,   233,
     151,   249,   684,    48,   487,   980,   361,   347,   980,   244,
     391,   198,   663,   432,   430,   430,   435,   940,   911,   122,
     958,   959,    31,   432,   911,   432,   432,   432,   432,   151,
     432,   432,   432,   432,   432,   435,   432,   268,   949,   432,
     912,   912,    11,   171,   192,   251,   418,   419,   420,   422,
     423,   424,   425,   426,   427,   937,   912,   432,   432,   146,
     151,   952,   953,   432,   414,   432,   432,    31,   954,   940,
     954,   954,   151,   432,   432,   990,   266,   922,    31,   432,
     435,   911,   990,   435,   911,   964,   911,   987,   432,   432,
     414,   912,   912,   128,   940,   151,   115,   117,   140,   240,
     245,   363,   373,   431,   128,   344,   965,   911,   955,   911,
     357,   735,   911,   431,   832,   350,   352,   350,   352,   972,
     842,   842,   842,   201,   431,   832,   869,   870,   871,   878,
     881,   914,   980,   987,   394,   882,   941,   941,   942,   432,
     258,   926,    13,   432,   435,   846,   766,   982,   909,   468,
     911,   796,   974,   805,   848,   251,   935,   938,   415,   416,
     708,   911,   857,   377,   854,   869,   394,   883,   385,   811,
     812,   987,   302,   813,   825,   826,   435,   868,   418,   964,
     984,   974,   974,   210,   985,   985,   249,   973,   252,   249,
     911,   532,   976,   431,   431,   431,   550,   174,   535,   621,
     135,   487,   357,   984,   974,   473,   637,   887,   974,   400,
     663,   663,   663,   663,   734,    74,   112,   263,   351,   974,
     568,   974,   160,   383,   357,   357,   568,   585,   592,   295,
     324,   484,   974,   974,   974,   182,   240,   664,   715,   719,
     719,   426,   357,   253,   590,   120,   299,   324,   486,   592,
     748,   135,   487,   135,   487,   974,   974,   974,   974,   595,
     596,   595,   432,   435,   597,   983,   432,   435,   418,   433,
     984,   295,   324,   484,   974,   974,   974,   262,   295,   324,
      18,   120,   262,   295,   324,   887,   234,   887,   984,   974,
     210,   267,   240,   983,   267,   985,   376,   357,   357,   312,
     357,   747,   312,   357,   357,   218,   218,   218,   357,   357,
     312,   357,   357,   312,   357,   312,   357,   312,   357,   487,
     887,   235,   983,   324,   748,   135,   487,   357,   974,   357,
     312,   984,   974,   669,   887,   192,   669,   669,   976,   976,
     669,   192,   192,   669,   500,   431,   502,   503,   251,   422,
     423,   564,   636,   719,   938,   983,   994,     3,   640,   432,
     429,   432,   982,   430,   982,   164,   222,   910,   222,   910,
     910,   982,   225,   432,   635,   636,   249,   210,   418,   774,
     774,   774,   774,   774,   774,   774,    60,    66,    76,   103,
     105,   178,   235,   240,   276,   290,   372,   525,   526,   527,
     134,   393,   442,   473,   974,   473,   590,   972,   972,   432,
     435,   985,   159,   306,   985,   982,   366,   972,   534,    38,
     461,   297,   347,    96,   535,   972,   613,   641,   642,   983,
     432,   435,   974,   535,   972,   974,   553,   431,   517,   432,
     248,   490,   248,   249,   547,   490,    31,   831,   491,   357,
     972,   432,   435,   103,   418,   724,   983,   473,   347,   718,
     719,   397,   723,   725,   108,   184,   317,   377,   756,   160,
     831,   487,   887,   974,   487,   487,   379,   487,   379,   487,
     487,   663,   663,   974,   607,   487,   312,   312,   312,   973,
     688,   435,   984,   397,   435,   686,   252,   133,   133,    96,
     985,   683,   487,   984,   637,   711,   564,   663,   192,   944,
     432,   354,   911,   126,   887,   432,   911,   911,   911,   952,
     887,   912,   115,   117,   235,   245,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   911,   911,   953,   952,
     908,   908,   887,   432,   432,   432,   940,   432,   435,    48,
     913,   432,   990,   919,   273,   342,   921,   432,   435,   390,
     915,    31,   432,   905,   983,   911,    28,    28,   911,   432,
     911,   151,   431,   943,   911,   912,   912,   128,   128,   911,
     432,   128,   911,   842,   842,   842,   842,   972,   972,   972,
     832,   881,   832,   870,   871,    31,   872,   873,   987,   435,
      84,   152,   180,   195,   207,   230,   305,   875,   873,    31,
     872,   874,   987,   431,   963,   911,   159,   859,   435,   845,
     846,   845,   432,   926,   431,   927,   987,   911,   926,   983,
     387,   942,   432,   432,   430,   432,   431,   708,   432,   250,
      86,   911,   813,   432,   435,   964,   969,   432,   435,   822,
     883,   966,   774,   154,   319,   348,   367,   697,   146,   697,
     432,   431,   538,   539,   704,   914,   987,   535,   535,   621,
     978,   432,   105,   178,   233,   235,   622,   974,   974,    31,
     974,   379,   379,   663,   663,   663,   663,   664,   984,   974,
     357,   747,   312,   357,   182,   426,   366,   974,   431,   524,
     235,   490,    96,   235,   337,   340,   490,   366,   974,   987,
     594,   493,   636,   990,   357,   747,   312,   357,   357,   357,
     312,   153,   251,   340,   646,   647,   153,   251,   654,   655,
     357,   357,   312,   432,   432,   432,   986,   983,   983,   983,
     974,   974,   974,   974,   974,   974,   974,   974,   146,   146,
     297,   146,   166,   984,   974,   974,   984,   974,   974,   974,
     974,   974,   974,   974,    66,   488,   135,    20,    40,   366,
     987,   974,   592,   974,   974,   432,   669,   192,   192,   669,
     669,   501,   509,   510,   990,    44,    85,   109,   124,   128,
     147,   150,   162,   240,   248,   282,   504,   621,   982,   397,
     398,   430,   430,   432,   909,   972,   774,   103,   982,   983,
     103,   983,   103,   983,   103,   983,   103,   974,   103,   974,
     103,   974,   431,   663,   974,   912,   106,   168,   105,   240,
     196,   972,   725,   280,   625,   626,   987,   578,   431,   529,
     321,   520,   985,   985,   887,   431,   491,   984,   972,   400,
     146,   614,   432,   435,   886,   590,   432,   245,   431,   807,
     519,   521,   523,   531,   987,   546,   177,   545,    71,   349,
     548,   831,   553,   548,   983,   702,   720,   911,   911,   435,
     431,   721,   633,   357,   568,   432,   487,   976,   976,   487,
     487,   321,   973,   973,   973,   564,   156,   685,   692,   151,
     192,   192,   192,   192,   240,   673,   983,   911,   432,   432,
     953,   151,   115,   117,   245,   431,   432,   403,   917,   940,
     289,    48,   395,   395,   432,   911,   233,   911,   435,   916,
     889,   909,   912,   912,   911,   943,   432,    28,    28,   911,
     911,   128,   911,   432,   972,   972,   972,   972,   873,   874,
     432,   987,   431,   870,   195,   257,   876,   870,   876,   195,
     875,   876,   195,   431,   987,   431,   941,    48,   161,   860,
     432,   432,   926,   928,   987,   942,   926,   983,   735,   245,
     831,   812,   418,   825,   813,   986,   357,   680,   151,   621,
     911,   432,   435,   397,    66,   705,   705,   432,   432,   725,
     106,   168,   176,   105,   381,   487,   887,   976,   976,   974,
     974,   974,   974,   366,   591,   595,   240,   240,   986,   987,
     887,   487,   487,   418,   974,   974,   974,   974,   984,   974,
     974,   982,   982,   887,   435,   982,   982,   435,   984,   974,
     974,   357,   973,   973,   663,   973,   135,   663,   983,   983,
     887,   487,   487,   192,   669,   669,   379,   507,   508,   432,
     435,   424,   431,   470,   511,   564,   782,   983,   782,   235,
     282,   782,   782,   430,   153,   181,   153,   151,   620,   986,
     911,   235,   526,   725,   534,   379,   549,   980,    28,   134,
     171,   516,   132,   172,   974,   379,   535,    31,   461,   431,
     974,   121,   615,   393,   617,   983,   491,   663,   516,   553,
     432,   435,   397,   547,   431,   546,   108,   120,   273,   974,
     397,   769,   151,   431,   983,   717,   726,   727,   988,   725,
     972,   179,   569,   487,   487,   487,   974,   252,   487,   684,
     673,   673,   673,   673,   912,   151,   431,   943,   431,   432,
     435,   432,   913,   289,   432,   384,   334,   432,   432,   432,
     912,   912,   911,   872,   431,   973,   870,   249,   379,   877,
     870,   195,   870,   885,   431,   885,   987,   432,   940,   911,
     396,   923,   926,   926,   265,   929,   432,   909,   432,   828,
     968,   684,   249,   684,   432,   725,   539,   251,   735,   663,
     379,   663,   706,   706,   290,   725,   549,   432,   357,   432,
     435,   488,   636,   357,   431,   980,   735,   647,   431,   431,
     655,   974,   397,   297,   397,   397,   146,   488,   669,   442,
     110,   510,   470,   512,   513,   983,   983,   240,   424,   535,
     983,   983,   688,    31,   740,   740,   972,   621,   432,   549,
     219,   537,   174,   431,   626,   280,   431,   432,    22,    70,
      77,   104,   175,   340,   530,   530,   590,   976,   432,   831,
     590,   308,   336,   616,   431,   134,    31,   517,   432,   521,
     253,   548,   971,   547,   309,   309,    52,    60,   213,   663,
     703,   704,   719,   432,   435,   882,   568,   233,   383,   570,
     571,   487,   912,   943,   432,   918,   940,    48,   233,   413,
     973,   432,   911,   431,   870,   877,   432,   885,   432,   924,
     925,   987,    48,   845,   926,   686,   697,   487,   705,   549,
     431,   663,   707,   707,   972,   549,   621,   974,   595,   379,
     489,   974,   943,   711,   146,   650,   734,   943,   943,   662,
     663,   662,   663,   973,   487,   502,   983,   432,   435,   535,
     740,    34,   170,   146,   233,   533,   152,   264,   329,   249,
     541,   542,   543,   349,   432,   980,     5,   627,   321,   141,
     649,   491,   769,   911,   280,   831,   546,   545,   524,   432,
     548,    60,   252,    60,   432,   435,   721,   726,   116,   383,
     568,   432,   432,   432,   289,   384,   432,   973,   432,   435,
      31,   940,   283,   309,   930,   151,   706,   394,   540,   735,
     708,   708,   534,   621,   911,   432,   255,   314,   287,   651,
     650,   432,   432,   397,   513,   121,   176,   108,   377,   249,
     543,   249,   542,   974,   431,   432,   435,   974,   663,    31,
      31,   432,   980,   547,   546,   252,   252,   491,   704,   725,
      23,   185,   757,   432,   925,   927,    42,    86,   368,   911,
     931,   932,   931,   432,   684,   707,   431,   621,   432,   537,
     980,    48,   651,   663,   308,    51,   233,   301,   324,   544,
     544,   432,     5,   590,   646,   831,   431,   548,   547,   548,
     236,   431,   752,   754,   759,   809,   814,   820,   831,   932,
     308,   145,   271,   145,   271,   487,   708,   911,   541,   711,
     663,   617,    17,   103,   240,     4,   618,   619,   982,   983,
     990,   548,   882,   753,   754,   755,   832,   833,    28,   432,
     621,   134,   432,   435,   432,   434,   932,   280,   619,   755,
     980,   431,   618,   432
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (core_yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 681 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 688 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 695 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 819 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 830 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 840 "gram.y"
    {}
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 841 "gram.y"
    {}
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 850 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 851 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 855 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 856 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 861 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 866 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 870 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 875 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 880 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 884 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 888 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 893 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 897 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 950 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 953 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 957 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 961 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 965 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 969 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 983 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 1001 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 1011 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1012 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1017 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1025 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1043 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1055 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1076 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 1083 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1102 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1109 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1126 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1144 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1154 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 1155 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1168 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1175 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1192 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1205 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1215 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(6) - (9)].str) != NULL)
						n->schemaname = (yyvsp[(6) - (9)].str);
					else
						n->schemaname = (yyvsp[(8) - (9)].str);
					n->authid = (yyvsp[(8) - (9)].str);
					if ((yyvsp[(9) - (9)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(9) - (9)]))));
					n->schemaElts = (yyvsp[(9) - (9)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1233 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(6) - (7)].str);
					n->authid = NULL;
					if ((yyvsp[(7) - (7)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(7) - (7)]))));
					n->schemaElts = (yyvsp[(7) - (7)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1250 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1251 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1256 "gram.y"
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[(2) - (2)]);
					(yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node));
				}
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1262 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1290 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1296 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1302 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1311 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1319 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1331 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1339 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1347 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1354 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1361 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1369 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1380 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1388 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1396 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1407 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1415 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1423 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1430 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1439 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1448 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1450 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				}
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1456 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1457 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1461 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1463 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1466 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1467 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1468 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1469 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1473 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1474 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1475 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1481 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1494 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1498 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1502 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1517 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1539 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1540 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1541 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1545 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1546 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1547 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1551 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1552 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1557 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1564 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1571 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1578 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1585 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1594 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1595 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1600 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1601 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1607 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1613 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1619 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1625 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1631 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1641 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1650 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1651 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1655 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1656 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1665 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1680 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1686 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1692 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1698 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1716 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1725 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1734 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1743 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1761 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1770 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1779 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1788 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1797 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1808 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1809 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1815 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1823 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1831 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1840 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1848 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1856 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1865 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1874 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1883 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1892 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1902 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1915 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1929 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1938 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1946 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1954 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1964 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1974 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1981 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1988 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1996 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 2004 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 2012 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 2020 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 2028 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 2035 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 2042 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 2050 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 2057 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 2064 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 2072 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 2080 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 2088 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 2096 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 2104 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 2112 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 2122 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 2129 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 2137 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 2145 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 2153 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 2160 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 2169 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 2170 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 2174 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 2175 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 2176 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 2181 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 2188 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 2192 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 2193 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 2197 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 2200 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 2201 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 2205 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 2206 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 2212 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 2216 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 2220 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 2225 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 2240 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 2252 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 2253 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 2259 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 2268 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 2278 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 2288 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 2313 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 2319 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 2350 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (11)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (11)].list);
					n->is_from = (yyvsp[(6) - (11)].boolean);
					n->is_program = (yyvsp[(7) - (11)].boolean);
					n->filename = (yyvsp[(8) - (11)].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(8) - (11)]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (11)].defelt));
					if ((yyvsp[(5) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (11)].defelt));
					if ((yyvsp[(9) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(9) - (11)].defelt));
					if ((yyvsp[(11) - (11)].list))
						n->options = list_concat(n->options, (yyvsp[(11) - (11)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 2378 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (7)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[(4) - (7)].boolean);
					n->filename = (yyvsp[(5) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(5) - (7)]))));

					(yyval.node) = (Node *)n;
				}
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 2399 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 2400 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 2404 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 2405 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 2414 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 2415 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 2416 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 2419 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 2420 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 2425 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 2426 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 2431 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 2435 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 2439 "gram.y"
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 2443 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 2447 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 2451 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 2455 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 2459 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 2463 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 2467 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 2471 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 2475 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 2479 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 2488 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 2491 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 2496 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 2499 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 2504 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 2511 "gram.y"
    {}
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 2512 "gram.y"
    {}
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 2518 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 2522 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 2529 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 2535 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 2536 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 2537 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 2538 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 2539 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 2544 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 2548 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 2555 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 2568 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 2584 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 2599 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 2615 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 2642 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 2643 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 2644 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 2645 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 2647 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 2654 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 2661 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 2665 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 2666 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 2670 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 2671 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 2676 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 2680 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 2687 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 2691 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 2697 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 2698 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 2699 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 2703 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 2704 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 2708 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 2728 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 2747 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 2748 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 2753 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 2760 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 2761 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 2763 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 2794 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 2801 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 2808 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 2819 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 2830 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 2840 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 2849 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 2882 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 2889 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 2896 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 2903 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 2914 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 2923 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 2924 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 2925 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 2929 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 2930 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 2931 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 2932 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 2933 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 2934 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 2944 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 2951 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 2956 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 2970 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 2984 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 2999 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 3013 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 3029 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 3046 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 3065 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 3066 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 3070 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 3071 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 3075 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 3076 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 3080 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 3086 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 3090 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 3098 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 3102 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 3108 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 3110 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 3114 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 3119 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 3125 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 3126 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 3137 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 3139 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 3141 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 3143 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 3145 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 3148 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 3151 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 3155 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 3156 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 3157 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 3158 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 3159 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 3162 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 3163 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 3168 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 3169 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 3170 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 3171 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 3174 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 3175 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 3176 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 3177 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 3180 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 3181 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 3184 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 3185 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 3188 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 3204 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 3219 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 3232 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 3233 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 3234 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 3247 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(7) - (8)].node);
					ctas->into = (yyvsp[(5) - (8)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(5) - (8)].into)->rel->relpersistence = (yyvsp[(2) - (8)].ival);
					(yyvsp[(5) - (8)].into)->skipData = !((yyvsp[(8) - (8)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 3262 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (4)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (4)].list);
					(yyval.into)->options = (yyvsp[(3) - (4)].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[(4) - (4)].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 3274 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 3275 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 3288 "gram.y"
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->skipData = !((yyvsp[(5) - (5)].boolean));
					(yyval.node) = (Node *) n;
				}
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 3307 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 3319 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 3327 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 3337 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 3338 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 3341 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 3342 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 3346 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 3350 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 3354 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 3358 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 3362 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 3366 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 3370 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 3374 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 3378 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 3382 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 3386 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 3390 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 3395 "gram.y"
    {}
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 3396 "gram.y"
    {}
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 3400 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 3402 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 3406 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 3409 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 3410 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 3423 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 3436 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 3449 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 3450 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 3458 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 3459 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 3463 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 3464 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 3468 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 3469 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 3473 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 3474 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 3479 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 3490 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 3502 "gram.y"
    {}
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 3503 "gram.y"
    {}
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 3514 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 3523 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 3524 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 3538 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 3545 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 3562 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 3570 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 3581 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 3583 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 3588 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 3592 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 3596 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 3608 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 3618 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 3620 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 3625 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 3638 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 3648 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 3658 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 3667 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 3676 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 3685 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 3695 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 3704 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 3714 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 3724 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 3734 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 3743 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 3752 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 3761 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 3770 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 3779 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 3788 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 3797 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 3806 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 3815 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 3824 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 3833 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 3842 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 3851 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 3869 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 3879 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 3880 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 3881 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 3882 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 3886 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 3887 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 3891 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 3892 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 3903 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 3914 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 3934 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 3942 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 582:

/* Line 1806 of yacc.c  */
#line 3953 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 3954 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 3959 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 3963 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 3970 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 3975 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 3979 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 3986 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 3990 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 3995 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 4000 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 4007 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 4013 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 4018 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 4030 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 4042 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 4043 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 4049 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 4054 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 4065 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 4076 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 4096 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 606:

/* Line 1806 of yacc.c  */
#line 4105 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 4113 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 4132 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (10)].range);
					n->base.tableElts = (yyvsp[(6) - (10)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 4147 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (13)].range);
					n->base.tableElts = (yyvsp[(9) - (13)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(12) - (13)].str);
					n->options = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 4170 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 4179 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 612:

/* Line 1806 of yacc.c  */
#line 4197 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 613:

/* Line 1806 of yacc.c  */
#line 4208 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 4209 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 4210 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); }
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 4221 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 4229 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 4246 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 4267 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 4288 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 4309 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 622:

/* Line 1806 of yacc.c  */
#line 4310 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 623:

/* Line 1806 of yacc.c  */
#line 4311 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 624:

/* Line 1806 of yacc.c  */
#line 4316 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 625:

/* Line 1806 of yacc.c  */
#line 4318 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 4340 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 4342 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 4344 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 4346 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 4348 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 4353 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 4357 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 4367 "gram.y"
    {}
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 4368 "gram.y"
    {}
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 4372 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 636:

/* Line 1806 of yacc.c  */
#line 4373 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 637:

/* Line 1806 of yacc.c  */
#line 4377 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 638:

/* Line 1806 of yacc.c  */
#line 4378 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 639:

/* Line 1806 of yacc.c  */
#line 4382 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 4383 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 641:

/* Line 1806 of yacc.c  */
#line 4384 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 4389 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 4394 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 4395 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 4396 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 4400 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 647:

/* Line 1806 of yacc.c  */
#line 4401 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 4406 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 4408 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 4434 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 4435 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 4436 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 4437 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 4438 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 4439 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 4445 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 4456 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 4480 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (11)].str);
					n->eventname = (yyvsp[(6) - (11)].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 4491 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (13)].str);
					n->eventname = (yyvsp[(6) - (13)].str);
					n->whenclause = (yyvsp[(8) - (13)].list);
					n->funcname = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 4503 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 4505 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 4510 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (5)].str), (Node *) (yyvsp[(4) - (5)].list)); }
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 4515 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 4517 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 4522 "gram.y"
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[(4) - (5)].str);
					n->tgenabled = (yyvsp[(5) - (5)].chr);
					(yyval.node) = (Node *) n;
				}
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 4531 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 4532 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 4533 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 4534 "gram.y"
    { (yyval.chr) = TRIGGER_DISABLED; }
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 4548 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 4567 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 4590 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 4600 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 4611 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 4621 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 4631 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 4642 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 4651 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 4658 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 4665 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 4674 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 4683 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 4692 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 4701 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 4710 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 686:

/* Line 1806 of yacc.c  */
#line 4720 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 687:

/* Line 1806 of yacc.c  */
#line 4723 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 4724 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 689:

/* Line 1806 of yacc.c  */
#line 4728 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 690:

/* Line 1806 of yacc.c  */
#line 4732 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 4738 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 4739 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 693:

/* Line 1806 of yacc.c  */
#line 4740 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 694:

/* Line 1806 of yacc.c  */
#line 4741 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 4742 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 4745 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 697:

/* Line 1806 of yacc.c  */
#line 4746 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 4749 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 4752 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 4753 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 701:

/* Line 1806 of yacc.c  */
#line 4762 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 702:

/* Line 1806 of yacc.c  */
#line 4768 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 4769 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 704:

/* Line 1806 of yacc.c  */
#line 4773 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 705:

/* Line 1806 of yacc.c  */
#line 4775 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 706:

/* Line 1806 of yacc.c  */
#line 4786 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (7)].list);
				n->newVal = (yyvsp[(7) - (7)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (7)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 707:

/* Line 1806 of yacc.c  */
#line 4796 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 708:

/* Line 1806 of yacc.c  */
#line 4806 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 709:

/* Line 1806 of yacc.c  */
#line 4817 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 710:

/* Line 1806 of yacc.c  */
#line 4818 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 711:

/* Line 1806 of yacc.c  */
#line 4836 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 712:

/* Line 1806 of yacc.c  */
#line 4849 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 713:

/* Line 1806 of yacc.c  */
#line 4850 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 714:

/* Line 1806 of yacc.c  */
#line 4855 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 715:

/* Line 1806 of yacc.c  */
#line 4866 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 716:

/* Line 1806 of yacc.c  */
#line 4876 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 717:

/* Line 1806 of yacc.c  */
#line 4885 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 718:

/* Line 1806 of yacc.c  */
#line 4895 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 719:

/* Line 1806 of yacc.c  */
#line 4903 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 720:

/* Line 1806 of yacc.c  */
#line 4904 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 721:

/* Line 1806 of yacc.c  */
#line 4907 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 722:

/* Line 1806 of yacc.c  */
#line 4908 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 723:

/* Line 1806 of yacc.c  */
#line 4911 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 4912 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 4913 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 726:

/* Line 1806 of yacc.c  */
#line 4917 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 727:

/* Line 1806 of yacc.c  */
#line 4930 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 728:

/* Line 1806 of yacc.c  */
#line 4936 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 729:

/* Line 1806 of yacc.c  */
#line 4946 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 730:

/* Line 1806 of yacc.c  */
#line 4955 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 731:

/* Line 1806 of yacc.c  */
#line 4966 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 732:

/* Line 1806 of yacc.c  */
#line 4967 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 733:

/* Line 1806 of yacc.c  */
#line 4972 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 734:

/* Line 1806 of yacc.c  */
#line 4980 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 735:

/* Line 1806 of yacc.c  */
#line 4992 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 736:

/* Line 1806 of yacc.c  */
#line 5003 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 737:

/* Line 1806 of yacc.c  */
#line 5017 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 5028 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 5051 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 5061 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 5079 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 742:

/* Line 1806 of yacc.c  */
#line 5090 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 743:

/* Line 1806 of yacc.c  */
#line 5101 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 744:

/* Line 1806 of yacc.c  */
#line 5112 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 745:

/* Line 1806 of yacc.c  */
#line 5125 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 746:

/* Line 1806 of yacc.c  */
#line 5126 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 747:

/* Line 1806 of yacc.c  */
#line 5127 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 748:

/* Line 1806 of yacc.c  */
#line 5128 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 749:

/* Line 1806 of yacc.c  */
#line 5129 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 750:

/* Line 1806 of yacc.c  */
#line 5130 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 751:

/* Line 1806 of yacc.c  */
#line 5131 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 752:

/* Line 1806 of yacc.c  */
#line 5132 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 753:

/* Line 1806 of yacc.c  */
#line 5133 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 754:

/* Line 1806 of yacc.c  */
#line 5134 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 755:

/* Line 1806 of yacc.c  */
#line 5135 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 756:

/* Line 1806 of yacc.c  */
#line 5136 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 757:

/* Line 1806 of yacc.c  */
#line 5137 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 758:

/* Line 1806 of yacc.c  */
#line 5138 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 759:

/* Line 1806 of yacc.c  */
#line 5139 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 760:

/* Line 1806 of yacc.c  */
#line 5140 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 761:

/* Line 1806 of yacc.c  */
#line 5141 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 762:

/* Line 1806 of yacc.c  */
#line 5145 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 763:

/* Line 1806 of yacc.c  */
#line 5146 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 764:

/* Line 1806 of yacc.c  */
#line 5149 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 765:

/* Line 1806 of yacc.c  */
#line 5150 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 766:

/* Line 1806 of yacc.c  */
#line 5154 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 767:

/* Line 1806 of yacc.c  */
#line 5156 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 768:

/* Line 1806 of yacc.c  */
#line 5169 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 769:

/* Line 1806 of yacc.c  */
#line 5179 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 770:

/* Line 1806 of yacc.c  */
#line 5180 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 771:

/* Line 1806 of yacc.c  */
#line 5181 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 772:

/* Line 1806 of yacc.c  */
#line 5214 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 773:

/* Line 1806 of yacc.c  */
#line 5223 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 774:

/* Line 1806 of yacc.c  */
#line 5232 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 775:

/* Line 1806 of yacc.c  */
#line 5241 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 776:

/* Line 1806 of yacc.c  */
#line 5250 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 777:

/* Line 1806 of yacc.c  */
#line 5259 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 778:

/* Line 1806 of yacc.c  */
#line 5268 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 779:

/* Line 1806 of yacc.c  */
#line 5278 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 780:

/* Line 1806 of yacc.c  */
#line 5287 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 781:

/* Line 1806 of yacc.c  */
#line 5296 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 782:

/* Line 1806 of yacc.c  */
#line 5305 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 783:

/* Line 1806 of yacc.c  */
#line 5314 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 784:

/* Line 1806 of yacc.c  */
#line 5323 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 785:

/* Line 1806 of yacc.c  */
#line 5334 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 786:

/* Line 1806 of yacc.c  */
#line 5335 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 787:

/* Line 1806 of yacc.c  */
#line 5336 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 788:

/* Line 1806 of yacc.c  */
#line 5337 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 789:

/* Line 1806 of yacc.c  */
#line 5338 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 790:

/* Line 1806 of yacc.c  */
#line 5339 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 791:

/* Line 1806 of yacc.c  */
#line 5340 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 792:

/* Line 1806 of yacc.c  */
#line 5341 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 793:

/* Line 1806 of yacc.c  */
#line 5342 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 794:

/* Line 1806 of yacc.c  */
#line 5343 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 795:

/* Line 1806 of yacc.c  */
#line 5344 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 796:

/* Line 1806 of yacc.c  */
#line 5345 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 797:

/* Line 1806 of yacc.c  */
#line 5346 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 798:

/* Line 1806 of yacc.c  */
#line 5347 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 799:

/* Line 1806 of yacc.c  */
#line 5348 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 800:

/* Line 1806 of yacc.c  */
#line 5349 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 801:

/* Line 1806 of yacc.c  */
#line 5350 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 802:

/* Line 1806 of yacc.c  */
#line 5351 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 803:

/* Line 1806 of yacc.c  */
#line 5352 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 804:

/* Line 1806 of yacc.c  */
#line 5353 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 805:

/* Line 1806 of yacc.c  */
#line 5354 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 806:

/* Line 1806 of yacc.c  */
#line 5355 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 807:

/* Line 1806 of yacc.c  */
#line 5356 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 808:

/* Line 1806 of yacc.c  */
#line 5360 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 809:

/* Line 1806 of yacc.c  */
#line 5361 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 810:

/* Line 1806 of yacc.c  */
#line 5377 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 811:

/* Line 1806 of yacc.c  */
#line 5388 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = (yyvsp[(7) - (9)].list);
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 812:

/* Line 1806 of yacc.c  */
#line 5399 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 813:

/* Line 1806 of yacc.c  */
#line 5410 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 814:

/* Line 1806 of yacc.c  */
#line 5421 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 815:

/* Line 1806 of yacc.c  */
#line 5432 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 816:

/* Line 1806 of yacc.c  */
#line 5433 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 817:

/* Line 1806 of yacc.c  */
#line 5437 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 818:

/* Line 1806 of yacc.c  */
#line 5438 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 819:

/* Line 1806 of yacc.c  */
#line 5439 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 820:

/* Line 1806 of yacc.c  */
#line 5440 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 821:

/* Line 1806 of yacc.c  */
#line 5441 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 822:

/* Line 1806 of yacc.c  */
#line 5442 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 823:

/* Line 1806 of yacc.c  */
#line 5443 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 824:

/* Line 1806 of yacc.c  */
#line 5444 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 825:

/* Line 1806 of yacc.c  */
#line 5445 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 826:

/* Line 1806 of yacc.c  */
#line 5446 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 827:

/* Line 1806 of yacc.c  */
#line 5447 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 828:

/* Line 1806 of yacc.c  */
#line 5448 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 829:

/* Line 1806 of yacc.c  */
#line 5449 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 830:

/* Line 1806 of yacc.c  */
#line 5452 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 831:

/* Line 1806 of yacc.c  */
#line 5453 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 832:

/* Line 1806 of yacc.c  */
#line 5464 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 833:

/* Line 1806 of yacc.c  */
#line 5470 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 834:

/* Line 1806 of yacc.c  */
#line 5478 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 835:

/* Line 1806 of yacc.c  */
#line 5486 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 836:

/* Line 1806 of yacc.c  */
#line 5494 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 837:

/* Line 1806 of yacc.c  */
#line 5502 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 838:

/* Line 1806 of yacc.c  */
#line 5510 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 839:

/* Line 1806 of yacc.c  */
#line 5518 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 840:

/* Line 1806 of yacc.c  */
#line 5526 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 841:

/* Line 1806 of yacc.c  */
#line 5534 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 842:

/* Line 1806 of yacc.c  */
#line 5542 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 843:

/* Line 1806 of yacc.c  */
#line 5550 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 844:

/* Line 1806 of yacc.c  */
#line 5558 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 845:

/* Line 1806 of yacc.c  */
#line 5566 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 846:

/* Line 1806 of yacc.c  */
#line 5574 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 847:

/* Line 1806 of yacc.c  */
#line 5582 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 848:

/* Line 1806 of yacc.c  */
#line 5590 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 849:

/* Line 1806 of yacc.c  */
#line 5598 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 850:

/* Line 1806 of yacc.c  */
#line 5607 "gram.y"
    {}
    break;

  case 851:

/* Line 1806 of yacc.c  */
#line 5608 "gram.y"
    {}
    break;

  case 852:

/* Line 1806 of yacc.c  */
#line 5611 "gram.y"
    {}
    break;

  case 853:

/* Line 1806 of yacc.c  */
#line 5612 "gram.y"
    {}
    break;

  case 854:

/* Line 1806 of yacc.c  */
#line 5624 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 855:

/* Line 1806 of yacc.c  */
#line 5640 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 856:

/* Line 1806 of yacc.c  */
#line 5654 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 857:

/* Line 1806 of yacc.c  */
#line 5679 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 858:

/* Line 1806 of yacc.c  */
#line 5681 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 859:

/* Line 1806 of yacc.c  */
#line 5683 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 860:

/* Line 1806 of yacc.c  */
#line 5685 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 861:

/* Line 1806 of yacc.c  */
#line 5692 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 862:

/* Line 1806 of yacc.c  */
#line 5700 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 863:

/* Line 1806 of yacc.c  */
#line 5701 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 864:

/* Line 1806 of yacc.c  */
#line 5705 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 865:

/* Line 1806 of yacc.c  */
#line 5712 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 866:

/* Line 1806 of yacc.c  */
#line 5719 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 867:

/* Line 1806 of yacc.c  */
#line 5726 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 868:

/* Line 1806 of yacc.c  */
#line 5740 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 869:

/* Line 1806 of yacc.c  */
#line 5748 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 870:

/* Line 1806 of yacc.c  */
#line 5756 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 871:

/* Line 1806 of yacc.c  */
#line 5764 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 872:

/* Line 1806 of yacc.c  */
#line 5772 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 873:

/* Line 1806 of yacc.c  */
#line 5780 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 874:

/* Line 1806 of yacc.c  */
#line 5788 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 875:

/* Line 1806 of yacc.c  */
#line 5796 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 876:

/* Line 1806 of yacc.c  */
#line 5804 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 877:

/* Line 1806 of yacc.c  */
#line 5812 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 878:

/* Line 1806 of yacc.c  */
#line 5820 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 879:

/* Line 1806 of yacc.c  */
#line 5828 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 880:

/* Line 1806 of yacc.c  */
#line 5836 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 881:

/* Line 1806 of yacc.c  */
#line 5844 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 882:

/* Line 1806 of yacc.c  */
#line 5852 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 883:

/* Line 1806 of yacc.c  */
#line 5860 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 884:

/* Line 1806 of yacc.c  */
#line 5871 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 885:

/* Line 1806 of yacc.c  */
#line 5872 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 886:

/* Line 1806 of yacc.c  */
#line 5876 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 887:

/* Line 1806 of yacc.c  */
#line 5886 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 888:

/* Line 1806 of yacc.c  */
#line 5899 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 889:

/* Line 1806 of yacc.c  */
#line 5900 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 890:

/* Line 1806 of yacc.c  */
#line 5904 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 891:

/* Line 1806 of yacc.c  */
#line 5906 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 892:

/* Line 1806 of yacc.c  */
#line 5911 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 893:

/* Line 1806 of yacc.c  */
#line 5927 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				}
    break;

  case 894:

/* Line 1806 of yacc.c  */
#line 5940 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 895:

/* Line 1806 of yacc.c  */
#line 5950 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 896:

/* Line 1806 of yacc.c  */
#line 5961 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 897:

/* Line 1806 of yacc.c  */
#line 5962 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 898:

/* Line 1806 of yacc.c  */
#line 5965 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 899:

/* Line 1806 of yacc.c  */
#line 5966 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 900:

/* Line 1806 of yacc.c  */
#line 5977 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 901:

/* Line 1806 of yacc.c  */
#line 5986 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 902:

/* Line 1806 of yacc.c  */
#line 5987 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 903:

/* Line 1806 of yacc.c  */
#line 5992 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 904:

/* Line 1806 of yacc.c  */
#line 5996 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 905:

/* Line 1806 of yacc.c  */
#line 6000 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 906:

/* Line 1806 of yacc.c  */
#line 6012 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 907:

/* Line 1806 of yacc.c  */
#line 6025 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 908:

/* Line 1806 of yacc.c  */
#line 6039 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 909:

/* Line 1806 of yacc.c  */
#line 6054 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 910:

/* Line 1806 of yacc.c  */
#line 6055 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 911:

/* Line 1806 of yacc.c  */
#line 6056 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 912:

/* Line 1806 of yacc.c  */
#line 6057 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 913:

/* Line 1806 of yacc.c  */
#line 6072 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 914:

/* Line 1806 of yacc.c  */
#line 6096 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 915:

/* Line 1806 of yacc.c  */
#line 6097 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 916:

/* Line 1806 of yacc.c  */
#line 6101 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 917:

/* Line 1806 of yacc.c  */
#line 6102 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 918:

/* Line 1806 of yacc.c  */
#line 6106 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 919:

/* Line 1806 of yacc.c  */
#line 6107 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 920:

/* Line 1806 of yacc.c  */
#line 6111 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 921:

/* Line 1806 of yacc.c  */
#line 6112 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 922:

/* Line 1806 of yacc.c  */
#line 6115 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 923:

/* Line 1806 of yacc.c  */
#line 6116 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 924:

/* Line 1806 of yacc.c  */
#line 6125 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 925:

/* Line 1806 of yacc.c  */
#line 6136 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 926:

/* Line 1806 of yacc.c  */
#line 6147 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 927:

/* Line 1806 of yacc.c  */
#line 6159 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 928:

/* Line 1806 of yacc.c  */
#line 6160 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 929:

/* Line 1806 of yacc.c  */
#line 6163 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 930:

/* Line 1806 of yacc.c  */
#line 6164 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 931:

/* Line 1806 of yacc.c  */
#line 6165 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 932:

/* Line 1806 of yacc.c  */
#line 6168 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 933:

/* Line 1806 of yacc.c  */
#line 6169 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 934:

/* Line 1806 of yacc.c  */
#line 6170 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 935:

/* Line 1806 of yacc.c  */
#line 6173 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 936:

/* Line 1806 of yacc.c  */
#line 6174 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 937:

/* Line 1806 of yacc.c  */
#line 6175 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 938:

/* Line 1806 of yacc.c  */
#line 6193 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 939:

/* Line 1806 of yacc.c  */
#line 6205 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 940:

/* Line 1806 of yacc.c  */
#line 6218 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 941:

/* Line 1806 of yacc.c  */
#line 6231 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 942:

/* Line 1806 of yacc.c  */
#line 6232 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 943:

/* Line 1806 of yacc.c  */
#line 6235 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 944:

/* Line 1806 of yacc.c  */
#line 6236 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 945:

/* Line 1806 of yacc.c  */
#line 6240 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 946:

/* Line 1806 of yacc.c  */
#line 6241 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 947:

/* Line 1806 of yacc.c  */
#line 6249 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 948:

/* Line 1806 of yacc.c  */
#line 6250 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 949:

/* Line 1806 of yacc.c  */
#line 6254 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 950:

/* Line 1806 of yacc.c  */
#line 6256 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 951:

/* Line 1806 of yacc.c  */
#line 6271 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 952:

/* Line 1806 of yacc.c  */
#line 6280 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 953:

/* Line 1806 of yacc.c  */
#line 6289 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 954:

/* Line 1806 of yacc.c  */
#line 6298 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 955:

/* Line 1806 of yacc.c  */
#line 6307 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 956:

/* Line 1806 of yacc.c  */
#line 6318 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 957:

/* Line 1806 of yacc.c  */
#line 6319 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 958:

/* Line 1806 of yacc.c  */
#line 6320 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 959:

/* Line 1806 of yacc.c  */
#line 6321 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 960:

/* Line 1806 of yacc.c  */
#line 6322 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 962:

/* Line 1806 of yacc.c  */
#line 6333 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 963:

/* Line 1806 of yacc.c  */
#line 6347 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 964:

/* Line 1806 of yacc.c  */
#line 6349 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 965:

/* Line 1806 of yacc.c  */
#line 6355 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 966:

/* Line 1806 of yacc.c  */
#line 6365 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 967:

/* Line 1806 of yacc.c  */
#line 6369 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 968:

/* Line 1806 of yacc.c  */
#line 6374 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 969:

/* Line 1806 of yacc.c  */
#line 6383 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 970:

/* Line 1806 of yacc.c  */
#line 6384 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 971:

/* Line 1806 of yacc.c  */
#line 6392 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 972:

/* Line 1806 of yacc.c  */
#line 6396 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 973:

/* Line 1806 of yacc.c  */
#line 6400 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 974:

/* Line 1806 of yacc.c  */
#line 6404 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 975:

/* Line 1806 of yacc.c  */
#line 6408 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 976:

/* Line 1806 of yacc.c  */
#line 6412 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 977:

/* Line 1806 of yacc.c  */
#line 6416 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 978:

/* Line 1806 of yacc.c  */
#line 6420 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 979:

/* Line 1806 of yacc.c  */
#line 6424 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 980:

/* Line 1806 of yacc.c  */
#line 6428 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 981:

/* Line 1806 of yacc.c  */
#line 6432 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 982:

/* Line 1806 of yacc.c  */
#line 6436 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 983:

/* Line 1806 of yacc.c  */
#line 6440 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 984:

/* Line 1806 of yacc.c  */
#line 6444 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 985:

/* Line 1806 of yacc.c  */
#line 6448 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 986:

/* Line 1806 of yacc.c  */
#line 6456 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 987:

/* Line 1806 of yacc.c  */
#line 6460 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 988:

/* Line 1806 of yacc.c  */
#line 6464 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 989:

/* Line 1806 of yacc.c  */
#line 6468 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 990:

/* Line 1806 of yacc.c  */
#line 6473 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 991:

/* Line 1806 of yacc.c  */
#line 6475 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 992:

/* Line 1806 of yacc.c  */
#line 6481 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 993:

/* Line 1806 of yacc.c  */
#line 6482 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 994:

/* Line 1806 of yacc.c  */
#line 6486 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 995:

/* Line 1806 of yacc.c  */
#line 6498 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 996:

/* Line 1806 of yacc.c  */
#line 6502 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 997:

/* Line 1806 of yacc.c  */
#line 6517 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 998:

/* Line 1806 of yacc.c  */
#line 6527 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 999:

/* Line 1806 of yacc.c  */
#line 6528 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1002:

/* Line 1806 of yacc.c  */
#line 6550 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1003:

/* Line 1806 of yacc.c  */
#line 6561 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1004:

/* Line 1806 of yacc.c  */
#line 6575 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1005:

/* Line 1806 of yacc.c  */
#line 6586 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1006:

/* Line 1806 of yacc.c  */
#line 6600 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1007:

/* Line 1806 of yacc.c  */
#line 6611 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1008:

/* Line 1806 of yacc.c  */
#line 6625 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 1009:

/* Line 1806 of yacc.c  */
#line 6633 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1010:

/* Line 1806 of yacc.c  */
#line 6635 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1011:

/* Line 1806 of yacc.c  */
#line 6637 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 1012:

/* Line 1806 of yacc.c  */
#line 6642 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1013:

/* Line 1806 of yacc.c  */
#line 6644 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 1014:

/* Line 1806 of yacc.c  */
#line 6657 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1015:

/* Line 1806 of yacc.c  */
#line 6665 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1016:

/* Line 1806 of yacc.c  */
#line 6666 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1017:

/* Line 1806 of yacc.c  */
#line 6671 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 1018:

/* Line 1806 of yacc.c  */
#line 6675 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1019:

/* Line 1806 of yacc.c  */
#line 6688 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1020:

/* Line 1806 of yacc.c  */
#line 6699 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1021:

/* Line 1806 of yacc.c  */
#line 6710 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1022:

/* Line 1806 of yacc.c  */
#line 6721 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 1023:

/* Line 1806 of yacc.c  */
#line 6722 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 1024:

/* Line 1806 of yacc.c  */
#line 6723 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 1025:

/* Line 1806 of yacc.c  */
#line 6728 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1026:

/* Line 1806 of yacc.c  */
#line 6740 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1027:

/* Line 1806 of yacc.c  */
#line 6741 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1028:

/* Line 1806 of yacc.c  */
#line 6756 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1029:

/* Line 1806 of yacc.c  */
#line 6764 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1030:

/* Line 1806 of yacc.c  */
#line 6774 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1031:

/* Line 1806 of yacc.c  */
#line 6786 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 1032:

/* Line 1806 of yacc.c  */
#line 6787 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 1033:

/* Line 1806 of yacc.c  */
#line 6790 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 1034:

/* Line 1806 of yacc.c  */
#line 6791 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 1035:

/* Line 1806 of yacc.c  */
#line 6802 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1036:

/* Line 1806 of yacc.c  */
#line 6812 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1037:

/* Line 1806 of yacc.c  */
#line 6821 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1038:

/* Line 1806 of yacc.c  */
#line 6830 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1039:

/* Line 1806 of yacc.c  */
#line 6839 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1040:

/* Line 1806 of yacc.c  */
#line 6848 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1041:

/* Line 1806 of yacc.c  */
#line 6858 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1042:

/* Line 1806 of yacc.c  */
#line 6867 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1043:

/* Line 1806 of yacc.c  */
#line 6877 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1044:

/* Line 1806 of yacc.c  */
#line 6886 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1045:

/* Line 1806 of yacc.c  */
#line 6895 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1046:

/* Line 1806 of yacc.c  */
#line 6905 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1047:

/* Line 1806 of yacc.c  */
#line 6915 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1048:

/* Line 1806 of yacc.c  */
#line 6924 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1049:

/* Line 1806 of yacc.c  */
#line 6933 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1050:

/* Line 1806 of yacc.c  */
#line 6943 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1051:

/* Line 1806 of yacc.c  */
#line 6953 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1052:

/* Line 1806 of yacc.c  */
#line 6963 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1053:

/* Line 1806 of yacc.c  */
#line 6973 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1054:

/* Line 1806 of yacc.c  */
#line 6983 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1055:

/* Line 1806 of yacc.c  */
#line 6993 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1056:

/* Line 1806 of yacc.c  */
#line 7003 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1057:

/* Line 1806 of yacc.c  */
#line 7013 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1058:

/* Line 1806 of yacc.c  */
#line 7023 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1059:

/* Line 1806 of yacc.c  */
#line 7033 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1060:

/* Line 1806 of yacc.c  */
#line 7043 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1061:

/* Line 1806 of yacc.c  */
#line 7053 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1062:

/* Line 1806 of yacc.c  */
#line 7064 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1063:

/* Line 1806 of yacc.c  */
#line 7075 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1064:

/* Line 1806 of yacc.c  */
#line 7086 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1065:

/* Line 1806 of yacc.c  */
#line 7097 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1066:

/* Line 1806 of yacc.c  */
#line 7107 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1067:

/* Line 1806 of yacc.c  */
#line 7118 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1068:

/* Line 1806 of yacc.c  */
#line 7129 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1069:

/* Line 1806 of yacc.c  */
#line 7139 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1070:

/* Line 1806 of yacc.c  */
#line 7149 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1071:

/* Line 1806 of yacc.c  */
#line 7157 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1072:

/* Line 1806 of yacc.c  */
#line 7166 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1073:

/* Line 1806 of yacc.c  */
#line 7175 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1074:

/* Line 1806 of yacc.c  */
#line 7184 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1075:

/* Line 1806 of yacc.c  */
#line 7193 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1076:

/* Line 1806 of yacc.c  */
#line 7202 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1077:

/* Line 1806 of yacc.c  */
#line 7211 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1078:

/* Line 1806 of yacc.c  */
#line 7220 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1079:

/* Line 1806 of yacc.c  */
#line 7229 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1080:

/* Line 1806 of yacc.c  */
#line 7238 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1081:

/* Line 1806 of yacc.c  */
#line 7247 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1082:

/* Line 1806 of yacc.c  */
#line 7260 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1083:

/* Line 1806 of yacc.c  */
#line 7261 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1084:

/* Line 1806 of yacc.c  */
#line 7264 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1085:

/* Line 1806 of yacc.c  */
#line 7265 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1086:

/* Line 1806 of yacc.c  */
#line 7276 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1087:

/* Line 1806 of yacc.c  */
#line 7286 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1088:

/* Line 1806 of yacc.c  */
#line 7295 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1089:

/* Line 1806 of yacc.c  */
#line 7304 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1090:

/* Line 1806 of yacc.c  */
#line 7313 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1091:

/* Line 1806 of yacc.c  */
#line 7322 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1092:

/* Line 1806 of yacc.c  */
#line 7332 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1093:

/* Line 1806 of yacc.c  */
#line 7342 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1094:

/* Line 1806 of yacc.c  */
#line 7352 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1095:

/* Line 1806 of yacc.c  */
#line 7362 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1096:

/* Line 1806 of yacc.c  */
#line 7371 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1097:

/* Line 1806 of yacc.c  */
#line 7380 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1098:

/* Line 1806 of yacc.c  */
#line 7389 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1099:

/* Line 1806 of yacc.c  */
#line 7398 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1100:

/* Line 1806 of yacc.c  */
#line 7407 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1101:

/* Line 1806 of yacc.c  */
#line 7416 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1102:

/* Line 1806 of yacc.c  */
#line 7425 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1103:

/* Line 1806 of yacc.c  */
#line 7434 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1104:

/* Line 1806 of yacc.c  */
#line 7443 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1105:

/* Line 1806 of yacc.c  */
#line 7452 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1106:

/* Line 1806 of yacc.c  */
#line 7461 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1107:

/* Line 1806 of yacc.c  */
#line 7470 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1108:

/* Line 1806 of yacc.c  */
#line 7479 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1109:

/* Line 1806 of yacc.c  */
#line 7488 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1110:

/* Line 1806 of yacc.c  */
#line 7505 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1111:

/* Line 1806 of yacc.c  */
#line 7514 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1112:

/* Line 1806 of yacc.c  */
#line 7522 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1113:

/* Line 1806 of yacc.c  */
#line 7530 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1114:

/* Line 1806 of yacc.c  */
#line 7538 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1115:

/* Line 1806 of yacc.c  */
#line 7546 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1116:

/* Line 1806 of yacc.c  */
#line 7555 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1117:

/* Line 1806 of yacc.c  */
#line 7563 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1118:

/* Line 1806 of yacc.c  */
#line 7571 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1119:

/* Line 1806 of yacc.c  */
#line 7580 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1120:

/* Line 1806 of yacc.c  */
#line 7589 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1121:

/* Line 1806 of yacc.c  */
#line 7598 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:

/* Line 1806 of yacc.c  */
#line 7606 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:

/* Line 1806 of yacc.c  */
#line 7614 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:

/* Line 1806 of yacc.c  */
#line 7622 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:

/* Line 1806 of yacc.c  */
#line 7630 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:

/* Line 1806 of yacc.c  */
#line 7638 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1127:

/* Line 1806 of yacc.c  */
#line 7646 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1128:

/* Line 1806 of yacc.c  */
#line 7654 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1129:

/* Line 1806 of yacc.c  */
#line 7673 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1130:

/* Line 1806 of yacc.c  */
#line 7687 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1131:

/* Line 1806 of yacc.c  */
#line 7688 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1132:

/* Line 1806 of yacc.c  */
#line 7689 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1133:

/* Line 1806 of yacc.c  */
#line 7695 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1134:

/* Line 1806 of yacc.c  */
#line 7701 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1140:

/* Line 1806 of yacc.c  */
#line 7717 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1141:

/* Line 1806 of yacc.c  */
#line 7718 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1142:

/* Line 1806 of yacc.c  */
#line 7721 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1143:

/* Line 1806 of yacc.c  */
#line 7722 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1144:

/* Line 1806 of yacc.c  */
#line 7723 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1145:

/* Line 1806 of yacc.c  */
#line 7724 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1146:

/* Line 1806 of yacc.c  */
#line 7728 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1147:

/* Line 1806 of yacc.c  */
#line 7729 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1148:

/* Line 1806 of yacc.c  */
#line 7730 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1149:

/* Line 1806 of yacc.c  */
#line 7736 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1150:

/* Line 1806 of yacc.c  */
#line 7747 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1151:

/* Line 1806 of yacc.c  */
#line 7769 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1152:

/* Line 1806 of yacc.c  */
#line 7778 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1153:

/* Line 1806 of yacc.c  */
#line 7779 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1154:

/* Line 1806 of yacc.c  */
#line 7783 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1155:

/* Line 1806 of yacc.c  */
#line 7792 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1156:

/* Line 1806 of yacc.c  */
#line 7798 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1157:

/* Line 1806 of yacc.c  */
#line 7817 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1158:

/* Line 1806 of yacc.c  */
#line 7824 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1159:

/* Line 1806 of yacc.c  */
#line 7831 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1160:

/* Line 1806 of yacc.c  */
#line 7838 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1161:

/* Line 1806 of yacc.c  */
#line 7845 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1162:

/* Line 1806 of yacc.c  */
#line 7852 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1163:

/* Line 1806 of yacc.c  */
#line 7859 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1164:

/* Line 1806 of yacc.c  */
#line 7867 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1165:

/* Line 1806 of yacc.c  */
#line 7875 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1166:

/* Line 1806 of yacc.c  */
#line 7883 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1167:

/* Line 1806 of yacc.c  */
#line 7891 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1168:

/* Line 1806 of yacc.c  */
#line 7899 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1169:

/* Line 1806 of yacc.c  */
#line 7906 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1170:

/* Line 1806 of yacc.c  */
#line 7913 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1171:

/* Line 1806 of yacc.c  */
#line 7921 "gram.y"
    {}
    break;

  case 1172:

/* Line 1806 of yacc.c  */
#line 7922 "gram.y"
    {}
    break;

  case 1173:

/* Line 1806 of yacc.c  */
#line 7923 "gram.y"
    {}
    break;

  case 1174:

/* Line 1806 of yacc.c  */
#line 7928 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1175:

/* Line 1806 of yacc.c  */
#line 7931 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1176:

/* Line 1806 of yacc.c  */
#line 7934 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1177:

/* Line 1806 of yacc.c  */
#line 7937 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1178:

/* Line 1806 of yacc.c  */
#line 7940 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1179:

/* Line 1806 of yacc.c  */
#line 7947 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1180:

/* Line 1806 of yacc.c  */
#line 7949 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1181:

/* Line 1806 of yacc.c  */
#line 7951 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1183:

/* Line 1806 of yacc.c  */
#line 7957 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1184:

/* Line 1806 of yacc.c  */
#line 7971 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1185:

/* Line 1806 of yacc.c  */
#line 7983 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1186:

/* Line 1806 of yacc.c  */
#line 7995 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(5) - (11)].range);
					n->view->relpersistence = (yyvsp[(2) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(11) - (11)].node));
					n->replace = false;
					n->options = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1187:

/* Line 1806 of yacc.c  */
#line 8007 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(7) - (13)].range);
					n->view->relpersistence = (yyvsp[(4) - (13)].ival);
					n->aliases = (yyvsp[(9) - (13)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(13) - (13)].node));
					n->replace = true;
					n->options = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1188:

/* Line 1806 of yacc.c  */
#line 8021 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1189:

/* Line 1806 of yacc.c  */
#line 8027 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1190:

/* Line 1806 of yacc.c  */
#line 8033 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1191:

/* Line 1806 of yacc.c  */
#line 8038 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1192:

/* Line 1806 of yacc.c  */
#line 8049 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1193:

/* Line 1806 of yacc.c  */
#line 8065 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1194:

/* Line 1806 of yacc.c  */
#line 8074 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1195:

/* Line 1806 of yacc.c  */
#line 8075 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1196:

/* Line 1806 of yacc.c  */
#line 8080 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1197:

/* Line 1806 of yacc.c  */
#line 8084 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
    break;

  case 1198:

/* Line 1806 of yacc.c  */
#line 8088 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1199:

/* Line 1806 of yacc.c  */
#line 8092 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
    break;

  case 1200:

/* Line 1806 of yacc.c  */
#line 8096 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1201:

/* Line 1806 of yacc.c  */
#line 8100 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
    break;

  case 1202:

/* Line 1806 of yacc.c  */
#line 8104 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1203:

/* Line 1806 of yacc.c  */
#line 8108 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1204:

/* Line 1806 of yacc.c  */
#line 8112 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
    break;

  case 1205:

/* Line 1806 of yacc.c  */
#line 8116 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1206:

/* Line 1806 of yacc.c  */
#line 8120 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
    break;

  case 1207:

/* Line 1806 of yacc.c  */
#line 8124 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1208:

/* Line 1806 of yacc.c  */
#line 8128 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
    break;

  case 1209:

/* Line 1806 of yacc.c  */
#line 8132 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1210:

/* Line 1806 of yacc.c  */
#line 8136 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1211:

/* Line 1806 of yacc.c  */
#line 8140 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
    break;

  case 1212:

/* Line 1806 of yacc.c  */
#line 8149 "gram.y"
    {}
    break;

  case 1213:

/* Line 1806 of yacc.c  */
#line 8150 "gram.y"
    {}
    break;

  case 1214:

/* Line 1806 of yacc.c  */
#line 8162 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1215:

/* Line 1806 of yacc.c  */
#line 8169 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1216:

/* Line 1806 of yacc.c  */
#line 8180 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1217:

/* Line 1806 of yacc.c  */
#line 8190 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1218:

/* Line 1806 of yacc.c  */
#line 8191 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1219:

/* Line 1806 of yacc.c  */
#line 8196 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1220:

/* Line 1806 of yacc.c  */
#line 8210 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1221:

/* Line 1806 of yacc.c  */
#line 8217 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1222:

/* Line 1806 of yacc.c  */
#line 8234 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1223:

/* Line 1806 of yacc.c  */
#line 8247 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1224:

/* Line 1806 of yacc.c  */
#line 8256 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1225:

/* Line 1806 of yacc.c  */
#line 8264 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1226:

/* Line 1806 of yacc.c  */
#line 8272 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1227:

/* Line 1806 of yacc.c  */
#line 8281 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1228:

/* Line 1806 of yacc.c  */
#line 8292 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1229:

/* Line 1806 of yacc.c  */
#line 8303 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1230:

/* Line 1806 of yacc.c  */
#line 8312 "gram.y"
    {}
    break;

  case 1231:

/* Line 1806 of yacc.c  */
#line 8313 "gram.y"
    {}
    break;

  case 1232:

/* Line 1806 of yacc.c  */
#line 8325 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1233:

/* Line 1806 of yacc.c  */
#line 8335 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1234:

/* Line 1806 of yacc.c  */
#line 8345 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1235:

/* Line 1806 of yacc.c  */
#line 8355 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1236:

/* Line 1806 of yacc.c  */
#line 8365 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1237:

/* Line 1806 of yacc.c  */
#line 8375 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1238:

/* Line 1806 of yacc.c  */
#line 8383 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1239:

/* Line 1806 of yacc.c  */
#line 8405 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1240:

/* Line 1806 of yacc.c  */
#line 8427 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1241:

/* Line 1806 of yacc.c  */
#line 8435 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1242:

/* Line 1806 of yacc.c  */
#line 8444 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1243:

/* Line 1806 of yacc.c  */
#line 8454 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1244:

/* Line 1806 of yacc.c  */
#line 8455 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1245:

/* Line 1806 of yacc.c  */
#line 8468 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1246:

/* Line 1806 of yacc.c  */
#line 8484 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1247:

/* Line 1806 of yacc.c  */
#line 8500 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1248:

/* Line 1806 of yacc.c  */
#line 8514 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1249:

/* Line 1806 of yacc.c  */
#line 8534 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1250:

/* Line 1806 of yacc.c  */
#line 8558 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1251:

/* Line 1806 of yacc.c  */
#line 8559 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1252:

/* Line 1806 of yacc.c  */
#line 8563 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1253:

/* Line 1806 of yacc.c  */
#line 8564 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1254:

/* Line 1806 of yacc.c  */
#line 8565 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1255:

/* Line 1806 of yacc.c  */
#line 8566 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1256:

/* Line 1806 of yacc.c  */
#line 8571 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1257:

/* Line 1806 of yacc.c  */
#line 8585 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1258:

/* Line 1806 of yacc.c  */
#line 8601 "gram.y"
    {}
    break;

  case 1259:

/* Line 1806 of yacc.c  */
#line 8602 "gram.y"
    {}
    break;

  case 1260:

/* Line 1806 of yacc.c  */
#line 8606 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1261:

/* Line 1806 of yacc.c  */
#line 8607 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1262:

/* Line 1806 of yacc.c  */
#line 8610 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1263:

/* Line 1806 of yacc.c  */
#line 8611 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1264:

/* Line 1806 of yacc.c  */
#line 8614 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1265:

/* Line 1806 of yacc.c  */
#line 8615 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1266:

/* Line 1806 of yacc.c  */
#line 8619 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1267:

/* Line 1806 of yacc.c  */
#line 8620 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1268:

/* Line 1806 of yacc.c  */
#line 8634 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1269:

/* Line 1806 of yacc.c  */
#line 8641 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1270:

/* Line 1806 of yacc.c  */
#line 8651 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1271:

/* Line 1806 of yacc.c  */
#line 8658 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1281:

/* Line 1806 of yacc.c  */
#line 8680 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1282:

/* Line 1806 of yacc.c  */
#line 8684 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1283:

/* Line 1806 of yacc.c  */
#line 8691 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1284:

/* Line 1806 of yacc.c  */
#line 8697 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1285:

/* Line 1806 of yacc.c  */
#line 8698 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1286:

/* Line 1806 of yacc.c  */
#line 8702 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1287:

/* Line 1806 of yacc.c  */
#line 8703 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1288:

/* Line 1806 of yacc.c  */
#line 8704 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1289:

/* Line 1806 of yacc.c  */
#line 8715 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1290:

/* Line 1806 of yacc.c  */
#line 8724 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1291:

/* Line 1806 of yacc.c  */
#line 8725 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1296:

/* Line 1806 of yacc.c  */
#line 8743 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1297:

/* Line 1806 of yacc.c  */
#line 8751 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1298:

/* Line 1806 of yacc.c  */
#line 8767 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1299:

/* Line 1806 of yacc.c  */
#line 8768 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1300:

/* Line 1806 of yacc.c  */
#line 8779 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1301:

/* Line 1806 of yacc.c  */
#line 8785 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1302:

/* Line 1806 of yacc.c  */
#line 8791 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1303:

/* Line 1806 of yacc.c  */
#line 8797 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1304:

/* Line 1806 of yacc.c  */
#line 8813 "gram.y"
    {
					(yyvsp[(5) - (6)].istmt)->relation = (yyvsp[(4) - (6)].range);
					(yyvsp[(5) - (6)].istmt)->returningList = (yyvsp[(6) - (6)].list);
					(yyvsp[(5) - (6)].istmt)->withClause = (yyvsp[(1) - (6)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (6)].istmt);
				}
    break;

  case 1305:

/* Line 1806 of yacc.c  */
#line 8823 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1306:

/* Line 1806 of yacc.c  */
#line 8829 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1307:

/* Line 1806 of yacc.c  */
#line 8835 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1308:

/* Line 1806 of yacc.c  */
#line 8844 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1309:

/* Line 1806 of yacc.c  */
#line 8846 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1310:

/* Line 1806 of yacc.c  */
#line 8851 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1311:

/* Line 1806 of yacc.c  */
#line 8861 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1312:

/* Line 1806 of yacc.c  */
#line 8862 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1313:

/* Line 1806 of yacc.c  */
#line 8875 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1314:

/* Line 1806 of yacc.c  */
#line 8887 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1315:

/* Line 1806 of yacc.c  */
#line 8888 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1316:

/* Line 1806 of yacc.c  */
#line 8900 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1317:

/* Line 1806 of yacc.c  */
#line 8910 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1318:

/* Line 1806 of yacc.c  */
#line 8911 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1319:

/* Line 1806 of yacc.c  */
#line 8914 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1320:

/* Line 1806 of yacc.c  */
#line 8915 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1321:

/* Line 1806 of yacc.c  */
#line 8916 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1322:

/* Line 1806 of yacc.c  */
#line 8917 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1323:

/* Line 1806 of yacc.c  */
#line 8918 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1324:

/* Line 1806 of yacc.c  */
#line 8919 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1325:

/* Line 1806 of yacc.c  */
#line 8920 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1326:

/* Line 1806 of yacc.c  */
#line 8921 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1327:

/* Line 1806 of yacc.c  */
#line 8924 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1328:

/* Line 1806 of yacc.c  */
#line 8925 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1329:

/* Line 1806 of yacc.c  */
#line 8941 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1330:

/* Line 1806 of yacc.c  */
#line 8954 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1331:

/* Line 1806 of yacc.c  */
#line 8955 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1332:

/* Line 1806 of yacc.c  */
#line 8959 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1333:

/* Line 1806 of yacc.c  */
#line 8960 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1334:

/* Line 1806 of yacc.c  */
#line 8965 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1335:

/* Line 1806 of yacc.c  */
#line 8973 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1336:

/* Line 1806 of yacc.c  */
#line 9001 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1337:

/* Line 1806 of yacc.c  */
#line 9011 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1338:

/* Line 1806 of yacc.c  */
#line 9012 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1339:

/* Line 1806 of yacc.c  */
#line 9023 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1340:

/* Line 1806 of yacc.c  */
#line 9033 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1341:

/* Line 1806 of yacc.c  */
#line 9036 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1342:

/* Line 1806 of yacc.c  */
#line 9037 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1343:

/* Line 1806 of yacc.c  */
#line 9038 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1344:

/* Line 1806 of yacc.c  */
#line 9039 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1345:

/* Line 1806 of yacc.c  */
#line 9040 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1346:

/* Line 1806 of yacc.c  */
#line 9043 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1347:

/* Line 1806 of yacc.c  */
#line 9044 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1348:

/* Line 1806 of yacc.c  */
#line 9045 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1351:

/* Line 1806 of yacc.c  */
#line 9098 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1352:

/* Line 1806 of yacc.c  */
#line 9099 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1353:

/* Line 1806 of yacc.c  */
#line 9114 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1354:

/* Line 1806 of yacc.c  */
#line 9116 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1355:

/* Line 1806 of yacc.c  */
#line 9123 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1356:

/* Line 1806 of yacc.c  */
#line 9131 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1357:

/* Line 1806 of yacc.c  */
#line 9139 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1358:

/* Line 1806 of yacc.c  */
#line 9147 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1359:

/* Line 1806 of yacc.c  */
#line 9155 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1360:

/* Line 1806 of yacc.c  */
#line 9163 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1361:

/* Line 1806 of yacc.c  */
#line 9173 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1362:

/* Line 1806 of yacc.c  */
#line 9174 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1363:

/* Line 1806 of yacc.c  */
#line 9204 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1364:

/* Line 1806 of yacc.c  */
#line 9216 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1365:

/* Line 1806 of yacc.c  */
#line 9218 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1366:

/* Line 1806 of yacc.c  */
#line 9237 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1367:

/* Line 1806 of yacc.c  */
#line 9241 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1368:

/* Line 1806 of yacc.c  */
#line 9245 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1369:

/* Line 1806 of yacc.c  */
#line 9260 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1370:

/* Line 1806 of yacc.c  */
#line 9267 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1371:

/* Line 1806 of yacc.c  */
#line 9276 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1372:

/* Line 1806 of yacc.c  */
#line 9277 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1373:

/* Line 1806 of yacc.c  */
#line 9281 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1374:

/* Line 1806 of yacc.c  */
#line 9292 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1375:

/* Line 1806 of yacc.c  */
#line 9293 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1376:

/* Line 1806 of yacc.c  */
#line 9298 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1377:

/* Line 1806 of yacc.c  */
#line 9309 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1378:

/* Line 1806 of yacc.c  */
#line 9318 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1379:

/* Line 1806 of yacc.c  */
#line 9323 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1380:

/* Line 1806 of yacc.c  */
#line 9328 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1381:

/* Line 1806 of yacc.c  */
#line 9333 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1382:

/* Line 1806 of yacc.c  */
#line 9338 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1383:

/* Line 1806 of yacc.c  */
#line 9346 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1384:

/* Line 1806 of yacc.c  */
#line 9354 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1385:

/* Line 1806 of yacc.c  */
#line 9359 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1386:

/* Line 1806 of yacc.c  */
#line 9364 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1387:

/* Line 1806 of yacc.c  */
#line 9370 "gram.y"
    {}
    break;

  case 1388:

/* Line 1806 of yacc.c  */
#line 9371 "gram.y"
    {}
    break;

  case 1389:

/* Line 1806 of yacc.c  */
#line 9374 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1390:

/* Line 1806 of yacc.c  */
#line 9375 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1391:

/* Line 1806 of yacc.c  */
#line 9376 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1392:

/* Line 1806 of yacc.c  */
#line 9383 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1393:

/* Line 1806 of yacc.c  */
#line 9384 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1394:

/* Line 1806 of yacc.c  */
#line 9385 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1395:

/* Line 1806 of yacc.c  */
#line 9386 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1396:

/* Line 1806 of yacc.c  */
#line 9390 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1397:

/* Line 1806 of yacc.c  */
#line 9391 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1398:

/* Line 1806 of yacc.c  */
#line 9395 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1399:

/* Line 1806 of yacc.c  */
#line 9399 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1400:

/* Line 1806 of yacc.c  */
#line 9400 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1401:

/* Line 1806 of yacc.c  */
#line 9404 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1402:

/* Line 1806 of yacc.c  */
#line 9413 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1403:

/* Line 1806 of yacc.c  */
#line 9425 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1404:

/* Line 1806 of yacc.c  */
#line 9426 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1405:

/* Line 1806 of yacc.c  */
#line 9427 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1406:

/* Line 1806 of yacc.c  */
#line 9428 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1407:

/* Line 1806 of yacc.c  */
#line 9432 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1408:

/* Line 1806 of yacc.c  */
#line 9433 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1409:

/* Line 1806 of yacc.c  */
#line 9438 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1410:

/* Line 1806 of yacc.c  */
#line 9440 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1411:

/* Line 1806 of yacc.c  */
#line 9450 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1412:

/* Line 1806 of yacc.c  */
#line 9455 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1413:

/* Line 1806 of yacc.c  */
#line 9458 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1414:

/* Line 1806 of yacc.c  */
#line 9462 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1415:

/* Line 1806 of yacc.c  */
#line 9464 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1416:

/* Line 1806 of yacc.c  */
#line 9471 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1417:

/* Line 1806 of yacc.c  */
#line 9481 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1418:

/* Line 1806 of yacc.c  */
#line 9482 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1419:

/* Line 1806 of yacc.c  */
#line 9483 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1420:

/* Line 1806 of yacc.c  */
#line 9491 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1421:

/* Line 1806 of yacc.c  */
#line 9495 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1422:

/* Line 1806 of yacc.c  */
#line 9496 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1423:

/* Line 1806 of yacc.c  */
#line 9499 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1424:

/* Line 1806 of yacc.c  */
#line 9500 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1425:

/* Line 1806 of yacc.c  */
#line 9505 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1426:

/* Line 1806 of yacc.c  */
#line 9506 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1427:

/* Line 1806 of yacc.c  */
#line 9510 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1428:

/* Line 1806 of yacc.c  */
#line 9511 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1429:

/* Line 1806 of yacc.c  */
#line 9515 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1430:

/* Line 1806 of yacc.c  */
#line 9516 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1431:

/* Line 1806 of yacc.c  */
#line 9520 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1432:

/* Line 1806 of yacc.c  */
#line 9521 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1433:

/* Line 1806 of yacc.c  */
#line 9525 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1434:

/* Line 1806 of yacc.c  */
#line 9526 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1435:

/* Line 1806 of yacc.c  */
#line 9531 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(2) - (3)].list);
					n->strength = (yyvsp[(1) - (3)].ival);
					n->noWait = (yyvsp[(3) - (3)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1436:

/* Line 1806 of yacc.c  */
#line 9541 "gram.y"
    { (yyval.ival) = LCS_FORUPDATE; }
    break;

  case 1437:

/* Line 1806 of yacc.c  */
#line 9542 "gram.y"
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
    break;

  case 1438:

/* Line 1806 of yacc.c  */
#line 9543 "gram.y"
    { (yyval.ival) = LCS_FORSHARE; }
    break;

  case 1439:

/* Line 1806 of yacc.c  */
#line 9544 "gram.y"
    { (yyval.ival) = LCS_FORKEYSHARE; }
    break;

  case 1440:

/* Line 1806 of yacc.c  */
#line 9548 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1441:

/* Line 1806 of yacc.c  */
#line 9549 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1442:

/* Line 1806 of yacc.c  */
#line 9555 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1443:

/* Line 1806 of yacc.c  */
#line 9561 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1444:

/* Line 1806 of yacc.c  */
#line 9578 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1445:

/* Line 1806 of yacc.c  */
#line 9579 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1446:

/* Line 1806 of yacc.c  */
#line 9583 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1447:

/* Line 1806 of yacc.c  */
#line 9584 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1448:

/* Line 1806 of yacc.c  */
#line 9591 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1449:

/* Line 1806 of yacc.c  */
#line 9596 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = linitial((yyvsp[(2) - (2)].list));
					n->coldeflist = lsecond((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1450:

/* Line 1806 of yacc.c  */
#line 9605 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = true;
					n->funccallnode = (yyvsp[(2) - (3)].node);
					n->alias = linitial((yyvsp[(3) - (3)].list));
					n->coldeflist = lsecond((yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1451:

/* Line 1806 of yacc.c  */
#line 9614 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[(2) - (2)].alias) == NULL)
					{
						if (IsA((yyvsp[(1) - (2)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(1) - (2)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1452:

/* Line 1806 of yacc.c  */
#line 9649 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[(2) - (3)].node);
					n->alias = (yyvsp[(3) - (3)].alias);
					/* same coment as above */
					if ((yyvsp[(3) - (3)].alias) == NULL)
					{
						if (IsA((yyvsp[(2) - (3)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(2) - (3)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1453:

/* Line 1806 of yacc.c  */
#line 9674 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1454:

/* Line 1806 of yacc.c  */
#line 9678 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1455:

/* Line 1806 of yacc.c  */
#line 9704 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1456:

/* Line 1806 of yacc.c  */
#line 9708 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1457:

/* Line 1806 of yacc.c  */
#line 9720 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1458:

/* Line 1806 of yacc.c  */
#line 9733 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1459:

/* Line 1806 of yacc.c  */
#line 9747 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1460:

/* Line 1806 of yacc.c  */
#line 9758 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1461:

/* Line 1806 of yacc.c  */
#line 9773 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1462:

/* Line 1806 of yacc.c  */
#line 9779 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1463:

/* Line 1806 of yacc.c  */
#line 9784 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1464:

/* Line 1806 of yacc.c  */
#line 9790 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1465:

/* Line 1806 of yacc.c  */
#line 9796 "gram.y"
    { (yyval.alias) = (yyvsp[(1) - (1)].alias); }
    break;

  case 1466:

/* Line 1806 of yacc.c  */
#line 9797 "gram.y"
    { (yyval.alias) = NULL; }
    break;

  case 1467:

/* Line 1806 of yacc.c  */
#line 9806 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (1)].alias), NIL);
				}
    break;

  case 1468:

/* Line 1806 of yacc.c  */
#line 9810 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1469:

/* Line 1806 of yacc.c  */
#line 9814 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.list) = list_make2(a, (yyvsp[(4) - (5)].list));
				}
    break;

  case 1470:

/* Line 1806 of yacc.c  */
#line 9820 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.list) = list_make2(a, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1471:

/* Line 1806 of yacc.c  */
#line 9826 "gram.y"
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
    break;

  case 1472:

/* Line 1806 of yacc.c  */
#line 9831 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1473:

/* Line 1806 of yacc.c  */
#line 9832 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1474:

/* Line 1806 of yacc.c  */
#line 9833 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1475:

/* Line 1806 of yacc.c  */
#line 9834 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1476:

/* Line 1806 of yacc.c  */
#line 9838 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1477:

/* Line 1806 of yacc.c  */
#line 9839 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1478:

/* Line 1806 of yacc.c  */
#line 9851 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1479:

/* Line 1806 of yacc.c  */
#line 9852 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1480:

/* Line 1806 of yacc.c  */
#line 9858 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1481:

/* Line 1806 of yacc.c  */
#line 9865 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1482:

/* Line 1806 of yacc.c  */
#line 9872 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1483:

/* Line 1806 of yacc.c  */
#line 9879 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1484:

/* Line 1806 of yacc.c  */
#line 9889 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1485:

/* Line 1806 of yacc.c  */
#line 9890 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1486:

/* Line 1806 of yacc.c  */
#line 9904 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1487:

/* Line 1806 of yacc.c  */
#line 9908 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1488:

/* Line 1806 of yacc.c  */
#line 9915 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1489:

/* Line 1806 of yacc.c  */
#line 9924 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1490:

/* Line 1806 of yacc.c  */
#line 9929 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1491:

/* Line 1806 of yacc.c  */
#line 9930 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1492:

/* Line 1806 of yacc.c  */
#line 9935 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1493:

/* Line 1806 of yacc.c  */
#line 9937 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1494:

/* Line 1806 of yacc.c  */
#line 9944 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1495:

/* Line 1806 of yacc.c  */
#line 9949 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1496:

/* Line 1806 of yacc.c  */
#line 9950 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1497:

/* Line 1806 of yacc.c  */
#line 9955 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1498:

/* Line 1806 of yacc.c  */
#line 9959 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1499:

/* Line 1806 of yacc.c  */
#line 9965 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1500:

/* Line 1806 of yacc.c  */
#line 9994 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1501:

/* Line 1806 of yacc.c  */
#line 9999 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1502:

/* Line 1806 of yacc.c  */
#line 10006 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1503:

/* Line 1806 of yacc.c  */
#line 10011 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1504:

/* Line 1806 of yacc.c  */
#line 10017 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1505:

/* Line 1806 of yacc.c  */
#line 10022 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1506:

/* Line 1806 of yacc.c  */
#line 10031 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1507:

/* Line 1806 of yacc.c  */
#line 10033 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1508:

/* Line 1806 of yacc.c  */
#line 10035 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1509:

/* Line 1806 of yacc.c  */
#line 10039 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1510:

/* Line 1806 of yacc.c  */
#line 10040 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1511:

/* Line 1806 of yacc.c  */
#line 10041 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1512:

/* Line 1806 of yacc.c  */
#line 10042 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1513:

/* Line 1806 of yacc.c  */
#line 10043 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1514:

/* Line 1806 of yacc.c  */
#line 10045 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1515:

/* Line 1806 of yacc.c  */
#line 10050 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				}
    break;

  case 1516:

/* Line 1806 of yacc.c  */
#line 10079 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1517:

/* Line 1806 of yacc.c  */
#line 10080 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1518:

/* Line 1806 of yacc.c  */
#line 10081 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1519:

/* Line 1806 of yacc.c  */
#line 10082 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1520:

/* Line 1806 of yacc.c  */
#line 10094 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1521:

/* Line 1806 of yacc.c  */
#line 10100 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1522:

/* Line 1806 of yacc.c  */
#line 10107 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1523:

/* Line 1806 of yacc.c  */
#line 10108 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1524:

/* Line 1806 of yacc.c  */
#line 10115 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1525:

/* Line 1806 of yacc.c  */
#line 10120 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1526:

/* Line 1806 of yacc.c  */
#line 10125 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1527:

/* Line 1806 of yacc.c  */
#line 10130 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1528:

/* Line 1806 of yacc.c  */
#line 10135 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1529:

/* Line 1806 of yacc.c  */
#line 10140 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1530:

/* Line 1806 of yacc.c  */
#line 10145 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1531:

/* Line 1806 of yacc.c  */
#line 10150 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1532:

/* Line 1806 of yacc.c  */
#line 10156 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1533:

/* Line 1806 of yacc.c  */
#line 10162 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1534:

/* Line 1806 of yacc.c  */
#line 10168 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1535:

/* Line 1806 of yacc.c  */
#line 10175 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1536:

/* Line 1806 of yacc.c  */
#line 10196 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1537:

/* Line 1806 of yacc.c  */
#line 10206 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1538:

/* Line 1806 of yacc.c  */
#line 10210 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1539:

/* Line 1806 of yacc.c  */
#line 10218 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1540:

/* Line 1806 of yacc.c  */
#line 10222 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1541:

/* Line 1806 of yacc.c  */
#line 10230 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1542:

/* Line 1806 of yacc.c  */
#line 10242 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1543:

/* Line 1806 of yacc.c  */
#line 10263 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1544:

/* Line 1806 of yacc.c  */
#line 10267 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1545:

/* Line 1806 of yacc.c  */
#line 10273 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1546:

/* Line 1806 of yacc.c  */
#line 10277 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1547:

/* Line 1806 of yacc.c  */
#line 10290 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1548:

/* Line 1806 of yacc.c  */
#line 10309 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1549:

/* Line 1806 of yacc.c  */
#line 10332 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1550:

/* Line 1806 of yacc.c  */
#line 10334 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1551:

/* Line 1806 of yacc.c  */
#line 10336 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1552:

/* Line 1806 of yacc.c  */
#line 10338 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1553:

/* Line 1806 of yacc.c  */
#line 10340 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1554:

/* Line 1806 of yacc.c  */
#line 10342 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1555:

/* Line 1806 of yacc.c  */
#line 10346 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1556:

/* Line 1806 of yacc.c  */
#line 10347 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1557:

/* Line 1806 of yacc.c  */
#line 10351 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1558:

/* Line 1806 of yacc.c  */
#line 10352 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1559:

/* Line 1806 of yacc.c  */
#line 10360 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1560:

/* Line 1806 of yacc.c  */
#line 10369 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1561:

/* Line 1806 of yacc.c  */
#line 10377 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1562:

/* Line 1806 of yacc.c  */
#line 10386 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1563:

/* Line 1806 of yacc.c  */
#line 10397 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1564:

/* Line 1806 of yacc.c  */
#line 10404 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1565:

/* Line 1806 of yacc.c  */
#line 10405 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1566:

/* Line 1806 of yacc.c  */
#line 10406 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1567:

/* Line 1806 of yacc.c  */
#line 10411 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1568:

/* Line 1806 of yacc.c  */
#line 10413 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1569:

/* Line 1806 of yacc.c  */
#line 10415 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1570:

/* Line 1806 of yacc.c  */
#line 10417 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1571:

/* Line 1806 of yacc.c  */
#line 10419 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1572:

/* Line 1806 of yacc.c  */
#line 10421 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1573:

/* Line 1806 of yacc.c  */
#line 10423 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1574:

/* Line 1806 of yacc.c  */
#line 10428 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1575:

/* Line 1806 of yacc.c  */
#line 10433 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1576:

/* Line 1806 of yacc.c  */
#line 10439 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1577:

/* Line 1806 of yacc.c  */
#line 10447 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1578:

/* Line 1806 of yacc.c  */
#line 10452 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1579:

/* Line 1806 of yacc.c  */
#line 10459 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1580:

/* Line 1806 of yacc.c  */
#line 10465 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1581:

/* Line 1806 of yacc.c  */
#line 10470 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1582:

/* Line 1806 of yacc.c  */
#line 10474 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1583:

/* Line 1806 of yacc.c  */
#line 10503 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1584:

/* Line 1806 of yacc.c  */
#line 10505 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1585:

/* Line 1806 of yacc.c  */
#line 10507 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1586:

/* Line 1806 of yacc.c  */
#line 10515 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1587:

/* Line 1806 of yacc.c  */
#line 10537 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1588:

/* Line 1806 of yacc.c  */
#line 10539 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1589:

/* Line 1806 of yacc.c  */
#line 10541 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1590:

/* Line 1806 of yacc.c  */
#line 10543 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1591:

/* Line 1806 of yacc.c  */
#line 10545 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1592:

/* Line 1806 of yacc.c  */
#line 10547 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1593:

/* Line 1806 of yacc.c  */
#line 10549 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1594:

/* Line 1806 of yacc.c  */
#line 10551 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1595:

/* Line 1806 of yacc.c  */
#line 10553 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1596:

/* Line 1806 of yacc.c  */
#line 10555 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1597:

/* Line 1806 of yacc.c  */
#line 10557 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1598:

/* Line 1806 of yacc.c  */
#line 10560 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1599:

/* Line 1806 of yacc.c  */
#line 10562 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1600:

/* Line 1806 of yacc.c  */
#line 10564 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1601:

/* Line 1806 of yacc.c  */
#line 10567 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1602:

/* Line 1806 of yacc.c  */
#line 10569 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1603:

/* Line 1806 of yacc.c  */
#line 10571 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1604:

/* Line 1806 of yacc.c  */
#line 10574 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1605:

/* Line 1806 of yacc.c  */
#line 10576 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1606:

/* Line 1806 of yacc.c  */
#line 10589 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1607:

/* Line 1806 of yacc.c  */
#line 10591 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1608:

/* Line 1806 of yacc.c  */
#line 10604 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1609:

/* Line 1806 of yacc.c  */
#line 10606 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1610:

/* Line 1806 of yacc.c  */
#line 10619 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1611:

/* Line 1806 of yacc.c  */
#line 10621 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1612:

/* Line 1806 of yacc.c  */
#line 10635 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1613:

/* Line 1806 of yacc.c  */
#line 10648 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1614:

/* Line 1806 of yacc.c  */
#line 10661 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1615:

/* Line 1806 of yacc.c  */
#line 10674 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1616:

/* Line 1806 of yacc.c  */
#line 10697 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1617:

/* Line 1806 of yacc.c  */
#line 10704 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1618:

/* Line 1806 of yacc.c  */
#line 10711 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1619:

/* Line 1806 of yacc.c  */
#line 10718 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1620:

/* Line 1806 of yacc.c  */
#line 10725 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]), yyscanner);
				}
    break;

  case 1621:

/* Line 1806 of yacc.c  */
#line 10729 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1622:

/* Line 1806 of yacc.c  */
#line 10736 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1623:

/* Line 1806 of yacc.c  */
#line 10743 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1624:

/* Line 1806 of yacc.c  */
#line 10750 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1625:

/* Line 1806 of yacc.c  */
#line 10757 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1626:

/* Line 1806 of yacc.c  */
#line 10764 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1627:

/* Line 1806 of yacc.c  */
#line 10771 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1628:

/* Line 1806 of yacc.c  */
#line 10775 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				}
    break;

  case 1629:

/* Line 1806 of yacc.c  */
#line 10783 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1630:

/* Line 1806 of yacc.c  */
#line 10787 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1631:

/* Line 1806 of yacc.c  */
#line 10797 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1632:

/* Line 1806 of yacc.c  */
#line 10804 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1633:

/* Line 1806 of yacc.c  */
#line 10811 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1634:

/* Line 1806 of yacc.c  */
#line 10824 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1635:

/* Line 1806 of yacc.c  */
#line 10837 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1636:

/* Line 1806 of yacc.c  */
#line 10856 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1637:

/* Line 1806 of yacc.c  */
#line 10877 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1638:

/* Line 1806 of yacc.c  */
#line 10887 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1639:

/* Line 1806 of yacc.c  */
#line 10894 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1640:

/* Line 1806 of yacc.c  */
#line 10910 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1641:

/* Line 1806 of yacc.c  */
#line 10915 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1642:

/* Line 1806 of yacc.c  */
#line 10933 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1643:

/* Line 1806 of yacc.c  */
#line 10935 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1644:

/* Line 1806 of yacc.c  */
#line 10937 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1645:

/* Line 1806 of yacc.c  */
#line 10939 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1646:

/* Line 1806 of yacc.c  */
#line 10941 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1647:

/* Line 1806 of yacc.c  */
#line 10943 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1648:

/* Line 1806 of yacc.c  */
#line 10945 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1649:

/* Line 1806 of yacc.c  */
#line 10947 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1650:

/* Line 1806 of yacc.c  */
#line 10949 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1651:

/* Line 1806 of yacc.c  */
#line 10951 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1652:

/* Line 1806 of yacc.c  */
#line 10953 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1653:

/* Line 1806 of yacc.c  */
#line 10955 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1654:

/* Line 1806 of yacc.c  */
#line 10957 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1655:

/* Line 1806 of yacc.c  */
#line 10959 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1656:

/* Line 1806 of yacc.c  */
#line 10961 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1657:

/* Line 1806 of yacc.c  */
#line 10963 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1658:

/* Line 1806 of yacc.c  */
#line 10965 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1659:

/* Line 1806 of yacc.c  */
#line 10969 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				}
    break;

  case 1660:

/* Line 1806 of yacc.c  */
#line 10974 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1661:

/* Line 1806 of yacc.c  */
#line 10978 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1662:

/* Line 1806 of yacc.c  */
#line 10982 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1663:

/* Line 1806 of yacc.c  */
#line 10987 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1664:

/* Line 1806 of yacc.c  */
#line 11003 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1665:

/* Line 1806 of yacc.c  */
#line 11004 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1666:

/* Line 1806 of yacc.c  */
#line 11006 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1667:

/* Line 1806 of yacc.c  */
#line 11021 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1668:

/* Line 1806 of yacc.c  */
#line 11033 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1669:

/* Line 1806 of yacc.c  */
#line 11035 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1670:

/* Line 1806 of yacc.c  */
#line 11037 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1671:

/* Line 1806 of yacc.c  */
#line 11047 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1672:

/* Line 1806 of yacc.c  */
#line 11070 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1673:

/* Line 1806 of yacc.c  */
#line 11080 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1674:

/* Line 1806 of yacc.c  */
#line 11090 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1675:

/* Line 1806 of yacc.c  */
#line 11098 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1676:

/* Line 1806 of yacc.c  */
#line 11117 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1677:

/* Line 1806 of yacc.c  */
#line 11130 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1678:

/* Line 1806 of yacc.c  */
#line 11143 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1679:

/* Line 1806 of yacc.c  */
#line 11156 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1680:

/* Line 1806 of yacc.c  */
#line 11169 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1681:

/* Line 1806 of yacc.c  */
#line 11182 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1682:

/* Line 1806 of yacc.c  */
#line 11199 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1683:

/* Line 1806 of yacc.c  */
#line 11212 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1684:

/* Line 1806 of yacc.c  */
#line 11235 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("pg_collation_for");
					n->args = list_make1((yyvsp[(4) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1685:

/* Line 1806 of yacc.c  */
#line 11248 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1686:

/* Line 1806 of yacc.c  */
#line 11274 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1687:

/* Line 1806 of yacc.c  */
#line 11284 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1688:

/* Line 1806 of yacc.c  */
#line 11297 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1689:

/* Line 1806 of yacc.c  */
#line 11314 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1690:

/* Line 1806 of yacc.c  */
#line 11327 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1691:

/* Line 1806 of yacc.c  */
#line 11337 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1692:

/* Line 1806 of yacc.c  */
#line 11350 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1693:

/* Line 1806 of yacc.c  */
#line 11360 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1694:

/* Line 1806 of yacc.c  */
#line 11373 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1695:

/* Line 1806 of yacc.c  */
#line 11386 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1696:

/* Line 1806 of yacc.c  */
#line 11399 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1697:

/* Line 1806 of yacc.c  */
#line 11412 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1698:

/* Line 1806 of yacc.c  */
#line 11425 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1699:

/* Line 1806 of yacc.c  */
#line 11438 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1700:

/* Line 1806 of yacc.c  */
#line 11451 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1701:

/* Line 1806 of yacc.c  */
#line 11453 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1702:

/* Line 1806 of yacc.c  */
#line 11466 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1703:

/* Line 1806 of yacc.c  */
#line 11484 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1704:

/* Line 1806 of yacc.c  */
#line 11498 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1705:

/* Line 1806 of yacc.c  */
#line 11514 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1706:

/* Line 1806 of yacc.c  */
#line 11536 "gram.y"
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1707:

/* Line 1806 of yacc.c  */
#line 11552 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1708:

/* Line 1806 of yacc.c  */
#line 11565 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1709:

/* Line 1806 of yacc.c  */
#line 11578 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1710:

/* Line 1806 of yacc.c  */
#line 11591 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1711:

/* Line 1806 of yacc.c  */
#line 11595 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1712:

/* Line 1806 of yacc.c  */
#line 11602 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1713:

/* Line 1806 of yacc.c  */
#line 11610 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1714:

/* Line 1806 of yacc.c  */
#line 11618 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1715:

/* Line 1806 of yacc.c  */
#line 11622 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1716:

/* Line 1806 of yacc.c  */
#line 11626 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1717:

/* Line 1806 of yacc.c  */
#line 11630 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1718:

/* Line 1806 of yacc.c  */
#line 11634 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1719:

/* Line 1806 of yacc.c  */
#line 11638 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1720:

/* Line 1806 of yacc.c  */
#line 11653 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1721:

/* Line 1806 of yacc.c  */
#line 11657 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1722:

/* Line 1806 of yacc.c  */
#line 11666 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1723:

/* Line 1806 of yacc.c  */
#line 11670 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1724:

/* Line 1806 of yacc.c  */
#line 11674 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1725:

/* Line 1806 of yacc.c  */
#line 11679 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1726:

/* Line 1806 of yacc.c  */
#line 11693 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1727:

/* Line 1806 of yacc.c  */
#line 11695 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1728:

/* Line 1806 of yacc.c  */
#line 11699 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1729:

/* Line 1806 of yacc.c  */
#line 11701 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1730:

/* Line 1806 of yacc.c  */
#line 11703 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1731:

/* Line 1806 of yacc.c  */
#line 11705 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1732:

/* Line 1806 of yacc.c  */
#line 11708 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1733:

/* Line 1806 of yacc.c  */
#line 11711 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1734:

/* Line 1806 of yacc.c  */
#line 11712 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1735:

/* Line 1806 of yacc.c  */
#line 11716 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1736:

/* Line 1806 of yacc.c  */
#line 11724 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1737:

/* Line 1806 of yacc.c  */
#line 11733 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1738:

/* Line 1806 of yacc.c  */
#line 11734 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1739:

/* Line 1806 of yacc.c  */
#line 11737 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1740:

/* Line 1806 of yacc.c  */
#line 11738 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1741:

/* Line 1806 of yacc.c  */
#line 11739 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1742:

/* Line 1806 of yacc.c  */
#line 11745 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1743:

/* Line 1806 of yacc.c  */
#line 11749 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1744:

/* Line 1806 of yacc.c  */
#line 11753 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1745:

/* Line 1806 of yacc.c  */
#line 11757 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1746:

/* Line 1806 of yacc.c  */
#line 11767 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1747:

/* Line 1806 of yacc.c  */
#line 11768 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1748:

/* Line 1806 of yacc.c  */
#line 11772 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1749:

/* Line 1806 of yacc.c  */
#line 11774 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1750:

/* Line 1806 of yacc.c  */
#line 11779 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1751:

/* Line 1806 of yacc.c  */
#line 11787 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1752:

/* Line 1806 of yacc.c  */
#line 11789 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1753:

/* Line 1806 of yacc.c  */
#line 11802 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1754:

/* Line 1806 of yacc.c  */
#line 11807 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1755:

/* Line 1806 of yacc.c  */
#line 11832 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1756:

/* Line 1806 of yacc.c  */
#line 11833 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1757:

/* Line 1806 of yacc.c  */
#line 11836 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1758:

/* Line 1806 of yacc.c  */
#line 11837 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1759:

/* Line 1806 of yacc.c  */
#line 11849 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1760:

/* Line 1806 of yacc.c  */
#line 11867 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1761:

/* Line 1806 of yacc.c  */
#line 11873 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1762:

/* Line 1806 of yacc.c  */
#line 11883 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1763:

/* Line 1806 of yacc.c  */
#line 11900 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1764:

/* Line 1806 of yacc.c  */
#line 11945 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1765:

/* Line 1806 of yacc.c  */
#line 11953 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1766:

/* Line 1806 of yacc.c  */
#line 11961 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1767:

/* Line 1806 of yacc.c  */
#line 11969 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1768:

/* Line 1806 of yacc.c  */
#line 11977 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1769:

/* Line 1806 of yacc.c  */
#line 11997 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1770:

/* Line 1806 of yacc.c  */
#line 11998 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1771:

/* Line 1806 of yacc.c  */
#line 11999 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1772:

/* Line 1806 of yacc.c  */
#line 12002 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1773:

/* Line 1806 of yacc.c  */
#line 12003 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1774:

/* Line 1806 of yacc.c  */
#line 12004 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1775:

/* Line 1806 of yacc.c  */
#line 12007 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1776:

/* Line 1806 of yacc.c  */
#line 12008 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1777:

/* Line 1806 of yacc.c  */
#line 12011 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1778:

/* Line 1806 of yacc.c  */
#line 12012 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1779:

/* Line 1806 of yacc.c  */
#line 12013 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1780:

/* Line 1806 of yacc.c  */
#line 12014 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1781:

/* Line 1806 of yacc.c  */
#line 12015 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1782:

/* Line 1806 of yacc.c  */
#line 12016 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1783:

/* Line 1806 of yacc.c  */
#line 12017 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1784:

/* Line 1806 of yacc.c  */
#line 12018 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1785:

/* Line 1806 of yacc.c  */
#line 12019 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1786:

/* Line 1806 of yacc.c  */
#line 12023 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1787:

/* Line 1806 of yacc.c  */
#line 12025 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1788:

/* Line 1806 of yacc.c  */
#line 12030 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1789:

/* Line 1806 of yacc.c  */
#line 12032 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1790:

/* Line 1806 of yacc.c  */
#line 12037 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1791:

/* Line 1806 of yacc.c  */
#line 12039 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1792:

/* Line 1806 of yacc.c  */
#line 12041 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1793:

/* Line 1806 of yacc.c  */
#line 12043 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1794:

/* Line 1806 of yacc.c  */
#line 12045 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1795:

/* Line 1806 of yacc.c  */
#line 12047 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1796:

/* Line 1806 of yacc.c  */
#line 12059 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1797:

/* Line 1806 of yacc.c  */
#line 12063 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1798:

/* Line 1806 of yacc.c  */
#line 12070 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1799:

/* Line 1806 of yacc.c  */
#line 12074 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1800:

/* Line 1806 of yacc.c  */
#line 12080 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1801:

/* Line 1806 of yacc.c  */
#line 12084 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1802:

/* Line 1806 of yacc.c  */
#line 12094 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1803:

/* Line 1806 of yacc.c  */
#line 12095 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1804:

/* Line 1806 of yacc.c  */
#line 12099 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1805:

/* Line 1806 of yacc.c  */
#line 12103 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1806:

/* Line 1806 of yacc.c  */
#line 12107 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1807:

/* Line 1806 of yacc.c  */
#line 12112 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1808:

/* Line 1806 of yacc.c  */
#line 12113 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1809:

/* Line 1806 of yacc.c  */
#line 12119 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1810:

/* Line 1806 of yacc.c  */
#line 12122 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1811:

/* Line 1806 of yacc.c  */
#line 12129 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1812:

/* Line 1806 of yacc.c  */
#line 12130 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1813:

/* Line 1806 of yacc.c  */
#line 12131 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1814:

/* Line 1806 of yacc.c  */
#line 12132 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1815:

/* Line 1806 of yacc.c  */
#line 12133 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1816:

/* Line 1806 of yacc.c  */
#line 12134 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1817:

/* Line 1806 of yacc.c  */
#line 12135 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1818:

/* Line 1806 of yacc.c  */
#line 12136 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1819:

/* Line 1806 of yacc.c  */
#line 12147 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1820:

/* Line 1806 of yacc.c  */
#line 12151 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1821:

/* Line 1806 of yacc.c  */
#line 12158 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1822:

/* Line 1806 of yacc.c  */
#line 12164 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1823:

/* Line 1806 of yacc.c  */
#line 12165 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1824:

/* Line 1806 of yacc.c  */
#line 12182 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1825:

/* Line 1806 of yacc.c  */
#line 12186 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1826:

/* Line 1806 of yacc.c  */
#line 12191 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1827:

/* Line 1806 of yacc.c  */
#line 12195 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1828:

/* Line 1806 of yacc.c  */
#line 12210 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1829:

/* Line 1806 of yacc.c  */
#line 12214 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1830:

/* Line 1806 of yacc.c  */
#line 12218 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1831:

/* Line 1806 of yacc.c  */
#line 12221 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1832:

/* Line 1806 of yacc.c  */
#line 12224 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1833:

/* Line 1806 of yacc.c  */
#line 12225 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1834:

/* Line 1806 of yacc.c  */
#line 12226 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1835:

/* Line 1806 of yacc.c  */
#line 12230 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1836:

/* Line 1806 of yacc.c  */
#line 12236 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1837:

/* Line 1806 of yacc.c  */
#line 12247 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1838:

/* Line 1806 of yacc.c  */
#line 12260 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1839:

/* Line 1806 of yacc.c  */
#line 12261 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1840:

/* Line 1806 of yacc.c  */
#line 12266 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1841:

/* Line 1806 of yacc.c  */
#line 12276 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1842:

/* Line 1806 of yacc.c  */
#line 12277 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1843:

/* Line 1806 of yacc.c  */
#line 12280 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1844:

/* Line 1806 of yacc.c  */
#line 12281 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1845:

/* Line 1806 of yacc.c  */
#line 12285 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 1846:

/* Line 1806 of yacc.c  */
#line 12289 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 1847:

/* Line 1806 of yacc.c  */
#line 12296 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1848:

/* Line 1806 of yacc.c  */
#line 12300 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 1849:

/* Line 1806 of yacc.c  */
#line 12304 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1850:

/* Line 1806 of yacc.c  */
#line 12311 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1851:

/* Line 1806 of yacc.c  */
#line 12320 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1852:

/* Line 1806 of yacc.c  */
#line 12321 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1853:

/* Line 1806 of yacc.c  */
#line 12325 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1854:

/* Line 1806 of yacc.c  */
#line 12326 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1857:

/* Line 1806 of yacc.c  */
#line 12341 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 1858:

/* Line 1806 of yacc.c  */
#line 12343 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1859:

/* Line 1806 of yacc.c  */
#line 12351 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1860:

/* Line 1806 of yacc.c  */
#line 12352 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1861:

/* Line 1806 of yacc.c  */
#line 12360 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1862:

/* Line 1806 of yacc.c  */
#line 12371 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1863:

/* Line 1806 of yacc.c  */
#line 12372 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1864:

/* Line 1806 of yacc.c  */
#line 12376 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1865:

/* Line 1806 of yacc.c  */
#line 12392 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1866:

/* Line 1806 of yacc.c  */
#line 12400 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1867:

/* Line 1806 of yacc.c  */
#line 12408 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1868:

/* Line 1806 of yacc.c  */
#line 12429 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1869:

/* Line 1806 of yacc.c  */
#line 12430 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1870:

/* Line 1806 of yacc.c  */
#line 12442 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1871:

/* Line 1806 of yacc.c  */
#line 12446 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 1872:

/* Line 1806 of yacc.c  */
#line 12473 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1873:

/* Line 1806 of yacc.c  */
#line 12475 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1874:

/* Line 1806 of yacc.c  */
#line 12479 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1875:

/* Line 1806 of yacc.c  */
#line 12482 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1876:

/* Line 1806 of yacc.c  */
#line 12485 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1877:

/* Line 1806 of yacc.c  */
#line 12487 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1878:

/* Line 1806 of yacc.c  */
#line 12489 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1879:

/* Line 1806 of yacc.c  */
#line 12491 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1880:

/* Line 1806 of yacc.c  */
#line 12502 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1881:

/* Line 1806 of yacc.c  */
#line 12504 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 1882:

/* Line 1806 of yacc.c  */
#line 12515 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 1883:

/* Line 1806 of yacc.c  */
#line 12519 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1884:

/* Line 1806 of yacc.c  */
#line 12523 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1885:

/* Line 1806 of yacc.c  */
#line 12527 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1886:

/* Line 1806 of yacc.c  */
#line 12531 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1887:

/* Line 1806 of yacc.c  */
#line 12540 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 1888:

/* Line 1806 of yacc.c  */
#line 12547 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 1889:

/* Line 1806 of yacc.c  */
#line 12572 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 1890:

/* Line 1806 of yacc.c  */
#line 12576 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 1891:

/* Line 1806 of yacc.c  */
#line 12582 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 1892:

/* Line 1806 of yacc.c  */
#line 12599 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 1893:

/* Line 1806 of yacc.c  */
#line 12603 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 1894:

/* Line 1806 of yacc.c  */
#line 12607 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1895:

/* Line 1806 of yacc.c  */
#line 12612 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1896:

/* Line 1806 of yacc.c  */
#line 12613 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1897:

/* Line 1806 of yacc.c  */
#line 12614 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1898:

/* Line 1806 of yacc.c  */
#line 12617 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1899:

/* Line 1806 of yacc.c  */
#line 12619 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1900:

/* Line 1806 of yacc.c  */
#line 12622 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1901:

/* Line 1806 of yacc.c  */
#line 12623 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 1902:

/* Line 1806 of yacc.c  */
#line 12624 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 1903:

/* Line 1806 of yacc.c  */
#line 12640 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1904:

/* Line 1806 of yacc.c  */
#line 12641 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1905:

/* Line 1806 of yacc.c  */
#line 12642 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1906:

/* Line 1806 of yacc.c  */
#line 12647 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1907:

/* Line 1806 of yacc.c  */
#line 12648 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1908:

/* Line 1806 of yacc.c  */
#line 12649 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1909:

/* Line 1806 of yacc.c  */
#line 12654 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1910:

/* Line 1806 of yacc.c  */
#line 12655 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1911:

/* Line 1806 of yacc.c  */
#line 12656 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1912:

/* Line 1806 of yacc.c  */
#line 12657 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1913:

/* Line 1806 of yacc.c  */
#line 12663 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1914:

/* Line 1806 of yacc.c  */
#line 12664 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1915:

/* Line 1806 of yacc.c  */
#line 12665 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1916:

/* Line 1806 of yacc.c  */
#line 12666 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1917:

/* Line 1806 of yacc.c  */
#line 12667 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;



/* Line 1806 of yacc.c  */
#line 39227 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 13125 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location, core_yyscan_t yyscanner)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 parser_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 parser_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_order = NIL;
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));;
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"

